//-----------------------------------------------------------------------------
// Copyright Notice
//
//   Copyright 2002 Sandia Corporation. Under the terms
//   of Contract DE-AC04-94AL85000 with Sandia Corporation, the U.S.
//   Government retains certain rights in this software.
//
//    Xyce(TM) Parallel Electrical Simulator
//    Copyright (C) 2002-2016 Sandia Corporation
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//
// Purpose        : Linear Solver Factory
//
// Special Notes  :
//
// Creator        : Robert Hoekstra, SNL, Parallel Computational Sciences
//
// Creation Date  : 08/12/03
//
//
//
//
//-----------------------------------------------------------------------------

#ifndef Xyce_N_IO_DistToolFactory_h
#define Xyce_N_IO_DistToolFactory_h

// ---------- Standard Includes ----------

#include <string>

#include <N_IO_fwd.h>
#include <N_IO_CircuitBlock.h>
#include <N_IO_DistributionTool.h>
#include <N_IO_PkgOptionsMgr.h>
#include <N_PDS_Comm.h>

#include <N_IO_DistributionTool.h>

namespace Xyce {
namespace IO {

//-----------------------------------------------------------------------------
// Class         : DistToolFactory
// Purpose       :
// Special Notes :
// Creator       : Heidi Thornquist, SNL
// Creation Date : 08/12/03
//-----------------------------------------------------------------------------
struct DistToolFactory
{
  // Creates a new IO distribution tool
  static DistributionTool * create(
    Parallel::Communicator *                 pdsCommPtr,    
    PkgOptionsMgr &                          optionsManager,
    CircuitBlock &                           circuitBlock,
    std::map<std::string,FileSSFPair>      & ssfMap,
    std::map<std::string, IncludeFileInfo> & iflMap);
};

} // namespace IO 
} // namespace Xyce

#endif // Xyce_N_IO_DistToolFactory_h

