
//-----------------------------------------------------------------------------
// Copyright Notice
//
//   Copyright 2002 Sandia Corporation. Under the terms
//   of Contract DE-AC04-94AL85000 with Sandia Corporation, the U.S.
//   Government retains certain rights in this software.
//
//    Xyce(TM) Parallel Electrical Simulator
//    Copyright (C) 2002-2016 Sandia Corporation
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//-----------------------------------------------------------------------------

//-------------------------------------------------------------------------
//
// Purpose        :
//
// Special Notes  : Generated from verilog file bjt504.va with ADMS
//                  interface for Xyce 6.5.0
//                  DO NOT EDIT THIS FILE DIRECTLY!  It may be overwritten!
//
// Creator        : admsXml-2.3.5
//
// Creation Date  : Tue, 03 May 2016 14:01:07
//
//-------------------------------------------------------------------------
// Shut up clang's warnings about extraneous parentheses
#pragma clang diagnostic ignored "-Wparentheses-equality"

#include <Xyce_config.h>
#include <N_DEV_ADMSbjt504va.h>


#include <N_DEV_Const.h>
#include <N_DEV_DeviceOptions.h>
#include <N_DEV_DeviceMaster.h>
#include <N_DEV_ExternData.h>
#include <N_DEV_SolverState.h>
#include <N_DEV_Message.h>

#include <N_LAS_Matrix.h>
#include <N_LAS_Vector.h>

#include <N_ANP_NoiseData.h>

#include <N_UTL_FeatureTest.h>
#if defined(HAVE_UNORDERED_MAP)
#include <unordered_map>
using std::unordered_map;
#elif defined(HAVE_TR1_UNORDERED_MAP)
#include <tr1/unordered_map>
using std::tr1::unordered_map;
#else
#error neither unordered_map or tr1/unordered_map found
#endif

namespace Xyce {
namespace Device {
namespace ADMSbjt504va {


//This is necessary because the IntPair usage can trip undefined references
const int Instance::admsNodeID_c;
const int Instance::admsNodeID_b;
const int Instance::admsNodeID_e;
const int Instance::admsNodeID_s;
const int Instance::admsNodeID_e1;
const int Instance::admsNodeID_b1;
const int Instance::admsNodeID_b2;
const int Instance::admsNodeID_c1;
const int Instance::admsNodeID_c2;
const int Instance::admsNodeID_c3;
const int Instance::admsNodeID_c4;
const int Instance::admsNodeID_noi;
const int Instance::admsNodeID_GND;
// Additional IDs for branch equations


void
Traits::loadInstanceParameters(ParametricData<ADMSbjt504va::Instance> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have an instance parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSINSTTEMP", 0.0, &ADMSbjt504va::Instance::admsInstTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device instance temperature");
  p.addPar("MULT", static_cast<double>(1.0), &ADMSbjt504va::Instance::MULT)
    .setDescription("Multiplication factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;


}

void Traits::loadModelParameters(ParametricData<ADMSbjt504va::Model> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have a model parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSMODTEMP", 0.0, &ADMSbjt504va::Model::admsModTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device model temperature");
  p.addPar("LEVEL", static_cast<int>(504), &ADMSbjt504va::Model::LEVEL)
    .setDescription("Model level");
  p.addPar("TREF", static_cast<double>(25.0), &ADMSbjt504va::Model::TREF)
    .setUnit(U_DEGC)
    .setDescription("Reference temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DTA", static_cast<double>(0.0), &ADMSbjt504va::Model::DTA)
    .setUnit(U_DEGC)
    .setDescription("Difference between the local and global ambient temperatures")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EXMOD", static_cast<int>(1), &ADMSbjt504va::Model::EXMOD)
    .setDescription("Flag for extended modeling of the reverse current gain");
  p.addPar("EXPHI", static_cast<int>(1), &ADMSbjt504va::Model::EXPHI)
    .setDescription("Flag for the distributed high-frequency effects in transient");
  p.addPar("EXAVL", static_cast<int>(0), &ADMSbjt504va::Model::EXAVL)
    .setDescription("Flag for extended modeling of avalanche currents");
  p.addPar("EXSUB", static_cast<int>(0), &ADMSbjt504va::Model::EXSUB)
    .setDescription("Flag for extended modelling of substrate currents");
  p.addPar("IS", static_cast<double>(22.0*1.0e-18), &ADMSbjt504va::Model::IS)
    .setUnit(U_AMP)
    .setDescription("Collector-emitter saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IK", static_cast<double>(0.1), &ADMSbjt504va::Model::IK)
    .setUnit(U_AMP)
    .setDescription("Collector-emitter high injection knee current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VER", static_cast<double>(2.5), &ADMSbjt504va::Model::VER)
    .setUnit(U_VOLT)
    .setDescription("Reverse Early voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VEF", static_cast<double>(44.0), &ADMSbjt504va::Model::VEF)
    .setUnit(U_VOLT)
    .setDescription("Forward Early voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BF", static_cast<double>(215.0), &ADMSbjt504va::Model::BF)
    .setDescription("Ideal forward current gain")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBF", static_cast<double>(2.7*1.0e-15), &ADMSbjt504va::Model::IBF)
    .setUnit(U_AMP)
    .setDescription("Saturation current of the non-ideal forward base current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MLF", static_cast<double>(2.0), &ADMSbjt504va::Model::MLF)
    .setDescription("Non-ideality factor of the non-ideal forward base current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XIBI", static_cast<double>(0.0), &ADMSbjt504va::Model::XIBI)
    .setDescription("Part of ideal base current that belongs to the sidewall")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IZEB", static_cast<double>(0.0), &ADMSbjt504va::Model::IZEB)
    .setUnit(U_AMP)
    .setDescription("Pre-factor of emitter-base Zener tunneling current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NZEB", static_cast<double>(22.0), &ADMSbjt504va::Model::NZEB)
    .setDescription("Coefficient of emitter-base Zener tunneling current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BRI", static_cast<double>(7.0), &ADMSbjt504va::Model::BRI)
    .setDescription("Ideal reverse current gain")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBR", static_cast<double>(1.0*1.0e-15), &ADMSbjt504va::Model::IBR)
    .setUnit(U_AMP)
    .setDescription("Saturation current of the non-ideal reverse base current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VLR", static_cast<double>(0.2), &ADMSbjt504va::Model::VLR)
    .setUnit(U_VOLT)
    .setDescription("Cross-over voltage of the non-ideal reverse base current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XEXT", static_cast<double>(0.63), &ADMSbjt504va::Model::XEXT)
    .setDescription("Part of currents and charges that belong to extrinsic region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WAVL", static_cast<double>(1.1*1.0e-6), &ADMSbjt504va::Model::WAVL)
    .setUnit(U_METER)
    .setDescription("Epilayer thickness used in weak-avalanche model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VAVL", static_cast<double>(3.0), &ADMSbjt504va::Model::VAVL)
    .setUnit(U_VOLT)
    .setDescription("Voltage determining curvature of avalanche current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SFH", static_cast<double>(0.3), &ADMSbjt504va::Model::SFH)
    .setDescription("Current spreading factor of avalanche model when EXAVL=1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RE", static_cast<double>(5.0), &ADMSbjt504va::Model::RE)
    .setUnit(U_OHM)
    .setDescription("Emitter resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBC", static_cast<double>(23.0), &ADMSbjt504va::Model::RBC)
    .setUnit(U_OHM)
    .setDescription("Constant part of the base resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBV", static_cast<double>(18.0), &ADMSbjt504va::Model::RBV)
    .setUnit(U_OHM)
    .setDescription("Zero-bias value of the variable part of the base resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RCC", static_cast<double>(12.0), &ADMSbjt504va::Model::RCC)
    .setUnit(U_OHM)
    .setDescription("Constant part of the collector resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RCV", static_cast<double>(150.0), &ADMSbjt504va::Model::RCV)
    .setUnit(U_OHM)
    .setDescription("Resistance of the un-modulated epilayer")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SCRCV", static_cast<double>(1250.0), &ADMSbjt504va::Model::SCRCV)
    .setUnit(U_OHM)
    .setDescription("Space charge resistance of the epilayer")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IHC", static_cast<double>(4.0*1.0e-3), &ADMSbjt504va::Model::IHC)
    .setUnit(U_AMP)
    .setDescription("Critical current for velocity saturation in the epilayer")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AXI", static_cast<double>(0.3), &ADMSbjt504va::Model::AXI)
    .setDescription("Smoothness parameter for the onset of quasi-saturation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJE", static_cast<double>(73.0*1.0e-15), &ADMSbjt504va::Model::CJE)
    .setUnit(U_FARAD)
    .setDescription("Zero-bias emitter-base depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VDE", static_cast<double>(0.95), &ADMSbjt504va::Model::VDE)
    .setUnit(U_OHM)
    .setDescription("Emitter-base diffusion voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PE", static_cast<double>(0.4), &ADMSbjt504va::Model::PE)
    .setDescription("Emitter-base grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XCJE", static_cast<double>(0.4), &ADMSbjt504va::Model::XCJE)
    .setDescription("Sidewall fraction of the emitter-base depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBEO", static_cast<double>(0.0), &ADMSbjt504va::Model::CBEO)
    .setDescription("Emitter-base overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJC", static_cast<double>(78.0*1.0e-15), &ADMSbjt504va::Model::CJC)
    .setUnit(U_FARAD)
    .setDescription("Zero-bias collector-base depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VDC", static_cast<double>(0.68), &ADMSbjt504va::Model::VDC)
    .setUnit(U_VOLT)
    .setDescription("Collector-base diffusion voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PC", static_cast<double>(0.5), &ADMSbjt504va::Model::PC)
    .setDescription("Collector-base grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XP", static_cast<double>(0.35), &ADMSbjt504va::Model::XP)
    .setDescription("Constant part of Cjc")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MC", static_cast<double>(0.5), &ADMSbjt504va::Model::MC)
    .setDescription("Coefficient for current modulation of CB depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XCJC", static_cast<double>(32.0*1.0e-3), &ADMSbjt504va::Model::XCJC)
    .setDescription("Fraction of CB depletion capacitance under the emitter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RCBLX", static_cast<double>(0.0), &ADMSbjt504va::Model::RCBLX)
    .setUnit(U_OHM)
    .setDescription("Resistance Collector Buried Layer eXtrinsic")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RCBLI", static_cast<double>(0.0), &ADMSbjt504va::Model::RCBLI)
    .setUnit(U_OHM)
    .setDescription("Resistance Collector Buried Layer Intrinsic")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBCO", static_cast<double>(0.0), &ADMSbjt504va::Model::CBCO)
    .setDescription("Collector-base overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MTAU", static_cast<double>(1.0), &ADMSbjt504va::Model::MTAU)
    .setDescription("Non-ideality factor of the emitter stored charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TAUE", static_cast<double>(2.0*1.0e-12), &ADMSbjt504va::Model::TAUE)
    .setUnit(U_SECOND)
    .setDescription("Minimum transit time of stored emitter charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TAUB", static_cast<double>(4.2*1.0e-12), &ADMSbjt504va::Model::TAUB)
    .setUnit(U_SECOND)
    .setDescription("Transit time of stored base sharge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TEPI", static_cast<double>(41.0*1.0e-12), &ADMSbjt504va::Model::TEPI)
    .setUnit(U_SECOND)
    .setDescription("Transit time of stored epilayer charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TAUR", static_cast<double>(520.0*1.0e-12), &ADMSbjt504va::Model::TAUR)
    .setUnit(U_SECOND)
    .setDescription("Transit time of reverse extrinsic stored base charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DEG", static_cast<double>(0.0), &ADMSbjt504va::Model::DEG)
    .setUnit(U_EV)
    .setDescription("Bandgap difference over the base")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XREC", static_cast<double>(0.0), &ADMSbjt504va::Model::XREC)
    .setDescription("Pre-factor of the recombination part of Ib1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AQBO", static_cast<double>(0.3), &ADMSbjt504va::Model::AQBO)
    .setDescription("Temperature coefficient of the zero-bias base charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AE", static_cast<double>(0.0), &ADMSbjt504va::Model::AE)
    .setDescription("Temperature coefficient of the resistivity of the emitter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AB", static_cast<double>(1.0), &ADMSbjt504va::Model::AB)
    .setDescription("Temperature coefficient of the resistivity of the base")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AEPI", static_cast<double>(2.5), &ADMSbjt504va::Model::AEPI)
    .setDescription("Temperature coefficient of the resistivity of the epilayer")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AEX", static_cast<double>(0.62), &ADMSbjt504va::Model::AEX)
    .setDescription("Temperature coefficient of the resistivity of the extrinsic base")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AC", static_cast<double>(2.0), &ADMSbjt504va::Model::AC)
    .setDescription("Temperature coefficient of the resistivity of the collector contact")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ACBL", static_cast<double>(2.0), &ADMSbjt504va::Model::ACBL)
    .setDescription("Temperature coefficient of the resistivity of the collector buried layer")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVGBF", static_cast<double>(50.0*1.0e-3), &ADMSbjt504va::Model::DVGBF)
    .setUnit(U_VOLT)
    .setDescription("Band-gap voltage difference of the forward current gain")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVGBR", static_cast<double>(45.0*1.0e-3), &ADMSbjt504va::Model::DVGBR)
    .setUnit(U_VOLT)
    .setDescription("Band-gap voltage difference of the reverse current gain")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGB", static_cast<double>(1.17), &ADMSbjt504va::Model::VGB)
    .setUnit(U_VOLT)
    .setDescription("Band-gap voltage of the base")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGC", static_cast<double>(1.18), &ADMSbjt504va::Model::VGC)
    .setUnit(U_VOLT)
    .setDescription("Band-gap voltage of the collector")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGJ", static_cast<double>(1.15), &ADMSbjt504va::Model::VGJ)
    .setUnit(U_VOLT)
    .setDescription("Band-gap voltage recombination emitter-base junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGZEB", static_cast<double>(1.15), &ADMSbjt504va::Model::VGZEB)
    .setUnit(U_VOLT)
    .setDescription("Band-gap voltage at Tref of Zener effect emitter-base junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AVGEB", static_cast<double>(4.73e-4), &ADMSbjt504va::Model::AVGEB)
    .setUnit(U_VKM1)
    .setDescription("Temperature coefficient band-gap voltage for Zener effect emitter-base junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TVGEB", static_cast<double>(636.0), &ADMSbjt504va::Model::TVGEB)
    .setUnit(U_DEGK)
    .setDescription("Temperature coefficient band-gap voltage for Zener effect emitter-base junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVGTE", static_cast<double>(0.05), &ADMSbjt504va::Model::DVGTE)
    .setUnit(U_VOLT)
    .setDescription("Band-gap voltage difference of emitter stored charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DAIS", static_cast<double>(0.0), &ADMSbjt504va::Model::DAIS)
    .setDescription("Fine tuning of temperature dependence of C-E saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AF", static_cast<double>(2.0), &ADMSbjt504va::Model::AF)
    .setDescription("Exponent of the Flicker-noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KF", static_cast<double>(20.0*1.0e-12), &ADMSbjt504va::Model::KF)
    .setDescription("Flicker-noise coefficient of the ideal base current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KFN", static_cast<double>(20.0*1.0e-12), &ADMSbjt504va::Model::KFN)
    .setDescription("Flicker-noise coefficient of the non-ideal base current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KAVL", static_cast<int>(0), &ADMSbjt504va::Model::KAVL)
    .setDescription("Switch for white noise contribution due to avalanche");
  p.addPar("ISS", static_cast<double>(48.0*1.0e-18), &ADMSbjt504va::Model::ISS)
    .setUnit(U_AMP)
    .setDescription("Base-substrate saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ICSS", static_cast<double>((-1.0)), &ADMSbjt504va::Model::ICSS)
    .setUnit(U_AMP)
    .setDescription("Collector-substrate ideal saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IKS", static_cast<double>(250.0*1.0e-6), &ADMSbjt504va::Model::IKS)
    .setUnit(U_AMP)
    .setDescription("Base-substrate high injection knee current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJS", static_cast<double>(315.0*1.0e-15), &ADMSbjt504va::Model::CJS)
    .setUnit(U_FARAD)
    .setDescription("Zero-bias collector-substrate depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VDS", static_cast<double>(0.62), &ADMSbjt504va::Model::VDS)
    .setUnit(U_VOLT)
    .setDescription("Collector-substrate diffusion voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PS", static_cast<double>(0.34), &ADMSbjt504va::Model::PS)
    .setDescription("Collector-substrate grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGS", static_cast<double>(1.20), &ADMSbjt504va::Model::VGS)
    .setUnit(U_VOLT)
    .setDescription("band-gap voltage of the substrate")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AS", static_cast<double>(1.58), &ADMSbjt504va::Model::AS)
    .setDescription("Substrate temperature coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ASUB", static_cast<double>(2.0), &ADMSbjt504va::Model::ASUB)
    .setDescription("Temperature coefficient for mobility of minorities in the substrate")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MULT", static_cast<double>(1.0), &ADMSbjt504va::Model::MULT)
    .setDescription("Multiplication factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TYPE", static_cast<int>(1), &ADMSbjt504va::Model::TYPE)
    .setDescription("Flag for NPN (1) or PNP (-1) transistor type");
  p.addPar("GMIN", static_cast<double>(1.0e-13), &ADMSbjt504va::Model::GMIN)
    .setDescription("Minimum conductance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;

}

//-----------------------------------------------------------------------------
// Function      : Instance::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::processParams()
{
  // set any non-constant parameter defaults

  // copy any model variables that have associated instance variables, but
  // are only given in the model card:
  if (!(given("MULT")))
  {
    MULT = model_.MULT;
  }



  // Set any parameters that were not given and whose defaults depend on other
  // parameters:


  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

  //    Parameter MULT : ] 0.0,  (+inf) [
  if ( (!((MULT >0.0))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter MULT value " << MULT << " out of range ] 0.0,  (+inf) [";
  }


  // this seems a little stupid, but verilog models that use $temperature
  // don't also use a defined parameter "Temp", and count on $temperature
  // to be the one the simulator wants:

  updateTemperature(admsInstTemp);

  // and of course, this routine is where we should put the initial_instance
  // stuff


  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::Instance
// Purpose       : "instance block" constructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------

Instance::Instance(
   const Configuration & configuration,
   const InstanceBlock & instance_block,
   Model &               model,
   const FactoryBlock &  factory_block)
  : DeviceInstance(instance_block, configuration.getInstanceParameters(), factory_block),
    model_(model),
    MULT(1.0),
    Izteb(0.0),
    qBI(0.0),
    Ir(0.0),
    If(0.0),
    Ib1(0.0),
    Ib1_s(0.0),
    Ib2(0.0),
    Ib3(0.0),
    Iex(0.0),
    XIex(0.0),
    Isub(0.0),
    XIsub(0.0),
    Rb2(0.0),
    Gem(0.0),
    eVb1b2(0.0),
    li_c(-1),
    li_b(-1),
    li_e(-1),
    li_s(-1),
    li_e1(-1),
    li_b1(-1),
    li_b2(-1),
    li_c1(-1),
    li_c2(-1),
    li_c3(-1),
    li_c4(-1),
    li_noi(-1),
    f_c1_Equ_c1_Node_Ptr(0),
    f_c1_Equ_c2_Node_Ptr(0),
    f_c2_Equ_c1_Node_Ptr(0),
    f_c2_Equ_c2_Node_Ptr(0),
    f_c1_Equ_b2_Node_Ptr(0),
    f_c2_Equ_b2_Node_Ptr(0),
    f_e1_Equ_c1_Node_Ptr(0),
    f_e1_Equ_c2_Node_Ptr(0),
    f_e1_Equ_b2_Node_Ptr(0),
    f_c2_Equ_e1_Node_Ptr(0),
    f_e1_Equ_e1_Node_Ptr(0),
    f_b1_Equ_b1_Node_Ptr(0),
    f_b1_Equ_e1_Node_Ptr(0),
    f_e1_Equ_b1_Node_Ptr(0),
    f_b2_Equ_b2_Node_Ptr(0),
    f_b2_Equ_e1_Node_Ptr(0),
    f_b2_Equ_c1_Node_Ptr(0),
    f_b2_Equ_c2_Node_Ptr(0),
    f_b1_Equ_s_Node_Ptr(0),
    f_b1_Equ_c1_Node_Ptr(0),
    f_s_Equ_s_Node_Ptr(0),
    f_s_Equ_c1_Node_Ptr(0),
    f_b1_Equ_c4_Node_Ptr(0),
    f_s_Equ_c4_Node_Ptr(0),
    f_b1_Equ_c2_Node_Ptr(0),
    f_s_Equ_c2_Node_Ptr(0),
    f_b1_Equ_b2_Node_Ptr(0),
    f_s_Equ_b2_Node_Ptr(0),
    f_s_Equ_b1_Node_Ptr(0),
    f_b_Equ_s_Node_Ptr(0),
    f_b_Equ_c1_Node_Ptr(0),
    f_b_Equ_c2_Node_Ptr(0),
    f_b_Equ_b2_Node_Ptr(0),
    f_b_Equ_e1_Node_Ptr(0),
    f_s_Equ_e1_Node_Ptr(0),
    f_b_Equ_c3_Node_Ptr(0),
    f_b_Equ_c4_Node_Ptr(0),
    f_s_Equ_c3_Node_Ptr(0),
    f_b_Equ_b1_Node_Ptr(0),
    f_b_Equ_b_Node_Ptr(0),
    f_s_Equ_b_Node_Ptr(0),
    f_b_Equ_c_Node_Ptr(0),
    f_s_Equ_c_Node_Ptr(0),
    f_c1_Equ_s_Node_Ptr(0),
    f_b1_Equ_c3_Node_Ptr(0),
    f_b2_Equ_c3_Node_Ptr(0),
    f_b2_Equ_c4_Node_Ptr(0),
    f_b1_Equ_b_Node_Ptr(0),
    f_b2_Equ_b_Node_Ptr(0),
    f_b2_Equ_b1_Node_Ptr(0),
    f_b1_Equ_c_Node_Ptr(0),
    f_b2_Equ_c_Node_Ptr(0),
    f_c2_Equ_c3_Node_Ptr(0),
    f_c2_Equ_c4_Node_Ptr(0),
    f_c2_Equ_b1_Node_Ptr(0),
    f_c2_Equ_b_Node_Ptr(0),
    f_c2_Equ_c_Node_Ptr(0),
    f_e_Equ_e_Node_Ptr(0),
    f_e_Equ_e1_Node_Ptr(0),
    f_e1_Equ_e_Node_Ptr(0),
    f_noi_Equ_noi_Node_Ptr(0),
    f_noi_Equ_e1_Node_Ptr(0),
    f_e1_Equ_noi_Node_Ptr(0),
    f_b2_Equ_noi_Node_Ptr(0),
    f_c2_Equ_noi_Node_Ptr(0),
    f_e1_Equ_c3_Node_Ptr(0),
    f_e1_Equ_c4_Node_Ptr(0),
    f_e1_Equ_b_Node_Ptr(0),
    f_e1_Equ_c_Node_Ptr(0),
    f_b_Equ_e_Node_Ptr(0),
    f_e_Equ_b_Node_Ptr(0),
    f_c_Equ_b_Node_Ptr(0),
    f_c_Equ_c_Node_Ptr(0),
    f_c3_Equ_s_Node_Ptr(0),
    f_c3_Equ_c1_Node_Ptr(0),
    f_c3_Equ_c2_Node_Ptr(0),
    f_c3_Equ_b2_Node_Ptr(0),
    f_c3_Equ_e1_Node_Ptr(0),
    f_c3_Equ_c3_Node_Ptr(0),
    f_c3_Equ_c4_Node_Ptr(0),
    f_c3_Equ_b1_Node_Ptr(0),
    f_c3_Equ_b_Node_Ptr(0),
    f_c3_Equ_c_Node_Ptr(0),
    f_c_Equ_c3_Node_Ptr(0),
    f_c_Equ_c4_Node_Ptr(0),
    f_c_Equ_c1_Node_Ptr(0),
    f_c_Equ_c2_Node_Ptr(0),
    f_c_Equ_b2_Node_Ptr(0),
    f_c_Equ_b1_Node_Ptr(0),
    f_c4_Equ_c4_Node_Ptr(0),
    f_c4_Equ_c1_Node_Ptr(0),
    f_c1_Equ_c4_Node_Ptr(0),
    f_c4_Equ_b2_Node_Ptr(0),
    f_c4_Equ_e1_Node_Ptr(0),
    f_c4_Equ_c2_Node_Ptr(0),
    f_c4_Equ_b1_Node_Ptr(0),
    f_c4_Equ_c3_Node_Ptr(0),
    f_c1_Equ_e1_Node_Ptr(0),
    f_c1_Equ_b1_Node_Ptr(0),
    f_c1_Equ_c3_Node_Ptr(0),
    f_c4_Equ_s_Node_Ptr(0),
    f_c4_Equ_b_Node_Ptr(0),
    f_c4_Equ_c_Node_Ptr(0),
    f_c1_Equ_b_Node_Ptr(0),
    f_c1_Equ_c_Node_Ptr(0),
    f_noi_Equ_b2_Node_Ptr(0),
    f_noi_Equ_c1_Node_Ptr(0),
    f_noi_Equ_c2_Node_Ptr(0),
    q_c1_Equ_c1_Node_Ptr(0),
    q_c1_Equ_c2_Node_Ptr(0),
    q_c2_Equ_c1_Node_Ptr(0),
    q_c2_Equ_c2_Node_Ptr(0),
    q_c1_Equ_b2_Node_Ptr(0),
    q_c2_Equ_b2_Node_Ptr(0),
    q_e1_Equ_c1_Node_Ptr(0),
    q_e1_Equ_c2_Node_Ptr(0),
    q_e1_Equ_b2_Node_Ptr(0),
    q_c2_Equ_e1_Node_Ptr(0),
    q_e1_Equ_e1_Node_Ptr(0),
    q_b1_Equ_b1_Node_Ptr(0),
    q_b1_Equ_e1_Node_Ptr(0),
    q_e1_Equ_b1_Node_Ptr(0),
    q_b2_Equ_b2_Node_Ptr(0),
    q_b2_Equ_e1_Node_Ptr(0),
    q_b2_Equ_c1_Node_Ptr(0),
    q_b2_Equ_c2_Node_Ptr(0),
    q_b1_Equ_s_Node_Ptr(0),
    q_b1_Equ_c1_Node_Ptr(0),
    q_s_Equ_s_Node_Ptr(0),
    q_s_Equ_c1_Node_Ptr(0),
    q_b1_Equ_c4_Node_Ptr(0),
    q_s_Equ_c4_Node_Ptr(0),
    q_b1_Equ_c2_Node_Ptr(0),
    q_s_Equ_c2_Node_Ptr(0),
    q_b1_Equ_b2_Node_Ptr(0),
    q_s_Equ_b2_Node_Ptr(0),
    q_s_Equ_b1_Node_Ptr(0),
    q_b_Equ_s_Node_Ptr(0),
    q_b_Equ_c1_Node_Ptr(0),
    q_b_Equ_c2_Node_Ptr(0),
    q_b_Equ_b2_Node_Ptr(0),
    q_b_Equ_e1_Node_Ptr(0),
    q_s_Equ_e1_Node_Ptr(0),
    q_b_Equ_c3_Node_Ptr(0),
    q_b_Equ_c4_Node_Ptr(0),
    q_s_Equ_c3_Node_Ptr(0),
    q_b_Equ_b1_Node_Ptr(0),
    q_b_Equ_b_Node_Ptr(0),
    q_s_Equ_b_Node_Ptr(0),
    q_b_Equ_c_Node_Ptr(0),
    q_s_Equ_c_Node_Ptr(0),
    q_c1_Equ_s_Node_Ptr(0),
    q_b1_Equ_c3_Node_Ptr(0),
    q_b2_Equ_c3_Node_Ptr(0),
    q_b2_Equ_c4_Node_Ptr(0),
    q_b1_Equ_b_Node_Ptr(0),
    q_b2_Equ_b_Node_Ptr(0),
    q_b2_Equ_b1_Node_Ptr(0),
    q_b1_Equ_c_Node_Ptr(0),
    q_b2_Equ_c_Node_Ptr(0),
    q_c2_Equ_c3_Node_Ptr(0),
    q_c2_Equ_c4_Node_Ptr(0),
    q_c2_Equ_b1_Node_Ptr(0),
    q_c2_Equ_b_Node_Ptr(0),
    q_c2_Equ_c_Node_Ptr(0),
    q_e_Equ_e_Node_Ptr(0),
    q_e_Equ_e1_Node_Ptr(0),
    q_e1_Equ_e_Node_Ptr(0),
    q_noi_Equ_noi_Node_Ptr(0),
    q_noi_Equ_e1_Node_Ptr(0),
    q_e1_Equ_noi_Node_Ptr(0),
    q_b2_Equ_noi_Node_Ptr(0),
    q_c2_Equ_noi_Node_Ptr(0),
    q_e1_Equ_c3_Node_Ptr(0),
    q_e1_Equ_c4_Node_Ptr(0),
    q_e1_Equ_b_Node_Ptr(0),
    q_e1_Equ_c_Node_Ptr(0),
    q_b_Equ_e_Node_Ptr(0),
    q_e_Equ_b_Node_Ptr(0),
    q_c_Equ_b_Node_Ptr(0),
    q_c_Equ_c_Node_Ptr(0),
    q_c3_Equ_s_Node_Ptr(0),
    q_c3_Equ_c1_Node_Ptr(0),
    q_c3_Equ_c2_Node_Ptr(0),
    q_c3_Equ_b2_Node_Ptr(0),
    q_c3_Equ_e1_Node_Ptr(0),
    q_c3_Equ_c3_Node_Ptr(0),
    q_c3_Equ_c4_Node_Ptr(0),
    q_c3_Equ_b1_Node_Ptr(0),
    q_c3_Equ_b_Node_Ptr(0),
    q_c3_Equ_c_Node_Ptr(0),
    q_c_Equ_c3_Node_Ptr(0),
    q_c_Equ_c4_Node_Ptr(0),
    q_c_Equ_c1_Node_Ptr(0),
    q_c_Equ_c2_Node_Ptr(0),
    q_c_Equ_b2_Node_Ptr(0),
    q_c_Equ_b1_Node_Ptr(0),
    q_c4_Equ_c4_Node_Ptr(0),
    q_c4_Equ_c1_Node_Ptr(0),
    q_c1_Equ_c4_Node_Ptr(0),
    q_c4_Equ_b2_Node_Ptr(0),
    q_c4_Equ_e1_Node_Ptr(0),
    q_c4_Equ_c2_Node_Ptr(0),
    q_c4_Equ_b1_Node_Ptr(0),
    q_c4_Equ_c3_Node_Ptr(0),
    q_c1_Equ_e1_Node_Ptr(0),
    q_c1_Equ_b1_Node_Ptr(0),
    q_c1_Equ_c3_Node_Ptr(0),
    q_c4_Equ_s_Node_Ptr(0),
    q_c4_Equ_b_Node_Ptr(0),
    q_c4_Equ_c_Node_Ptr(0),
    q_c1_Equ_b_Node_Ptr(0),
    q_c1_Equ_c_Node_Ptr(0),
    q_noi_Equ_b2_Node_Ptr(0),
    q_noi_Equ_c1_Node_Ptr(0),
    q_noi_Equ_c2_Node_Ptr(0),
    A_c1_Equ_c1_NodeOffset(-1),
    A_c1_Equ_c2_NodeOffset(-1),
    A_c2_Equ_c1_NodeOffset(-1),
    A_c2_Equ_c2_NodeOffset(-1),
    A_c1_Equ_b2_NodeOffset(-1),
    A_c2_Equ_b2_NodeOffset(-1),
    A_e1_Equ_c1_NodeOffset(-1),
    A_e1_Equ_c2_NodeOffset(-1),
    A_e1_Equ_b2_NodeOffset(-1),
    A_c2_Equ_e1_NodeOffset(-1),
    A_e1_Equ_e1_NodeOffset(-1),
    A_b1_Equ_b1_NodeOffset(-1),
    A_b1_Equ_e1_NodeOffset(-1),
    A_e1_Equ_b1_NodeOffset(-1),
    A_b2_Equ_b2_NodeOffset(-1),
    A_b2_Equ_e1_NodeOffset(-1),
    A_b2_Equ_c1_NodeOffset(-1),
    A_b2_Equ_c2_NodeOffset(-1),
    A_b1_Equ_s_NodeOffset(-1),
    A_b1_Equ_c1_NodeOffset(-1),
    A_s_Equ_s_NodeOffset(-1),
    A_s_Equ_c1_NodeOffset(-1),
    A_b1_Equ_c4_NodeOffset(-1),
    A_s_Equ_c4_NodeOffset(-1),
    A_b1_Equ_c2_NodeOffset(-1),
    A_s_Equ_c2_NodeOffset(-1),
    A_b1_Equ_b2_NodeOffset(-1),
    A_s_Equ_b2_NodeOffset(-1),
    A_s_Equ_b1_NodeOffset(-1),
    A_b_Equ_s_NodeOffset(-1),
    A_b_Equ_c1_NodeOffset(-1),
    A_b_Equ_c2_NodeOffset(-1),
    A_b_Equ_b2_NodeOffset(-1),
    A_b_Equ_e1_NodeOffset(-1),
    A_s_Equ_e1_NodeOffset(-1),
    A_b_Equ_c3_NodeOffset(-1),
    A_b_Equ_c4_NodeOffset(-1),
    A_s_Equ_c3_NodeOffset(-1),
    A_b_Equ_b1_NodeOffset(-1),
    A_b_Equ_b_NodeOffset(-1),
    A_s_Equ_b_NodeOffset(-1),
    A_b_Equ_c_NodeOffset(-1),
    A_s_Equ_c_NodeOffset(-1),
    A_c1_Equ_s_NodeOffset(-1),
    A_b1_Equ_c3_NodeOffset(-1),
    A_b2_Equ_c3_NodeOffset(-1),
    A_b2_Equ_c4_NodeOffset(-1),
    A_b1_Equ_b_NodeOffset(-1),
    A_b2_Equ_b_NodeOffset(-1),
    A_b2_Equ_b1_NodeOffset(-1),
    A_b1_Equ_c_NodeOffset(-1),
    A_b2_Equ_c_NodeOffset(-1),
    A_c2_Equ_c3_NodeOffset(-1),
    A_c2_Equ_c4_NodeOffset(-1),
    A_c2_Equ_b1_NodeOffset(-1),
    A_c2_Equ_b_NodeOffset(-1),
    A_c2_Equ_c_NodeOffset(-1),
    A_e_Equ_e_NodeOffset(-1),
    A_e_Equ_e1_NodeOffset(-1),
    A_e1_Equ_e_NodeOffset(-1),
    A_noi_Equ_noi_NodeOffset(-1),
    A_noi_Equ_e1_NodeOffset(-1),
    A_e1_Equ_noi_NodeOffset(-1),
    A_b2_Equ_noi_NodeOffset(-1),
    A_c2_Equ_noi_NodeOffset(-1),
    A_e1_Equ_c3_NodeOffset(-1),
    A_e1_Equ_c4_NodeOffset(-1),
    A_e1_Equ_b_NodeOffset(-1),
    A_e1_Equ_c_NodeOffset(-1),
    A_b_Equ_e_NodeOffset(-1),
    A_e_Equ_b_NodeOffset(-1),
    A_c_Equ_b_NodeOffset(-1),
    A_c_Equ_c_NodeOffset(-1),
    A_c3_Equ_s_NodeOffset(-1),
    A_c3_Equ_c1_NodeOffset(-1),
    A_c3_Equ_c2_NodeOffset(-1),
    A_c3_Equ_b2_NodeOffset(-1),
    A_c3_Equ_e1_NodeOffset(-1),
    A_c3_Equ_c3_NodeOffset(-1),
    A_c3_Equ_c4_NodeOffset(-1),
    A_c3_Equ_b1_NodeOffset(-1),
    A_c3_Equ_b_NodeOffset(-1),
    A_c3_Equ_c_NodeOffset(-1),
    A_c_Equ_c3_NodeOffset(-1),
    A_c_Equ_c4_NodeOffset(-1),
    A_c_Equ_c1_NodeOffset(-1),
    A_c_Equ_c2_NodeOffset(-1),
    A_c_Equ_b2_NodeOffset(-1),
    A_c_Equ_b1_NodeOffset(-1),
    A_c4_Equ_c4_NodeOffset(-1),
    A_c4_Equ_c1_NodeOffset(-1),
    A_c1_Equ_c4_NodeOffset(-1),
    A_c4_Equ_b2_NodeOffset(-1),
    A_c4_Equ_e1_NodeOffset(-1),
    A_c4_Equ_c2_NodeOffset(-1),
    A_c4_Equ_b1_NodeOffset(-1),
    A_c4_Equ_c3_NodeOffset(-1),
    A_c1_Equ_e1_NodeOffset(-1),
    A_c1_Equ_b1_NodeOffset(-1),
    A_c1_Equ_c3_NodeOffset(-1),
    A_c4_Equ_s_NodeOffset(-1),
    A_c4_Equ_b_NodeOffset(-1),
    A_c4_Equ_c_NodeOffset(-1),
    A_c1_Equ_b_NodeOffset(-1),
    A_c1_Equ_c_NodeOffset(-1),
    A_noi_Equ_b2_NodeOffset(-1),
    A_noi_Equ_c1_NodeOffset(-1),
    A_noi_Equ_c2_NodeOffset(-1),
    admsTemperature(getDeviceOptions().temp.getImmutableValue<double>())

{
  numIntVars = 8 + 0;
  numExtVars = 4;


  // Right now, we only have store for limited probes...
  setNumStoreVars(4);


  // Set up jacobian stamp:
  // Create a vector of the non-zero elements of the stamp
  PairVector jacobianElements;
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_noi));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_e1,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_b1,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_b2,admsNodeID_noi));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_c1,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_c2,admsNodeID_noi));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_c3,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_c4));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_c2));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_b1));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_c3));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_c4,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_noi,admsNodeID_noi));
  jacobianElements.push_back(IntPair(admsNodeID_noi,admsNodeID_e1));
  jacobianElements.push_back(IntPair(admsNodeID_noi,admsNodeID_b2));
  jacobianElements.push_back(IntPair(admsNodeID_noi,admsNodeID_c1));
  jacobianElements.push_back(IntPair(admsNodeID_noi,admsNodeID_c2));

  

  setDefaultParams();
  setParams(instance_block.params);

  // Real bogosity here...
  if (!given("XYCEADMSINSTTEMP"))
    admsInstTemp=getDeviceOptions().temp.getImmutableValue<double>();

  //calculate any parameters specified as expressions
  updateDependentParameters();

  // calculate dependent (i.e. computed params) and check for errors.
  processParams();

  PairVector collapsedNodes;
  collapseNodes();

  if (collapseNode_c1)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_c1,admsNodeID_c4));
  }
  if (collapseNode_c4)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_c4,admsNodeID_c3));
  }

  // Now generate the jacstamp from what we already have.
  // This jacstamp will have all the correct node mapping.  map will be the nodal mapping of original
  // node IDs to row/column ids in the reduced (non-sparse) representation of the jacobian.
  // (for devices that have no collapsibles, this will be static, so check that it hasn't already
  // been filled in)
  if (jacStamp.empty())
  {
    int originalSize = 12+0;
    computeJacStampAndMaps(jacobianElements,collapsedNodes,jacStamp,nodeMap,pairToJacStampMap,originalSize);
  }

}

//-----------------------------------------------------------------------------
// Function      : Instance::collapseNodes
// Purpose       : function to handle collapsing of nodes
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::collapseNodes()
{
  collapseNode_c1 = false;
  collapseNode_c4 = false;
  if (((model_.RCBLX)>0.0))
  {

    if (!(((model_.RCBLI)>0.0)))
    {

      collapseNode_c1 = true;

    }

  }

  else
  {

    collapseNode_c4 = true;

    if (!(((model_.RCBLI)>0.0)))
    {

      collapseNode_c1 = true;

    }

  }


  if (collapseNode_c1)
  {
    numIntVars--;
  }
  if (collapseNode_c4)
  {
    numIntVars--;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::~Instance
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
Instance::~Instance()
{
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerLIDs
// Purpose       : function for registering, and setting up, local ID's.
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerLIDs( const LocalIdVector & intLIDVecRef,
                             const LocalIdVector & extLIDVecRef)
{
  AssertLIDs(intLIDVecRef.size() == numIntVars);
  AssertLIDs(extLIDVecRef.size() == numExtVars);

  LocalIdVector localLIDVec;
  
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << std::endl << section_divider << std::endl
                 << "In ADMSbjt504va::Instance::register LIDs\n\n"
                 << "name             = " << getName() << std::endl
                 << "number of internal variables: " << numIntVars << std::endl
                 << "number of external variables: " << numExtVars << std::endl;
  }

  // copy over the global ID lists into a local array.
  // The end result of this is an array of LIDs corresponding to all the
  // nodes we actually have, in the order that topology thinks of them
  intLIDVec = intLIDVecRef;
  extLIDVec = extLIDVecRef;
  localLIDVec.resize(numExtVars+numIntVars);
  for (int localNodeIndex=0;localNodeIndex<numExtVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=extLIDVec[localNodeIndex];
  }
  for (int localNodeIndex=numExtVars;localNodeIndex<numExtVars+numIntVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=intLIDVec[localNodeIndex-numExtVars];
  }
    
  // Now pull the LIDs for each of our nodes out of the local array.
  // Use the node mapping created by createJacStampAndMaps to handle
  // all the node collapse complications.
  li_c = localLIDVec[nodeMap[admsNodeID_c]];
  li_b = localLIDVec[nodeMap[admsNodeID_b]];
  li_e = localLIDVec[nodeMap[admsNodeID_e]];
  li_s = localLIDVec[nodeMap[admsNodeID_s]];
  li_e1 = localLIDVec[nodeMap[admsNodeID_e1]];
  li_b1 = localLIDVec[nodeMap[admsNodeID_b1]];
  li_b2 = localLIDVec[nodeMap[admsNodeID_b2]];
  li_c1 = localLIDVec[nodeMap[admsNodeID_c1]];
  li_c2 = localLIDVec[nodeMap[admsNodeID_c2]];
  li_c3 = localLIDVec[nodeMap[admsNodeID_c3]];
  li_c4 = localLIDVec[nodeMap[admsNodeID_c4]];
  li_noi = localLIDVec[nodeMap[admsNodeID_noi]];


  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << "\nSolution and RHS variables:\n";
    Xyce::dout() << "\nli_c = " << li_c << std::endl;
    Xyce::dout() << "\nli_b = " << li_b << std::endl;
    Xyce::dout() << "\nli_e = " << li_e << std::endl;
    Xyce::dout() << "\nli_s = " << li_s << std::endl;
    Xyce::dout() << "\nli_e1 = " << li_e1 << std::endl;
    Xyce::dout() << "\nli_b1 = " << li_b1 << std::endl;
    Xyce::dout() << "\nli_b2 = " << li_b2 << std::endl;
    Xyce::dout() << "\nli_c1 = " << li_c1 << std::endl;
    Xyce::dout() << "\nli_c2 = " << li_c2 << std::endl;
    Xyce::dout() << "\nli_c3 = " << li_c3 << std::endl;
    Xyce::dout() << "\nli_c4 = " << li_c4 << std::endl;
    Xyce::dout() << "\nli_noi = " << li_noi << std::endl;

    Xyce::dout() << "\nEnd of ADMSbjt504va::Instance::register LIDs\n";
    Xyce::dout() << section_divider << std::endl;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadNodeSymbols
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::loadNodeSymbols(Util::SymbolTable &symbol_table) const
{
  addInternalNode(symbol_table, li_e1, getName(), "e1");
  addInternalNode(symbol_table, li_b1, getName(), "b1");
  addInternalNode(symbol_table, li_b2, getName(), "b2");
  if (!collapseNode_c1)
  {
    addInternalNode(symbol_table, li_c1, getName(), "c1");
  }
  addInternalNode(symbol_table, li_c2, getName(), "c2");
  addInternalNode(symbol_table, li_c3, getName(), "c3");
  if (!collapseNode_c4)
  {
    addInternalNode(symbol_table, li_c4, getName(), "c4");
  }
  addInternalNode(symbol_table, li_noi, getName(), "noi");
}
 
//-----------------------------------------------------------------------------
// Function      : Instance::registerStoreLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerStoreLIDs( const LocalIdVector & stoLIDVecRef)
{
  AssertLIDs(stoLIDVecRef.size() == getNumStoreVars());

  int numSto = stoLIDVecRef.size();
  if (numSto > 0)
  {
    int i=0;
    stoLIDVec = stoLIDVecRef;

    li_store_admsProbeID_V_b2_c1 = stoLIDVec[i++];
    li_store_admsProbeID_V_b2_c2 = stoLIDVec[i++];
    li_store_admsProbeID_V_b1_e1 = stoLIDVec[i++];
    li_store_admsProbeID_V_b1_b2 = stoLIDVec[i++];
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::jacobianStamp
// Purpose       :
// Special Notes : In initial version, we won't support mapping away nodes
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
const JacobianStamp & Instance::jacobianStamp() const
{
  return jacStamp;
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerJacLIDs
// Purpose       : Create Offset variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerJacLIDs( const JacobianStamp & jacLIDVec)
{
  DeviceInstance::registerJacLIDs(jacLIDVec);  IntPair jacLoc;
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_b)];
  A_c_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_c)];
  A_c_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_c3)];
  A_c_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_c4)];
  A_c_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_c1)];
  A_c_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_c2)];
  A_c_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_b2)];
  A_c_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_b1)];
  A_c_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_s)];
  A_b_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_c1)];
  A_b_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_c2)];
  A_b_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_b2)];
  A_b_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_e1)];
  A_b_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_c3)];
  A_b_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_c4)];
  A_b_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_b1)];
  A_b_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_b)];
  A_b_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_c)];
  A_b_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_e)];
  A_b_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_e)];
  A_e_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_e1)];
  A_e_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_b)];
  A_e_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_s)];
  A_s_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_c1)];
  A_s_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_c4)];
  A_s_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_c2)];
  A_s_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_b2)];
  A_s_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_b1)];
  A_s_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_e1)];
  A_s_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_c3)];
  A_s_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_b)];
  A_s_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_c)];
  A_s_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_c1)];
  A_e1_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_c2)];
  A_e1_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_b2)];
  A_e1_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_e1)];
  A_e1_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_b1)];
  A_e1_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_e)];
  A_e1_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_noi)];
  A_e1_Equ_noi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_c3)];
  A_e1_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_c4)];
  A_e1_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_b)];
  A_e1_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e1,admsNodeID_c)];
  A_e1_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_b1)];
  A_b1_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_e1)];
  A_b1_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_s)];
  A_b1_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_c1)];
  A_b1_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_c4)];
  A_b1_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_c2)];
  A_b1_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_b2)];
  A_b1_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_c3)];
  A_b1_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_b)];
  A_b1_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b1,admsNodeID_c)];
  A_b1_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_b2)];
  A_b2_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_e1)];
  A_b2_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_c1)];
  A_b2_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_c2)];
  A_b2_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_c3)];
  A_b2_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_c4)];
  A_b2_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_b)];
  A_b2_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_b1)];
  A_b2_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_c)];
  A_b2_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b2,admsNodeID_noi)];
  A_b2_Equ_noi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_c1)];
  A_c1_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_c2)];
  A_c1_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_b2)];
  A_c1_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_s)];
  A_c1_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_c4)];
  A_c1_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_e1)];
  A_c1_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_b1)];
  A_c1_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_c3)];
  A_c1_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_b)];
  A_c1_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c1,admsNodeID_c)];
  A_c1_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_c1)];
  A_c2_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_c2)];
  A_c2_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_b2)];
  A_c2_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_e1)];
  A_c2_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_c3)];
  A_c2_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_c4)];
  A_c2_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_b1)];
  A_c2_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_b)];
  A_c2_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_c)];
  A_c2_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c2,admsNodeID_noi)];
  A_c2_Equ_noi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_s)];
  A_c3_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_c1)];
  A_c3_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_c2)];
  A_c3_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_b2)];
  A_c3_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_e1)];
  A_c3_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_c3)];
  A_c3_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_c4)];
  A_c3_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_b1)];
  A_c3_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_b)];
  A_c3_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c3,admsNodeID_c)];
  A_c3_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_c4)];
  A_c4_Equ_c4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_c1)];
  A_c4_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_b2)];
  A_c4_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_e1)];
  A_c4_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_c2)];
  A_c4_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_b1)];
  A_c4_Equ_b1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_c3)];
  A_c4_Equ_c3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_s)];
  A_c4_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_b)];
  A_c4_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c4,admsNodeID_c)];
  A_c4_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_noi,admsNodeID_noi)];
  A_noi_Equ_noi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_noi,admsNodeID_e1)];
  A_noi_Equ_e1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_noi,admsNodeID_b2)];
  A_noi_Equ_b2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_noi,admsNodeID_c1)];
  A_noi_Equ_c1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_noi,admsNodeID_c2)];
  A_noi_Equ_c2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];


}

//-----------------------------------------------------------------------------
// Function      : Instance::setupPointers
// Purpose       : Create pointer variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupPointers( )
{

  Linear::Matrix * dFdxMatPtr = extData.dFdxMatrixPtr;
  Linear::Matrix * dQdxMatPtr = extData.dQdxMatrixPtr;
  f_c_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_b);
  q_c_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_b);
  f_c_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_c);
  q_c_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_c);
  f_c_Equ_c3_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_c3);
  q_c_Equ_c3_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_c3);
  f_c_Equ_c4_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_c4);
  q_c_Equ_c4_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_c4);
  f_c_Equ_c1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_c1);
  q_c_Equ_c1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_c1);
  f_c_Equ_c2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_c2);
  q_c_Equ_c2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_c2);
  f_c_Equ_b2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_b2);
  q_c_Equ_b2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_b2);
  f_c_Equ_b1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c,li_b1);
  q_c_Equ_b1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c,li_b1);
  f_b_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_s);
  q_b_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_s);
  f_b_Equ_c1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_c1);
  q_b_Equ_c1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_c1);
  f_b_Equ_c2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_c2);
  q_b_Equ_c2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_c2);
  f_b_Equ_b2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_b2);
  q_b_Equ_b2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_b2);
  f_b_Equ_e1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_e1);
  q_b_Equ_e1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_e1);
  f_b_Equ_c3_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_c3);
  q_b_Equ_c3_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_c3);
  f_b_Equ_c4_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_c4);
  q_b_Equ_c4_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_c4);
  f_b_Equ_b1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_b1);
  q_b_Equ_b1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_b1);
  f_b_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_b);
  q_b_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_b);
  f_b_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_c);
  q_b_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_c);
  f_b_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b,li_e);
  q_b_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b,li_e);
  f_e_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_e);
  q_e_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_e);
  f_e_Equ_e1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_e1);
  q_e_Equ_e1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_e1);
  f_e_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e,li_b);
  q_e_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e,li_b);
  f_s_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_s);
  q_s_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_s);
  f_s_Equ_c1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_c1);
  q_s_Equ_c1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_c1);
  f_s_Equ_c4_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_c4);
  q_s_Equ_c4_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_c4);
  f_s_Equ_c2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_c2);
  q_s_Equ_c2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_c2);
  f_s_Equ_b2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_b2);
  q_s_Equ_b2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_b2);
  f_s_Equ_b1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_b1);
  q_s_Equ_b1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_b1);
  f_s_Equ_e1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_e1);
  q_s_Equ_e1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_e1);
  f_s_Equ_c3_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_c3);
  q_s_Equ_c3_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_c3);
  f_s_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_b);
  q_s_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_b);
  f_s_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_s,li_c);
  q_s_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_s,li_c);
  f_e1_Equ_c1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e1,li_c1);
  q_e1_Equ_c1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e1,li_c1);
  f_e1_Equ_c2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e1,li_c2);
  q_e1_Equ_c2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e1,li_c2);
  f_e1_Equ_b2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e1,li_b2);
  q_e1_Equ_b2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e1,li_b2);
  f_e1_Equ_e1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e1,li_e1);
  q_e1_Equ_e1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e1,li_e1);
  f_e1_Equ_b1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e1,li_b1);
  q_e1_Equ_b1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e1,li_b1);
  f_e1_Equ_e_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e1,li_e);
  q_e1_Equ_e_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e1,li_e);
  f_e1_Equ_noi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e1,li_noi);
  q_e1_Equ_noi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e1,li_noi);
  f_e1_Equ_c3_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e1,li_c3);
  q_e1_Equ_c3_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e1,li_c3);
  f_e1_Equ_c4_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e1,li_c4);
  q_e1_Equ_c4_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e1,li_c4);
  f_e1_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e1,li_b);
  q_e1_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e1,li_b);
  f_e1_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_e1,li_c);
  q_e1_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_e1,li_c);
  f_b1_Equ_b1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b1,li_b1);
  q_b1_Equ_b1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b1,li_b1);
  f_b1_Equ_e1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b1,li_e1);
  q_b1_Equ_e1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b1,li_e1);
  f_b1_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b1,li_s);
  q_b1_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b1,li_s);
  f_b1_Equ_c1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b1,li_c1);
  q_b1_Equ_c1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b1,li_c1);
  f_b1_Equ_c4_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b1,li_c4);
  q_b1_Equ_c4_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b1,li_c4);
  f_b1_Equ_c2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b1,li_c2);
  q_b1_Equ_c2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b1,li_c2);
  f_b1_Equ_b2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b1,li_b2);
  q_b1_Equ_b2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b1,li_b2);
  f_b1_Equ_c3_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b1,li_c3);
  q_b1_Equ_c3_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b1,li_c3);
  f_b1_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b1,li_b);
  q_b1_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b1,li_b);
  f_b1_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b1,li_c);
  q_b1_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b1,li_c);
  f_b2_Equ_b2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b2,li_b2);
  q_b2_Equ_b2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b2,li_b2);
  f_b2_Equ_e1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b2,li_e1);
  q_b2_Equ_e1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b2,li_e1);
  f_b2_Equ_c1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b2,li_c1);
  q_b2_Equ_c1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b2,li_c1);
  f_b2_Equ_c2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b2,li_c2);
  q_b2_Equ_c2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b2,li_c2);
  f_b2_Equ_c3_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b2,li_c3);
  q_b2_Equ_c3_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b2,li_c3);
  f_b2_Equ_c4_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b2,li_c4);
  q_b2_Equ_c4_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b2,li_c4);
  f_b2_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b2,li_b);
  q_b2_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b2,li_b);
  f_b2_Equ_b1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b2,li_b1);
  q_b2_Equ_b1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b2,li_b1);
  f_b2_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b2,li_c);
  q_b2_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b2,li_c);
  f_b2_Equ_noi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_b2,li_noi);
  q_b2_Equ_noi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_b2,li_noi);
  f_c1_Equ_c1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c1,li_c1);
  q_c1_Equ_c1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c1,li_c1);
  f_c1_Equ_c2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c1,li_c2);
  q_c1_Equ_c2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c1,li_c2);
  f_c1_Equ_b2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c1,li_b2);
  q_c1_Equ_b2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c1,li_b2);
  f_c1_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c1,li_s);
  q_c1_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c1,li_s);
  f_c1_Equ_c4_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c1,li_c4);
  q_c1_Equ_c4_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c1,li_c4);
  f_c1_Equ_e1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c1,li_e1);
  q_c1_Equ_e1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c1,li_e1);
  f_c1_Equ_b1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c1,li_b1);
  q_c1_Equ_b1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c1,li_b1);
  f_c1_Equ_c3_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c1,li_c3);
  q_c1_Equ_c3_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c1,li_c3);
  f_c1_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c1,li_b);
  q_c1_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c1,li_b);
  f_c1_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c1,li_c);
  q_c1_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c1,li_c);
  f_c2_Equ_c1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c2,li_c1);
  q_c2_Equ_c1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c2,li_c1);
  f_c2_Equ_c2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c2,li_c2);
  q_c2_Equ_c2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c2,li_c2);
  f_c2_Equ_b2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c2,li_b2);
  q_c2_Equ_b2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c2,li_b2);
  f_c2_Equ_e1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c2,li_e1);
  q_c2_Equ_e1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c2,li_e1);
  f_c2_Equ_c3_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c2,li_c3);
  q_c2_Equ_c3_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c2,li_c3);
  f_c2_Equ_c4_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c2,li_c4);
  q_c2_Equ_c4_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c2,li_c4);
  f_c2_Equ_b1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c2,li_b1);
  q_c2_Equ_b1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c2,li_b1);
  f_c2_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c2,li_b);
  q_c2_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c2,li_b);
  f_c2_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c2,li_c);
  q_c2_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c2,li_c);
  f_c2_Equ_noi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c2,li_noi);
  q_c2_Equ_noi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c2,li_noi);
  f_c3_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c3,li_s);
  q_c3_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c3,li_s);
  f_c3_Equ_c1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c3,li_c1);
  q_c3_Equ_c1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c3,li_c1);
  f_c3_Equ_c2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c3,li_c2);
  q_c3_Equ_c2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c3,li_c2);
  f_c3_Equ_b2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c3,li_b2);
  q_c3_Equ_b2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c3,li_b2);
  f_c3_Equ_e1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c3,li_e1);
  q_c3_Equ_e1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c3,li_e1);
  f_c3_Equ_c3_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c3,li_c3);
  q_c3_Equ_c3_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c3,li_c3);
  f_c3_Equ_c4_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c3,li_c4);
  q_c3_Equ_c4_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c3,li_c4);
  f_c3_Equ_b1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c3,li_b1);
  q_c3_Equ_b1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c3,li_b1);
  f_c3_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c3,li_b);
  q_c3_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c3,li_b);
  f_c3_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c3,li_c);
  q_c3_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c3,li_c);
  f_c4_Equ_c4_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c4,li_c4);
  q_c4_Equ_c4_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c4,li_c4);
  f_c4_Equ_c1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c4,li_c1);
  q_c4_Equ_c1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c4,li_c1);
  f_c4_Equ_b2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c4,li_b2);
  q_c4_Equ_b2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c4,li_b2);
  f_c4_Equ_e1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c4,li_e1);
  q_c4_Equ_e1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c4,li_e1);
  f_c4_Equ_c2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c4,li_c2);
  q_c4_Equ_c2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c4,li_c2);
  f_c4_Equ_b1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c4,li_b1);
  q_c4_Equ_b1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c4,li_b1);
  f_c4_Equ_c3_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c4,li_c3);
  q_c4_Equ_c3_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c4,li_c3);
  f_c4_Equ_s_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c4,li_s);
  q_c4_Equ_s_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c4,li_s);
  f_c4_Equ_b_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c4,li_b);
  q_c4_Equ_b_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c4,li_b);
  f_c4_Equ_c_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_c4,li_c);
  q_c4_Equ_c_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_c4,li_c);
  f_noi_Equ_noi_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_noi,li_noi);
  q_noi_Equ_noi_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_noi,li_noi);
  f_noi_Equ_e1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_noi,li_e1);
  q_noi_Equ_e1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_noi,li_e1);
  f_noi_Equ_b2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_noi,li_b2);
  q_noi_Equ_b2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_noi,li_b2);
  f_noi_Equ_c1_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_noi,li_c1);
  q_noi_Equ_c1_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_noi,li_c1);
  f_noi_Equ_c2_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_noi,li_c2);
  q_noi_Equ_c2_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_noi,li_c2);


}

// RHS load functions

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEFVector
// Purpose       : load F vector (static contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEFVector()
{

  bool bsuccess=true;
  (*extData.daeFVectorPtr)[li_c] += staticContributions[admsNodeID_c].val();
  (*extData.daeFVectorPtr)[li_b] += staticContributions[admsNodeID_b].val();
  (*extData.daeFVectorPtr)[li_e] += staticContributions[admsNodeID_e].val();
  (*extData.daeFVectorPtr)[li_s] += staticContributions[admsNodeID_s].val();
  (*extData.daeFVectorPtr)[li_e1] += staticContributions[admsNodeID_e1].val();
  (*extData.daeFVectorPtr)[li_b1] += staticContributions[admsNodeID_b1].val();
  (*extData.daeFVectorPtr)[li_b2] += staticContributions[admsNodeID_b2].val();
  (*extData.daeFVectorPtr)[li_c1] += staticContributions[admsNodeID_c1].val();
  (*extData.daeFVectorPtr)[li_c2] += staticContributions[admsNodeID_c2].val();
  (*extData.daeFVectorPtr)[li_c3] += staticContributions[admsNodeID_c3].val();
  (*extData.daeFVectorPtr)[li_c4] += staticContributions[admsNodeID_c4].val();
  (*extData.daeFVectorPtr)[li_noi] += staticContributions[admsNodeID_noi].val();

  if (getDeviceOptions().voltageLimiterFlag && !origFlag)
  {
    double *dFdxdVp = extData.dFdxdVpVectorRawPtr;dFdxdVp[li_c] += Jdxp_static[admsNodeID_c];
    dFdxdVp[li_b] += Jdxp_static[admsNodeID_b];
    dFdxdVp[li_e] += Jdxp_static[admsNodeID_e];
    dFdxdVp[li_s] += Jdxp_static[admsNodeID_s];
    dFdxdVp[li_e1] += Jdxp_static[admsNodeID_e1];
    dFdxdVp[li_b1] += Jdxp_static[admsNodeID_b1];
    dFdxdVp[li_b2] += Jdxp_static[admsNodeID_b2];
    dFdxdVp[li_c1] += Jdxp_static[admsNodeID_c1];
    dFdxdVp[li_c2] += Jdxp_static[admsNodeID_c2];
    dFdxdVp[li_c3] += Jdxp_static[admsNodeID_c3];
    dFdxdVp[li_c4] += Jdxp_static[admsNodeID_c4];
    dFdxdVp[li_noi] += Jdxp_static[admsNodeID_noi];


  }

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEQVector
// Purpose       : load Q vector (dynamic contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEQVector()
{
  (*extData.daeQVectorPtr)[li_c] += dynamicContributions[admsNodeID_c].val();
  (*extData.daeQVectorPtr)[li_b] += dynamicContributions[admsNodeID_b].val();
  (*extData.daeQVectorPtr)[li_e] += dynamicContributions[admsNodeID_e].val();
  (*extData.daeQVectorPtr)[li_s] += dynamicContributions[admsNodeID_s].val();
  (*extData.daeQVectorPtr)[li_e1] += dynamicContributions[admsNodeID_e1].val();
  (*extData.daeQVectorPtr)[li_b1] += dynamicContributions[admsNodeID_b1].val();
  (*extData.daeQVectorPtr)[li_b2] += dynamicContributions[admsNodeID_b2].val();
  (*extData.daeQVectorPtr)[li_c1] += dynamicContributions[admsNodeID_c1].val();
  (*extData.daeQVectorPtr)[li_c2] += dynamicContributions[admsNodeID_c2].val();
  (*extData.daeQVectorPtr)[li_c3] += dynamicContributions[admsNodeID_c3].val();
  (*extData.daeQVectorPtr)[li_c4] += dynamicContributions[admsNodeID_c4].val();
  (*extData.daeQVectorPtr)[li_noi] += dynamicContributions[admsNodeID_noi].val();

  if (getDeviceOptions().voltageLimiterFlag && !origFlag)
  {
    double *dQdxdVp = extData.dQdxdVpVectorRawPtr;dQdxdVp[li_c] += Jdxp_dynamic[admsNodeID_c];
    dQdxdVp[li_b] += Jdxp_dynamic[admsNodeID_b];
    dQdxdVp[li_e] += Jdxp_dynamic[admsNodeID_e];
    dQdxdVp[li_s] += Jdxp_dynamic[admsNodeID_s];
    dQdxdVp[li_e1] += Jdxp_dynamic[admsNodeID_e1];
    dQdxdVp[li_b1] += Jdxp_dynamic[admsNodeID_b1];
    dQdxdVp[li_b2] += Jdxp_dynamic[admsNodeID_b2];
    dQdxdVp[li_c1] += Jdxp_dynamic[admsNodeID_c1];
    dQdxdVp[li_c2] += Jdxp_dynamic[admsNodeID_c2];
    dQdxdVp[li_c3] += Jdxp_dynamic[admsNodeID_c3];
    dQdxdVp[li_c4] += Jdxp_dynamic[admsNodeID_c4];
    dQdxdVp[li_noi] += Jdxp_dynamic[admsNodeID_noi];

  }

  return true;
}


//-----------------------------------------------------------------------------
// Function      : Instance::updatePrimaryState
// Purpose       :
// Special Notes : In this initial implementation, does little more than
//                 call updateIntermediateVars()
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updatePrimaryState()
{
  bool bsuccess = true;

  bsuccess = updateIntermediateVars();

  // if old DAE were implemented, we'd save dynamic contributions as state
  // here.

  double * stoVec = extData.nextStoVectorRawPtr;
  // Also need to save limited voltage drops
  // This formulation assumes that we have *always* written the
  // limited voltages back into the probeVars[] array.

  stoVec[li_store_admsProbeID_V_b2_c1] = probeVars[admsProbeID_V_b2_c1].val();
  stoVec[li_store_admsProbeID_V_b2_c2] = probeVars[admsProbeID_V_b2_c2].val();
  stoVec[li_store_admsProbeID_V_b1_e1] = probeVars[admsProbeID_V_b1_e1].val();
  stoVec[li_store_admsProbeID_V_b1_b2] = probeVars[admsProbeID_V_b1_b2].val();

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateSecondaryState
// Purpose       :
// Special Notes : In this initial implementation, does nothing
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateSecondaryState()
{
  bool bsuccess = true;

  // were old DAE implemented, we'd pull dynamic contribution derivatives
  // out of state.

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateIntermediateVars
// Purpose       : update intermediate variables for one bjt504va instance
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateIntermediateVars()
{

  bool bsuccess=true;
  Linear::Vector * solVectorPtr = extData.nextSolVectorPtr;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << std::endl << subsection_divider << std::endl;
    Xyce::dout() << "  In ADMSbjt504va::Instance::updateIntermediateVars\n\n";
    Xyce::dout() << "  name = " << getName() << std::endl;
  }

  // Local variables
  double common;
  double powerREC;
  double powerRBC;
  double powerRCCxx;
  double powerRCCex;
  double powerRCCin;
  AdmsFadType powerRBV;
  AdmsFadType powerCCS;
  AdmsFadType powerFBCS;
  AdmsFadType powerFBC1fB1;
  double exponentFBC1fB2;
  AdmsFadType powerFBC1fB2;
  AdmsFadType powerEBSCS;
  AdmsFadType powerEBSC1f;
  AdmsFadType powerRBCS;
  AdmsFadType powerRBC1f;
  AdmsFadType powerExCS;
  AdmsFadType powerExC1f;
  AdmsFadType powerExCSMOD;
  AdmsFadType powerExC1fMOD;
  AdmsFadType powerSubsCS_B1S;
  AdmsFadType powerSubsCS_BS;
  AdmsFadType twoqIavl;
  AdmsFadType powerCCS_A;
  AdmsFadType Vb2c1;
  AdmsFadType Vb2c2;
  AdmsFadType Vb2e1;
  AdmsFadType Vb1e1;
  AdmsFadType Vb1b2;
  AdmsFadType Vsc1;
  AdmsFadType Vc1c2;
  AdmsFadType Vee1;
  AdmsFadType Vbb1;
  AdmsFadType Vbe;
  AdmsFadType Vbc;
  AdmsFadType Vc4c1;
  AdmsFadType Vc3c4;
  AdmsFadType Vb1c4;
  AdmsFadType Vcc3;
  AdmsFadType Vbc3;
  AdmsFadType Vsc4;
  AdmsFadType Vsc3;
  double expl;
  AdmsFadType eVb2c2;
  AdmsFadType eVb2e1;
  AdmsFadType eVb1e1;
  AdmsFadType eVb1c4;
  AdmsFadType eVbc3;
  AdmsFadType eVsc1;
  AdmsFadType eVsc3;
  AdmsFadType eVsc4;
  AdmsFadType eVbc3VDC;
  AdmsFadType eVb1c4VDC;
  AdmsFadType eVb2c2VDC;
  AdmsFadType eVb2c1VDC;
  AdmsFadType K0;
  AdmsFadType Kw;
  AdmsFadType pW;
  AdmsFadType Ec;
  AdmsFadType Ic1c2;
  AdmsFadType pav;
  AdmsFadType tmpV;
  AdmsFadType Vqs_th;
  double eps_VDC;
  double eps2;
  AdmsFadType x2;
  AdmsFadType Vqs;
  AdmsFadType Iqs;
  AdmsFadType Ic1c2_Iqs;
  AdmsFadType alpha1;
  AdmsFadType alpha;
  AdmsFadType vyi;
  AdmsFadType yi;
  AdmsFadType xi_w;
  AdmsFadType gp0;
  AdmsFadType gp0_help;
  AdmsFadType gp02;
  AdmsFadType sqr_arg;
  AdmsFadType p0star;
  AdmsFadType eVb2c2star;
  AdmsFadType B1;
  AdmsFadType B2;
  AdmsFadType Vxi0;
  AdmsFadType Vch;
  AdmsFadType Icap;
  AdmsFadType Icap_IHC;
  double Vfe;
  double a_VDE;
  AdmsFadType Vje;
  AdmsFadType E0BE;
  AdmsFadType Vte;
  AdmsFadType Vjunc;
  double bjc;
  double Vfc;
  AdmsFadType Vjc;
  AdmsFadType fI;
  AdmsFadType Vcv;
  AdmsFadType Vtc;
  double If0;
  AdmsFadType f1;
  AdmsFadType n0;
  AdmsFadType f2;
  AdmsFadType nB;
  AdmsFadType termE;
  AdmsFadType termC;
  AdmsFadType q0I;
  AdmsFadType q1I;
  AdmsFadType In;
  double Ibf0;
  AdmsFadType tmpExp;
  AdmsFadType eZEB;
  AdmsFadType x;
  AdmsFadType dE0BE;
  AdmsFadType edZEB;
  AdmsFadType DZEB;
  AdmsFadType g1;
  AdmsFadType g2;
  AdmsFadType nBex;
  AdmsFadType pWex;
  AdmsFadType Isf;
  AdmsFadType Xg1;
  AdmsFadType XnBex;
  AdmsFadType XIMex;
  AdmsFadType XIMsub;
  double Vex_bias;
  double Vex;
  AdmsFadType vdif;
  AdmsFadType VBex;
  AdmsFadType Fex;
  AdmsFadType q0Q;
  AdmsFadType q1Q;
  AdmsFadType qBQ;
  AdmsFadType Ib1b2;
  AdmsFadType Iavl;
  double dEdx0;
  AdmsFadType xd;
  AdmsFadType xi_w1;
  AdmsFadType Weff;
  AdmsFadType Wd;
  AdmsFadType Eav;
  AdmsFadType E0;
  AdmsFadType SHw;
  double Efi;
  AdmsFadType Ew;
  AdmsFadType Em;
  AdmsFadType EmEav_Em;
  AdmsFadType lambda;
  AdmsFadType Gmax;
  AdmsFadType Vb2c2star;
  AdmsFadType Qte;
  AdmsFadType Vje_s;
  AdmsFadType Qte_s;
  AdmsFadType Qtc;
  double Qb0;
  AdmsFadType Qbe_qs;
  AdmsFadType Qbc_qs;
  double a_VDC;
  AdmsFadType Vjcex;
  AdmsFadType Vtexv;
  AdmsFadType Qtex;
  AdmsFadType XVjcex;
  AdmsFadType XVtexv;
  AdmsFadType XQtex;
  double a_VDS;
  double Vfs;
  AdmsFadType Vjs;
  AdmsFadType Qts;
  double Qe0;
  AdmsFadType Qe;
  double Qepi0;
  AdmsFadType Qepi;
  AdmsFadType Qex;
  AdmsFadType XQex;
  AdmsFadType Xg2;
  AdmsFadType XpWex;
  AdmsFadType Qb1b2;
  AdmsFadType dVteVje;
  AdmsFadType Vb2e1Vfe;
  AdmsFadType dVjeVb2e1;
  AdmsFadType dVteVb2e1;
  AdmsFadType dQteVb2e1;
  AdmsFadType dn0Vb2e1;
  AdmsFadType dQbeVb2e1;
  AdmsFadType dQeVb2e1;
  AdmsFadType Qbc;
  AdmsFadType Qbe;
  AdmsFadType cor_exp_1;
  AdmsFadType cor_exp_2;
  // temporary variables for limiting
  double Vb1b2_orig,Vb1b2_limited,Vb1b2_old;
  double Vb1e1_orig,Vb1e1_limited,Vb1e1_old;
  double Vb2c2_orig,Vb2c2_limited,Vb2c2_old;
  double Vb2c1_orig,Vb2c1_limited,Vb2c1_old;


  // set the sizes of the Fad arrays:

  if (probeVars.size() != (15))
  {
    probeVars.resize(15);
    staticContributions.resize(12+0);
    dynamicContributions.resize(12+0);
    probeDiffs.resize(15,0.0);
    Jdxp_static.resize(12+0);
    Jdxp_dynamic.resize(12+0);
  }

  noiseContribsPower.resize(26);
  noiseContribsExponent.resize(26);
  
  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 12+0 ; ++i)
  {
    staticContributions[i]=0;
    dynamicContributions[i]=0;
    Jdxp_static[i]=0;
    Jdxp_dynamic[i]=0;
  }

  for (int i=0; i < 15 ; ++i)
  {
    probeDiffs[i] = 0.0;
  }
  // extract solution variables and set as Fad independent variables.
  probeVars[admsProbeID_V_noi_e1] = (*solVectorPtr)[li_noi] - (*solVectorPtr)[li_e1];
  probeVars[admsProbeID_V_noi_e1].diff(admsProbeID_V_noi_e1,15);
  probeVars[admsProbeID_V_c3_c1] = (*solVectorPtr)[li_c3] - (*solVectorPtr)[li_c1];
  probeVars[admsProbeID_V_c3_c1].diff(admsProbeID_V_c3_c1,15);
  probeVars[admsProbeID_V_c3_c4] = (*solVectorPtr)[li_c3] - (*solVectorPtr)[li_c4];
  probeVars[admsProbeID_V_c3_c4].diff(admsProbeID_V_c3_c4,15);
  probeVars[admsProbeID_V_c4_c1] = (*solVectorPtr)[li_c4] - (*solVectorPtr)[li_c1];
  probeVars[admsProbeID_V_c4_c1].diff(admsProbeID_V_c4_c1,15);
  probeVars[admsProbeID_V_b_c] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_c];
  probeVars[admsProbeID_V_b_c].diff(admsProbeID_V_b_c,15);
  probeVars[admsProbeID_V_b_e] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_e];
  probeVars[admsProbeID_V_b_e].diff(admsProbeID_V_b_e,15);
  probeVars[admsProbeID_V_b_b1] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_b1];
  probeVars[admsProbeID_V_b_b1].diff(admsProbeID_V_b_b1,15);
  probeVars[admsProbeID_V_e_e1] = (*solVectorPtr)[li_e] - (*solVectorPtr)[li_e1];
  probeVars[admsProbeID_V_e_e1].diff(admsProbeID_V_e_e1,15);
  probeVars[admsProbeID_V_c1_c2] = (*solVectorPtr)[li_c1] - (*solVectorPtr)[li_c2];
  probeVars[admsProbeID_V_c1_c2].diff(admsProbeID_V_c1_c2,15);
  probeVars[admsProbeID_V_s_c1] = (*solVectorPtr)[li_s] - (*solVectorPtr)[li_c1];
  probeVars[admsProbeID_V_s_c1].diff(admsProbeID_V_s_c1,15);
  probeVars[admsProbeID_V_b1_b2] = (*solVectorPtr)[li_b1] - (*solVectorPtr)[li_b2];
  probeVars[admsProbeID_V_b1_b2].diff(admsProbeID_V_b1_b2,15);
  probeVars[admsProbeID_V_b1_e1] = (*solVectorPtr)[li_b1] - (*solVectorPtr)[li_e1];
  probeVars[admsProbeID_V_b1_e1].diff(admsProbeID_V_b1_e1,15);
  probeVars[admsProbeID_V_b2_e1] = (*solVectorPtr)[li_b2] - (*solVectorPtr)[li_e1];
  probeVars[admsProbeID_V_b2_e1].diff(admsProbeID_V_b2_e1,15);
  probeVars[admsProbeID_V_b2_c2] = (*solVectorPtr)[li_b2] - (*solVectorPtr)[li_c2];
  probeVars[admsProbeID_V_b2_c2].diff(admsProbeID_V_b2_c2,15);
  probeVars[admsProbeID_V_b2_c1] = (*solVectorPtr)[li_b2] - (*solVectorPtr)[li_c1];
  probeVars[admsProbeID_V_b2_c1].diff(admsProbeID_V_b2_c1,15);


  // pre-multiply any "typed" probes (i.e. those limited with "typedpnjlim")
  probeVars[admsProbeID_V_b1_b2] *= (model_.TYPE);
  probeVars[admsProbeID_V_b1_e1] *= (model_.TYPE);
  probeVars[admsProbeID_V_b2_c2] *= (model_.TYPE);
  probeVars[admsProbeID_V_b2_c1] *= (model_.TYPE);
  // Copy probes into limiting vars

  Vb1b2_orig = Vb1b2_limited = probeVars[admsProbeID_V_b1_b2].val();
  probeDiffs[admsProbeID_V_b1_b2] = 0.0;
  Vb1e1_orig = Vb1e1_limited = probeVars[admsProbeID_V_b1_e1].val();
  probeDiffs[admsProbeID_V_b1_e1] = 0.0;
  Vb2c2_orig = Vb2c2_limited = probeVars[admsProbeID_V_b2_c2].val();
  probeDiffs[admsProbeID_V_b2_c2] = 0.0;
  Vb2c1_orig = Vb2c1_limited = probeVars[admsProbeID_V_b2_c1].val();
  probeDiffs[admsProbeID_V_b2_c1] = 0.0;

  origFlag = true;

  if (getSolverState().newtonIter == 0)
  {

    if (!(getSolverState().dcopFlag)||(getSolverState().locaEnabledFlag && getSolverState().dcopFlag))
    {
      Vb1b2_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_b1_b2];
      Vb1e1_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_b1_e1];
      Vb2c2_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_b2_c2];
      Vb2c1_old = ((*extData.currStoVectorPtr))[li_store_admsProbeID_V_b2_c1];
    }
    else
    {
      Vb1b2_old = Vb1b2_limited;
      Vb1e1_old = Vb1e1_limited;
      Vb2c2_old = Vb2c2_limited;
      Vb2c1_old = Vb2c1_limited;
    }
  }
  else
  {
    Vb1b2_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_b1_b2];
    Vb1e1_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_b1_e1];
    Vb2c2_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_b2_c2];
    Vb2c1_old = ((*extData.nextStoVectorPtr))[li_store_admsProbeID_V_b2_c1];
  }
  // -- code converted from analog/code block
  {


    //Vb2c1 = ($limit(V(b2,c1),"trunc_ev","typed",TYPE,(-VER),0.7));
    if (getDeviceOptions().voltageLimiterFlag)
    {
      int icheck=0;
      Vb2c1_limited = AnalogFunctions::trunc_ev(Vb2c1_limited,Vb2c1_old,(-(model_.VER)),0.7);
      if (Vb2c1_limited != Vb2c1_orig)
      {
        icheck=1;
      }
      if (icheck == 1)
        origFlag = false;
      if (!origFlag)
      {
        probeDiffs[admsProbeID_V_b2_c1] = Vb2c1_limited - Vb2c1_orig;
        probeVars[admsProbeID_V_b2_c1] += probeDiffs[admsProbeID_V_b2_c1];
      }
    }
    Vb2c1 = probeVars[admsProbeID_V_b2_c1];



    //Vb2c2 = ($limit(V(b2,c2),"trunc_ev","typed",TYPE,(-VER),0.7));
    if (getDeviceOptions().voltageLimiterFlag)
    {
      int icheck=0;
      Vb2c2_limited = AnalogFunctions::trunc_ev(Vb2c2_limited,Vb2c2_old,(-(model_.VER)),0.7);
      if (Vb2c2_limited != Vb2c2_orig)
      {
        icheck=1;
      }
      if (icheck == 1)
        origFlag = false;
      if (!origFlag)
      {
        probeDiffs[admsProbeID_V_b2_c2] = Vb2c2_limited - Vb2c2_orig;
        probeVars[admsProbeID_V_b2_c2] += probeDiffs[admsProbeID_V_b2_c2];
      }
    }
    Vb2c2 = probeVars[admsProbeID_V_b2_c2];

    Vb2e1 = ((model_.TYPE)*(probeVars[admsProbeID_V_b2_e1]));


    //Vb1e1 = ($limit(V(b1,e1),"trunc_ev","typed",TYPE,(-VER),0.7));
    if (getDeviceOptions().voltageLimiterFlag)
    {
      int icheck=0;
      Vb1e1_limited = AnalogFunctions::trunc_ev(Vb1e1_limited,Vb1e1_old,(-(model_.VER)),0.7);
      if (Vb1e1_limited != Vb1e1_orig)
      {
        icheck=1;
      }
      if (icheck == 1)
        origFlag = false;
      if (!origFlag)
      {
        probeDiffs[admsProbeID_V_b1_e1] = Vb1e1_limited - Vb1e1_orig;
        probeVars[admsProbeID_V_b1_e1] += probeDiffs[admsProbeID_V_b1_e1];
      }
    }
    Vb1e1 = probeVars[admsProbeID_V_b1_e1];



    //Vb1b2 = ($limit(V(b1,b2),"trunc_ev","typed",TYPE,(-VER),0.7));
    if (getDeviceOptions().voltageLimiterFlag)
    {
      int icheck=0;
      Vb1b2_limited = AnalogFunctions::trunc_ev(Vb1b2_limited,Vb1b2_old,(-(model_.VER)),0.7);
      if (Vb1b2_limited != Vb1b2_orig)
      {
        icheck=1;
      }
      if (icheck == 1)
        origFlag = false;
      if (!origFlag)
      {
        probeDiffs[admsProbeID_V_b1_b2] = Vb1b2_limited - Vb1b2_orig;
        probeVars[admsProbeID_V_b1_b2] += probeDiffs[admsProbeID_V_b1_b2];
      }
    }
    Vb1b2 = probeVars[admsProbeID_V_b1_b2];

    Vsc1 = ((model_.TYPE)*(probeVars[admsProbeID_V_s_c1]));
    Vc1c2 = ((model_.TYPE)*(probeVars[admsProbeID_V_c1_c2]));
    Vee1 = ((model_.TYPE)*(probeVars[admsProbeID_V_e_e1]));
    Vbb1 = ((model_.TYPE)*(probeVars[admsProbeID_V_b_b1]));
    Vbe = ((model_.TYPE)*(probeVars[admsProbeID_V_b_e]));
    Vbc = ((model_.TYPE)*(probeVars[admsProbeID_V_b_c]));
    if (((model_.RCBLX)>0.0))
    {
      if (((model_.RCBLI)>0.0))
      {
        Vc4c1 = ((model_.TYPE)*(probeVars[admsProbeID_V_c4_c1]));
        Vc3c4 = ((model_.TYPE)*(probeVars[admsProbeID_V_c3_c4]));
      }
      else
      {
        Vc4c1 = 0;
        Vc3c4 = ((model_.TYPE)*(probeVars[admsProbeID_V_c3_c1]));
      }
    }
    else
    {
      if (((model_.RCBLI)>0.0))
      {
        Vc4c1 = ((model_.TYPE)*(probeVars[admsProbeID_V_c4_c1]));
        Vc3c4 = 0;
      }
      else
      {
        Vc4c1 = 0;
        Vc3c4 = 0;
      }
    }
    Vb1c4 = (((Vb1b2+Vb2c2)-Vc1c2)-Vc4c1);
    Vcc3 = ((((-Vbc)+Vbb1)+Vb1c4)-Vc3c4);
    Vbc3 = (Vbc+Vcc3);
    Vsc4 = (Vsc1-Vc4c1);
    Vsc3 = (Vsc4-Vc3c4);
    if (((Vb2c2*(model_.VtINV))<400.0))
    {
      eVb2c2 = exp((Vb2c2*(model_.VtINV)));
    }
    else
    {
      expl = exp(400.0);
      eVb2c2 = (expl*(1.0+((Vb2c2*(model_.VtINV))-400.0)));
    }
    if (((Vb2e1*(model_.VtINV))<400.0))
    {
      eVb2e1 = exp((Vb2e1*(model_.VtINV)));
    }
    else
    {
      expl = exp(400.0);
      eVb2e1 = (expl*(1.0+((Vb2e1*(model_.VtINV))-400.0)));
    }
    if (((Vb1e1*(model_.VtINV))<400.0))
    {
      eVb1e1 = exp((Vb1e1*(model_.VtINV)));
    }
    else
    {
      expl = exp(400.0);
      eVb1e1 = (expl*(1.0+((Vb1e1*(model_.VtINV))-400.0)));
    }
    if (((Vb1c4*(model_.VtINV))<400.0))
    {
      eVb1c4 = exp((Vb1c4*(model_.VtINV)));
    }
    else
    {
      expl = exp(400.0);
      eVb1c4 = (expl*(1.0+((Vb1c4*(model_.VtINV))-400.0)));
    }
    if (((Vb1b2*(model_.VtINV))<400.0))
    {
      eVb1b2 = exp((Vb1b2*(model_.VtINV)));
    }
    else
    {
      expl = exp(400.0);
      eVb1b2 = (expl*(1.0+((Vb1b2*(model_.VtINV))-400.0)));
    }
    if (((Vbc3*(model_.VtINV))<400.0))
    {
      eVbc3 = exp((Vbc3*(model_.VtINV)));
    }
    else
    {
      expl = exp(400.0);
      eVbc3 = (expl*(1.0+((Vbc3*(model_.VtINV))-400.0)));
    }
    if (((Vsc1*(model_.VtINV))<400.0))
    {
      eVsc1 = exp((Vsc1*(model_.VtINV)));
    }
    else
    {
      expl = exp(400.0);
      eVsc1 = (expl*(1.0+((Vsc1*(model_.VtINV))-400.0)));
    }
    if (((Vsc3*(model_.VtINV))<400.0))
    {
      eVsc3 = exp((Vsc3*(model_.VtINV)));
    }
    else
    {
      expl = exp(400.0);
      eVsc3 = (expl*(1.0+((Vsc3*(model_.VtINV))-400.0)));
    }
    if (((Vsc4*(model_.VtINV))<400.0))
    {
      eVsc4 = exp((Vsc4*(model_.VtINV)));
    }
    else
    {
      expl = exp(400.0);
      eVsc4 = (expl*(1.0+((Vsc4*(model_.VtINV))-400.0)));
    }
    if ((((Vbc3-(model_.VDC_T))*(model_.VtINV))<400.0))
    {
      eVbc3VDC = exp(((Vbc3-(model_.VDC_T))*(model_.VtINV)));
    }
    else
    {
      expl = exp(400.0);
      eVbc3VDC = (expl*(1.0+(((Vbc3-(model_.VDC_T))*(model_.VtINV))-400.0)));
    }
    if ((((Vb1c4-(model_.VDC_T))*(model_.VtINV))<400.0))
    {
      eVb1c4VDC = exp(((Vb1c4-(model_.VDC_T))*(model_.VtINV)));
    }
    else
    {
      expl = exp(400.0);
      eVb1c4VDC = (expl*(1.0+(((Vb1c4-(model_.VDC_T))*(model_.VtINV))-400.0)));
    }
    if ((((Vb2c2-(model_.VDC_T))*(model_.VtINV))<400.0))
    {
      eVb2c2VDC = exp(((Vb2c2-(model_.VDC_T))*(model_.VtINV)));
    }
    else
    {
      expl = exp(400.0);
      eVb2c2VDC = (expl*(1.0+(((Vb2c2-(model_.VDC_T))*(model_.VtINV))-400.0)));
    }
    if ((((Vb2c1-(model_.VDC_T))*(model_.VtINV))<400.0))
    {
      eVb2c1VDC = exp(((Vb2c1-(model_.VDC_T))*(model_.VtINV)));
    }
    else
    {
      expl = exp(400.0);
      eVb2c1VDC = (expl*(1.0+(((Vb2c1-(model_.VDC_T))*(model_.VtINV))-400.0)));
    }
    K0 = sqrt((1.0+(4.0*eVb2c2VDC)));
    Kw = sqrt((1.0+(4.0*eVb2c1VDC)));
    pW = ((2.0*eVb2c1VDC)/(1.0+Kw));
    if ((pW<1.0e-40))
    {
      pW = 0;
    }
    Ec = ((model_.Vt)*((K0-Kw)-log(((K0+1.0)/(Kw+1.0)))));
    Ic1c2 = ((Ec+Vc1c2)/(model_.RCV_TM));
    if ((Ic1c2>0.0))
    {
      if ((Vb2c1<100.0))
      {
        tmpV = Vb2c1;
      }
      else
      {
        tmpV = (100.0+log((1.0+(Vb2c1-100.0))));
      }
      tmpV = tmpV;
      Vqs_th = (((model_.VDC_T)+((2.0*(model_.Vt))*log(((((0.5*Ic1c2)*(model_.RCV_TM))*(model_.VtINV))+1.0))))-tmpV);
      eps_VDC = (0.2*(model_.VDC_T));
      eps2 = (eps_VDC*eps_VDC);
      x2 = (Vqs_th*Vqs_th);
      if ((Vqs_th<0.0))
      {
        Vqs = ((0.5*eps2)/(sqrt((x2+eps2))-Vqs_th));
      }
      else
      {
        Vqs = (0.5*(sqrt((x2+eps2))+Vqs_th));
      }
      Vqs = Vqs;
      Iqs = ((Vqs*(Vqs+((model_.IHC_M)*(model_.SCRCV_M))))/((model_.SCRCV_M)*(Vqs+((model_.IHC_M)*(model_.RCV_TM)))));
      Ic1c2_Iqs = (Ic1c2/Iqs);
      {
        //Block-local variables for block 
        AdmsFadType dxa;
        //End of Block-local variables
        dxa = ((Ic1c2_Iqs-1.0)/(model_.AXI));
        if ((Ic1c2_Iqs<1.0))
        {
          alpha1 = (1.0+((model_.AXI)*log((1.0+exp(dxa)))));
        }
        else
        {
          alpha1 = (Ic1c2_Iqs+((model_.AXI)*log((1.0+exp((-dxa))))));
        }
        alpha1 = alpha1;
      }
      alpha = (alpha1/(1.0+((model_.AXI)*log((1.0+exp(((-1.0)/(model_.AXI))))))));
      vyi = (Vqs/((model_.IHC_M)*(model_.SCRCV_M)));
      yi = ((1.0+sqrt((1.0+(((4.0*alpha)*vyi)*(1.0+vyi)))))/((2.0*alpha)*(1.0+vyi)));
      xi_w = (1.0-(yi/(1.0+(pW*yi))));
      gp0 = ((((0.5*Ic1c2)*(model_.RCV_TM))*xi_w)*(model_.VtINV));
      gp0_help = ((2.0*gp0)+(pW*((pW+gp0)+1.0)));
      gp02 = (0.5*(gp0-1.0));
      sqr_arg = ((gp02*gp02)+gp0_help);
      if ((gp0>=1.0))
      {
        p0star = (gp02+sqrt(sqr_arg));
      }
      else
      {
        p0star = (gp0_help/(sqrt(sqr_arg)-gp02));
      }
      if ((p0star<1.0e-40))
      {
        p0star = 0.0;
      }
      eVb2c2star = ((p0star*(p0star+1.0))*exp(((model_.VDC_T)*(model_.VtINV))));
      B1 = ((0.5*(model_.SCRCV_M))*(Ic1c2-(model_.IHC_M)));
      B2 = ((((model_.SCRCV_M)*(model_.RCV_TM))*(model_.IHC_M))*Ic1c2);
      Vxi0 = (B1+sqrt(((B1*B1)+B2)));
      Vch = ((model_.VDC_T)*(0.1+((2.0*Ic1c2)/(Ic1c2+Iqs))));
      Icap = (((model_.IHC_M)*Ic1c2)/((model_.IHC_M)+Ic1c2));
      Icap_IHC = ((model_.IHC_M)/((model_.IHC_M)+Ic1c2));
    }
    else
    {
      Iqs = 0.0;
      p0star = ((2.0*eVb2c2VDC)/(1.0+K0));
      eVb2c2star = eVb2c2;
      if (((fabs(Vc1c2)<(1.0e-5*(model_.Vt)))||(fabs(Ec)<((1.0e-40*(model_.Vt))*(K0+Kw)))))
      {
        pav = (0.5*(p0star+pW));
        xi_w = (pav/(pav+1.0));
      }
      else
      {
        xi_w = (Ec/((Ec+Vb2c2)-Vb2c1));
      }
      Vxi0 = Vc1c2;
      Vch = (0.1*(model_.VDC_T));
      Icap = Ic1c2;
      Icap_IHC = (1.0-(Icap/(model_.IHC_M)));
    }
    Vfe = ((model_.VDE_T)*(1.0-pow(3.0,((-1.0)/(model_.PE)))));
    a_VDE = (0.1*(model_.VDE_T));
    {
      //Block-local variables for block 
      AdmsFadType dxa;
      //End of Block-local variables
      dxa = ((Vb2e1-Vfe)/a_VDE);
      if ((Vb2e1<Vfe))
      {
        Vje = (Vb2e1-(a_VDE*log((1.0+exp(dxa)))));
      }
      else
      {
        Vje = (Vfe-(a_VDE*log((1.0+exp((-dxa))))));
      }
      Vje = Vje;
    }
    E0BE = pow((1.0-(Vje*(model_.inv_VDE_T))),(1.0-(model_.PE)));
    Vte = ((((model_.VDE_T)/(1.0-(model_.PE)))*(1.0-E0BE))+(3.0*(Vb2e1-Vje)));
    Vjunc = (Vb2c1+Vxi0);
    bjc = ((2.0-(model_.XP_T))/(1.0-(model_.XP_T)));
    Vfc = ((model_.VDC_T)*(1.0-pow(bjc,((-1.0)/(model_.PC)))));
    {
      //Block-local variables for block 
      AdmsFadType dxa;
      //End of Block-local variables
      dxa = ((Vjunc-Vfc)/Vch);
      if ((Vjunc<Vfc))
      {
        Vjc = (Vjunc-(Vch*log((1.0+exp(dxa)))));
      }
      else
      {
        Vjc = (Vfc-(Vch*log((1.0+exp((-dxa))))));
      }
      Vjc = Vjc;
    }
    fI = pow(Icap_IHC,(model_.MC));
    Vcv = ((((model_.VDC_T)/(1.0-(model_.PC)))*(1.0-(fI*pow((1.0-(Vjc/(model_.VDC_T))),(1.0-(model_.PC))))))+((fI*bjc)*(Vjunc-Vjc)));
    Vtc = (((1.0-(model_.XP_T))*Vcv)+((model_.XP_T)*Vb2c1));
    If0 = ((4.0*(model_.IS_TM))/(model_.IK_TM));
    f1 = (If0*eVb2e1);
    n0 = (f1/(1.0+sqrt((1.0+f1))));
    f2 = (If0*eVb2c2star);
    nB = (f2/(1.0+sqrt((1.0+f2))));
    if (((model_.DEG)==0.0))
    {
      q0I = ((1.0+(Vte/(model_.VER_T)))+(Vtc/(model_.VEF_T)));
    }
    else
    {
      termE = ((((Vte/(model_.VER_T))+1.0)*(model_.DEG_T))*(model_.VtINV));
      termC = ((((-Vtc)/(model_.VEF_T))*(model_.DEG_T))*(model_.VtINV));
      q0I = ((exp(termE)-exp(termC))/(exp(((model_.DEG_T)*(model_.VtINV)))-1.0));
    }
    eps2 = (0.1*0.1);
    x2 = (q0I*q0I);
    if ((q0I<0.0))
    {
      q1I = ((0.5*eps2)/(sqrt((x2+eps2))-q0I));
    }
    else
    {
      q1I = (0.5*(sqrt((x2+eps2))+q0I));
    }
    q1I = q1I;
    qBI = (q1I*(1.0+(0.5*(n0+nB))));
    Ir = ((model_.IS_TM)*eVb2c2star);
    If = ((model_.IS_TM)*eVb2e1);
    In = ((If-Ir)/qBI);
    Ibf0 = ((model_.IS_TM)/(model_.BF_T));
    if (((model_.XREC)==0.0))
    {
      Ib1 = (((1.0-(model_.XIBI))*Ibf0)*(eVb2e1-1.0));
    }
    else
    {
      Ib1 = (((1.0-(model_.XIBI))*Ibf0)*(((1.0-(model_.XREC))*(eVb2e1-1.0))+(((model_.XREC)*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/(model_.VEF_T))))));
    }
    Ib1_s = (((model_.XIBI)*Ibf0)*(eVb1e1-1.0));
    if ((((Vb2e1*(model_.VtINV))/(model_.MLF))<400.0))
    {
      tmpExp = exp(((Vb2e1*(model_.VtINV))/(model_.MLF)));
    }
    else
    {
      expl = exp(400.0);
      tmpExp = (expl*(1.0+(((Vb2e1*(model_.VtINV))/(model_.MLF))-400.0)));
    }
    Ib2 = (((model_.IBF_TM)*(tmpExp-1.0))+((model_.GMIN)*Vb2e1));
    if ((((0.5*Vb1c4)*(model_.VtINV))<400.0))
    {
      tmpExp = exp(((0.5*Vb1c4)*(model_.VtINV)));
    }
    else
    {
      expl = exp(400.0);
      tmpExp = (expl*(1.0+(((0.5*Vb1c4)*(model_.VtINV))-400.0)));
    }
    Ib3 = ((((model_.IBR_TM)*(eVb1c4-1.0))/(tmpExp+exp(((0.5*(model_.VLR))*(model_.VtINV)))))+((model_.GMIN)*Vb1c4));
    if (((((model_.IZEB)>0.0)&&((model_.NZEB)>0.0))&&(Vb2e1<0)))
    {
      if ((((model_.nZEB_T)*(1-((model_.pow2_2mPE)/(2.0*E0BE))))<400.0))
      {
        eZEB = exp(((model_.nZEB_T)*(1-((model_.pow2_2mPE)/(2.0*E0BE)))));
      }
      else
      {
        expl = exp(400.0);
        eZEB = (expl*(1.0+(((model_.nZEB_T)*(1-((model_.pow2_2mPE)/(2.0*E0BE))))-400.0)));
      }
      x = (Vb2e1*(model_.inv_VDE_T));
      dE0BE = ((pow((-x),((-2.0)-(model_.PE)))*(((model_.PE)*((1-((model_.PE)*(model_.PE)))-((3*x)*((model_.PE)-1))))-(((6*x)*x)*(((model_.PE)-1)+x))))*0.16666666666666666667);
      if (((((Vb2e1*(model_.pow2_2mPE))*(model_.nZEB_T))/((model_.VGZEB_T)*dE0BE))<400.0))
      {
        edZEB = exp((((Vb2e1*(model_.pow2_2mPE))*(model_.nZEB_T))/((model_.VGZEB_T)*dE0BE)));
      }
      else
      {
        expl = exp(400.0);
        edZEB = (expl*(1.0+((((Vb2e1*(model_.pow2_2mPE))*(model_.nZEB_T))/((model_.VGZEB_T)*dE0BE))-400.0)));
      }
      DZEB = ((-Vb2e1)-((((model_.VGZEB_T)*dE0BE)*(1-edZEB))/((model_.pow2_2mPE)*(model_.nZEB_T))));
      Izteb = ((((((2.0*(model_.IZEB_TM))*DZEB)*E0BE)*eZEB)*(model_.inv_VDE_T))*(model_.pow2_PEm2));
    }
    else
    {
      DZEB = 0;
      Izteb = 0;
    }
    g1 = (If0*eVb1c4);
    g2 = (4.0*eVb1c4VDC);
    nBex = ((g1-If0)/(1.0+sqrt((1.0+g1))));
    pWex = (g2/(1.0+sqrt((1.0+g2))));
    Iex = (((model_.IK_TM)*nBex)/(2.0*(model_.BRI_T)));
    if (((model_.EXSUB)==1.0))
    {
      Isub = (((2.0*(model_.ISS_TM))*(eVb1c4-eVsc4))/(1.0+sqrt((1.0+((4.0*((model_.IS_TM)/(model_.IKS_TM)))*eVb1c4)))));
    }
    else
    {
      Isub = (((2.0*(model_.ISS_TM))*(eVb1c4-1.0))/(1.0+sqrt((1.0+((4.0*((model_.IS_TM)/(model_.IKS_TM)))*eVb1c4)))));
    }
    if (((model_.ICSS)<0.0))
    {
      Isf = ((model_.ISS_TM)*(eVsc1-1.0));
    }
    else
    {
      Isf = ((model_.ICSS_TM)*(eVsc1-1.0));
    }
    XIex = 0.0;
    XIsub = 0.0;
    if ((((model_.EXMOD)==1)||((model_.EXMOD)==2)))
    {
      Iex = (Iex*(model_.Xext1));
      Isub = (Isub*(model_.Xext1));
      Xg1 = (If0*eVbc3);
      XnBex = ((Xg1-If0)/(1.0+sqrt((1.0+Xg1))));
      XIMex = (((((model_.XEXT)*0.5)*(model_.IK_TM))*XnBex)/(model_.BRI_T));
      if (((model_.EXSUB)==1.0))
      {
        XIMsub = (((((model_.XEXT)*2.0)*(model_.ISS_TM))*(eVbc3-eVsc3))/(1.0+sqrt((1.0+(((4.0*(model_.IS_T))/(model_.IKS_T))*eVbc3)))));
      }
      else
      {
        XIMsub = (((((model_.XEXT)*2.0)*(model_.ISS_TM))*(eVbc3-1.0))/(1.0+sqrt((1.0+(((4.0*(model_.IS_T))/(model_.IKS_T))*eVbc3)))));
      }
      if (((model_.EXMOD)==1))
      {
        Vex_bias = (((model_.XEXT)*(((model_.IS_TM)/(model_.BRI_T))+(model_.ISS_TM)))*(model_.RCCxx_TM));
        Vex = ((model_.Vt)*(2.0-log((Vex_bias*(model_.VtINV)))));
        vdif = (Vbc3-Vex);
        eps2 = (0.11*0.11);
        x2 = (vdif*vdif);
        if ((vdif<0.0))
        {
          VBex = ((0.5*eps2)/(sqrt((x2+eps2))-vdif));
        }
        else
        {
          VBex = (0.5*(sqrt((x2+eps2))+vdif));
        }
        VBex = VBex;
        Fex = (VBex/((Vex_bias+((XIMex+XIMsub)*(model_.RCCxx_TM)))+VBex));
      }
      else
      {
        Vex = 0.0;
        vdif = 0.0;
        VBex = 0.0;
        Fex = 1.0;
      }
      XIex = (Fex*XIMex);
      XIsub = (Fex*XIMsub);
    }
    else
    {
      Fex = 0;
      XnBex = 0;
    }
    q0Q = ((1.0+(Vte/(model_.VER_T)))+(Vtc/(model_.VEF_T)));
    eps2 = (0.1*0.1);
    x2 = (q0Q*q0Q);
    if ((q0Q<0.0))
    {
      q1Q = ((0.5*eps2)/(sqrt((x2+eps2))-q0Q));
    }
    else
    {
      q1Q = (0.5*(sqrt((x2+eps2))+q0Q));
    }
    q1Q = q1Q;
    qBQ = (q1Q*(1.0+(0.5*(n0+nB))));
    Rb2 = ((3.0*(model_.RBV_TM))/qBQ);
    Ib1b2 = ((((2.0*(model_.Vt))*(eVb1b2-1.0))+Vb1b2)/Rb2);
    Iavl = 0.0;
    Gem = 0.0;
    if (((Ic1c2>0.0)&&(Vb2c1<(model_.VDC_T))))
    {
      dEdx0 = ((2.0*(model_.VAVL))/((model_.WAVL)*(model_.WAVL)));
      sqr_arg = (((model_.VDC_T)-Vb2c1)/Icap_IHC);
      xd = sqrt(((2.0*sqr_arg)/dEdx0));
      if (((model_.EXAVL)==0.0))
      {
        Weff = (model_.WAVL);
      }
      else
      {
        xi_w1 = (1.0-(0.5*xi_w));
        Weff = (((model_.WAVL)*xi_w1)*xi_w1);
      }
      Wd = ((xd*Weff)/sqrt(((xd*xd)+(Weff*Weff))));
      Eav = (((model_.VDC_T)-Vb2c1)/Wd);
      E0 = (Eav+(((0.5*Wd)*dEdx0)*Icap_IHC));
      if (((model_.EXAVL)==0))
      {
        Em = E0;
      }
      else
      {
        SHw = (1.0+((2.0*(model_.SFH))*(1.0+(2.0*xi_w))));
        Efi = ((1.0+(model_.SFH))/(1.0+(2.0*(model_.SFH))));
        Ew = (Eav-(((0.5*Wd)*dEdx0)*(Efi-(Ic1c2/((model_.IHC_M)*SHw)))));
        sqr_arg = (((Ew-E0)*(Ew-E0))+((((0.1*Eav)*Eav)*Icap)/(model_.IHC_M)));
        Em = (0.5*((Ew+E0)+sqrt(sqr_arg)));
      }
      EmEav_Em = ((Em-Eav)/Em);
      if ((fabs(EmEav_Em)>1.0e-7))
      {
        lambda = ((0.5*Wd)/EmEav_Em);
        Gem = (((((model_.An)/(model_.BnT))*Em)*lambda)*(exp(((-(model_.BnT))/Em))-exp((((-(model_.BnT))/Em)*(1.0+(Weff/lambda))))));
      }
      else
      {
        Gem = (((model_.An)*Weff)*exp(((-(model_.BnT))/Em)));
      }
      Gmax = ((((model_.Vt)/(Ic1c2*((model_.RBC_TM)+Rb2)))+(qBI/(model_.BF_T)))+((model_.RE_TM)/((model_.RBC_TM)+Rb2)));
      Iavl = ((Ic1c2*Gem)/((Gem+(Gem/Gmax))+1.0));
    }
    if ((eVb2c2star>0.0))
    {
      Vb2c2star = ((model_.Vt)*log(eVb2c2star));
    }
    else
    {
      Vb2c2star = Vb2c2;
    }
    Qte = (((1.0-(model_.XCJE))*(model_.CJE_TM))*Vte);
    {
      //Block-local variables for block 
      AdmsFadType dxa;
      //End of Block-local variables
      dxa = ((Vb1e1-Vfe)/a_VDE);
      if ((Vb1e1<Vfe))
      {
        Vje_s = (Vb1e1-(a_VDE*log((1.0+exp(dxa)))));
      }
      else
      {
        Vje_s = (Vfe-(a_VDE*log((1.0+exp((-dxa))))));
      }
      Vje_s = Vje_s;
    }
    Qte_s = (((model_.XCJE)*(model_.CJE_TM))*((((model_.VDE_T)/(1.0-(model_.PE)))*(1.0-pow((1.0-(Vje_s*(model_.inv_VDE_T))),(1.0-(model_.PE)))))+(3.0*(Vb1e1-Vje_s))));
    Qtc = (((model_.XCJC)*(model_.CJC_TM))*Vtc);
    Qb0 = ((model_.TAUB_T)*(model_.IK_TM));
    Qbe_qs = (((0.5*Qb0)*n0)*q1Q);
    Qbc_qs = (((0.5*Qb0)*nB)*q1Q);
    a_VDC = (0.1*(model_.VDC_T));
    {
      //Block-local variables for block 
      AdmsFadType dxa;
      //End of Block-local variables
      dxa = ((Vb1c4-Vfc)/a_VDC);
      if ((Vb1c4<Vfc))
      {
        Vjcex = (Vb1c4-(a_VDC*log((1.0+exp(dxa)))));
      }
      else
      {
        Vjcex = (Vfc-(a_VDC*log((1.0+exp((-dxa))))));
      }
      Vjcex = Vjcex;
    }
    Vtexv = ((((model_.VDC_T)/(1.0-(model_.PC)))*(1.0-pow((1.0-(Vjcex/(model_.VDC_T))),(1.0-(model_.PC)))))+(bjc*(Vb1c4-Vjcex)));
    Qtex = ((((model_.CJC_TM)*(((1.0-(model_.XP_T))*Vtexv)+((model_.XP_T)*Vb1c4)))*(1.0-(model_.XCJC)))*(1.0-(model_.XEXT)));
    {
      //Block-local variables for block 
      AdmsFadType dxa;
      //End of Block-local variables
      dxa = ((Vbc3-Vfc)/a_VDC);
      if ((Vbc3<Vfc))
      {
        XVjcex = (Vbc3-(a_VDC*log((1.0+exp(dxa)))));
      }
      else
      {
        XVjcex = (Vfc-(a_VDC*log((1.0+exp((-dxa))))));
      }
      XVjcex = XVjcex;
    }
    XVtexv = ((((model_.VDC_T)/(1.0-(model_.PC)))*(1.0-pow((1.0-(XVjcex/(model_.VDC_T))),(1.0-(model_.PC)))))+(bjc*(Vbc3-XVjcex)));
    XQtex = ((((model_.CJC_TM)*(((1.0-(model_.XP_T))*XVtexv)+((model_.XP_T)*Vbc3)))*(1.0-(model_.XCJC)))*(model_.XEXT));
    a_VDS = (0.1*(model_.VDS_T));
    Vfs = ((model_.VDS_T)*(1.0-pow(2.0,((-1.0)/(model_.PS)))));
    {
      //Block-local variables for block 
      AdmsFadType dxa;
      //End of Block-local variables
      dxa = ((Vsc1-Vfs)/a_VDS);
      if ((Vsc1<Vfs))
      {
        Vjs = (Vsc1-(a_VDS*log((1.0+exp(dxa)))));
      }
      else
      {
        Vjs = (Vfs-(a_VDS*log((1.0+exp((-dxa))))));
      }
      Vjs = Vjs;
    }
    Qts = ((model_.CJS_TM)*((((model_.VDS_T)/(1.0-(model_.PS)))*(1.0-pow((1.0-(Vjs/(model_.VDS_T))),(1.0-(model_.PS)))))+(2.0*(Vsc1-Vjs))));
    Qe0 = (((model_.TAUE_T)*(model_.IK_TM))*pow(((model_.IS_TM)/(model_.IK_TM)),(1.0/(model_.MTAU))));
    if (((Vb2e1/((model_.MTAU)*(model_.Vt)))<400.0))
    {
      tmpExp = exp((Vb2e1/((model_.MTAU)*(model_.Vt))));
    }
    else
    {
      expl = exp(400.0);
      tmpExp = (expl*(1.0+((Vb2e1/((model_.MTAU)*(model_.Vt)))-400.0)));
    }
    Qe = (Qe0*(tmpExp-1.0));
    Qepi0 = (((4.0*(model_.TEPI_T))*(model_.Vt))/(model_.RCV_TM));
    Qepi = (((0.5*Qepi0)*xi_w)*((p0star+pW)+2.0));
    Qex = ((((model_.TAUR_T)*0.5)*((Qb0*nBex)+(Qepi0*pWex)))/((model_.TAUB_T)+(model_.TEPI_T)));
    XQex = 0.0;
    if (((model_.EXMOD)==1))
    {
      Qex = (Qex*(1.0-(model_.XEXT)));
      Xg2 = (4.0*eVbc3VDC);
      XpWex = (Xg2/(1.0+sqrt((1.0+Xg2))));
      XQex = (((((0.5*Fex)*(model_.XEXT))*(model_.TAUR_T))*((Qb0*XnBex)+(Qepi0*XpWex)))/((model_.TAUB_T)+(model_.TEPI_T)));
    }
    Qb1b2 = 0.0;
    if (((model_.EXPHI)==1))
    {
      dVteVje = (pow((1.0-(Vje*(model_.inv_VDE_T))),(-(model_.PE)))-3.0);
      Vb2e1Vfe = ((Vb2e1-Vfe)/a_VDE);
      if ((Vb2e1Vfe<0.0))
      {
        dVjeVb2e1 = (1.0/(1.0+exp(Vb2e1Vfe)));
      }
      else
      {
        dVjeVb2e1 = (exp((-Vb2e1Vfe))/(1.0+exp((-Vb2e1Vfe))));
      }
      dVteVb2e1 = ((dVteVje*dVjeVb2e1)+3.0);
      dQteVb2e1 = (((1.0-(model_.XCJE))*(model_.CJE_TM))*dVteVb2e1);
      dn0Vb2e1 = (((If0*eVb2e1)*(model_.VtINV))*(0.5/sqrt((1.0+f1))));
      dQbeVb2e1 = (((0.5*Qb0)*q1Q)*dn0Vb2e1);
      dQeVb2e1 = ((Qe+Qe0)/((model_.MTAU)*(model_.Vt)));
      Qb1b2 = ((0.2*Vb1b2)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1));
      Qbc = ((Qbe_qs*0.33333333333333333333)+Qbc_qs);
      Qbe = ((2.0*Qbe_qs)*0.33333333333333333333);
    }
    else
    {
      Qbe = Qbe_qs;
      Qbc = Qbc_qs;
    }
    // I(c1,c2) <+ ((TYPE*Ic1c2))
    {
      AdmsFadType contribTemp;
      contribTemp= ((model_.TYPE)*Ic1c2);
      staticContributions[admsNodeID_c1] += contribTemp;
      staticContributions[admsNodeID_c2] -= contribTemp;

      Jdxp_static[admsNodeID_c1] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2);
      Jdxp_static[admsNodeID_c2] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2);
    }
    // I(c2,e1) <+ ((TYPE*In))
    {
      AdmsFadType contribTemp;
      contribTemp= ((model_.TYPE)*In);
      staticContributions[admsNodeID_c2] += contribTemp;
      staticContributions[admsNodeID_e1] -= contribTemp;

      Jdxp_static[admsNodeID_c2] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2);
      Jdxp_static[admsNodeID_e1] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2);
    }
    // I(b1,e1) <+ ((TYPE*Ib1_s))
    {
      AdmsFadType contribTemp;
      contribTemp= ((model_.TYPE)*Ib1_s);
      staticContributions[admsNodeID_b1] += contribTemp;
      staticContributions[admsNodeID_e1] -= contribTemp;

      Jdxp_static[admsNodeID_b1] += contribTemp.dx(admsProbeID_V_b1_e1)*probeDiffs[admsProbeID_V_b1_e1]*probeVars[admsProbeID_V_b1_e1].dx(admsProbeID_V_b1_e1);
      Jdxp_static[admsNodeID_e1] -= contribTemp.dx(admsProbeID_V_b1_e1)*probeDiffs[admsProbeID_V_b1_e1]*probeVars[admsProbeID_V_b1_e1].dx(admsProbeID_V_b1_e1);
    }
    // I(b2,e1) <+ ((TYPE*((Ib1+Ib2)-Izteb)))
    {
      AdmsFadType contribTemp;
      contribTemp= ((model_.TYPE)*((Ib1+Ib2)-Izteb));
      staticContributions[admsNodeID_b2] += contribTemp;
      staticContributions[admsNodeID_e1] -= contribTemp;

      Jdxp_static[admsNodeID_b2] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2);
      Jdxp_static[admsNodeID_e1] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2);
    }
    // I(b1,s) <+ ((TYPE*Isub))
    {
      AdmsFadType contribTemp;
      contribTemp= ((model_.TYPE)*Isub);
      staticContributions[admsNodeID_b1] += contribTemp;
      staticContributions[admsNodeID_s] -= contribTemp;

      Jdxp_static[admsNodeID_b1] += contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      Jdxp_static[admsNodeID_s] -= contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
    }
    // I(b,s) <+ ((TYPE*XIsub))
    {
      AdmsFadType contribTemp;
      contribTemp= ((model_.TYPE)*XIsub);
      staticContributions[admsNodeID_b] += contribTemp;
      staticContributions[admsNodeID_s] -= contribTemp;

      Jdxp_static[admsNodeID_b] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      Jdxp_static[admsNodeID_s] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
    }
    // I(s,c1) <+ ((TYPE*Isf))
    staticContributions[admsNodeID_s] += ((model_.TYPE)*Isf);
    staticContributions[admsNodeID_c1] -= ((model_.TYPE)*Isf);
    // I(b1,b2) <+ ((TYPE*Ib1b2))
    {
      AdmsFadType contribTemp;
      contribTemp= ((model_.TYPE)*Ib1b2);
      staticContributions[admsNodeID_b1] += contribTemp;
      staticContributions[admsNodeID_b2] -= contribTemp;

      Jdxp_static[admsNodeID_b1] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      Jdxp_static[admsNodeID_b2] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
    }
    // I(b2,c2) <+ ((TYPE*((-1.0)*Iavl)))
    {
      AdmsFadType contribTemp;
      contribTemp= ((model_.TYPE)*((-1.0)*Iavl));
      staticContributions[admsNodeID_b2] += contribTemp;
      staticContributions[admsNodeID_c2] -= contribTemp;

      Jdxp_static[admsNodeID_b2] += contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2)+contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2);
      Jdxp_static[admsNodeID_c2] -= contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2)+contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2);
    }
    // I(e,e1) <+ (((TYPE*Vee1)/RE_TM))
    staticContributions[admsNodeID_e] += (((model_.TYPE)*Vee1)/(model_.RE_TM));
    staticContributions[admsNodeID_e1] -= (((model_.TYPE)*Vee1)/(model_.RE_TM));
    // I(b,b1) <+ (((TYPE*Vbb1)/RBC_TM))
    staticContributions[admsNodeID_b] += (((model_.TYPE)*Vbb1)/(model_.RBC_TM));
    staticContributions[admsNodeID_b1] -= (((model_.TYPE)*Vbb1)/(model_.RBC_TM));
    // I(noi,e1) <+ (V(noi,e1))
    staticContributions[admsNodeID_noi] += (probeVars[admsProbeID_V_noi_e1]);
    staticContributions[admsNodeID_e1] -= (probeVars[admsProbeID_V_noi_e1]);
    cor_exp_1 = (sqrt((1.0+(2.0*Gem)))*(probeVars[admsProbeID_V_noi_e1]));
    // I(b2,e1) <+ (cor_exp_1)
    {
      AdmsFadType contribTemp;
      contribTemp= cor_exp_1;
      staticContributions[admsNodeID_b2] += contribTemp;
      staticContributions[admsNodeID_e1] -= contribTemp;

      Jdxp_static[admsNodeID_b2] += contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1);
      Jdxp_static[admsNodeID_e1] -= contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1);
    }
    cor_exp_2 = (((2.0+(2.0*Gem))/sqrt((1.0+(2.0*Gem))))*(probeVars[admsProbeID_V_noi_e1]));
    // I(e1,c2) <+ (cor_exp_2)
    {
      AdmsFadType contribTemp;
      contribTemp= cor_exp_2;
      staticContributions[admsNodeID_e1] += contribTemp;
      staticContributions[admsNodeID_c2] -= contribTemp;

      Jdxp_static[admsNodeID_e1] += contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1);
      Jdxp_static[admsNodeID_c2] -= contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1);
    }
    // I(b2,e1) <+ (ddt((TYPE*((Qte+Qbe)+Qe))))
    {
      AdmsFadType contribTemp;
      contribTemp= (((model_.TYPE)*((Qte+Qbe)+Qe)));
      dynamicContributions[admsNodeID_b2] += contribTemp;
      dynamicContributions[admsNodeID_e1] -= contribTemp;

      Jdxp_dynamic[admsNodeID_b2] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      Jdxp_dynamic[admsNodeID_e1] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
    }
    // I(b1,e1) <+ (ddt((TYPE*Qte_s)))
    {
      AdmsFadType contribTemp;
      contribTemp= (((model_.TYPE)*Qte_s));
      dynamicContributions[admsNodeID_b1] += contribTemp;
      dynamicContributions[admsNodeID_e1] -= contribTemp;

      Jdxp_dynamic[admsNodeID_b1] += contribTemp.dx(admsProbeID_V_b1_e1)*probeDiffs[admsProbeID_V_b1_e1]*probeVars[admsProbeID_V_b1_e1].dx(admsProbeID_V_b1_e1);
      Jdxp_dynamic[admsNodeID_e1] -= contribTemp.dx(admsProbeID_V_b1_e1)*probeDiffs[admsProbeID_V_b1_e1]*probeVars[admsProbeID_V_b1_e1].dx(admsProbeID_V_b1_e1);
    }
    // I(b2,c2) <+ (ddt((TYPE*((Qtc+Qbc)+Qepi))))
    {
      AdmsFadType contribTemp;
      contribTemp= (((model_.TYPE)*((Qtc+Qbc)+Qepi)));
      dynamicContributions[admsNodeID_b2] += contribTemp;
      dynamicContributions[admsNodeID_c2] -= contribTemp;

      Jdxp_dynamic[admsNodeID_b2] += contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2)+contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2);
      Jdxp_dynamic[admsNodeID_c2] -= contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2)+contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2);
    }
    // I(s,c1) <+ (ddt((TYPE*Qts)))
    dynamicContributions[admsNodeID_s] += (((model_.TYPE)*Qts));
    dynamicContributions[admsNodeID_c1] -= (((model_.TYPE)*Qts));
    // I(b1,b2) <+ (ddt((TYPE*Qb1b2)))
    {
      AdmsFadType contribTemp;
      contribTemp= (((model_.TYPE)*Qb1b2));
      dynamicContributions[admsNodeID_b1] += contribTemp;
      dynamicContributions[admsNodeID_b2] -= contribTemp;

      Jdxp_dynamic[admsNodeID_b1] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      Jdxp_dynamic[admsNodeID_b2] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
    }
    // I(b,e) <+ (ddt(((TYPE*CBEO_M)*Vbe)))
    dynamicContributions[admsNodeID_b] += ((((model_.TYPE)*(model_.CBEO_M))*Vbe));
    dynamicContributions[admsNodeID_e] -= ((((model_.TYPE)*(model_.CBEO_M))*Vbe));
    // I(b,c) <+ (ddt(((TYPE*CBCO_M)*Vbc)))
    dynamicContributions[admsNodeID_b] += ((((model_.TYPE)*(model_.CBCO_M))*Vbc));
    dynamicContributions[admsNodeID_c] -= ((((model_.TYPE)*(model_.CBCO_M))*Vbc));
  }
  if (((model_.RCBLX)>0.0))
  {
    // I(b,c3) <+ ((TYPE*XIex))
    {
      AdmsFadType contribTemp;
      contribTemp= ((model_.TYPE)*XIex);
      staticContributions[admsNodeID_b] += contribTemp;
      staticContributions[admsNodeID_c3] -= contribTemp;

      Jdxp_static[admsNodeID_b] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      Jdxp_static[admsNodeID_c3] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
    }
    // I(c,c3) <+ (((TYPE*Vcc3)*GCCxx_TM))
    {
      AdmsFadType contribTemp;
      contribTemp= (((model_.TYPE)*Vcc3)*(model_.GCCxx_TM));
      staticContributions[admsNodeID_c] += contribTemp;
      staticContributions[admsNodeID_c3] -= contribTemp;

      Jdxp_static[admsNodeID_c] += contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      Jdxp_static[admsNodeID_c3] -= contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
    }
    // I(b,c3) <+ (ddt((TYPE*(XQtex+XQex))))
    {
      AdmsFadType contribTemp;
      contribTemp= (((model_.TYPE)*(XQtex+XQex)));
      dynamicContributions[admsNodeID_b] += contribTemp;
      dynamicContributions[admsNodeID_c3] -= contribTemp;

      Jdxp_dynamic[admsNodeID_b] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      Jdxp_dynamic[admsNodeID_c3] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
    }
    if (((model_.RCBLI)>0.0))
    {
      // I(c4,c1) <+ (((TYPE*Vc4c1)*GCCin_TM))
      staticContributions[admsNodeID_c4] += (((model_.TYPE)*Vc4c1)*(model_.GCCin_TM));
      staticContributions[admsNodeID_c1] -= (((model_.TYPE)*Vc4c1)*(model_.GCCin_TM));
      // I(b1,c4) <+ ((TYPE*(Ib3+Iex)))
      {
        AdmsFadType contribTemp;
        contribTemp= ((model_.TYPE)*(Ib3+Iex));
        staticContributions[admsNodeID_b1] += contribTemp;
        staticContributions[admsNodeID_c4] -= contribTemp;

        Jdxp_static[admsNodeID_b1] += contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_static[admsNodeID_c4] -= contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
      // I(c3,c4) <+ (((TYPE*Vc3c4)*GCCex_TM))
      staticContributions[admsNodeID_c3] += (((model_.TYPE)*Vc3c4)*(model_.GCCex_TM));
      staticContributions[admsNodeID_c4] -= (((model_.TYPE)*Vc3c4)*(model_.GCCex_TM));
      // I(b1,c4) <+ (ddt((TYPE*(Qtex+Qex))))
      {
        AdmsFadType contribTemp;
        contribTemp= (((model_.TYPE)*(Qtex+Qex)));
        dynamicContributions[admsNodeID_b1] += contribTemp;
        dynamicContributions[admsNodeID_c4] -= contribTemp;

        Jdxp_dynamic[admsNodeID_b1] += contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_dynamic[admsNodeID_c4] -= contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
    }
    else
    {
      // V(c4,c1) <+ (0.0)
      // do nothing at all
      // I(b1,c1) <+ ((TYPE*(Ib3+Iex)))
      {
        AdmsFadType contribTemp;
        contribTemp= ((model_.TYPE)*(Ib3+Iex));
        staticContributions[admsNodeID_b1] += contribTemp;
        staticContributions[admsNodeID_c1] -= contribTemp;

        Jdxp_static[admsNodeID_b1] += contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_static[admsNodeID_c1] -= contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
      // I(b1,c1) <+ (ddt((TYPE*(Qtex+Qex))))
      {
        AdmsFadType contribTemp;
        contribTemp= (((model_.TYPE)*(Qtex+Qex)));
        dynamicContributions[admsNodeID_b1] += contribTemp;
        dynamicContributions[admsNodeID_c1] -= contribTemp;

        Jdxp_dynamic[admsNodeID_b1] += contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_dynamic[admsNodeID_c1] -= contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
      // I(c3,c1) <+ (((TYPE*Vc3c4)*GCCex_TM))
      staticContributions[admsNodeID_c3] += (((model_.TYPE)*Vc3c4)*(model_.GCCex_TM));
      staticContributions[admsNodeID_c1] -= (((model_.TYPE)*Vc3c4)*(model_.GCCex_TM));
    }
  }
  else
  {
    // V(c3,c4) <+ (0)
    // do nothing at all
    if (((model_.RCBLI)>0.0))
    {
      // I(b,c4) <+ ((TYPE*XIex))
      {
        AdmsFadType contribTemp;
        contribTemp= ((model_.TYPE)*XIex);
        staticContributions[admsNodeID_b] += contribTemp;
        staticContributions[admsNodeID_c4] -= contribTemp;

        Jdxp_static[admsNodeID_b] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_static[admsNodeID_c4] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
      // I(c,c4) <+ (((TYPE*Vcc3)*GCCxx_TM))
      {
        AdmsFadType contribTemp;
        contribTemp= (((model_.TYPE)*Vcc3)*(model_.GCCxx_TM));
        staticContributions[admsNodeID_c] += contribTemp;
        staticContributions[admsNodeID_c4] -= contribTemp;

        Jdxp_static[admsNodeID_c] += contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_static[admsNodeID_c4] -= contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
      // I(c4,c1) <+ (((TYPE*Vc4c1)*GCCin_TM))
      staticContributions[admsNodeID_c4] += (((model_.TYPE)*Vc4c1)*(model_.GCCin_TM));
      staticContributions[admsNodeID_c1] -= (((model_.TYPE)*Vc4c1)*(model_.GCCin_TM));
      // I(b1,c4) <+ ((TYPE*(Ib3+Iex)))
      {
        AdmsFadType contribTemp;
        contribTemp= ((model_.TYPE)*(Ib3+Iex));
        staticContributions[admsNodeID_b1] += contribTemp;
        staticContributions[admsNodeID_c4] -= contribTemp;

        Jdxp_static[admsNodeID_b1] += contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_static[admsNodeID_c4] -= contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
      // I(b1,c4) <+ (ddt((TYPE*(Qtex+Qex))))
      {
        AdmsFadType contribTemp;
        contribTemp= (((model_.TYPE)*(Qtex+Qex)));
        dynamicContributions[admsNodeID_b1] += contribTemp;
        dynamicContributions[admsNodeID_c4] -= contribTemp;

        Jdxp_dynamic[admsNodeID_b1] += contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_dynamic[admsNodeID_c4] -= contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
      // I(b,c4) <+ (ddt((TYPE*(XQtex+XQex))))
      {
        AdmsFadType contribTemp;
        contribTemp= (((model_.TYPE)*(XQtex+XQex)));
        dynamicContributions[admsNodeID_b] += contribTemp;
        dynamicContributions[admsNodeID_c4] -= contribTemp;

        Jdxp_dynamic[admsNodeID_b] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_dynamic[admsNodeID_c4] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
    }
    else
    {
      // I(b,c1) <+ ((TYPE*XIex))
      {
        AdmsFadType contribTemp;
        contribTemp= ((model_.TYPE)*XIex);
        staticContributions[admsNodeID_b] += contribTemp;
        staticContributions[admsNodeID_c1] -= contribTemp;

        Jdxp_static[admsNodeID_b] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_static[admsNodeID_c1] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
      // I(c,c1) <+ (((TYPE*Vcc3)*GCCxx_TM))
      {
        AdmsFadType contribTemp;
        contribTemp= (((model_.TYPE)*Vcc3)*(model_.GCCxx_TM));
        staticContributions[admsNodeID_c] += contribTemp;
        staticContributions[admsNodeID_c1] -= contribTemp;

        Jdxp_static[admsNodeID_c] += contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_static[admsNodeID_c1] -= contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
      // V(c4,c1) <+ (0.0)
      // do nothing at all
      // I(b1,c1) <+ ((TYPE*(Ib3+Iex)))
      {
        AdmsFadType contribTemp;
        contribTemp= ((model_.TYPE)*(Ib3+Iex));
        staticContributions[admsNodeID_b1] += contribTemp;
        staticContributions[admsNodeID_c1] -= contribTemp;

        Jdxp_static[admsNodeID_b1] += contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_static[admsNodeID_c1] -= contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
      // I(b1,c1) <+ (ddt((TYPE*(Qtex+Qex))))
      {
        AdmsFadType contribTemp;
        contribTemp= (((model_.TYPE)*(Qtex+Qex)));
        dynamicContributions[admsNodeID_b1] += contribTemp;
        dynamicContributions[admsNodeID_c1] -= contribTemp;

        Jdxp_dynamic[admsNodeID_b1] += contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_dynamic[admsNodeID_c1] -= contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
      // I(b,c1) <+ (ddt((TYPE*(XQtex+XQex))))
      {
        AdmsFadType contribTemp;
        contribTemp= (((model_.TYPE)*(XQtex+XQex)));
        dynamicContributions[admsNodeID_b] += contribTemp;
        dynamicContributions[admsNodeID_c1] -= contribTemp;

        Jdxp_dynamic[admsNodeID_b] += contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
        Jdxp_dynamic[admsNodeID_c1] -= contribTemp.dx(admsProbeID_V_b2_c1)*probeDiffs[admsProbeID_V_b2_c1]*probeVars[admsProbeID_V_b2_c1].dx(admsProbeID_V_b2_c1)+contribTemp.dx(admsProbeID_V_b2_c2)*probeDiffs[admsProbeID_V_b2_c2]*probeVars[admsProbeID_V_b2_c2].dx(admsProbeID_V_b2_c2)+contribTemp.dx(admsProbeID_V_b1_b2)*probeDiffs[admsProbeID_V_b1_b2]*probeVars[admsProbeID_V_b1_b2].dx(admsProbeID_V_b1_b2);
      }
      // I(c3,c1) <+ (((TYPE*Vc3c4)*GCCex_TM))
      staticContributions[admsNodeID_c3] += (((model_.TYPE)*Vc3c4)*(model_.GCCex_TM));
      staticContributions[admsNodeID_c1] -= (((model_.TYPE)*Vc3c4)*(model_.GCCex_TM));
    }
  }
  //Begin block noise
  {
    common = ((4.0*1.3806226e-23)*(model_.Tk));
    powerREC = (common/(model_.RE_TM));
    powerRBC = (common/(model_.RBC_TM));
    powerRCCxx = (common*(model_.GCCxx_TM));
    powerRCCex = (common*(model_.GCCex_TM));
    powerRCCin = (common*(model_.GCCin_TM));
    powerRBV = (((common/Rb2)*((4.0*eVb1b2)+5.0))*0.33333333333333333333);
    powerCCS = (((2.0*1.6021918e-19)*(If+Ir))/qBI);
    powerFBCS = ((2.0*1.6021918e-19)*((fabs(Ib1)+fabs(Ib2))+fabs(Izteb)));
    powerFBC1fB1 = (((1.0-(model_.XIBI))*pow((fabs(Ib1)/(1-(model_.XIBI))),(model_.AF)))*(model_.KF_M));
    exponentFBC1fB2 = ((2.0*((model_.MLF)-1.0))+((model_.AF)*(2.0-(model_.MLF))));
    powerFBC1fB2 = ((model_.KFN_M)*pow(fabs(Ib2),exponentFBC1fB2));
    powerEBSCS = ((2.0*1.6021918e-19)*fabs(Ib1_s));
    if (((model_.XIBI)==0))
    {
      powerEBSC1f = 0.0;
    }
    else
    {
      powerEBSC1f = (((model_.KF_M)*(model_.XIBI))*pow(fabs((Ib1_s/(model_.XIBI))),(model_.AF)));
    }
    powerRBCS = ((2.0*1.6021918e-19)*fabs(Ib3));
    powerRBC1f = ((model_.KF_M)*pow(fabs(Ib3),(model_.AF)));
    powerExCS = ((2.0*1.6021918e-19)*fabs(Iex));
    powerExC1f = (((model_.KF_M)*(1-((model_.EXMOD)*(model_.XEXT))))*pow((fabs(Iex)/(1-((model_.EXMOD)*(model_.XEXT)))),(model_.AF)));
    powerExCSMOD = (((2.0*1.6021918e-19)*fabs(XIex))*(model_.EXMOD));
    if (((model_.XEXT)==0.0))
    {
      powerExC1fMOD = 0.0;
    }
    else
    {
      powerExC1fMOD = ((((model_.KF_M)*(model_.EXMOD))*(model_.XEXT))*pow((fabs(XIex)/(model_.XEXT)),(model_.AF)));
    }
    powerSubsCS_B1S = ((2.0*1.6021918e-19)*fabs(Isub));
    powerSubsCS_BS = ((2.0*1.6021918e-19)*fabs(XIsub));
    twoqIavl = (((model_.KAVL)*Gem)*powerCCS);
    powerCCS_A = (powerCCS+(twoqIavl*((3.0+(2.0*Gem))-(((2.0+(2.0*Gem))*(2.0+(2.0*Gem)))/(1.0+(2.0*Gem))))));
    // I(e,e1) <+ (white_noise(powerREC))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[0]= powerREC;
    }
    // I(b,b1) <+ (white_noise(powerRBC))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[1]= powerRBC;
    }
    // I(b1,b2) <+ (white_noise(powerRBV))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[2]= powerRBV.val();
    }
    // I(noi,e1) <+ (white_noise(twoqIavl))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[3]= twoqIavl.val();
    }
    // I(c2,e1) <+ (white_noise(powerCCS_A))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[4]= powerCCS_A.val();
    }
    // I(b2,e1) <+ (white_noise(powerFBCS))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[5]= powerFBCS.val();
    }
    // I(b2,e1) <+ (flicker_noise(powerFBC1fB1,1))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[6]= powerFBC1fB1.val();
      noiseContribsExponent[6]= 1;
    }
    // I(b2,e1) <+ (flicker_noise(powerFBC1fB2,1))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[7]= powerFBC1fB2.val();
      noiseContribsExponent[7]= 1;
    }
    // I(e1,b1) <+ (white_noise(powerEBSCS))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[8]= powerEBSCS.val();
    }
    // I(e1,b1) <+ (flicker_noise(powerEBSC1f,1))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[9]= powerEBSC1f.val();
      noiseContribsExponent[9]= 1;
    }
    // I(b1,c4) <+ (white_noise(powerRBCS))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[10]= powerRBCS.val();
    }
    // I(b1,c4) <+ (flicker_noise(powerRBC1f,1))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[11]= powerRBC1f.val();
      noiseContribsExponent[11]= 1;
    }
    // I(b1,c4) <+ (white_noise(powerExCS))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[12]= powerExCS.val();
    }
    // I(b1,c4) <+ (flicker_noise(powerExC1f,1))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[13]= powerExC1f.val();
      noiseContribsExponent[13]= 1;
    }
    // I(b,c3) <+ (white_noise(powerExCSMOD))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[14]= powerExCSMOD.val();
    }
    // I(b,c3) <+ (flicker_noise(powerExC1fMOD,1))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[15]= powerExC1fMOD.val();
      noiseContribsExponent[15]= 1;
    }
    // I(b1,s) <+ (white_noise(powerSubsCS_B1S))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[16]= powerSubsCS_B1S.val();
    }
    // I(b,s) <+ (white_noise(powerSubsCS_BS))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[17]= powerSubsCS_BS.val();
    }
    if (((model_.RCBLX)>0.0))
    {
      if (((model_.RCBLI)>0.0))
      {
        // I(c,c3) <+ (white_noise(powerRCCxx))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[18]= powerRCCxx;
        }
        // I(c3,c4) <+ (white_noise(powerRCCex))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[19]= powerRCCex;
        }
        // I(c4,c1) <+ (white_noise(powerRCCin))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[20]= powerRCCin;
        }
      }
      else
      {
        // I(c,c3) <+ (white_noise(powerRCCxx))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[21]= powerRCCxx;
        }
        // I(c3,c1) <+ (white_noise(powerRCCex))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[22]= powerRCCex;
        }
      }
    }
    else
    {
      if (((model_.RCBLI)>0.0))
      {
        // I(c,c4) <+ (white_noise(powerRCCxx))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[23]= powerRCCxx;
        }
        // I(c4,c1) <+ (white_noise(powerRCCin))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[24]= powerRCCin;
        }
      }
      else
      {
        // I(c,c1) <+ (white_noise(powerRCCxx))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[25]= powerRCCxx;
        }
      }
    }
  }
  // End block noise
  {
  }


  // -- endcode converted from analog/code block
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << " probeVars[admsProbeID_V_noi_e1] =  "
                 <<probeVars[admsProbeID_V_noi_e1].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_c3_c1] =  "
                 <<probeVars[admsProbeID_V_c3_c1].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_c3_c4] =  "
                 <<probeVars[admsProbeID_V_c3_c4].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_c4_c1] =  "
                 <<probeVars[admsProbeID_V_c4_c1].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_c] =  "
                 <<probeVars[admsProbeID_V_b_c].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_e] =  "
                 <<probeVars[admsProbeID_V_b_e].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_b1] =  "
                 <<probeVars[admsProbeID_V_b_b1].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_e_e1] =  "
                 <<probeVars[admsProbeID_V_e_e1].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_c1_c2] =  "
                 <<probeVars[admsProbeID_V_c1_c2].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_s_c1] =  "
                 <<probeVars[admsProbeID_V_s_c1].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b1_b2] =  "
                 <<probeVars[admsProbeID_V_b1_b2].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b1_e1] =  "
                 <<probeVars[admsProbeID_V_b1_e1].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b2_e1] =  "
                 <<probeVars[admsProbeID_V_b2_e1].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b2_c2] =  "
                 <<probeVars[admsProbeID_V_b2_c2].val() << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b2_c1] =  "
                 <<probeVars[admsProbeID_V_b2_c1].val() << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_c] =  "
                 <<staticContributions[admsNodeID_c].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_noi_e1) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_noi_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_c3_c1) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_c3_c4) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_c4_c1) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_b1) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_e_e1) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_c1_c2) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_s_c1) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b1_b2) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b1_e1) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b2_e1) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b2_c2) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b2_c1) =  " <<staticContributions[admsNodeID_c].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_c] =  "
                 <<dynamicContributions[admsNodeID_c].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_noi_e1) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_noi_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c3_c1) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c3_c4) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c4_c1) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_b1) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_e_e1) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c1_c2) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_s_c1) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b1_b2) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b1_e1) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b2_e1) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b2_c2) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b2_c1) =  " <<dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_c] =  "
                 <<Jdxp_static[admsNodeID_c] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_c] =  "
                 <<Jdxp_dynamic[admsNodeID_c] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_b] =  "
                 <<staticContributions[admsNodeID_b].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_noi_e1) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_noi_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_c3_c1) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_c3_c4) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_c4_c1) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_b1) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_e_e1) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_c1_c2) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_s_c1) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b1_b2) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b1_e1) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_e1) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_c2) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_c1) =  " <<staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_b] =  "
                 <<dynamicContributions[admsNodeID_b].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_noi_e1) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_noi_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c3_c1) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c3_c4) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c4_c1) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_b1) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_e_e1) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c1_c2) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_c1) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b1_b2) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b1_e1) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_e1) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_c2) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_c1) =  " <<dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_b] =  "
                 <<Jdxp_static[admsNodeID_b] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_b] =  "
                 <<Jdxp_dynamic[admsNodeID_b] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_e] =  "
                 <<staticContributions[admsNodeID_e].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_noi_e1) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_noi_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_c3_c1) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_c3_c4) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_c4_c1) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_b1) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_e_e1) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_c1_c2) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_s_c1) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b1_b2) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b1_e1) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b2_e1) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b2_c2) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b2_c1) =  " <<staticContributions[admsNodeID_e].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_e] =  "
                 <<dynamicContributions[admsNodeID_e].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_noi_e1) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_noi_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c3_c1) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c3_c4) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c4_c1) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_b1) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_e1) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c1_c2) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_s_c1) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b1_b2) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b1_e1) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b2_e1) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b2_c2) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b2_c1) =  " <<dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_e] =  "
                 <<Jdxp_static[admsNodeID_e] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_e] =  "
                 <<Jdxp_dynamic[admsNodeID_e] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_s] =  "
                 <<staticContributions[admsNodeID_s].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_noi_e1) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_noi_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_c3_c1) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_c3_c4) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_c4_c1) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_b1) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_e_e1) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_c1_c2) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_s_c1) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b1_b2) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b1_e1) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_e1) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_c2) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_c1) =  " <<staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_s] =  "
                 <<dynamicContributions[admsNodeID_s].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_noi_e1) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_noi_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c3_c1) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c3_c4) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c4_c1) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_b1) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_e1) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c1_c2) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_c1) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b1_b2) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b1_e1) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_e1) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_c2) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_c1) =  " <<dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_s] =  "
                 <<Jdxp_static[admsNodeID_s] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_s] =  "
                 <<Jdxp_dynamic[admsNodeID_s] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_e1] =  "
                 <<staticContributions[admsNodeID_e1].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_noi_e1) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_noi_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c1) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c4) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_c4_c1) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_b_b1) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_e_e1) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_c1_c2) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_s_c1) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_b1_b2) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_b1_e1) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_e1) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c2) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c1) =  " <<staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_e1] =  "
                 <<dynamicContributions[admsNodeID_e1].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_noi_e1) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_noi_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c1) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c4) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c4_c1) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_b1) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_e_e1) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c1_c2) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_s_c1) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b1_b2) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b1_e1) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_e1) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c2) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c1) =  " <<dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_e1] =  "
                 <<Jdxp_static[admsNodeID_e1] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_e1] =  "
                 <<Jdxp_dynamic[admsNodeID_e1] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_b1] =  "
                 <<staticContributions[admsNodeID_b1].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_noi_e1) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_noi_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c1) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c4) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_c4_c1) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_b1) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_e_e1) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_c1_c2) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_s_c1) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_b1_b2) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_b1_e1) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_e1) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c2) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c1) =  " <<staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_b1] =  "
                 <<dynamicContributions[admsNodeID_b1].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_noi_e1) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_noi_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c1) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c4) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c4_c1) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_b1) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_e_e1) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c1_c2) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_s_c1) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b1_b2) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b1_e1) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_e1) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c2) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c1) =  " <<dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_b1] =  "
                 <<Jdxp_static[admsNodeID_b1] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_b1] =  "
                 <<Jdxp_dynamic[admsNodeID_b1] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_b2] =  "
                 <<staticContributions[admsNodeID_b2].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_noi_e1) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_noi_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c1) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c4) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_c4_c1) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_b1) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_e_e1) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_c1_c2) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_s_c1) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_b1_b2) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_b1_e1) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_e1) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c2) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c1) =  " <<staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_b2] =  "
                 <<dynamicContributions[admsNodeID_b2].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_noi_e1) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_noi_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c1) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c4) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c4_c1) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_b1) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_e_e1) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c1_c2) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_s_c1) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b1_b2) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b1_e1) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_e1) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c2) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c1) =  " <<dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_b2] =  "
                 <<Jdxp_static[admsNodeID_b2] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_b2] =  "
                 <<Jdxp_dynamic[admsNodeID_b2] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_c1] =  "
                 <<staticContributions[admsNodeID_c1].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_noi_e1) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_noi_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c1) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c4) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_c4_c1) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_b1) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_e_e1) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_c1_c2) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_s_c1) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_b1_b2) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_b1_e1) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_e1) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c2) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c1) =  " <<staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_c1] =  "
                 <<dynamicContributions[admsNodeID_c1].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_noi_e1) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_noi_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c1) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c4) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c4_c1) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_b1) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_e_e1) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c1_c2) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_s_c1) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b1_b2) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b1_e1) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_e1) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c2) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c1) =  " <<dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_c1] =  "
                 <<Jdxp_static[admsNodeID_c1] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_c1] =  "
                 <<Jdxp_dynamic[admsNodeID_c1] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_c2] =  "
                 <<staticContributions[admsNodeID_c2].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_noi_e1) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_noi_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c1) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c4) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_c4_c1) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_b1) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_e_e1) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_c1_c2) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_s_c1) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_b1_b2) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_b1_e1) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_e1) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c2) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c1) =  " <<staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_c2] =  "
                 <<dynamicContributions[admsNodeID_c2].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_noi_e1) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_noi_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c1) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c4) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c4_c1) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_b1) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_e_e1) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c1_c2) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_s_c1) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b1_b2) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b1_e1) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_e1) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c2) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c1) =  " <<dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_c2] =  "
                 <<Jdxp_static[admsNodeID_c2] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_c2] =  "
                 <<Jdxp_dynamic[admsNodeID_c2] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_c3] =  "
                 <<staticContributions[admsNodeID_c3].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_noi_e1) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_noi_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c1) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c4) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_c4_c1) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_b1) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_e_e1) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_c1_c2) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_s_c1) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_b1_b2) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_b1_e1) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_e1) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c2) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c1) =  " <<staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_c3] =  "
                 <<dynamicContributions[admsNodeID_c3].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_noi_e1) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_noi_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c1) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c4) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c4_c1) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_b1) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_e_e1) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c1_c2) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_s_c1) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b1_b2) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b1_e1) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_e1) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c2) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c1) =  " <<dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_c3] =  "
                 <<Jdxp_static[admsNodeID_c3] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_c3] =  "
                 <<Jdxp_dynamic[admsNodeID_c3] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_c4] =  "
                 <<staticContributions[admsNodeID_c4].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_noi_e1) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_noi_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c1) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c4) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_c4_c1) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_b1) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_e_e1) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_c1_c2) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_s_c1) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_b1_b2) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_b1_e1) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_e1) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c2) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c1) =  " <<staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_c4] =  "
                 <<dynamicContributions[admsNodeID_c4].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_noi_e1) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_noi_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c1) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c4) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c4_c1) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_b1) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_e_e1) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c1_c2) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_s_c1) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b1_b2) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b1_e1) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_e1) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c2) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c1) =  " <<dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_c4] =  "
                 <<Jdxp_static[admsNodeID_c4] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_c4] =  "
                 <<Jdxp_dynamic[admsNodeID_c4] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_noi] =  "
                 <<staticContributions[admsNodeID_noi].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_noi_e1) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_noi_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_c3_c1) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_c3_c4) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_c4_c1) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_b_c) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_b_e) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_b_b1) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_e_e1) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_c1_c2) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_s_c1) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_b1_b2) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_b1_e1) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_e1) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c2) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c1) =  " <<staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_noi] =  "
                 <<dynamicContributions[admsNodeID_noi].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_noi_e1) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_noi_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_c3_c1) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_c3_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_c3_c4) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_c3_c4) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_c4_c1) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_c4_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b_c) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b_c) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b_e) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b_e) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b_b1) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b_b1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_e_e1) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_e_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_c1_c2) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_c1_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_s_c1) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_s_c1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b1_b2) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b1_b2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b1_e1) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b1_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b2_e1) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b2_e1) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c2) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c2) << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c1) =  " <<dynamicContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c1) << std::endl;
    Xyce::dout() << " Jdxp_static[admsNodeID_noi] =  "
                 <<Jdxp_static[admsNodeID_noi] << std::endl;
    Xyce::dout() << " Jdxp_dynamic[admsNodeID_noi] =  "
                 <<Jdxp_dynamic[admsNodeID_noi] << std::endl;

    if (!origFlag)
      Xyce::dout() << "This step was limited by this device." << std::endl;
  }

  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::getNumNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
int Instance::getNumNoiseSources () const
{
  return 26;
}

//-----------------------------------------------------------------------------
// Function      : Instance::setupNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{
  int numSources=getNumNoiseSources();
  noiseData.numSources = numSources;
  noiseData.resize(numSources);

  noiseData.deviceName = getName().getEncodedName();
  std::string theNoiseName;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_e_e1");
  noiseData.noiseNames[0]=theNoiseName;
  noiseData.li_Pos[0]=li_e;
  noiseData.li_Neg[0]=li_e1;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_b_b1");
  noiseData.noiseNames[1]=theNoiseName;
  noiseData.li_Pos[1]=li_b;
  noiseData.li_Neg[1]=li_b1;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_b1_b2");
  noiseData.noiseNames[2]=theNoiseName;
  noiseData.li_Pos[2]=li_b1;
  noiseData.li_Neg[2]=li_b2;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_noi_e1");
  noiseData.noiseNames[3]=theNoiseName;
  noiseData.li_Pos[3]=li_noi;
  noiseData.li_Neg[3]=li_e1;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_c2_e1");
  noiseData.noiseNames[4]=theNoiseName;
  noiseData.li_Pos[4]=li_c2;
  noiseData.li_Neg[4]=li_e1;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_b2_e1");
  noiseData.noiseNames[5]=theNoiseName;
  noiseData.li_Pos[5]=li_b2;
  noiseData.li_Neg[5]=li_e1;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_flicker_b2_e1");
  noiseData.noiseNames[6]=theNoiseName;
  noiseData.li_Pos[6]=li_b2;
  noiseData.li_Neg[6]=li_e1;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_flicker_b2_e1");
  noiseData.noiseNames[7]=theNoiseName;
  noiseData.li_Pos[7]=li_b2;
  noiseData.li_Neg[7]=li_e1;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_e1_b1");
  noiseData.noiseNames[8]=theNoiseName;
  noiseData.li_Pos[8]=li_e1;
  noiseData.li_Neg[8]=li_b1;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_flicker_e1_b1");
  noiseData.noiseNames[9]=theNoiseName;
  noiseData.li_Pos[9]=li_e1;
  noiseData.li_Neg[9]=li_b1;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_b1_c4");
  noiseData.noiseNames[10]=theNoiseName;
  noiseData.li_Pos[10]=li_b1;
  noiseData.li_Neg[10]=li_c4;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_flicker_b1_c4");
  noiseData.noiseNames[11]=theNoiseName;
  noiseData.li_Pos[11]=li_b1;
  noiseData.li_Neg[11]=li_c4;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_b1_c4");
  noiseData.noiseNames[12]=theNoiseName;
  noiseData.li_Pos[12]=li_b1;
  noiseData.li_Neg[12]=li_c4;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_flicker_b1_c4");
  noiseData.noiseNames[13]=theNoiseName;
  noiseData.li_Pos[13]=li_b1;
  noiseData.li_Neg[13]=li_c4;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_b_c3");
  noiseData.noiseNames[14]=theNoiseName;
  noiseData.li_Pos[14]=li_b;
  noiseData.li_Neg[14]=li_c3;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_flicker_b_c3");
  noiseData.noiseNames[15]=theNoiseName;
  noiseData.li_Pos[15]=li_b;
  noiseData.li_Neg[15]=li_c3;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_b1_s");
  noiseData.noiseNames[16]=theNoiseName;
  noiseData.li_Pos[16]=li_b1;
  noiseData.li_Neg[16]=li_s;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_b_s");
  noiseData.noiseNames[17]=theNoiseName;
  noiseData.li_Pos[17]=li_b;
  noiseData.li_Neg[17]=li_s;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_c_c3");
  noiseData.noiseNames[18]=theNoiseName;
  noiseData.li_Pos[18]=li_c;
  noiseData.li_Neg[18]=li_c3;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_c3_c4");
  noiseData.noiseNames[19]=theNoiseName;
  noiseData.li_Pos[19]=li_c3;
  noiseData.li_Neg[19]=li_c4;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_c4_c1");
  noiseData.noiseNames[20]=theNoiseName;
  noiseData.li_Pos[20]=li_c4;
  noiseData.li_Neg[20]=li_c1;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_c_c3");
  noiseData.noiseNames[21]=theNoiseName;
  noiseData.li_Pos[21]=li_c;
  noiseData.li_Neg[21]=li_c3;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_c3_c1");
  noiseData.noiseNames[22]=theNoiseName;
  noiseData.li_Pos[22]=li_c3;
  noiseData.li_Neg[22]=li_c1;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_c_c4");
  noiseData.noiseNames[23]=theNoiseName;
  noiseData.li_Pos[23]=li_c;
  noiseData.li_Neg[23]=li_c4;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_c4_c1");
  noiseData.noiseNames[24]=theNoiseName;
  noiseData.li_Pos[24]=li_c4;
  noiseData.li_Neg[24]=li_c1;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_c_c1");
  noiseData.noiseNames[25]=theNoiseName;
  noiseData.li_Pos[25]=li_c;
  noiseData.li_Neg[25]=li_c1;


}
//-----------------------------------------------------------------------------
// Function      : Instance::getNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::getNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{noiseData.noiseDens[0] = noiseContribsPower[0];
  noiseData.lnNoiseDens[0] = std::log(std::max(noiseData.noiseDens[0],N_MINLOG));
  noiseData.noiseDens[1] = noiseContribsPower[1];
  noiseData.lnNoiseDens[1] = std::log(std::max(noiseData.noiseDens[1],N_MINLOG));
  noiseData.noiseDens[2] = noiseContribsPower[2];
  noiseData.lnNoiseDens[2] = std::log(std::max(noiseData.noiseDens[2],N_MINLOG));
  noiseData.noiseDens[3] = noiseContribsPower[3];
  noiseData.lnNoiseDens[3] = std::log(std::max(noiseData.noiseDens[3],N_MINLOG));
  noiseData.noiseDens[4] = noiseContribsPower[4];
  noiseData.lnNoiseDens[4] = std::log(std::max(noiseData.noiseDens[4],N_MINLOG));
  noiseData.noiseDens[5] = noiseContribsPower[5];
  noiseData.lnNoiseDens[5] = std::log(std::max(noiseData.noiseDens[5],N_MINLOG));
  noiseData.noiseDens[6] = noiseContribsPower[6];

  noiseData.noiseDens[6] /= pow(noiseData.freq,noiseContribsExponent[6]);noiseData.lnNoiseDens[6] = std::log(std::max(noiseData.noiseDens[6],N_MINLOG));
  noiseData.noiseDens[7] = noiseContribsPower[7];

  noiseData.noiseDens[7] /= pow(noiseData.freq,noiseContribsExponent[7]);noiseData.lnNoiseDens[7] = std::log(std::max(noiseData.noiseDens[7],N_MINLOG));
  noiseData.noiseDens[8] = noiseContribsPower[8];
  noiseData.lnNoiseDens[8] = std::log(std::max(noiseData.noiseDens[8],N_MINLOG));
  noiseData.noiseDens[9] = noiseContribsPower[9];

  noiseData.noiseDens[9] /= pow(noiseData.freq,noiseContribsExponent[9]);noiseData.lnNoiseDens[9] = std::log(std::max(noiseData.noiseDens[9],N_MINLOG));
  noiseData.noiseDens[10] = noiseContribsPower[10];
  noiseData.lnNoiseDens[10] = std::log(std::max(noiseData.noiseDens[10],N_MINLOG));
  noiseData.noiseDens[11] = noiseContribsPower[11];

  noiseData.noiseDens[11] /= pow(noiseData.freq,noiseContribsExponent[11]);noiseData.lnNoiseDens[11] = std::log(std::max(noiseData.noiseDens[11],N_MINLOG));
  noiseData.noiseDens[12] = noiseContribsPower[12];
  noiseData.lnNoiseDens[12] = std::log(std::max(noiseData.noiseDens[12],N_MINLOG));
  noiseData.noiseDens[13] = noiseContribsPower[13];

  noiseData.noiseDens[13] /= pow(noiseData.freq,noiseContribsExponent[13]);noiseData.lnNoiseDens[13] = std::log(std::max(noiseData.noiseDens[13],N_MINLOG));
  noiseData.noiseDens[14] = noiseContribsPower[14];
  noiseData.lnNoiseDens[14] = std::log(std::max(noiseData.noiseDens[14],N_MINLOG));
  noiseData.noiseDens[15] = noiseContribsPower[15];

  noiseData.noiseDens[15] /= pow(noiseData.freq,noiseContribsExponent[15]);noiseData.lnNoiseDens[15] = std::log(std::max(noiseData.noiseDens[15],N_MINLOG));
  noiseData.noiseDens[16] = noiseContribsPower[16];
  noiseData.lnNoiseDens[16] = std::log(std::max(noiseData.noiseDens[16],N_MINLOG));
  noiseData.noiseDens[17] = noiseContribsPower[17];
  noiseData.lnNoiseDens[17] = std::log(std::max(noiseData.noiseDens[17],N_MINLOG));
  noiseData.noiseDens[18] = noiseContribsPower[18];
  noiseData.lnNoiseDens[18] = std::log(std::max(noiseData.noiseDens[18],N_MINLOG));
  noiseData.noiseDens[19] = noiseContribsPower[19];
  noiseData.lnNoiseDens[19] = std::log(std::max(noiseData.noiseDens[19],N_MINLOG));
  noiseData.noiseDens[20] = noiseContribsPower[20];
  noiseData.lnNoiseDens[20] = std::log(std::max(noiseData.noiseDens[20],N_MINLOG));
  noiseData.noiseDens[21] = noiseContribsPower[21];
  noiseData.lnNoiseDens[21] = std::log(std::max(noiseData.noiseDens[21],N_MINLOG));
  noiseData.noiseDens[22] = noiseContribsPower[22];
  noiseData.lnNoiseDens[22] = std::log(std::max(noiseData.noiseDens[22],N_MINLOG));
  noiseData.noiseDens[23] = noiseContribsPower[23];
  noiseData.lnNoiseDens[23] = std::log(std::max(noiseData.noiseDens[23],N_MINLOG));
  noiseData.noiseDens[24] = noiseContribsPower[24];
  noiseData.lnNoiseDens[24] = std::log(std::max(noiseData.noiseDens[24],N_MINLOG));
  noiseData.noiseDens[25] = noiseContribsPower[25];
  noiseData.lnNoiseDens[25] = std::log(std::max(noiseData.noiseDens[25],N_MINLOG));

}  

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdFdx
// Purpose       :
// Special Notes : Load the dFdx ("static jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdFdx()
{
  bool bsuccess = true;
  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*f_c1_Equ_c1_Node_Ptr) +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_c1].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c1].dx(admsProbeID_V_s_c1) -staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_c1_c2);
  (*f_c1_Equ_c2_Node_Ptr) +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_c1].dx(admsProbeID_V_c1_c2);
  (*f_c2_Equ_c1_Node_Ptr) +=  -staticContributions[admsNodeID_c2].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_c1_c2);
  (*f_c2_Equ_c2_Node_Ptr) +=  -staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_c2].dx(admsProbeID_V_c1_c2);
  (*f_c1_Equ_b2_Node_Ptr) +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c1);
  (*f_c2_Equ_b2_Node_Ptr) +=  -staticContributions[admsNodeID_c2].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c1);
  (*f_e1_Equ_c1_Node_Ptr) +=  -staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_e1].dx(admsProbeID_V_c1_c2);
  (*f_e1_Equ_c2_Node_Ptr) +=  -staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_e1].dx(admsProbeID_V_c1_c2);
  (*f_e1_Equ_b2_Node_Ptr) +=  +staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c1);
  (*f_c2_Equ_e1_Node_Ptr) +=  -staticContributions[admsNodeID_c2].dx(admsProbeID_V_noi_e1) -staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_e1);
  (*f_e1_Equ_e1_Node_Ptr) +=  -staticContributions[admsNodeID_e1].dx(admsProbeID_V_noi_e1) -staticContributions[admsNodeID_e1].dx(admsProbeID_V_e_e1) -staticContributions[admsNodeID_e1].dx(admsProbeID_V_b1_e1) -staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_e1);
  (*f_b1_Equ_b1_Node_Ptr) +=  -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b1_e1);
  (*f_b1_Equ_e1_Node_Ptr) +=  -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_e1) -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b1_e1);
  (*f_e1_Equ_b1_Node_Ptr) +=  +staticContributions[admsNodeID_e1].dx(admsProbeID_V_b1_e1);
  (*f_b2_Equ_b2_Node_Ptr) +=  -staticContributions[admsNodeID_b2].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_e1);
  (*f_b2_Equ_e1_Node_Ptr) +=  -staticContributions[admsNodeID_b2].dx(admsProbeID_V_noi_e1) -staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_e1);
  (*f_b2_Equ_c1_Node_Ptr) +=  -staticContributions[admsNodeID_b2].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_b2].dx(admsProbeID_V_c1_c2);
  (*f_b2_Equ_c2_Node_Ptr) +=  -staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_b2].dx(admsProbeID_V_c1_c2);
  (*f_b1_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_b1].dx(admsProbeID_V_s_c1);
  (*f_b1_Equ_c1_Node_Ptr) +=  -staticContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_c1_c2) -staticContributions[admsNodeID_b1].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_b1].dx(admsProbeID_V_s_c1);
  (*f_s_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_s_c1);
  (*f_s_Equ_c1_Node_Ptr) +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_s].dx(admsProbeID_V_c1_c2) -staticContributions[admsNodeID_s].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_s].dx(admsProbeID_V_s_c1);
  (*f_b1_Equ_c4_Node_Ptr) +=  -staticContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c4) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_c4_c1);
  (*f_s_Equ_c4_Node_Ptr) +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_c3_c4) +staticContributions[admsNodeID_s].dx(admsProbeID_V_c4_c1);
  (*f_b1_Equ_c2_Node_Ptr) +=  -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_b1].dx(admsProbeID_V_c1_c2);
  (*f_s_Equ_c2_Node_Ptr) +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_s].dx(admsProbeID_V_c1_c2);
  (*f_b1_Equ_b2_Node_Ptr) +=  +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c1) -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c2);
  (*f_s_Equ_b2_Node_Ptr) +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_c1) -staticContributions[admsNodeID_s].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_c2);
  (*f_s_Equ_b1_Node_Ptr) +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_s].dx(admsProbeID_V_b1_b2);
  (*f_b_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_s_c1);
  (*f_b_Equ_c1_Node_Ptr) +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_b].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_b].dx(admsProbeID_V_c1_c2) -staticContributions[admsNodeID_b].dx(admsProbeID_V_s_c1);
  (*f_b_Equ_c2_Node_Ptr) +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_b].dx(admsProbeID_V_c1_c2);
  (*f_b_Equ_b2_Node_Ptr) +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_c1);
  (*f_b_Equ_e1_Node_Ptr) +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_e1);
  (*f_s_Equ_e1_Node_Ptr) +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_e1);
  (*f_b_Equ_c3_Node_Ptr) +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_b].dx(admsProbeID_V_c3_c4);
  (*f_b_Equ_c4_Node_Ptr) +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_b].dx(admsProbeID_V_c3_c4);
  (*f_s_Equ_c3_Node_Ptr) +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_s].dx(admsProbeID_V_c3_c4);
  (*f_b_Equ_b1_Node_Ptr) +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_b].dx(admsProbeID_V_b1_b2);
  (*f_b_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_b].dx(admsProbeID_V_b_b1);
  (*f_s_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_s].dx(admsProbeID_V_b_b1);
  (*f_b_Equ_c_Node_Ptr) +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b_c);
  (*f_s_Equ_c_Node_Ptr) +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_b_c);
  (*f_c1_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_c1].dx(admsProbeID_V_s_c1);
  (*f_b1_Equ_c3_Node_Ptr) +=  +staticContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c4);
  (*f_b2_Equ_c3_Node_Ptr) +=  +staticContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c4);
  (*f_b2_Equ_c4_Node_Ptr) +=  +staticContributions[admsNodeID_b2].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c4);
  (*f_b1_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_b1);
  (*f_b2_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_b1);
  (*f_b2_Equ_b1_Node_Ptr) +=  +staticContributions[admsNodeID_b2].dx(admsProbeID_V_b1_b2) -staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_b1);
  (*f_b1_Equ_c_Node_Ptr) +=  -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_c);
  (*f_b2_Equ_c_Node_Ptr) +=  -staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_c);
  (*f_c2_Equ_c3_Node_Ptr) +=  +staticContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c4);
  (*f_c2_Equ_c4_Node_Ptr) +=  +staticContributions[admsNodeID_c2].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c4);
  (*f_c2_Equ_b1_Node_Ptr) +=  -staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_b1_b2);
  (*f_c2_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_b1);
  (*f_c2_Equ_c_Node_Ptr) +=  -staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_c);
  (*f_e_Equ_e_Node_Ptr) +=  +staticContributions[admsNodeID_e].dx(admsProbeID_V_e_e1);
  (*f_e_Equ_e1_Node_Ptr) +=  -staticContributions[admsNodeID_e].dx(admsProbeID_V_e_e1);
  (*f_e1_Equ_e_Node_Ptr) +=  +staticContributions[admsNodeID_e1].dx(admsProbeID_V_e_e1);
  (*f_noi_Equ_noi_Node_Ptr) +=  +staticContributions[admsNodeID_noi].dx(admsProbeID_V_noi_e1);
  (*f_noi_Equ_e1_Node_Ptr) +=  -staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_e1) -staticContributions[admsNodeID_noi].dx(admsProbeID_V_noi_e1);
  (*f_e1_Equ_noi_Node_Ptr) +=  +staticContributions[admsNodeID_e1].dx(admsProbeID_V_noi_e1);
  (*f_b2_Equ_noi_Node_Ptr) +=  +staticContributions[admsNodeID_b2].dx(admsProbeID_V_noi_e1);
  (*f_c2_Equ_noi_Node_Ptr) +=  +staticContributions[admsNodeID_c2].dx(admsProbeID_V_noi_e1);
  (*f_c_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_c].dx(admsProbeID_V_b_b1);
  (*f_c_Equ_c_Node_Ptr) +=  -staticContributions[admsNodeID_c].dx(admsProbeID_V_b_c);
  (*f_c3_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_c3].dx(admsProbeID_V_s_c1);
  (*f_c3_Equ_c1_Node_Ptr) +=  -staticContributions[admsNodeID_c3].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_c1_c2) -staticContributions[admsNodeID_c3].dx(admsProbeID_V_s_c1);
  (*f_c3_Equ_c2_Node_Ptr) +=  -staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_c3].dx(admsProbeID_V_c1_c2);
  (*f_c3_Equ_b2_Node_Ptr) +=  -staticContributions[admsNodeID_c3].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c1);
  (*f_c3_Equ_e1_Node_Ptr) +=  -staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_e1);
  (*f_c3_Equ_c3_Node_Ptr) +=  +staticContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c4);
  (*f_c3_Equ_c4_Node_Ptr) +=  +staticContributions[admsNodeID_c3].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c4);
  (*f_c3_Equ_b1_Node_Ptr) +=  -staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_b1_b2);
  (*f_c3_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_b1);
  (*f_c3_Equ_c_Node_Ptr) +=  -staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_c);
  (*f_c_Equ_c3_Node_Ptr) +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_c].dx(admsProbeID_V_c3_c4);
  (*f_c_Equ_c4_Node_Ptr) +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c].dx(admsProbeID_V_c3_c4);
  (*f_c_Equ_c1_Node_Ptr) +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_c1_c2) -staticContributions[admsNodeID_c].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c].dx(admsProbeID_V_c3_c1);
  (*f_c_Equ_c2_Node_Ptr) +=  -staticContributions[admsNodeID_c].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_c].dx(admsProbeID_V_c1_c2);
  (*f_c_Equ_b2_Node_Ptr) +=  -staticContributions[admsNodeID_c].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_c].dx(admsProbeID_V_b2_c2);
  (*f_c_Equ_b1_Node_Ptr) +=  -staticContributions[admsNodeID_c].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_c].dx(admsProbeID_V_b1_b2);
  (*f_c4_Equ_c4_Node_Ptr) +=  -staticContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c4) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_c4_c1);
  (*f_c4_Equ_c1_Node_Ptr) +=  -staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c1) -staticContributions[admsNodeID_c4].dx(admsProbeID_V_s_c1) -staticContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_c1_c2) -staticContributions[admsNodeID_c4].dx(admsProbeID_V_c4_c1);
  (*f_c1_Equ_c4_Node_Ptr) +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c4) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_c4_c1);
  (*f_c4_Equ_b2_Node_Ptr) +=  +staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c1) -staticContributions[admsNodeID_c4].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_e1);
  (*f_c4_Equ_e1_Node_Ptr) +=  -staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_e1);
  (*f_c4_Equ_c2_Node_Ptr) +=  -staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_c4].dx(admsProbeID_V_c1_c2);
  (*f_c4_Equ_b1_Node_Ptr) +=  -staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_b1_b2);
  (*f_c4_Equ_c3_Node_Ptr) +=  +staticContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c4);
  (*f_c1_Equ_e1_Node_Ptr) +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_e1);
  (*f_c1_Equ_b1_Node_Ptr) +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_b1_b2);
  (*f_c1_Equ_c3_Node_Ptr) +=  +staticContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c4);
  (*f_c4_Equ_s_Node_Ptr) +=  +staticContributions[admsNodeID_c4].dx(admsProbeID_V_s_c1);
  (*f_c4_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_b1);
  (*f_c4_Equ_c_Node_Ptr) +=  -staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_c);
  (*f_c1_Equ_b_Node_Ptr) +=  +staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_b1);
  (*f_c1_Equ_c_Node_Ptr) +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_c);
  (*f_noi_Equ_b2_Node_Ptr) +=  +staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_e1);
  (*f_noi_Equ_c1_Node_Ptr) +=  -staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_noi].dx(admsProbeID_V_c1_c2);
  (*f_noi_Equ_c2_Node_Ptr) +=  -staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_noi].dx(admsProbeID_V_c1_c2);

#else
  //use the offsets instead of pointers
  dFdx[li_c1][A_c1_Equ_c1_NodeOffset] +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_c1].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c1].dx(admsProbeID_V_s_c1) -staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_c1_c2);
  dFdx[li_c1][A_c1_Equ_c2_NodeOffset] +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_c1].dx(admsProbeID_V_c1_c2);
  dFdx[li_c2][A_c2_Equ_c1_NodeOffset] +=  -staticContributions[admsNodeID_c2].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_c1_c2);
  dFdx[li_c2][A_c2_Equ_c2_NodeOffset] +=  -staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_c2].dx(admsProbeID_V_c1_c2);
  dFdx[li_c1][A_c1_Equ_b2_NodeOffset] +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c1);
  dFdx[li_c2][A_c2_Equ_b2_NodeOffset] +=  -staticContributions[admsNodeID_c2].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c1);
  dFdx[li_e1][A_e1_Equ_c1_NodeOffset] +=  -staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_e1].dx(admsProbeID_V_c1_c2);
  dFdx[li_e1][A_e1_Equ_c2_NodeOffset] +=  -staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_e1].dx(admsProbeID_V_c1_c2);
  dFdx[li_e1][A_e1_Equ_b2_NodeOffset] +=  +staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c1);
  dFdx[li_c2][A_c2_Equ_e1_NodeOffset] +=  -staticContributions[admsNodeID_c2].dx(admsProbeID_V_noi_e1) -staticContributions[admsNodeID_c2].dx(admsProbeID_V_b2_e1);
  dFdx[li_e1][A_e1_Equ_e1_NodeOffset] +=  -staticContributions[admsNodeID_e1].dx(admsProbeID_V_noi_e1) -staticContributions[admsNodeID_e1].dx(admsProbeID_V_e_e1) -staticContributions[admsNodeID_e1].dx(admsProbeID_V_b1_e1) -staticContributions[admsNodeID_e1].dx(admsProbeID_V_b2_e1);
  dFdx[li_b1][A_b1_Equ_b1_NodeOffset] +=  -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b1_e1);
  dFdx[li_b1][A_b1_Equ_e1_NodeOffset] +=  -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_e1) -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b1_e1);
  dFdx[li_e1][A_e1_Equ_b1_NodeOffset] +=  +staticContributions[admsNodeID_e1].dx(admsProbeID_V_b1_e1);
  dFdx[li_b2][A_b2_Equ_b2_NodeOffset] +=  -staticContributions[admsNodeID_b2].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_e1);
  dFdx[li_b2][A_b2_Equ_e1_NodeOffset] +=  -staticContributions[admsNodeID_b2].dx(admsProbeID_V_noi_e1) -staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_e1);
  dFdx[li_b2][A_b2_Equ_c1_NodeOffset] +=  -staticContributions[admsNodeID_b2].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_b2].dx(admsProbeID_V_c1_c2);
  dFdx[li_b2][A_b2_Equ_c2_NodeOffset] +=  -staticContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_b2].dx(admsProbeID_V_c1_c2);
  dFdx[li_b1][A_b1_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_b1].dx(admsProbeID_V_s_c1);
  dFdx[li_b1][A_b1_Equ_c1_NodeOffset] +=  -staticContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_c1_c2) -staticContributions[admsNodeID_b1].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_b1].dx(admsProbeID_V_s_c1);
  dFdx[li_s][A_s_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_s_c1);
  dFdx[li_s][A_s_Equ_c1_NodeOffset] +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_s].dx(admsProbeID_V_c1_c2) -staticContributions[admsNodeID_s].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_s].dx(admsProbeID_V_s_c1);
  dFdx[li_b1][A_b1_Equ_c4_NodeOffset] +=  -staticContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c4) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_c4_c1);
  dFdx[li_s][A_s_Equ_c4_NodeOffset] +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_c3_c4) +staticContributions[admsNodeID_s].dx(admsProbeID_V_c4_c1);
  dFdx[li_b1][A_b1_Equ_c2_NodeOffset] +=  -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_b1].dx(admsProbeID_V_c1_c2);
  dFdx[li_s][A_s_Equ_c2_NodeOffset] +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_s].dx(admsProbeID_V_c1_c2);
  dFdx[li_b1][A_b1_Equ_b2_NodeOffset] +=  +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c1) -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c2);
  dFdx[li_s][A_s_Equ_b2_NodeOffset] +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_c1) -staticContributions[admsNodeID_s].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_c2);
  dFdx[li_s][A_s_Equ_b1_NodeOffset] +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_s].dx(admsProbeID_V_b1_b2);
  dFdx[li_b][A_b_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_s_c1);
  dFdx[li_b][A_b_Equ_c1_NodeOffset] +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_b].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_b].dx(admsProbeID_V_c1_c2) -staticContributions[admsNodeID_b].dx(admsProbeID_V_s_c1);
  dFdx[li_b][A_b_Equ_c2_NodeOffset] +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_b].dx(admsProbeID_V_c1_c2);
  dFdx[li_b][A_b_Equ_b2_NodeOffset] +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_c1);
  dFdx[li_b][A_b_Equ_e1_NodeOffset] +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b2_e1);
  dFdx[li_s][A_s_Equ_e1_NodeOffset] +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_b2_e1);
  dFdx[li_b][A_b_Equ_c3_NodeOffset] +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_b].dx(admsProbeID_V_c3_c4);
  dFdx[li_b][A_b_Equ_c4_NodeOffset] +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_b].dx(admsProbeID_V_c3_c4);
  dFdx[li_s][A_s_Equ_c3_NodeOffset] +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_s].dx(admsProbeID_V_c3_c4);
  dFdx[li_b][A_b_Equ_b1_NodeOffset] +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_b].dx(admsProbeID_V_b1_b2);
  dFdx[li_b][A_b_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_b].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_b].dx(admsProbeID_V_b_b1);
  dFdx[li_s][A_s_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_s].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_s].dx(admsProbeID_V_b_b1);
  dFdx[li_b][A_b_Equ_c_NodeOffset] +=  -staticContributions[admsNodeID_b].dx(admsProbeID_V_b_c);
  dFdx[li_s][A_s_Equ_c_NodeOffset] +=  -staticContributions[admsNodeID_s].dx(admsProbeID_V_b_c);
  dFdx[li_c1][A_c1_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_c1].dx(admsProbeID_V_s_c1);
  dFdx[li_b1][A_b1_Equ_c3_NodeOffset] +=  +staticContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c4);
  dFdx[li_b2][A_b2_Equ_c3_NodeOffset] +=  +staticContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c4);
  dFdx[li_b2][A_b2_Equ_c4_NodeOffset] +=  +staticContributions[admsNodeID_b2].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c4);
  dFdx[li_b1][A_b1_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_b1);
  dFdx[li_b2][A_b2_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_b1);
  dFdx[li_b2][A_b2_Equ_b1_NodeOffset] +=  +staticContributions[admsNodeID_b2].dx(admsProbeID_V_b1_b2) -staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_b1);
  dFdx[li_b1][A_b1_Equ_c_NodeOffset] +=  -staticContributions[admsNodeID_b1].dx(admsProbeID_V_b_c);
  dFdx[li_b2][A_b2_Equ_c_NodeOffset] +=  -staticContributions[admsNodeID_b2].dx(admsProbeID_V_b_c);
  dFdx[li_c2][A_c2_Equ_c3_NodeOffset] +=  +staticContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c4);
  dFdx[li_c2][A_c2_Equ_c4_NodeOffset] +=  +staticContributions[admsNodeID_c2].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c4);
  dFdx[li_c2][A_c2_Equ_b1_NodeOffset] +=  -staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_b1_b2);
  dFdx[li_c2][A_c2_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_b1);
  dFdx[li_c2][A_c2_Equ_c_NodeOffset] +=  -staticContributions[admsNodeID_c2].dx(admsProbeID_V_b_c);
  dFdx[li_e][A_e_Equ_e_NodeOffset] +=  +staticContributions[admsNodeID_e].dx(admsProbeID_V_e_e1);
  dFdx[li_e][A_e_Equ_e1_NodeOffset] +=  -staticContributions[admsNodeID_e].dx(admsProbeID_V_e_e1);
  dFdx[li_e1][A_e1_Equ_e_NodeOffset] +=  +staticContributions[admsNodeID_e1].dx(admsProbeID_V_e_e1);
  dFdx[li_noi][A_noi_Equ_noi_NodeOffset] +=  +staticContributions[admsNodeID_noi].dx(admsProbeID_V_noi_e1);
  dFdx[li_noi][A_noi_Equ_e1_NodeOffset] +=  -staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_e1) -staticContributions[admsNodeID_noi].dx(admsProbeID_V_noi_e1);
  dFdx[li_e1][A_e1_Equ_noi_NodeOffset] +=  +staticContributions[admsNodeID_e1].dx(admsProbeID_V_noi_e1);
  dFdx[li_b2][A_b2_Equ_noi_NodeOffset] +=  +staticContributions[admsNodeID_b2].dx(admsProbeID_V_noi_e1);
  dFdx[li_c2][A_c2_Equ_noi_NodeOffset] +=  +staticContributions[admsNodeID_c2].dx(admsProbeID_V_noi_e1);
  dFdx[li_c][A_c_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_c].dx(admsProbeID_V_b_b1);
  dFdx[li_c][A_c_Equ_c_NodeOffset] +=  -staticContributions[admsNodeID_c].dx(admsProbeID_V_b_c);
  dFdx[li_c3][A_c3_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_c3].dx(admsProbeID_V_s_c1);
  dFdx[li_c3][A_c3_Equ_c1_NodeOffset] +=  -staticContributions[admsNodeID_c3].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c1) -staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_c1_c2) -staticContributions[admsNodeID_c3].dx(admsProbeID_V_s_c1);
  dFdx[li_c3][A_c3_Equ_c2_NodeOffset] +=  -staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_c3].dx(admsProbeID_V_c1_c2);
  dFdx[li_c3][A_c3_Equ_b2_NodeOffset] +=  -staticContributions[admsNodeID_c3].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_e1) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c1);
  dFdx[li_c3][A_c3_Equ_e1_NodeOffset] +=  -staticContributions[admsNodeID_c3].dx(admsProbeID_V_b2_e1);
  dFdx[li_c3][A_c3_Equ_c3_NodeOffset] +=  +staticContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c4);
  dFdx[li_c3][A_c3_Equ_c4_NodeOffset] +=  +staticContributions[admsNodeID_c3].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c4);
  dFdx[li_c3][A_c3_Equ_b1_NodeOffset] +=  -staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_b1_b2);
  dFdx[li_c3][A_c3_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_b1);
  dFdx[li_c3][A_c3_Equ_c_NodeOffset] +=  -staticContributions[admsNodeID_c3].dx(admsProbeID_V_b_c);
  dFdx[li_c][A_c_Equ_c3_NodeOffset] +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_c].dx(admsProbeID_V_c3_c4);
  dFdx[li_c][A_c_Equ_c4_NodeOffset] +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c].dx(admsProbeID_V_c3_c4);
  dFdx[li_c][A_c_Equ_c1_NodeOffset] +=  +staticContributions[admsNodeID_c].dx(admsProbeID_V_c1_c2) -staticContributions[admsNodeID_c].dx(admsProbeID_V_c4_c1) -staticContributions[admsNodeID_c].dx(admsProbeID_V_c3_c1);
  dFdx[li_c][A_c_Equ_c2_NodeOffset] +=  -staticContributions[admsNodeID_c].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_c].dx(admsProbeID_V_c1_c2);
  dFdx[li_c][A_c_Equ_b2_NodeOffset] +=  -staticContributions[admsNodeID_c].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_c].dx(admsProbeID_V_b2_c2);
  dFdx[li_c][A_c_Equ_b1_NodeOffset] +=  -staticContributions[admsNodeID_c].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_c].dx(admsProbeID_V_b1_b2);
  dFdx[li_c4][A_c4_Equ_c4_NodeOffset] +=  -staticContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c4) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_c4_c1);
  dFdx[li_c4][A_c4_Equ_c1_NodeOffset] +=  -staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c1) -staticContributions[admsNodeID_c4].dx(admsProbeID_V_s_c1) -staticContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_c1_c2) -staticContributions[admsNodeID_c4].dx(admsProbeID_V_c4_c1);
  dFdx[li_c1][A_c1_Equ_c4_NodeOffset] +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c4) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_c4_c1);
  dFdx[li_c4][A_c4_Equ_b2_NodeOffset] +=  +staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c1) -staticContributions[admsNodeID_c4].dx(admsProbeID_V_b1_b2) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_e1);
  dFdx[li_c4][A_c4_Equ_e1_NodeOffset] +=  -staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_e1);
  dFdx[li_c4][A_c4_Equ_c2_NodeOffset] +=  -staticContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_c4].dx(admsProbeID_V_c1_c2);
  dFdx[li_c4][A_c4_Equ_b1_NodeOffset] +=  -staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_b1_b2);
  dFdx[li_c4][A_c4_Equ_c3_NodeOffset] +=  +staticContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c4);
  dFdx[li_c1][A_c1_Equ_e1_NodeOffset] +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_b2_e1);
  dFdx[li_c1][A_c1_Equ_b1_NodeOffset] +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_b1) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_b1_b2);
  dFdx[li_c1][A_c1_Equ_c3_NodeOffset] +=  +staticContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c1) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c4);
  dFdx[li_c4][A_c4_Equ_s_NodeOffset] +=  +staticContributions[admsNodeID_c4].dx(admsProbeID_V_s_c1);
  dFdx[li_c4][A_c4_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_b1);
  dFdx[li_c4][A_c4_Equ_c_NodeOffset] +=  -staticContributions[admsNodeID_c4].dx(admsProbeID_V_b_c);
  dFdx[li_c1][A_c1_Equ_b_NodeOffset] +=  +staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_c) +staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_b1);
  dFdx[li_c1][A_c1_Equ_c_NodeOffset] +=  -staticContributions[admsNodeID_c1].dx(admsProbeID_V_b_c);
  dFdx[li_noi][A_noi_Equ_b2_NodeOffset] +=  +staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c2) +staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_e1);
  dFdx[li_noi][A_noi_Equ_c1_NodeOffset] +=  -staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c1) +staticContributions[admsNodeID_noi].dx(admsProbeID_V_c1_c2);
  dFdx[li_noi][A_noi_Equ_c2_NodeOffset] +=  -staticContributions[admsNodeID_noi].dx(admsProbeID_V_b2_c2) -staticContributions[admsNodeID_noi].dx(admsProbeID_V_c1_c2);

#endif
  
  return bsuccess;
}


//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdQdx
// Purpose       :
// Special Notes : Load the dQdx ("dynamic jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdQdx()
{
  bool bsuccess = true;
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*q_c1_Equ_c1_Node_Ptr) +=  -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c1) -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c1) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c1_c2) -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_s_c1);
  (*q_c1_Equ_c2_Node_Ptr) +=  -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c1_c2);
  (*q_c2_Equ_c1_Node_Ptr) +=  -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c1) +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c1_c2) -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c1);
  (*q_c2_Equ_c2_Node_Ptr) +=  -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c1_c2);
  (*q_c1_Equ_b2_Node_Ptr) +=  +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_e1) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c1) -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c2);
  (*q_c2_Equ_b2_Node_Ptr) +=  +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c1) +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_e1) -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b1_b2);
  (*q_e1_Equ_c1_Node_Ptr) +=  -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c1) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c1) +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c1_c2);
  (*q_e1_Equ_c2_Node_Ptr) +=  -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c1_c2);
  (*q_e1_Equ_b2_Node_Ptr) +=  +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_e1) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c1);
  (*q_c2_Equ_e1_Node_Ptr) +=  -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_e1);
  (*q_e1_Equ_e1_Node_Ptr) +=  -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b1_e1) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_e1);
  (*q_b1_Equ_b1_Node_Ptr) +=  +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b1_b2) -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b1_e1);
  (*q_b1_Equ_e1_Node_Ptr) +=  -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_e1) -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b1_e1);
  (*q_e1_Equ_b1_Node_Ptr) +=  +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b1_e1) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b1_b2);
  (*q_b2_Equ_b2_Node_Ptr) +=  +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_e1) -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c1);
  (*q_b2_Equ_e1_Node_Ptr) +=  -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_e1);
  (*q_b2_Equ_c1_Node_Ptr) +=  -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c1) -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c1) +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c1_c2);
  (*q_b2_Equ_c2_Node_Ptr) +=  -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c1_c2);
  (*q_b1_Equ_c1_Node_Ptr) +=  -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c1) -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c1) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c1_c2);
  (*q_s_Equ_s_Node_Ptr) +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_c1);
  (*q_s_Equ_c1_Node_Ptr) +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_c1);
  (*q_b1_Equ_c4_Node_Ptr) +=  +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c4);
  (*q_b1_Equ_c2_Node_Ptr) +=  -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c1_c2);
  (*q_b1_Equ_b2_Node_Ptr) +=  -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_e1) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c1);
  (*q_b_Equ_s_Node_Ptr) +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_c1);
  (*q_b_Equ_c1_Node_Ptr) +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c1_c2) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c3_c1) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_c1) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_c1);
  (*q_b_Equ_c2_Node_Ptr) +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c1_c2);
  (*q_b_Equ_b2_Node_Ptr) +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_e1) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_c1);
  (*q_b_Equ_e1_Node_Ptr) +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_e1);
  (*q_b_Equ_c3_Node_Ptr) +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c3_c4);
  (*q_b_Equ_c4_Node_Ptr) +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c3_c4);
  (*q_b_Equ_b1_Node_Ptr) +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b1_b2);
  (*q_b_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e);
  (*q_b_Equ_c_Node_Ptr) +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c);
  (*q_c1_Equ_s_Node_Ptr) +=  +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_s_c1);
  (*q_b1_Equ_c3_Node_Ptr) +=  +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c4);
  (*q_b2_Equ_c3_Node_Ptr) +=  +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c4);
  (*q_b2_Equ_c4_Node_Ptr) +=  +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c4);
  (*q_b1_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_b1);
  (*q_b2_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_b1);
  (*q_b2_Equ_b1_Node_Ptr) +=  -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b1_b2);
  (*q_b1_Equ_c_Node_Ptr) +=  -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_c);
  (*q_b2_Equ_c_Node_Ptr) +=  -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_c);
  (*q_c2_Equ_c3_Node_Ptr) +=  +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c4);
  (*q_c2_Equ_c4_Node_Ptr) +=  +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c4);
  (*q_c2_Equ_b1_Node_Ptr) +=  -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b1_b2);
  (*q_c2_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_b1);
  (*q_c2_Equ_c_Node_Ptr) +=  -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_c);
  (*q_e_Equ_e_Node_Ptr) +=  -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e);
  (*q_e1_Equ_c3_Node_Ptr) +=  +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c4);
  (*q_e1_Equ_c4_Node_Ptr) +=  +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c4);
  (*q_e1_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_b1);
  (*q_e1_Equ_c_Node_Ptr) +=  -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_c);
  (*q_b_Equ_e_Node_Ptr) +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e);
  (*q_e_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e);
  (*q_c_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c);
  (*q_c_Equ_c_Node_Ptr) +=  -dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c);
  (*q_c3_Equ_s_Node_Ptr) +=  +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_s_c1);
  (*q_c3_Equ_c1_Node_Ptr) +=  +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c1_c2) -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c1) -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c1) -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_s_c1);
  (*q_c3_Equ_c2_Node_Ptr) +=  -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c1_c2);
  (*q_c3_Equ_b2_Node_Ptr) +=  -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_e1) +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c1);
  (*q_c3_Equ_e1_Node_Ptr) +=  -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_e1);
  (*q_c3_Equ_c3_Node_Ptr) +=  +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c4);
  (*q_c3_Equ_c4_Node_Ptr) +=  +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c4);
  (*q_c3_Equ_b1_Node_Ptr) +=  -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b1_b2);
  (*q_c3_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_b1);
  (*q_c3_Equ_c_Node_Ptr) +=  -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_c);
  (*q_c4_Equ_c4_Node_Ptr) +=  -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c4) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c4_c1);
  (*q_c4_Equ_c1_Node_Ptr) +=  -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c1) -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c1) -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_s_c1) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c1_c2) -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c4_c1);
  (*q_c1_Equ_c4_Node_Ptr) +=  -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c4) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c4_c1);
  (*q_c4_Equ_b2_Node_Ptr) +=  +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_e1) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c1) -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c2);
  (*q_c4_Equ_e1_Node_Ptr) +=  -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_e1);
  (*q_c4_Equ_c2_Node_Ptr) +=  -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c1_c2);
  (*q_c4_Equ_b1_Node_Ptr) +=  -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b1_b2);
  (*q_c4_Equ_c3_Node_Ptr) +=  +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c4);
  (*q_c1_Equ_e1_Node_Ptr) +=  -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_e1);
  (*q_c1_Equ_b1_Node_Ptr) +=  -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b1_b2);
  (*q_c1_Equ_c3_Node_Ptr) +=  +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c4);
  (*q_c4_Equ_s_Node_Ptr) +=  +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_s_c1);
  (*q_c4_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_b1);
  (*q_c4_Equ_c_Node_Ptr) +=  -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_c);
  (*q_c1_Equ_b_Node_Ptr) +=  +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_b1);
  (*q_c1_Equ_c_Node_Ptr) +=  -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_c);

#else
  //use the offsets instead of pointers
  dQdx[li_c1][A_c1_Equ_c1_NodeOffset] +=  -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c1) -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c1) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c1_c2) -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_s_c1);
  dQdx[li_c1][A_c1_Equ_c2_NodeOffset] +=  -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c1_c2);
  dQdx[li_c2][A_c2_Equ_c1_NodeOffset] +=  -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c1) +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c1_c2) -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c1);
  dQdx[li_c2][A_c2_Equ_c2_NodeOffset] +=  -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c1_c2);
  dQdx[li_c1][A_c1_Equ_b2_NodeOffset] +=  +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_e1) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c1) -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_c2);
  dQdx[li_c2][A_c2_Equ_b2_NodeOffset] +=  +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_c1) +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_e1) -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b1_b2);
  dQdx[li_e1][A_e1_Equ_c1_NodeOffset] +=  -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c1) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c1) +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c1_c2);
  dQdx[li_e1][A_e1_Equ_c2_NodeOffset] +=  -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c1_c2);
  dQdx[li_e1][A_e1_Equ_b2_NodeOffset] +=  +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_e1) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_c1);
  dQdx[li_c2][A_c2_Equ_e1_NodeOffset] +=  -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b2_e1);
  dQdx[li_e1][A_e1_Equ_e1_NodeOffset] +=  -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b1_e1) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b2_e1);
  dQdx[li_b1][A_b1_Equ_b1_NodeOffset] +=  +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b1_b2) -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b1_e1);
  dQdx[li_b1][A_b1_Equ_e1_NodeOffset] +=  -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_e1) -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b1_e1);
  dQdx[li_e1][A_e1_Equ_b1_NodeOffset] +=  +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b1_e1) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b1_b2);
  dQdx[li_b2][A_b2_Equ_b2_NodeOffset] +=  +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_e1) -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c1);
  dQdx[li_b2][A_b2_Equ_e1_NodeOffset] +=  -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_e1);
  dQdx[li_b2][A_b2_Equ_c1_NodeOffset] +=  -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c1) -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c1) +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c1_c2);
  dQdx[li_b2][A_b2_Equ_c2_NodeOffset] +=  -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c1_c2);
  dQdx[li_b1][A_b1_Equ_c1_NodeOffset] +=  -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c1) -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c1) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c1_c2);
  dQdx[li_s][A_s_Equ_s_NodeOffset] +=  +dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_c1);
  dQdx[li_s][A_s_Equ_c1_NodeOffset] +=  -dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_c1);
  dQdx[li_b1][A_b1_Equ_c4_NodeOffset] +=  +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c4);
  dQdx[li_b1][A_b1_Equ_c2_NodeOffset] +=  -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c1_c2);
  dQdx[li_b1][A_b1_Equ_b2_NodeOffset] +=  -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_e1) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b2_c1);
  dQdx[li_b][A_b_Equ_s_NodeOffset] +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_c1);
  dQdx[li_b][A_b_Equ_c1_NodeOffset] +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c1_c2) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c3_c1) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_c1) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_c1);
  dQdx[li_b][A_b_Equ_c2_NodeOffset] +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c1_c2);
  dQdx[li_b][A_b_Equ_b2_NodeOffset] +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_e1) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_c1);
  dQdx[li_b][A_b_Equ_e1_NodeOffset] +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b2_e1);
  dQdx[li_b][A_b_Equ_c3_NodeOffset] +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c3_c4);
  dQdx[li_b][A_b_Equ_c4_NodeOffset] +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c3_c4);
  dQdx[li_b][A_b_Equ_b1_NodeOffset] +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b1_b2);
  dQdx[li_b][A_b_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e);
  dQdx[li_b][A_b_Equ_c_NodeOffset] +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c);
  dQdx[li_c1][A_c1_Equ_s_NodeOffset] +=  +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_s_c1);
  dQdx[li_b1][A_b1_Equ_c3_NodeOffset] +=  +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_c3_c4);
  dQdx[li_b2][A_b2_Equ_c3_NodeOffset] +=  +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c4);
  dQdx[li_b2][A_b2_Equ_c4_NodeOffset] +=  +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_c3_c4);
  dQdx[li_b1][A_b1_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_b1);
  dQdx[li_b2][A_b2_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_b1);
  dQdx[li_b2][A_b2_Equ_b1_NodeOffset] +=  -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b1_b2);
  dQdx[li_b1][A_b1_Equ_c_NodeOffset] +=  -dynamicContributions[admsNodeID_b1].dx(admsProbeID_V_b_c);
  dQdx[li_b2][A_b2_Equ_c_NodeOffset] +=  -dynamicContributions[admsNodeID_b2].dx(admsProbeID_V_b_c);
  dQdx[li_c2][A_c2_Equ_c3_NodeOffset] +=  +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c4);
  dQdx[li_c2][A_c2_Equ_c4_NodeOffset] +=  +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_c3_c4);
  dQdx[li_c2][A_c2_Equ_b1_NodeOffset] +=  -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b1_b2);
  dQdx[li_c2][A_c2_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_b1);
  dQdx[li_c2][A_c2_Equ_c_NodeOffset] +=  -dynamicContributions[admsNodeID_c2].dx(admsProbeID_V_b_c);
  dQdx[li_e][A_e_Equ_e_NodeOffset] +=  -dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e);
  dQdx[li_e1][A_e1_Equ_c3_NodeOffset] +=  +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c4);
  dQdx[li_e1][A_e1_Equ_c4_NodeOffset] +=  +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_c3_c4);
  dQdx[li_e1][A_e1_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_b1);
  dQdx[li_e1][A_e1_Equ_c_NodeOffset] +=  -dynamicContributions[admsNodeID_e1].dx(admsProbeID_V_b_c);
  dQdx[li_b][A_b_Equ_e_NodeOffset] +=  -dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e);
  dQdx[li_e][A_e_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e);
  dQdx[li_c][A_c_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c);
  dQdx[li_c][A_c_Equ_c_NodeOffset] +=  -dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c);
  dQdx[li_c3][A_c3_Equ_s_NodeOffset] +=  +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_s_c1);
  dQdx[li_c3][A_c3_Equ_c1_NodeOffset] +=  +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c1_c2) -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c1) -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c1) -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_s_c1);
  dQdx[li_c3][A_c3_Equ_c2_NodeOffset] +=  -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c1_c2);
  dQdx[li_c3][A_c3_Equ_b2_NodeOffset] +=  -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c2) +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_e1) +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_c1);
  dQdx[li_c3][A_c3_Equ_e1_NodeOffset] +=  -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b2_e1);
  dQdx[li_c3][A_c3_Equ_c3_NodeOffset] +=  +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c4);
  dQdx[li_c3][A_c3_Equ_c4_NodeOffset] +=  +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c4_c1) -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_c3_c4);
  dQdx[li_c3][A_c3_Equ_b1_NodeOffset] +=  -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b1_b2);
  dQdx[li_c3][A_c3_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_b1);
  dQdx[li_c3][A_c3_Equ_c_NodeOffset] +=  -dynamicContributions[admsNodeID_c3].dx(admsProbeID_V_b_c);
  dQdx[li_c4][A_c4_Equ_c4_NodeOffset] +=  -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c4) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c4_c1);
  dQdx[li_c4][A_c4_Equ_c1_NodeOffset] +=  -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c1) -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c1) -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_s_c1) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c1_c2) -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c4_c1);
  dQdx[li_c1][A_c1_Equ_c4_NodeOffset] +=  -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c4) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c4_c1);
  dQdx[li_c4][A_c4_Equ_b2_NodeOffset] +=  +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_e1) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c1) -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b1_b2) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c2);
  dQdx[li_c4][A_c4_Equ_e1_NodeOffset] +=  -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_e1);
  dQdx[li_c4][A_c4_Equ_c2_NodeOffset] +=  -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b2_c2) -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c1_c2);
  dQdx[li_c4][A_c4_Equ_b1_NodeOffset] +=  -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b1_b2);
  dQdx[li_c4][A_c4_Equ_c3_NodeOffset] +=  +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_c3_c4);
  dQdx[li_c1][A_c1_Equ_e1_NodeOffset] +=  -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b2_e1);
  dQdx[li_c1][A_c1_Equ_b1_NodeOffset] +=  -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_b1) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b1_b2);
  dQdx[li_c1][A_c1_Equ_c3_NodeOffset] +=  +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c1) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_c3_c4);
  dQdx[li_c4][A_c4_Equ_s_NodeOffset] +=  +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_s_c1);
  dQdx[li_c4][A_c4_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_b1);
  dQdx[li_c4][A_c4_Equ_c_NodeOffset] +=  -dynamicContributions[admsNodeID_c4].dx(admsProbeID_V_b_c);
  dQdx[li_c1][A_c1_Equ_b_NodeOffset] +=  +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_c) +dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_b1);
  dQdx[li_c1][A_c1_Equ_c_NodeOffset] +=  -dynamicContributions[admsNodeID_c1].dx(admsProbeID_V_b_c);

  
#endif
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateTemperature
// Purpose       : Set temperature and update any parameters that depend on it
// Special Notes : In Xyce ADMS, we'll simply copy the temperature, which is
//                 in Kelvin, to our "admsTemperature" variable, which needs
//                 to be in Celsius.
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateTemperature(const double & temperatureTemp)
{

  admsTemperature = temperatureTemp;
  adms_vt_nom = adms_vt(temperatureTemp);

  return true;
}

// Class Model
//-----------------------------------------------------------------------------
// Function      : Model::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Model::processParams()
{

  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

  //    Parameter LEVEL : [ 504, 505 [
  if ( (!((LEVEL >=504 && LEVEL <505 ))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter LEVEL value " << LEVEL << " out of range [ 504, 505 [";
  }

  //    Parameter TREF : [ (-273.0),  (+inf) [
  if ( (!((TREF >=(-273.0)))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter TREF value " << TREF << " out of range [ (-273.0),  (+inf) [";
  }

  //    Parameter EXMOD : [ 0, 2 ]
  if ( (!((EXMOD >=0 && EXMOD <=2 ))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter EXMOD value " << EXMOD << " out of range [ 0, 2 ]";
  }

  //    Parameter EXPHI : [ 0, 1 ]
  if ( (!((EXPHI >=0 && EXPHI <=1 ))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter EXPHI value " << EXPHI << " out of range [ 0, 1 ]";
  }

  //    Parameter EXAVL : [ 0, 1 ]
  if ( (!((EXAVL >=0 && EXAVL <=1 ))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter EXAVL value " << EXAVL << " out of range [ 0, 1 ]";
  }

  //    Parameter EXSUB : [ 0, 1 ]
  if ( (!((EXSUB >=0 && EXSUB <=1 ))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter EXSUB value " << EXSUB << " out of range [ 0, 1 ]";
  }

  //    Parameter IS : ] 0.0,  (+inf) [
  if ( (!((IS >0.0))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter IS value " << IS << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter IK : [ 1.0*1.0e-12,  (+inf) [
  if ( (!((IK >=1.0*1.0e-12))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter IK value " << IK << " out of range [ 1.0*1.0e-12,  (+inf) [";
  }

  //    Parameter VER : [ 0.01,  (+inf) [
  if ( (!((VER >=0.01))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter VER value " << VER << " out of range [ 0.01,  (+inf) [";
  }

  //    Parameter VEF : [ 0.01,  (+inf) [
  if ( (!((VEF >=0.01))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter VEF value " << VEF << " out of range [ 0.01,  (+inf) [";
  }

  //    Parameter BF : [ 0.1*1.0e-3,  (+inf) [
  if ( (!((BF >=0.1*1.0e-3))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter BF value " << BF << " out of range [ 0.1*1.0e-3,  (+inf) [";
  }

  //    Parameter IBF : [ 0.0,  (+inf) [
  if ( (!((IBF >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter IBF value " << IBF << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter MLF : [ 0.1,  (+inf) [
  if ( (!((MLF >=0.1))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter MLF value " << MLF << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter XIBI : [ 0.0, 1.0 ]
  if ( (!((XIBI >=0.0 && XIBI <=1.0 ))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter XIBI value " << XIBI << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter IZEB : [ 0.0,  (+inf) [
  if ( (!((IZEB >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter IZEB value " << IZEB << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter NZEB : [ 0.0,  (+inf) [
  if ( (!((NZEB >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter NZEB value " << NZEB << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter BRI : [ 1.0e-4,  (+inf) [
  if ( (!((BRI >=1.0e-4))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter BRI value " << BRI << " out of range [ 1.0e-4,  (+inf) [";
  }

  //    Parameter IBR : [ 0.0,  (+inf) [
  if ( (!((IBR >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter IBR value " << IBR << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter XEXT : [ 0.0, 1.0 ]
  if ( (!((XEXT >=0.0 && XEXT <=1.0 ))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter XEXT value " << XEXT << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter WAVL : [ 1.0*1.0e-9,  (+inf) [
  if ( (!((WAVL >=1.0*1.0e-9))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter WAVL value " << WAVL << " out of range [ 1.0*1.0e-9,  (+inf) [";
  }

  //    Parameter VAVL : [ 0.01,  (+inf) [
  if ( (!((VAVL >=0.01))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter VAVL value " << VAVL << " out of range [ 0.01,  (+inf) [";
  }

  //    Parameter SFH : [ 0.0,  (+inf) [
  if ( (!((SFH >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter SFH value " << SFH << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter RE : [ 1.0*1.0e-3,  (+inf) [
  if ( (!((RE >=1.0*1.0e-3))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter RE value " << RE << " out of range [ 1.0*1.0e-3,  (+inf) [";
  }

  //    Parameter RBC : [ 1.0*1.0e-3,  (+inf) [
  if ( (!((RBC >=1.0*1.0e-3))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter RBC value " << RBC << " out of range [ 1.0*1.0e-3,  (+inf) [";
  }

  //    Parameter RBV : [ 1.0*1.0e-3,  (+inf) [
  if ( (!((RBV >=1.0*1.0e-3))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter RBV value " << RBV << " out of range [ 1.0*1.0e-3,  (+inf) [";
  }

  //    Parameter RCC : [ 1.0*1.0e-3,  (+inf) [
  if ( (!((RCC >=1.0*1.0e-3))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter RCC value " << RCC << " out of range [ 1.0*1.0e-3,  (+inf) [";
  }

  //    Parameter RCV : [ 1.0*1.0e-3,  (+inf) [
  if ( (!((RCV >=1.0*1.0e-3))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter RCV value " << RCV << " out of range [ 1.0*1.0e-3,  (+inf) [";
  }

  //    Parameter SCRCV : [ 1.0*1.0e-3,  (+inf) [
  if ( (!((SCRCV >=1.0*1.0e-3))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter SCRCV value " << SCRCV << " out of range [ 1.0*1.0e-3,  (+inf) [";
  }

  //    Parameter IHC : [ 1.0*1.0e-12,  (+inf) [
  if ( (!((IHC >=1.0*1.0e-12))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter IHC value " << IHC << " out of range [ 1.0*1.0e-12,  (+inf) [";
  }

  //    Parameter AXI : [ 0.02,  (+inf) [
  if ( (!((AXI >=0.02))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter AXI value " << AXI << " out of range [ 0.02,  (+inf) [";
  }

  //    Parameter CJE : [ 0.0,  (+inf) [
  if ( (!((CJE >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter CJE value " << CJE << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter VDE : [ 0.05,  (+inf) [
  if ( (!((VDE >=0.05))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter VDE value " << VDE << " out of range [ 0.05,  (+inf) [";
  }

  //    Parameter PE : [ 0.01, 0.99 [
  if ( (!((PE >=0.01 && PE <0.99 ))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter PE value " << PE << " out of range [ 0.01, 0.99 [";
  }

  //    Parameter XCJE : [ 0.0, 1.0 ]
  if ( (!((XCJE >=0.0 && XCJE <=1.0 ))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter XCJE value " << XCJE << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter CBEO : [ 0.0,  (+inf) [
  if ( (!((CBEO >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter CBEO value " << CBEO << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CJC : [ 0.0,  (+inf) [
  if ( (!((CJC >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter CJC value " << CJC << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter VDC : [ 0.05,  (+inf) [
  if ( (!((VDC >=0.05))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter VDC value " << VDC << " out of range [ 0.05,  (+inf) [";
  }

  //    Parameter PC : [ 0.01, 0.99 [
  if ( (!((PC >=0.01 && PC <0.99 ))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter PC value " << PC << " out of range [ 0.01, 0.99 [";
  }

  //    Parameter XP : [ 0.0, 0.99 [
  if ( (!((XP >=0.0 && XP <0.99 ))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter XP value " << XP << " out of range [ 0.0, 0.99 [";
  }

  //    Parameter MC : [ 0.0, 1.0 [
  if ( (!((MC >=0.0 && MC <1.0 ))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter MC value " << MC << " out of range [ 0.0, 1.0 [";
  }

  //    Parameter XCJC : [ 0.0, 1.0 ]
  if ( (!((XCJC >=0.0 && XCJC <=1.0 ))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter XCJC value " << XCJC << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter RCBLX : [ 0.0,  (+inf) [
  if ( (!((RCBLX >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter RCBLX value " << RCBLX << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter RCBLI : [ 0.0,  (+inf) [
  if ( (!((RCBLI >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter RCBLI value " << RCBLI << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CBCO : [ 0.0,  (+inf) [
  if ( (!((CBCO >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter CBCO value " << CBCO << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter MTAU : [ 0.1,  (+inf) [
  if ( (!((MTAU >=0.1))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter MTAU value " << MTAU << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter TAUE : [ 0.0,  (+inf) [
  if ( (!((TAUE >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter TAUE value " << TAUE << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter TAUB : ] 0.0,  (+inf) [
  if ( (!((TAUB >0.0))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter TAUB value " << TAUB << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter TEPI : [ 0.0,  (+inf) [
  if ( (!((TEPI >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter TEPI value " << TEPI << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter TAUR : [ 0.0,  (+inf) [
  if ( (!((TAUR >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter TAUR value " << TAUR << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter XREC : [ 0.0,  (+inf) [
  if ( (!((XREC >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter XREC value " << XREC << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter ACBL : [ 0.0,  (+inf) [
  if ( (!((ACBL >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter ACBL value " << ACBL << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter VGB : [ 0.1,  (+inf) [
  if ( (!((VGB >=0.1))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter VGB value " << VGB << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter VGC : [ 0.1,  (+inf) [
  if ( (!((VGC >=0.1))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter VGC value " << VGC << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter VGJ : [ 0.1,  (+inf) [
  if ( (!((VGJ >=0.1))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter VGJ value " << VGJ << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter VGZEB : [ 0.1,  (+inf) [
  if ( (!((VGZEB >=0.1))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter VGZEB value " << VGZEB << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter AVGEB :  ] (-inf)  (+inf) [

  //    Parameter TVGEB : [ 0.0,  (+inf) [
  if ( (!((TVGEB >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter TVGEB value " << TVGEB << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter AF : [ 0.01,  (+inf) [
  if ( (!((AF >=0.01))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter AF value " << AF << " out of range [ 0.01,  (+inf) [";
  }

  //    Parameter KF : [ 0.0,  (+inf) [
  if ( (!((KF >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter KF value " << KF << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter KFN : [ 0.0,  (+inf) [
  if ( (!((KFN >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter KFN value " << KFN << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter KAVL : [ 0, 1 ]
  if ( (!((KAVL >=0 && KAVL <=1 ))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter KAVL value " << KAVL << " out of range [ 0, 1 ]";
  }

  //    Parameter ISS : [ 0.0,  (+inf) [
  if ( (!((ISS >=0.0))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter ISS value " << ISS << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter ICSS :  ] (-inf)  (+inf) [

  //    Parameter IKS : [ 1.0*1.0e-12,  (+inf) [
  if ( (!((IKS >=1.0*1.0e-12))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter IKS value " << IKS << " out of range [ 1.0*1.0e-12,  (+inf) [";
  }

  //    Parameter CJS : [ 0,  (+inf) [
  if ( (!((CJS >=0))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter CJS value " << CJS << " out of range [ 0,  (+inf) [";
  }

  //    Parameter VDS : ] 0.05,  (+inf) [
  if ( (!((VDS >0.05))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter VDS value " << VDS << " out of range ] 0.05,  (+inf) [";
  }

  //    Parameter PS : ] 0.01, 0.99 [
  if ( (!((PS >0.01 && PS <0.99 ))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter PS value " << PS << " out of range ] 0.01, 0.99 [";
  }

  //    Parameter VGS : [ 0.1,  (+inf) [
  if ( (!((VGS >=0.1))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter VGS value " << VGS << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter MULT : ] 0.0,  (+inf) [
  if ( (!((MULT >0.0))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter MULT value " << MULT << " out of range ] 0.0,  (+inf) [";
  }

  //    Parameter TYPE : [ (-1), 1 ]
  if ( (!((TYPE >=(-1) && TYPE <=1 ))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter TYPE value " << TYPE << " out of range [ (-1), 1 ]";
  }

  //    Parameter GMIN : ] 0, 1e-10 ]
  if ( (!((GMIN >0 && GMIN <=1e-10 ))) )
  {
    UserError0(*this) << "ADMSbjt504va: Parameter GMIN value " << GMIN << " out of range ] 0, 1e-10 ]";
  }


  // and of course, this routine is where we should put the initial_model
  // stuff
  double RCCin_TM;
  double RCCex_TM;
  double Tk300;
  double ICSS_T;
  double ISS_T;
  double IZEB_T;
  double y;
  double tempx;
  double IBR_T;
  double IBF_T;
  double IK_T;
  double RCV_T;
  double RCCin_T;
  double RCCex_T;
  double RCCxx_T;
  double RBC_T;
  double RBV_T;
  double RE_T;
  double CJC_T;
  double CJCscaleINV;
  double CJCscale;
  double CJS_T;
  double CJE_T;
  double CJE_T_div_CJE;
  double UdsT;
  double UdcT;
  double UdeT;
  double lntN;
  double VdtINV;
  double VtrINV;
  double Vtr;
  double tN;
  double Tamb;
  double Vdt;
  double inv_VDE;
  double inv_VGZEB_Tr;
  double VGZEB_Tr;
  double dxa;
  double VGZEBOK;
  double Trk;
  double invMULT;
  double Bn;
  //Begin block initial_model
  {
    if ((TYPE==1))
    {
      An = 7.03e7;
      Bn = 1.23e8;
    }
    else
    {
      An = 1.58e8;
      Bn = 2.04e8;
    }
    Xext1 = (1.0-XEXT);
    CBEO_M = (CBEO*MULT);
    CBCO_M = (CBCO*MULT);
    invMULT = (1.0/MULT);
    SCRCV_M = (SCRCV*invMULT);
    KF_M = (KF*pow(MULT,(1.0-AF)));
    KFN_M = (KFN*pow(MULT,(1.0-((2.0*(MLF-1.0))+(AF*(2.0-MLF))))));
    pow2_2mPE = pow(2.0,(2.0-PE));
    pow2_PEm2 = (1.0/pow2_2mPE);
    Trk = (TREF+273.15);
    {
      //Block-local variables for block 
      double dxa;
      //End of Block-local variables
      dxa = (((VGZEB+(((AVGEB*Trk)*Trk)/(Trk+TVGEB)))-0.05)/0.1);
      if (((VGZEB+(((AVGEB*Trk)*Trk)/(Trk+TVGEB)))<0.05))
      {
        VGZEBOK = (0.05+(0.1*log((1.0+exp(dxa)))));
      }
      else
      {
        VGZEBOK = ((VGZEB+(((AVGEB*Trk)*Trk)/(Trk+TVGEB)))+(0.1*log((1.0+exp((-dxa))))));
      }
      VGZEBOK = VGZEBOK;
    }
    VGZEB_Tr = VGZEB;
    inv_VGZEB_Tr = (1.0/VGZEB_Tr);
    inv_VDE = (1.0/VDE);
    Vdt = 0.0;
    Tk = ((admsModTemp+DTA)+Vdt);
    Tamb = (admsModTemp+DTA);
    tN = (Tk/Trk);
    Vt = (8.61708691805812512584e-5*Tk);
    Vtr = (8.61708691805812512584e-5*Trk);
    VtINV = (1.0/Vt);
    VtrINV = (1.0/Vtr);
    VdtINV = (VtINV-VtrINV);
    lntN = log(tN);
    {
      //Block-local variables for block 
      double dxa;
      //End of Block-local variables
      dxa = (((VGZEBOK-(((AVGEB*Tk)*Tk)/(Tk+TVGEB)))-0.05)/0.1);
      if (((VGZEBOK-(((AVGEB*Tk)*Tk)/(Tk+TVGEB)))<0.05))
      {
        VGZEB_T = (0.05+(0.1*log((1.0+exp(dxa)))));
      }
      else
      {
        VGZEB_T = ((VGZEBOK-(((AVGEB*Tk)*Tk)/(Tk+TVGEB)))+(0.1*log((1.0+exp((-dxa))))));
      }
      VGZEB_T = VGZEB_T;
    }
    UdeT = (((((-3.0)*Vt)*log(tN))+(VDE*tN))+((1.0-tN)*VGB));
    {
      //Block-local variables for block 
      double dxa;
      //End of Block-local variables
      dxa = ((0.05-UdeT)/Vt);
      if ((0.05<UdeT))
      {
        VDE_T = (UdeT+(Vt*log((1.0+exp(dxa)))));
      }
      else
      {
        VDE_T = (0.05+(Vt*log((1.0+exp((-dxa))))));
      }
      VDE_T = VDE_T;
    }
    UdcT = (((((-3.0)*Vt)*log(tN))+(VDC*tN))+((1.0-tN)*VGC));
    {
      //Block-local variables for block 
      double dxa;
      //End of Block-local variables
      dxa = ((0.05-UdcT)/Vt);
      if ((0.05<UdcT))
      {
        VDC_T = (UdcT+(Vt*log((1.0+exp(dxa)))));
      }
      else
      {
        VDC_T = (0.05+(Vt*log((1.0+exp((-dxa))))));
      }
      VDC_T = VDC_T;
    }
    UdsT = (((((-3.0)*Vt)*log(tN))+(VDS*tN))+((1.0-tN)*VGS));
    {
      //Block-local variables for block 
      double dxa;
      //End of Block-local variables
      dxa = ((0.05-UdsT)/Vt);
      if ((0.05<UdsT))
      {
        VDS_T = (UdsT+(Vt*log((1.0+exp(dxa)))));
      }
      else
      {
        VDS_T = (0.05+(Vt*log((1.0+exp((-dxa))))));
      }
      VDS_T = VDS_T;
    }
    inv_VDE_T = (1.0/VDE_T);
    CJE_T_div_CJE = pow((VDE*inv_VDE_T),PE);
    CJE_T = (CJE*CJE_T_div_CJE);
    CJS_T = (CJS*pow((VDS/VDS_T),PS));
    CJCscale = (((1.0-XP)*pow((VDC/VDC_T),PC))+XP);
    CJCscaleINV = (1.0/CJCscale);
    CJC_T = (CJC*CJCscale);
    XP_T = (XP*CJCscaleINV);
    RE_T = (RE*exp((lntN*AE)));
    RBV_T = (RBV*exp((lntN*(AB-AQBO))));
    RBC_T = (RBC*exp((lntN*AEX)));
    RCCxx_T = (RCC*exp((lntN*AC)));
    RCCex_T = (RCBLX*exp((lntN*ACBL)));
    RCCin_T = (RCBLI*exp((lntN*ACBL)));
    RCV_T = (RCV*exp((lntN*AEPI)));
    BF_T = ((BF*exp((lntN*((AE-AB)-AQBO))))*exp(((-DVGBF)*VdtINV)));
    BRI_T = (BRI*exp(((-DVGBR)*VdtINV)));
    IS_T = ((IS*exp((lntN*(((4.0-AB)-AQBO)+DAIS))))*exp(((-VGB)*VdtINV)));
    IK_T = (IK*exp((lntN*(1.0-AB))));
    IBF_T = ((IBF*exp((lntN*(6.0-(2.0*MLF)))))*exp((((-VGJ)*VdtINV)/MLF)));
    IBR_T = (((IBR*tN)*tN)*exp((((-VGC)*VdtINV)/2.0)));
    tempx = pow((VGZEB_T*inv_VGZEB_Tr),(-0.5));
    y = (1.0/CJE_T_div_CJE);
    nZEB_T = ((((((((NZEB*VGZEB_T)*VGZEB_T)*tempx)*y)*VDE)*inv_VDE_T)*inv_VGZEB_Tr)*inv_VGZEB_Tr);
    IZEB_T = (((((((IZEB*tempx)*VDE_T)*VDE_T)*inv_VDE)*inv_VDE)*CJE_T_div_CJE)*exp((NZEB-nZEB_T)));
    tempx = exp((lntN*AQBO));
    VEF_T = ((VEF*tempx)*CJCscaleINV);
    VER_T = ((VER*tempx)*y);
    ISS_T = ((ISS*exp((lntN*(4.0-AS))))*exp(((-VGS)*VdtINV)));
    ICSS_T = ((ICSS*exp((lntN*(3.5-(0.5*ASUB)))))*exp(((-VGS)*VdtINV)));
    if ((ISS_T>0.0))
    {
      IKS_T = (((IKS*exp((lntN*(1.0-AS))))*(IS_T/IS))*(ISS/ISS_T));
    }
    else
    {
      IKS_T = (IKS*exp((lntN*(1.0-AS))));
    }
    TAUE_T = ((TAUE*exp((lntN*(AB-2.0))))*exp(((-DVGTE)*VdtINV)));
    TAUB_T = (TAUB*exp((lntN*((AQBO+AB)-1.0))));
    TEPI_T = (TEPI*exp((lntN*(AEPI-1.0))));
    TAUR_T = ((TAUR*(TAUB_T+TEPI_T))/(TAUB+TEPI));
    Tk300 = (Tk-300.0);
    if ((Tk<525.0))
    {
      BnT = (Bn*((1.0+(7.2e-4*Tk300))-((1.6e-6*Tk300)*Tk300)));
    }
    else
    {
      BnT = (Bn*1.081);
    }
    DEG_T = (DEG*exp((lntN*AQBO)));
    IS_TM = (IS_T*MULT);
    IK_TM = (IK_T*MULT);
    IBF_TM = (IBF_T*MULT);
    IBR_TM = (IBR_T*MULT);
    IZEB_TM = (IZEB_T*MULT);
    IHC_M = (IHC*MULT);
    ISS_TM = (ISS_T*MULT);
    ICSS_TM = (ICSS_T*MULT);
    IKS_TM = (IKS_T*MULT);
    CJE_TM = (CJE_T*MULT);
    CJC_TM = (CJC_T*MULT);
    CJS_TM = (CJS_T*MULT);
    RE_TM = (RE_T*invMULT);
    RBC_TM = (RBC_T*invMULT);
    RBV_TM = (RBV_T*invMULT);
    RCCxx_TM = (RCCxx_T*invMULT);
    RCCex_TM = (RCCex_T*invMULT);
    RCCin_TM = (RCCin_T*invMULT);
    RCV_TM = (RCV_T*invMULT);
    if ((RCC>0.0))
    {
      GCCxx_TM = (1.0/RCCxx_TM);
    }
    else
    {
      GCCxx_TM = 0;
    }
    if ((RCBLX>0.0))
    {
      GCCex_TM = (1.0/RCCex_TM);
    }
    else
    {
      GCCex_TM = 0;
    }
    if ((RCBLI>0.0))
    {
      GCCin_TM = (1.0/RCCin_TM);
    }
    else
    {
      GCCin_TM = 0;
    }
  }
  // End block initial_model


  return true;
}
//----------------------------------------------------------------------------
// Function      : Model::processInstanceParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//----------------------------------------------------------------------------
bool Model::processInstanceParams()
{

  std::vector<Instance*>::iterator iter;
  std::vector<Instance*>::iterator first = instanceContainer.begin();
  std::vector<Instance*>::iterator last  = instanceContainer.end();

  for (iter=first; iter!=last; ++iter)
  {
    (*iter)->processParams();
  }

  return true;
}

//-----------------------------------------------------------------------------
// Function      : Model::Model
// Purpose       : model block constructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::Model(
   const Configuration & configuration,
   const ModelBlock &    model_block,
   const FactoryBlock &  factory_block)
  : DeviceModel(model_block, configuration.getModelParameters(), factory_block),
    LEVEL(504),
    TREF(25.0),
    DTA(0.0),
    EXMOD(1),
    EXPHI(1),
    EXAVL(0),
    EXSUB(0),
    IS(22.0*1.0e-18),
    IK(0.1),
    VER(2.5),
    VEF(44.0),
    BF(215.0),
    IBF(2.7*1.0e-15),
    MLF(2.0),
    XIBI(0.0),
    IZEB(0.0),
    NZEB(22.0),
    BRI(7.0),
    IBR(1.0*1.0e-15),
    VLR(0.2),
    XEXT(0.63),
    WAVL(1.1*1.0e-6),
    VAVL(3.0),
    SFH(0.3),
    RE(5.0),
    RBC(23.0),
    RBV(18.0),
    RCC(12.0),
    RCV(150.0),
    SCRCV(1250.0),
    IHC(4.0*1.0e-3),
    AXI(0.3),
    CJE(73.0*1.0e-15),
    VDE(0.95),
    PE(0.4),
    XCJE(0.4),
    CBEO(0.0),
    CJC(78.0*1.0e-15),
    VDC(0.68),
    PC(0.5),
    XP(0.35),
    MC(0.5),
    XCJC(32.0*1.0e-3),
    RCBLX(0.0),
    RCBLI(0.0),
    CBCO(0.0),
    MTAU(1.0),
    TAUE(2.0*1.0e-12),
    TAUB(4.2*1.0e-12),
    TEPI(41.0*1.0e-12),
    TAUR(520.0*1.0e-12),
    DEG(0.0),
    XREC(0.0),
    AQBO(0.3),
    AE(0.0),
    AB(1.0),
    AEPI(2.5),
    AEX(0.62),
    AC(2.0),
    ACBL(2.0),
    DVGBF(50.0*1.0e-3),
    DVGBR(45.0*1.0e-3),
    VGB(1.17),
    VGC(1.18),
    VGJ(1.15),
    VGZEB(1.15),
    AVGEB(4.73e-4),
    TVGEB(636.0),
    DVGTE(0.05),
    DAIS(0.0),
    AF(2.0),
    KF(20.0*1.0e-12),
    KFN(20.0*1.0e-12),
    KAVL(0),
    ISS(48.0*1.0e-18),
    ICSS((-1.0)),
    IKS(250.0*1.0e-6),
    CJS(315.0*1.0e-15),
    VDS(0.62),
    PS(0.34),
    VGS(1.20),
    AS(1.58),
    ASUB(2.0),
    MULT(1.0),
    TYPE(1),
    GMIN(1.0e-13),
    An(0.0),
    Tk(0.0),
    Vt(0.0),
    VtINV(0.0),
    VDE_T(0.0),
    VDC_T(0.0),
    XP_T(0.0),
    BF_T(0.0),
    BRI_T(0.0),
    IS_T(0.0),
    VEF_T(0.0),
    VER_T(0.0),
    nZEB_T(0.0),
    pow2_2mPE(0.0),
    pow2_PEm2(0.0),
    inv_VDE_T(0.0),
    VGZEB_T(0.0),
    TAUE_T(0.0),
    TAUB_T(0.0),
    TEPI_T(0.0),
    TAUR_T(0.0),
    BnT(0.0),
    DEG_T(0.0),
    VDS_T(0.0),
    IKS_T(0.0),
    IS_TM(0.0),
    IK_TM(0.0),
    IBF_TM(0.0),
    IBR_TM(0.0),
    IHC_M(0.0),
    IZEB_TM(0.0),
    CJE_TM(0.0),
    CJC_TM(0.0),
    RE_TM(0.0),
    RBC_TM(0.0),
    RBV_TM(0.0),
    RCV_TM(0.0),
    SCRCV_M(0.0),
    RCCxx_TM(0.0),
    GCCxx_TM(0.0),
    GCCex_TM(0.0),
    GCCin_TM(0.0),
    KF_M(0.0),
    KFN_M(0.0),
    ISS_TM(0.0),
    ICSS_TM(0.0),
    IKS_TM(0.0),
    CJS_TM(0.0),
    Xext1(0.0),
    CBEO_M(0.0),
    CBCO_M(0.0)
{
  // Set params to constant default values (from parTable):
  setDefaultParams();

  // Set params according to .model line and constant defaults from metadata:
  setModParams(model_block.params);

  // Set any non-constant parameter defaults:
  // Set any parameters that were not given and whose defaults depend on other
  // parameters:


  if (!given("XYCEADMSMODTEMP"))
    admsModTemp=getDeviceOptions().temp.getImmutableValue<double>();

  // Calculate any parameters specified as expressions:

  updateDependentParameters();

  // set internal model type based on model card type
  if (getType() == "pnp" || getType() == "PNP")
    TYPE = -1;

  // calculate dependent (ie computed) params and check for errors:
  processParams();
}

//-----------------------------------------------------------------------------
// Function      : Model::~Model
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::~Model()
{
  std::vector<Instance*>::iterator iterI;
  std::vector<Instance*>::iterator firstI = instanceContainer.begin ();
  std::vector<Instance*>::iterator lastI  = instanceContainer.end ();

  // loop over instances:
  for (iterI = firstI; iterI != lastI; ++iterI)
  {
    delete (*iterI);
  }
}

//-----------------------------------------------------------------------------
// Function      : Model::printOutInstances
// Purpose       : debugging tool.
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
std::ostream &Model::printOutInstances(std::ostream &os) const
{
  std::vector<Instance*>::const_iterator iter;
  std::vector<Instance*>::const_iterator first = instanceContainer.begin();
  std::vector<Instance*>::const_iterator last  = instanceContainer.end();

  int i;
  os << std::endl;
  os << "    name     model name  Parameters" << std::endl;
  for (i=0, iter=first; iter!=last; ++iter, ++i)
  {
    os << "  " << i << ": " << (*iter)->getName() << "      ";
    os << getName();

    os << std::endl;
    os << "MULT  =  " << (*iter)->MULT << std::endl;
    os << std::endl;
  }

  os << std::endl;

  return os;
}

//-----------------------------------------------------------------------------
// Function      : Model::forEachInstance
// Purpose       : 
// Special Notes :
// Scope         : public
// Creator       : David Baur
// Creation Date : 2/4/2014
//-----------------------------------------------------------------------------
/// Apply a device instance "op" to all instances associated with this
/// model
/// 
/// @param[in] op Operator to apply to all instances.
/// 
/// 
void Model::forEachInstance(DeviceInstanceOp &op) const /* override */ 
{
  for (std::vector<Instance *>::const_iterator it = instanceContainer.begin(); it != instanceContainer.end(); ++it)
    op(*it);
}

Device *Traits::factory(const Configuration &configuration, const FactoryBlock &factory_block)
{
  return new DeviceMaster<Traits>(configuration, factory_block, factory_block.solverState_, factory_block.deviceOptions_);
}

void registerDevice()
{
  Config<Traits>::addConfiguration()
    .registerDevice("q", 504)
    .registerModelType("npn", 504)
    .registerModelType("pnp", 504);
}



#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Function      : evaluateInitialInstance
// Purpose       : Evaluate the statements in the initial_instance block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
void evaluateInitialInstance(
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_MULT,
   bool instancePar_given_MULT,
   // instance variables
   // reals
   AdmsSensFadType & instanceVar_Izteb,
   AdmsSensFadType & instanceVar_qBI,
   AdmsSensFadType & instanceVar_Ir,
   AdmsSensFadType & instanceVar_If,
   AdmsSensFadType & instanceVar_Ib1,
   AdmsSensFadType & instanceVar_Ib1_s,
   AdmsSensFadType & instanceVar_Ib2,
   AdmsSensFadType & instanceVar_Ib3,
   AdmsSensFadType & instanceVar_Iex,
   AdmsSensFadType & instanceVar_XIex,
   AdmsSensFadType & instanceVar_Isub,
   AdmsSensFadType & instanceVar_XIsub,
   AdmsSensFadType & instanceVar_Rb2,
   AdmsSensFadType & instanceVar_Gem,
   AdmsSensFadType & instanceVar_eVb1b2,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_TREF,
   bool modelPar_given_TREF,
   AdmsSensFadType & modelPar_DTA,
   bool modelPar_given_DTA,
   AdmsSensFadType & modelPar_IS,
   bool modelPar_given_IS,
   AdmsSensFadType & modelPar_IK,
   bool modelPar_given_IK,
   AdmsSensFadType & modelPar_VER,
   bool modelPar_given_VER,
   AdmsSensFadType & modelPar_VEF,
   bool modelPar_given_VEF,
   AdmsSensFadType & modelPar_BF,
   bool modelPar_given_BF,
   AdmsSensFadType & modelPar_IBF,
   bool modelPar_given_IBF,
   AdmsSensFadType & modelPar_MLF,
   bool modelPar_given_MLF,
   AdmsSensFadType & modelPar_XIBI,
   bool modelPar_given_XIBI,
   AdmsSensFadType & modelPar_IZEB,
   bool modelPar_given_IZEB,
   AdmsSensFadType & modelPar_NZEB,
   bool modelPar_given_NZEB,
   AdmsSensFadType & modelPar_BRI,
   bool modelPar_given_BRI,
   AdmsSensFadType & modelPar_IBR,
   bool modelPar_given_IBR,
   AdmsSensFadType & modelPar_VLR,
   bool modelPar_given_VLR,
   AdmsSensFadType & modelPar_XEXT,
   bool modelPar_given_XEXT,
   AdmsSensFadType & modelPar_WAVL,
   bool modelPar_given_WAVL,
   AdmsSensFadType & modelPar_VAVL,
   bool modelPar_given_VAVL,
   AdmsSensFadType & modelPar_SFH,
   bool modelPar_given_SFH,
   AdmsSensFadType & modelPar_RE,
   bool modelPar_given_RE,
   AdmsSensFadType & modelPar_RBC,
   bool modelPar_given_RBC,
   AdmsSensFadType & modelPar_RBV,
   bool modelPar_given_RBV,
   AdmsSensFadType & modelPar_RCC,
   bool modelPar_given_RCC,
   AdmsSensFadType & modelPar_RCV,
   bool modelPar_given_RCV,
   AdmsSensFadType & modelPar_SCRCV,
   bool modelPar_given_SCRCV,
   AdmsSensFadType & modelPar_IHC,
   bool modelPar_given_IHC,
   AdmsSensFadType & modelPar_AXI,
   bool modelPar_given_AXI,
   AdmsSensFadType & modelPar_CJE,
   bool modelPar_given_CJE,
   AdmsSensFadType & modelPar_VDE,
   bool modelPar_given_VDE,
   AdmsSensFadType & modelPar_PE,
   bool modelPar_given_PE,
   AdmsSensFadType & modelPar_XCJE,
   bool modelPar_given_XCJE,
   AdmsSensFadType & modelPar_CBEO,
   bool modelPar_given_CBEO,
   AdmsSensFadType & modelPar_CJC,
   bool modelPar_given_CJC,
   AdmsSensFadType & modelPar_VDC,
   bool modelPar_given_VDC,
   AdmsSensFadType & modelPar_PC,
   bool modelPar_given_PC,
   AdmsSensFadType & modelPar_XP,
   bool modelPar_given_XP,
   AdmsSensFadType & modelPar_MC,
   bool modelPar_given_MC,
   AdmsSensFadType & modelPar_XCJC,
   bool modelPar_given_XCJC,
   AdmsSensFadType & modelPar_RCBLX,
   bool modelPar_given_RCBLX,
   AdmsSensFadType & modelPar_RCBLI,
   bool modelPar_given_RCBLI,
   AdmsSensFadType & modelPar_CBCO,
   bool modelPar_given_CBCO,
   AdmsSensFadType & modelPar_MTAU,
   bool modelPar_given_MTAU,
   AdmsSensFadType & modelPar_TAUE,
   bool modelPar_given_TAUE,
   AdmsSensFadType & modelPar_TAUB,
   bool modelPar_given_TAUB,
   AdmsSensFadType & modelPar_TEPI,
   bool modelPar_given_TEPI,
   AdmsSensFadType & modelPar_TAUR,
   bool modelPar_given_TAUR,
   AdmsSensFadType & modelPar_DEG,
   bool modelPar_given_DEG,
   AdmsSensFadType & modelPar_XREC,
   bool modelPar_given_XREC,
   AdmsSensFadType & modelPar_AQBO,
   bool modelPar_given_AQBO,
   AdmsSensFadType & modelPar_AE,
   bool modelPar_given_AE,
   AdmsSensFadType & modelPar_AB,
   bool modelPar_given_AB,
   AdmsSensFadType & modelPar_AEPI,
   bool modelPar_given_AEPI,
   AdmsSensFadType & modelPar_AEX,
   bool modelPar_given_AEX,
   AdmsSensFadType & modelPar_AC,
   bool modelPar_given_AC,
   AdmsSensFadType & modelPar_ACBL,
   bool modelPar_given_ACBL,
   AdmsSensFadType & modelPar_DVGBF,
   bool modelPar_given_DVGBF,
   AdmsSensFadType & modelPar_DVGBR,
   bool modelPar_given_DVGBR,
   AdmsSensFadType & modelPar_VGB,
   bool modelPar_given_VGB,
   AdmsSensFadType & modelPar_VGC,
   bool modelPar_given_VGC,
   AdmsSensFadType & modelPar_VGJ,
   bool modelPar_given_VGJ,
   AdmsSensFadType & modelPar_VGZEB,
   bool modelPar_given_VGZEB,
   AdmsSensFadType & modelPar_AVGEB,
   bool modelPar_given_AVGEB,
   AdmsSensFadType & modelPar_TVGEB,
   bool modelPar_given_TVGEB,
   AdmsSensFadType & modelPar_DVGTE,
   bool modelPar_given_DVGTE,
   AdmsSensFadType & modelPar_DAIS,
   bool modelPar_given_DAIS,
   AdmsSensFadType & modelPar_AF,
   bool modelPar_given_AF,
   AdmsSensFadType & modelPar_KF,
   bool modelPar_given_KF,
   AdmsSensFadType & modelPar_KFN,
   bool modelPar_given_KFN,
   AdmsSensFadType & modelPar_ISS,
   bool modelPar_given_ISS,
   AdmsSensFadType & modelPar_ICSS,
   bool modelPar_given_ICSS,
   AdmsSensFadType & modelPar_IKS,
   bool modelPar_given_IKS,
   AdmsSensFadType & modelPar_CJS,
   bool modelPar_given_CJS,
   AdmsSensFadType & modelPar_VDS,
   bool modelPar_given_VDS,
   AdmsSensFadType & modelPar_PS,
   bool modelPar_given_PS,
   AdmsSensFadType & modelPar_VGS,
   bool modelPar_given_VGS,
   AdmsSensFadType & modelPar_AS,
   bool modelPar_given_AS,
   AdmsSensFadType & modelPar_ASUB,
   bool modelPar_given_ASUB,
   AdmsSensFadType & modelPar_MULT,
   bool modelPar_given_MULT,
   AdmsSensFadType & modelPar_GMIN,
   bool modelPar_given_GMIN,
   // non-reals (including hidden)
   int modelPar_LEVEL,
   bool modelPar_given_LEVEL,
   int modelPar_EXMOD,
   bool modelPar_given_EXMOD,
   int modelPar_EXPHI,
   bool modelPar_given_EXPHI,
   int modelPar_EXAVL,
   bool modelPar_given_EXAVL,
   int modelPar_EXSUB,
   bool modelPar_given_EXSUB,
   int modelPar_KAVL,
   bool modelPar_given_KAVL,
   int modelPar_TYPE,
   bool modelPar_given_TYPE// model variables
   ,
   // reals
   AdmsSensFadType & modelVar_An,
   AdmsSensFadType & modelVar_Tk,
   AdmsSensFadType & modelVar_Vt,
   AdmsSensFadType & modelVar_VtINV,
   AdmsSensFadType & modelVar_VDE_T,
   AdmsSensFadType & modelVar_VDC_T,
   AdmsSensFadType & modelVar_XP_T,
   AdmsSensFadType & modelVar_BF_T,
   AdmsSensFadType & modelVar_BRI_T,
   AdmsSensFadType & modelVar_IS_T,
   AdmsSensFadType & modelVar_VEF_T,
   AdmsSensFadType & modelVar_VER_T,
   AdmsSensFadType & modelVar_nZEB_T,
   AdmsSensFadType & modelVar_pow2_2mPE,
   AdmsSensFadType & modelVar_pow2_PEm2,
   AdmsSensFadType & modelVar_inv_VDE_T,
   AdmsSensFadType & modelVar_VGZEB_T,
   AdmsSensFadType & modelVar_TAUE_T,
   AdmsSensFadType & modelVar_TAUB_T,
   AdmsSensFadType & modelVar_TEPI_T,
   AdmsSensFadType & modelVar_TAUR_T,
   AdmsSensFadType & modelVar_BnT,
   AdmsSensFadType & modelVar_DEG_T,
   AdmsSensFadType & modelVar_VDS_T,
   AdmsSensFadType & modelVar_IKS_T,
   AdmsSensFadType & modelVar_IS_TM,
   AdmsSensFadType & modelVar_IK_TM,
   AdmsSensFadType & modelVar_IBF_TM,
   AdmsSensFadType & modelVar_IBR_TM,
   AdmsSensFadType & modelVar_IHC_M,
   AdmsSensFadType & modelVar_IZEB_TM,
   AdmsSensFadType & modelVar_CJE_TM,
   AdmsSensFadType & modelVar_CJC_TM,
   AdmsSensFadType & modelVar_RE_TM,
   AdmsSensFadType & modelVar_RBC_TM,
   AdmsSensFadType & modelVar_RBV_TM,
   AdmsSensFadType & modelVar_RCV_TM,
   AdmsSensFadType & modelVar_SCRCV_M,
   AdmsSensFadType & modelVar_RCCxx_TM,
   AdmsSensFadType & modelVar_GCCxx_TM,
   AdmsSensFadType & modelVar_GCCex_TM,
   AdmsSensFadType & modelVar_GCCin_TM,
   AdmsSensFadType & modelVar_KF_M,
   AdmsSensFadType & modelVar_KFN_M,
   AdmsSensFadType & modelVar_ISS_TM,
   AdmsSensFadType & modelVar_ICSS_TM,
   AdmsSensFadType & modelVar_IKS_TM,
   AdmsSensFadType & modelVar_CJS_TM,
   AdmsSensFadType & modelVar_Xext1,
   AdmsSensFadType & modelVar_CBEO_M,
   AdmsSensFadType & modelVar_CBCO_M,
   double admsTemperature, double adms_vt_nom, double gmin, const Instance & theInstance)
{
}



//-----------------------------------------------------------------------------
// Function      : evaluateInitialModel
// Purpose       : Evaluate the statements in the initial_model block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
void evaluateInitialModel(
   // model parameters
   // reals
   AdmsSensFadType & modelPar_TREF,
   bool modelPar_given_TREF,
   AdmsSensFadType & modelPar_DTA,
   bool modelPar_given_DTA,
   AdmsSensFadType & modelPar_IS,
   bool modelPar_given_IS,
   AdmsSensFadType & modelPar_IK,
   bool modelPar_given_IK,
   AdmsSensFadType & modelPar_VER,
   bool modelPar_given_VER,
   AdmsSensFadType & modelPar_VEF,
   bool modelPar_given_VEF,
   AdmsSensFadType & modelPar_BF,
   bool modelPar_given_BF,
   AdmsSensFadType & modelPar_IBF,
   bool modelPar_given_IBF,
   AdmsSensFadType & modelPar_MLF,
   bool modelPar_given_MLF,
   AdmsSensFadType & modelPar_XIBI,
   bool modelPar_given_XIBI,
   AdmsSensFadType & modelPar_IZEB,
   bool modelPar_given_IZEB,
   AdmsSensFadType & modelPar_NZEB,
   bool modelPar_given_NZEB,
   AdmsSensFadType & modelPar_BRI,
   bool modelPar_given_BRI,
   AdmsSensFadType & modelPar_IBR,
   bool modelPar_given_IBR,
   AdmsSensFadType & modelPar_VLR,
   bool modelPar_given_VLR,
   AdmsSensFadType & modelPar_XEXT,
   bool modelPar_given_XEXT,
   AdmsSensFadType & modelPar_WAVL,
   bool modelPar_given_WAVL,
   AdmsSensFadType & modelPar_VAVL,
   bool modelPar_given_VAVL,
   AdmsSensFadType & modelPar_SFH,
   bool modelPar_given_SFH,
   AdmsSensFadType & modelPar_RE,
   bool modelPar_given_RE,
   AdmsSensFadType & modelPar_RBC,
   bool modelPar_given_RBC,
   AdmsSensFadType & modelPar_RBV,
   bool modelPar_given_RBV,
   AdmsSensFadType & modelPar_RCC,
   bool modelPar_given_RCC,
   AdmsSensFadType & modelPar_RCV,
   bool modelPar_given_RCV,
   AdmsSensFadType & modelPar_SCRCV,
   bool modelPar_given_SCRCV,
   AdmsSensFadType & modelPar_IHC,
   bool modelPar_given_IHC,
   AdmsSensFadType & modelPar_AXI,
   bool modelPar_given_AXI,
   AdmsSensFadType & modelPar_CJE,
   bool modelPar_given_CJE,
   AdmsSensFadType & modelPar_VDE,
   bool modelPar_given_VDE,
   AdmsSensFadType & modelPar_PE,
   bool modelPar_given_PE,
   AdmsSensFadType & modelPar_XCJE,
   bool modelPar_given_XCJE,
   AdmsSensFadType & modelPar_CBEO,
   bool modelPar_given_CBEO,
   AdmsSensFadType & modelPar_CJC,
   bool modelPar_given_CJC,
   AdmsSensFadType & modelPar_VDC,
   bool modelPar_given_VDC,
   AdmsSensFadType & modelPar_PC,
   bool modelPar_given_PC,
   AdmsSensFadType & modelPar_XP,
   bool modelPar_given_XP,
   AdmsSensFadType & modelPar_MC,
   bool modelPar_given_MC,
   AdmsSensFadType & modelPar_XCJC,
   bool modelPar_given_XCJC,
   AdmsSensFadType & modelPar_RCBLX,
   bool modelPar_given_RCBLX,
   AdmsSensFadType & modelPar_RCBLI,
   bool modelPar_given_RCBLI,
   AdmsSensFadType & modelPar_CBCO,
   bool modelPar_given_CBCO,
   AdmsSensFadType & modelPar_MTAU,
   bool modelPar_given_MTAU,
   AdmsSensFadType & modelPar_TAUE,
   bool modelPar_given_TAUE,
   AdmsSensFadType & modelPar_TAUB,
   bool modelPar_given_TAUB,
   AdmsSensFadType & modelPar_TEPI,
   bool modelPar_given_TEPI,
   AdmsSensFadType & modelPar_TAUR,
   bool modelPar_given_TAUR,
   AdmsSensFadType & modelPar_DEG,
   bool modelPar_given_DEG,
   AdmsSensFadType & modelPar_XREC,
   bool modelPar_given_XREC,
   AdmsSensFadType & modelPar_AQBO,
   bool modelPar_given_AQBO,
   AdmsSensFadType & modelPar_AE,
   bool modelPar_given_AE,
   AdmsSensFadType & modelPar_AB,
   bool modelPar_given_AB,
   AdmsSensFadType & modelPar_AEPI,
   bool modelPar_given_AEPI,
   AdmsSensFadType & modelPar_AEX,
   bool modelPar_given_AEX,
   AdmsSensFadType & modelPar_AC,
   bool modelPar_given_AC,
   AdmsSensFadType & modelPar_ACBL,
   bool modelPar_given_ACBL,
   AdmsSensFadType & modelPar_DVGBF,
   bool modelPar_given_DVGBF,
   AdmsSensFadType & modelPar_DVGBR,
   bool modelPar_given_DVGBR,
   AdmsSensFadType & modelPar_VGB,
   bool modelPar_given_VGB,
   AdmsSensFadType & modelPar_VGC,
   bool modelPar_given_VGC,
   AdmsSensFadType & modelPar_VGJ,
   bool modelPar_given_VGJ,
   AdmsSensFadType & modelPar_VGZEB,
   bool modelPar_given_VGZEB,
   AdmsSensFadType & modelPar_AVGEB,
   bool modelPar_given_AVGEB,
   AdmsSensFadType & modelPar_TVGEB,
   bool modelPar_given_TVGEB,
   AdmsSensFadType & modelPar_DVGTE,
   bool modelPar_given_DVGTE,
   AdmsSensFadType & modelPar_DAIS,
   bool modelPar_given_DAIS,
   AdmsSensFadType & modelPar_AF,
   bool modelPar_given_AF,
   AdmsSensFadType & modelPar_KF,
   bool modelPar_given_KF,
   AdmsSensFadType & modelPar_KFN,
   bool modelPar_given_KFN,
   AdmsSensFadType & modelPar_ISS,
   bool modelPar_given_ISS,
   AdmsSensFadType & modelPar_ICSS,
   bool modelPar_given_ICSS,
   AdmsSensFadType & modelPar_IKS,
   bool modelPar_given_IKS,
   AdmsSensFadType & modelPar_CJS,
   bool modelPar_given_CJS,
   AdmsSensFadType & modelPar_VDS,
   bool modelPar_given_VDS,
   AdmsSensFadType & modelPar_PS,
   bool modelPar_given_PS,
   AdmsSensFadType & modelPar_VGS,
   bool modelPar_given_VGS,
   AdmsSensFadType & modelPar_AS,
   bool modelPar_given_AS,
   AdmsSensFadType & modelPar_ASUB,
   bool modelPar_given_ASUB,
   AdmsSensFadType & modelPar_MULT,
   bool modelPar_given_MULT,
   AdmsSensFadType & modelPar_GMIN,
   bool modelPar_given_GMIN,
   // non-reals (including hidden)
   int modelPar_LEVEL,
   bool modelPar_given_LEVEL,
   int modelPar_EXMOD,
   bool modelPar_given_EXMOD,
   int modelPar_EXPHI,
   bool modelPar_given_EXPHI,
   int modelPar_EXAVL,
   bool modelPar_given_EXAVL,
   int modelPar_EXSUB,
   bool modelPar_given_EXSUB,
   int modelPar_KAVL,
   bool modelPar_given_KAVL,
   int modelPar_TYPE,
   bool modelPar_given_TYPE// model variables
   ,
   // reals
   AdmsSensFadType & modelVar_An,
   AdmsSensFadType & modelVar_Tk,
   AdmsSensFadType & modelVar_Vt,
   AdmsSensFadType & modelVar_VtINV,
   AdmsSensFadType & modelVar_VDE_T,
   AdmsSensFadType & modelVar_VDC_T,
   AdmsSensFadType & modelVar_XP_T,
   AdmsSensFadType & modelVar_BF_T,
   AdmsSensFadType & modelVar_BRI_T,
   AdmsSensFadType & modelVar_IS_T,
   AdmsSensFadType & modelVar_VEF_T,
   AdmsSensFadType & modelVar_VER_T,
   AdmsSensFadType & modelVar_nZEB_T,
   AdmsSensFadType & modelVar_pow2_2mPE,
   AdmsSensFadType & modelVar_pow2_PEm2,
   AdmsSensFadType & modelVar_inv_VDE_T,
   AdmsSensFadType & modelVar_VGZEB_T,
   AdmsSensFadType & modelVar_TAUE_T,
   AdmsSensFadType & modelVar_TAUB_T,
   AdmsSensFadType & modelVar_TEPI_T,
   AdmsSensFadType & modelVar_TAUR_T,
   AdmsSensFadType & modelVar_BnT,
   AdmsSensFadType & modelVar_DEG_T,
   AdmsSensFadType & modelVar_VDS_T,
   AdmsSensFadType & modelVar_IKS_T,
   AdmsSensFadType & modelVar_IS_TM,
   AdmsSensFadType & modelVar_IK_TM,
   AdmsSensFadType & modelVar_IBF_TM,
   AdmsSensFadType & modelVar_IBR_TM,
   AdmsSensFadType & modelVar_IHC_M,
   AdmsSensFadType & modelVar_IZEB_TM,
   AdmsSensFadType & modelVar_CJE_TM,
   AdmsSensFadType & modelVar_CJC_TM,
   AdmsSensFadType & modelVar_RE_TM,
   AdmsSensFadType & modelVar_RBC_TM,
   AdmsSensFadType & modelVar_RBV_TM,
   AdmsSensFadType & modelVar_RCV_TM,
   AdmsSensFadType & modelVar_SCRCV_M,
   AdmsSensFadType & modelVar_RCCxx_TM,
   AdmsSensFadType & modelVar_GCCxx_TM,
   AdmsSensFadType & modelVar_GCCex_TM,
   AdmsSensFadType & modelVar_GCCin_TM,
   AdmsSensFadType & modelVar_KF_M,
   AdmsSensFadType & modelVar_KFN_M,
   AdmsSensFadType & modelVar_ISS_TM,
   AdmsSensFadType & modelVar_ICSS_TM,
   AdmsSensFadType & modelVar_IKS_TM,
   AdmsSensFadType & modelVar_CJS_TM,
   AdmsSensFadType & modelVar_Xext1,
   AdmsSensFadType & modelVar_CBEO_M,
   AdmsSensFadType & modelVar_CBCO_M,
   double admsTemperature, double gmin, const Instance & theInstance)
{
  AdmsSensFadType RCCin_TM;
  AdmsSensFadType RCCex_TM;
  AdmsSensFadType Tk300;
  AdmsSensFadType ICSS_T;
  AdmsSensFadType ISS_T;
  AdmsSensFadType IZEB_T;
  AdmsSensFadType y;
  AdmsSensFadType tempx;
  AdmsSensFadType IBR_T;
  AdmsSensFadType IBF_T;
  AdmsSensFadType IK_T;
  AdmsSensFadType RCV_T;
  AdmsSensFadType RCCin_T;
  AdmsSensFadType RCCex_T;
  AdmsSensFadType RCCxx_T;
  AdmsSensFadType RBC_T;
  AdmsSensFadType RBV_T;
  AdmsSensFadType RE_T;
  AdmsSensFadType CJC_T;
  AdmsSensFadType CJCscaleINV;
  AdmsSensFadType CJCscale;
  AdmsSensFadType CJS_T;
  AdmsSensFadType CJE_T;
  AdmsSensFadType CJE_T_div_CJE;
  AdmsSensFadType UdsT;
  AdmsSensFadType UdcT;
  AdmsSensFadType UdeT;
  AdmsSensFadType lntN;
  AdmsSensFadType VdtINV;
  AdmsSensFadType VtrINV;
  AdmsSensFadType Vtr;
  AdmsSensFadType tN;
  AdmsSensFadType Tamb;
  double Vdt;
  AdmsSensFadType inv_VDE;
  AdmsSensFadType inv_VGZEB_Tr;
  AdmsSensFadType VGZEB_Tr;
  AdmsSensFadType dxa;
  AdmsSensFadType VGZEBOK;
  AdmsSensFadType Trk;
  AdmsSensFadType invMULT;
  double Bn;
  //Begin block initial_model
  {
    if ((modelPar_TYPE==1))
    {
      modelVar_An = 7.03e7;
      Bn = 1.23e8;
    }
    else
    {
      modelVar_An = 1.58e8;
      Bn = 2.04e8;
    }
    modelVar_Xext1 = (1.0-modelPar_XEXT);
    modelVar_CBEO_M = (modelPar_CBEO*modelPar_MULT);
    modelVar_CBCO_M = (modelPar_CBCO*modelPar_MULT);
    invMULT = (1.0/modelPar_MULT);
    modelVar_SCRCV_M = (modelPar_SCRCV*invMULT);
    modelVar_KF_M = (modelPar_KF*pow(modelPar_MULT,(1.0-modelPar_AF)));
    modelVar_KFN_M = (modelPar_KFN*pow(modelPar_MULT,(1.0-((2.0*(modelPar_MLF-1.0))+(modelPar_AF*(2.0-modelPar_MLF))))));
    modelVar_pow2_2mPE = pow(2.0,(2.0-modelPar_PE));
    modelVar_pow2_PEm2 = (1.0/modelVar_pow2_2mPE);
    Trk = (modelPar_TREF+273.15);
    {
      //Block-local variables for block 
      AdmsSensFadType dxa;
      //End of Block-local variables
      dxa = (((modelPar_VGZEB+(((modelPar_AVGEB*Trk)*Trk)/(Trk+modelPar_TVGEB)))-0.05)/0.1);
      if (((modelPar_VGZEB+(((modelPar_AVGEB*Trk)*Trk)/(Trk+modelPar_TVGEB)))<0.05))
      {
        VGZEBOK = (0.05+(0.1*log((1.0+exp(dxa)))));
      }
      else
      {
        VGZEBOK = ((modelPar_VGZEB+(((modelPar_AVGEB*Trk)*Trk)/(Trk+modelPar_TVGEB)))+(0.1*log((1.0+exp((-dxa))))));
      }
      VGZEBOK = VGZEBOK;
    }
    VGZEB_Tr = modelPar_VGZEB;
    inv_VGZEB_Tr = (1.0/VGZEB_Tr);
    inv_VDE = (1.0/modelPar_VDE);
    Vdt = 0.0;
    modelVar_Tk = ((admsTemperature+modelPar_DTA)+Vdt);
    Tamb = (admsTemperature+modelPar_DTA);
    tN = (modelVar_Tk/Trk);
    modelVar_Vt = (8.61708691805812512584e-5*modelVar_Tk);
    Vtr = (8.61708691805812512584e-5*Trk);
    modelVar_VtINV = (1.0/modelVar_Vt);
    VtrINV = (1.0/Vtr);
    VdtINV = (modelVar_VtINV-VtrINV);
    lntN = log(tN);
    {
      //Block-local variables for block 
      AdmsSensFadType dxa;
      //End of Block-local variables
      dxa = (((VGZEBOK-(((modelPar_AVGEB*modelVar_Tk)*modelVar_Tk)/(modelVar_Tk+modelPar_TVGEB)))-0.05)/0.1);
      if (((VGZEBOK-(((modelPar_AVGEB*modelVar_Tk)*modelVar_Tk)/(modelVar_Tk+modelPar_TVGEB)))<0.05))
      {
        modelVar_VGZEB_T = (0.05+(0.1*log((1.0+exp(dxa)))));
      }
      else
      {
        modelVar_VGZEB_T = ((VGZEBOK-(((modelPar_AVGEB*modelVar_Tk)*modelVar_Tk)/(modelVar_Tk+modelPar_TVGEB)))+(0.1*log((1.0+exp((-dxa))))));
      }
      modelVar_VGZEB_T = modelVar_VGZEB_T;
    }
    UdeT = (((((-3.0)*modelVar_Vt)*log(tN))+(modelPar_VDE*tN))+((1.0-tN)*modelPar_VGB));
    {
      //Block-local variables for block 
      AdmsSensFadType dxa;
      //End of Block-local variables
      dxa = ((0.05-UdeT)/modelVar_Vt);
      if ((0.05<UdeT))
      {
        modelVar_VDE_T = (UdeT+(modelVar_Vt*log((1.0+exp(dxa)))));
      }
      else
      {
        modelVar_VDE_T = (0.05+(modelVar_Vt*log((1.0+exp((-dxa))))));
      }
      modelVar_VDE_T = modelVar_VDE_T;
    }
    UdcT = (((((-3.0)*modelVar_Vt)*log(tN))+(modelPar_VDC*tN))+((1.0-tN)*modelPar_VGC));
    {
      //Block-local variables for block 
      AdmsSensFadType dxa;
      //End of Block-local variables
      dxa = ((0.05-UdcT)/modelVar_Vt);
      if ((0.05<UdcT))
      {
        modelVar_VDC_T = (UdcT+(modelVar_Vt*log((1.0+exp(dxa)))));
      }
      else
      {
        modelVar_VDC_T = (0.05+(modelVar_Vt*log((1.0+exp((-dxa))))));
      }
      modelVar_VDC_T = modelVar_VDC_T;
    }
    UdsT = (((((-3.0)*modelVar_Vt)*log(tN))+(modelPar_VDS*tN))+((1.0-tN)*modelPar_VGS));
    {
      //Block-local variables for block 
      AdmsSensFadType dxa;
      //End of Block-local variables
      dxa = ((0.05-UdsT)/modelVar_Vt);
      if ((0.05<UdsT))
      {
        modelVar_VDS_T = (UdsT+(modelVar_Vt*log((1.0+exp(dxa)))));
      }
      else
      {
        modelVar_VDS_T = (0.05+(modelVar_Vt*log((1.0+exp((-dxa))))));
      }
      modelVar_VDS_T = modelVar_VDS_T;
    }
    modelVar_inv_VDE_T = (1.0/modelVar_VDE_T);
    CJE_T_div_CJE = pow((modelPar_VDE*modelVar_inv_VDE_T),modelPar_PE);
    CJE_T = (modelPar_CJE*CJE_T_div_CJE);
    CJS_T = (modelPar_CJS*pow((modelPar_VDS/modelVar_VDS_T),modelPar_PS));
    CJCscale = (((1.0-modelPar_XP)*pow((modelPar_VDC/modelVar_VDC_T),modelPar_PC))+modelPar_XP);
    CJCscaleINV = (1.0/CJCscale);
    CJC_T = (modelPar_CJC*CJCscale);
    modelVar_XP_T = (modelPar_XP*CJCscaleINV);
    RE_T = (modelPar_RE*exp((lntN*modelPar_AE)));
    RBV_T = (modelPar_RBV*exp((lntN*(modelPar_AB-modelPar_AQBO))));
    RBC_T = (modelPar_RBC*exp((lntN*modelPar_AEX)));
    RCCxx_T = (modelPar_RCC*exp((lntN*modelPar_AC)));
    RCCex_T = (modelPar_RCBLX*exp((lntN*modelPar_ACBL)));
    RCCin_T = (modelPar_RCBLI*exp((lntN*modelPar_ACBL)));
    RCV_T = (modelPar_RCV*exp((lntN*modelPar_AEPI)));
    modelVar_BF_T = ((modelPar_BF*exp((lntN*((modelPar_AE-modelPar_AB)-modelPar_AQBO))))*exp(((-modelPar_DVGBF)*VdtINV)));
    modelVar_BRI_T = (modelPar_BRI*exp(((-modelPar_DVGBR)*VdtINV)));
    modelVar_IS_T = ((modelPar_IS*exp((lntN*(((4.0-modelPar_AB)-modelPar_AQBO)+modelPar_DAIS))))*exp(((-modelPar_VGB)*VdtINV)));
    IK_T = (modelPar_IK*exp((lntN*(1.0-modelPar_AB))));
    IBF_T = ((modelPar_IBF*exp((lntN*(6.0-(2.0*modelPar_MLF)))))*exp((((-modelPar_VGJ)*VdtINV)/modelPar_MLF)));
    IBR_T = (((modelPar_IBR*tN)*tN)*exp((((-modelPar_VGC)*VdtINV)/2.0)));
    tempx = pow((modelVar_VGZEB_T*inv_VGZEB_Tr),(-0.5));
    y = (1.0/CJE_T_div_CJE);
    modelVar_nZEB_T = ((((((((modelPar_NZEB*modelVar_VGZEB_T)*modelVar_VGZEB_T)*tempx)*y)*modelPar_VDE)*modelVar_inv_VDE_T)*inv_VGZEB_Tr)*inv_VGZEB_Tr);
    IZEB_T = (((((((modelPar_IZEB*tempx)*modelVar_VDE_T)*modelVar_VDE_T)*inv_VDE)*inv_VDE)*CJE_T_div_CJE)*exp((modelPar_NZEB-modelVar_nZEB_T)));
    tempx = exp((lntN*modelPar_AQBO));
    modelVar_VEF_T = ((modelPar_VEF*tempx)*CJCscaleINV);
    modelVar_VER_T = ((modelPar_VER*tempx)*y);
    ISS_T = ((modelPar_ISS*exp((lntN*(4.0-modelPar_AS))))*exp(((-modelPar_VGS)*VdtINV)));
    ICSS_T = ((modelPar_ICSS*exp((lntN*(3.5-(0.5*modelPar_ASUB)))))*exp(((-modelPar_VGS)*VdtINV)));
    if ((ISS_T>0.0))
    {
      modelVar_IKS_T = (((modelPar_IKS*exp((lntN*(1.0-modelPar_AS))))*(modelVar_IS_T/modelPar_IS))*(modelPar_ISS/ISS_T));
    }
    else
    {
      modelVar_IKS_T = (modelPar_IKS*exp((lntN*(1.0-modelPar_AS))));
    }
    modelVar_TAUE_T = ((modelPar_TAUE*exp((lntN*(modelPar_AB-2.0))))*exp(((-modelPar_DVGTE)*VdtINV)));
    modelVar_TAUB_T = (modelPar_TAUB*exp((lntN*((modelPar_AQBO+modelPar_AB)-1.0))));
    modelVar_TEPI_T = (modelPar_TEPI*exp((lntN*(modelPar_AEPI-1.0))));
    modelVar_TAUR_T = ((modelPar_TAUR*(modelVar_TAUB_T+modelVar_TEPI_T))/(modelPar_TAUB+modelPar_TEPI));
    Tk300 = (modelVar_Tk-300.0);
    if ((modelVar_Tk<525.0))
    {
      modelVar_BnT = (Bn*((1.0+(7.2e-4*Tk300))-((1.6e-6*Tk300)*Tk300)));
    }
    else
    {
      modelVar_BnT = (Bn*1.081);
    }
    modelVar_DEG_T = (modelPar_DEG*exp((lntN*modelPar_AQBO)));
    modelVar_IS_TM = (modelVar_IS_T*modelPar_MULT);
    modelVar_IK_TM = (IK_T*modelPar_MULT);
    modelVar_IBF_TM = (IBF_T*modelPar_MULT);
    modelVar_IBR_TM = (IBR_T*modelPar_MULT);
    modelVar_IZEB_TM = (IZEB_T*modelPar_MULT);
    modelVar_IHC_M = (modelPar_IHC*modelPar_MULT);
    modelVar_ISS_TM = (ISS_T*modelPar_MULT);
    modelVar_ICSS_TM = (ICSS_T*modelPar_MULT);
    modelVar_IKS_TM = (modelVar_IKS_T*modelPar_MULT);
    modelVar_CJE_TM = (CJE_T*modelPar_MULT);
    modelVar_CJC_TM = (CJC_T*modelPar_MULT);
    modelVar_CJS_TM = (CJS_T*modelPar_MULT);
    modelVar_RE_TM = (RE_T*invMULT);
    modelVar_RBC_TM = (RBC_T*invMULT);
    modelVar_RBV_TM = (RBV_T*invMULT);
    modelVar_RCCxx_TM = (RCCxx_T*invMULT);
    RCCex_TM = (RCCex_T*invMULT);
    RCCin_TM = (RCCin_T*invMULT);
    modelVar_RCV_TM = (RCV_T*invMULT);
    if ((modelPar_RCC>0.0))
    {
      modelVar_GCCxx_TM = (1.0/modelVar_RCCxx_TM);
    }
    else
    {
      modelVar_GCCxx_TM = 0;
    }
    if ((modelPar_RCBLX>0.0))
    {
      modelVar_GCCex_TM = (1.0/RCCex_TM);
    }
    else
    {
      modelVar_GCCex_TM = 0;
    }
    if ((modelPar_RCBLI>0.0))
    {
      modelVar_GCCin_TM = (1.0/RCCin_TM);
    }
    else
    {
      modelVar_GCCin_TM = 0;
    }
  }
  // End block initial_model
}



//-----------------------------------------------------------------------------
// Function      : evaluateModelEquations
// Purpose       : Evaluate the main module block.  Similar to
//                 updateIntermediateVars, but takes all instance and model
//                 parameters and variables as arguments instead of using
//                 the ones stored in the objects.
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
void evaluateModelEquations(
   std::vector <double> & probeVars,
   // probe constants
   const int admsProbeID_V_noi_e1,
   const int admsProbeID_V_c3_c1,
   const int admsProbeID_V_c3_c4,
   const int admsProbeID_V_c4_c1,
   const int admsProbeID_V_b_c,
   const int admsProbeID_V_b_e,
   const int admsProbeID_V_b_b1,
   const int admsProbeID_V_e_e1,
   const int admsProbeID_V_c1_c2,
   const int admsProbeID_V_s_c1,
   const int admsProbeID_V_b1_b2,
   const int admsProbeID_V_b1_e1,
   const int admsProbeID_V_b2_e1,
   const int admsProbeID_V_b2_c2,
   const int admsProbeID_V_b2_c1,
   // node constants
   const int admsNodeID_c,
   const int admsNodeID_b,
   const int admsNodeID_e,
   const int admsNodeID_s,
   const int admsNodeID_e1,
   const int admsNodeID_b1,
   const int admsNodeID_b2,
   const int admsNodeID_c1,
   const int admsNodeID_c2,
   const int admsNodeID_c3,
   const int admsNodeID_c4,
   const int admsNodeID_noi,
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_MULT,
   bool instancePar_given_MULT,
   // instance variables
   // reals
   AdmsSensFadType & instanceVar_Izteb,
   AdmsSensFadType & instanceVar_qBI,
   AdmsSensFadType & instanceVar_Ir,
   AdmsSensFadType & instanceVar_If,
   AdmsSensFadType & instanceVar_Ib1,
   AdmsSensFadType & instanceVar_Ib1_s,
   AdmsSensFadType & instanceVar_Ib2,
   AdmsSensFadType & instanceVar_Ib3,
   AdmsSensFadType & instanceVar_Iex,
   AdmsSensFadType & instanceVar_XIex,
   AdmsSensFadType & instanceVar_Isub,
   AdmsSensFadType & instanceVar_XIsub,
   AdmsSensFadType & instanceVar_Rb2,
   AdmsSensFadType & instanceVar_Gem,
   AdmsSensFadType & instanceVar_eVb1b2,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_TREF,
   bool modelPar_given_TREF,
   AdmsSensFadType & modelPar_DTA,
   bool modelPar_given_DTA,
   AdmsSensFadType & modelPar_IS,
   bool modelPar_given_IS,
   AdmsSensFadType & modelPar_IK,
   bool modelPar_given_IK,
   AdmsSensFadType & modelPar_VER,
   bool modelPar_given_VER,
   AdmsSensFadType & modelPar_VEF,
   bool modelPar_given_VEF,
   AdmsSensFadType & modelPar_BF,
   bool modelPar_given_BF,
   AdmsSensFadType & modelPar_IBF,
   bool modelPar_given_IBF,
   AdmsSensFadType & modelPar_MLF,
   bool modelPar_given_MLF,
   AdmsSensFadType & modelPar_XIBI,
   bool modelPar_given_XIBI,
   AdmsSensFadType & modelPar_IZEB,
   bool modelPar_given_IZEB,
   AdmsSensFadType & modelPar_NZEB,
   bool modelPar_given_NZEB,
   AdmsSensFadType & modelPar_BRI,
   bool modelPar_given_BRI,
   AdmsSensFadType & modelPar_IBR,
   bool modelPar_given_IBR,
   AdmsSensFadType & modelPar_VLR,
   bool modelPar_given_VLR,
   AdmsSensFadType & modelPar_XEXT,
   bool modelPar_given_XEXT,
   AdmsSensFadType & modelPar_WAVL,
   bool modelPar_given_WAVL,
   AdmsSensFadType & modelPar_VAVL,
   bool modelPar_given_VAVL,
   AdmsSensFadType & modelPar_SFH,
   bool modelPar_given_SFH,
   AdmsSensFadType & modelPar_RE,
   bool modelPar_given_RE,
   AdmsSensFadType & modelPar_RBC,
   bool modelPar_given_RBC,
   AdmsSensFadType & modelPar_RBV,
   bool modelPar_given_RBV,
   AdmsSensFadType & modelPar_RCC,
   bool modelPar_given_RCC,
   AdmsSensFadType & modelPar_RCV,
   bool modelPar_given_RCV,
   AdmsSensFadType & modelPar_SCRCV,
   bool modelPar_given_SCRCV,
   AdmsSensFadType & modelPar_IHC,
   bool modelPar_given_IHC,
   AdmsSensFadType & modelPar_AXI,
   bool modelPar_given_AXI,
   AdmsSensFadType & modelPar_CJE,
   bool modelPar_given_CJE,
   AdmsSensFadType & modelPar_VDE,
   bool modelPar_given_VDE,
   AdmsSensFadType & modelPar_PE,
   bool modelPar_given_PE,
   AdmsSensFadType & modelPar_XCJE,
   bool modelPar_given_XCJE,
   AdmsSensFadType & modelPar_CBEO,
   bool modelPar_given_CBEO,
   AdmsSensFadType & modelPar_CJC,
   bool modelPar_given_CJC,
   AdmsSensFadType & modelPar_VDC,
   bool modelPar_given_VDC,
   AdmsSensFadType & modelPar_PC,
   bool modelPar_given_PC,
   AdmsSensFadType & modelPar_XP,
   bool modelPar_given_XP,
   AdmsSensFadType & modelPar_MC,
   bool modelPar_given_MC,
   AdmsSensFadType & modelPar_XCJC,
   bool modelPar_given_XCJC,
   AdmsSensFadType & modelPar_RCBLX,
   bool modelPar_given_RCBLX,
   AdmsSensFadType & modelPar_RCBLI,
   bool modelPar_given_RCBLI,
   AdmsSensFadType & modelPar_CBCO,
   bool modelPar_given_CBCO,
   AdmsSensFadType & modelPar_MTAU,
   bool modelPar_given_MTAU,
   AdmsSensFadType & modelPar_TAUE,
   bool modelPar_given_TAUE,
   AdmsSensFadType & modelPar_TAUB,
   bool modelPar_given_TAUB,
   AdmsSensFadType & modelPar_TEPI,
   bool modelPar_given_TEPI,
   AdmsSensFadType & modelPar_TAUR,
   bool modelPar_given_TAUR,
   AdmsSensFadType & modelPar_DEG,
   bool modelPar_given_DEG,
   AdmsSensFadType & modelPar_XREC,
   bool modelPar_given_XREC,
   AdmsSensFadType & modelPar_AQBO,
   bool modelPar_given_AQBO,
   AdmsSensFadType & modelPar_AE,
   bool modelPar_given_AE,
   AdmsSensFadType & modelPar_AB,
   bool modelPar_given_AB,
   AdmsSensFadType & modelPar_AEPI,
   bool modelPar_given_AEPI,
   AdmsSensFadType & modelPar_AEX,
   bool modelPar_given_AEX,
   AdmsSensFadType & modelPar_AC,
   bool modelPar_given_AC,
   AdmsSensFadType & modelPar_ACBL,
   bool modelPar_given_ACBL,
   AdmsSensFadType & modelPar_DVGBF,
   bool modelPar_given_DVGBF,
   AdmsSensFadType & modelPar_DVGBR,
   bool modelPar_given_DVGBR,
   AdmsSensFadType & modelPar_VGB,
   bool modelPar_given_VGB,
   AdmsSensFadType & modelPar_VGC,
   bool modelPar_given_VGC,
   AdmsSensFadType & modelPar_VGJ,
   bool modelPar_given_VGJ,
   AdmsSensFadType & modelPar_VGZEB,
   bool modelPar_given_VGZEB,
   AdmsSensFadType & modelPar_AVGEB,
   bool modelPar_given_AVGEB,
   AdmsSensFadType & modelPar_TVGEB,
   bool modelPar_given_TVGEB,
   AdmsSensFadType & modelPar_DVGTE,
   bool modelPar_given_DVGTE,
   AdmsSensFadType & modelPar_DAIS,
   bool modelPar_given_DAIS,
   AdmsSensFadType & modelPar_AF,
   bool modelPar_given_AF,
   AdmsSensFadType & modelPar_KF,
   bool modelPar_given_KF,
   AdmsSensFadType & modelPar_KFN,
   bool modelPar_given_KFN,
   AdmsSensFadType & modelPar_ISS,
   bool modelPar_given_ISS,
   AdmsSensFadType & modelPar_ICSS,
   bool modelPar_given_ICSS,
   AdmsSensFadType & modelPar_IKS,
   bool modelPar_given_IKS,
   AdmsSensFadType & modelPar_CJS,
   bool modelPar_given_CJS,
   AdmsSensFadType & modelPar_VDS,
   bool modelPar_given_VDS,
   AdmsSensFadType & modelPar_PS,
   bool modelPar_given_PS,
   AdmsSensFadType & modelPar_VGS,
   bool modelPar_given_VGS,
   AdmsSensFadType & modelPar_AS,
   bool modelPar_given_AS,
   AdmsSensFadType & modelPar_ASUB,
   bool modelPar_given_ASUB,
   AdmsSensFadType & modelPar_MULT,
   bool modelPar_given_MULT,
   AdmsSensFadType & modelPar_GMIN,
   bool modelPar_given_GMIN,
   // non-reals (including hidden)
   int modelPar_LEVEL,
   bool modelPar_given_LEVEL,
   int modelPar_EXMOD,
   bool modelPar_given_EXMOD,
   int modelPar_EXPHI,
   bool modelPar_given_EXPHI,
   int modelPar_EXAVL,
   bool modelPar_given_EXAVL,
   int modelPar_EXSUB,
   bool modelPar_given_EXSUB,
   int modelPar_KAVL,
   bool modelPar_given_KAVL,
   int modelPar_TYPE,
   bool modelPar_given_TYPE// model variables
   ,
   // reals
   AdmsSensFadType & modelVar_An,
   AdmsSensFadType & modelVar_Tk,
   AdmsSensFadType & modelVar_Vt,
   AdmsSensFadType & modelVar_VtINV,
   AdmsSensFadType & modelVar_VDE_T,
   AdmsSensFadType & modelVar_VDC_T,
   AdmsSensFadType & modelVar_XP_T,
   AdmsSensFadType & modelVar_BF_T,
   AdmsSensFadType & modelVar_BRI_T,
   AdmsSensFadType & modelVar_IS_T,
   AdmsSensFadType & modelVar_VEF_T,
   AdmsSensFadType & modelVar_VER_T,
   AdmsSensFadType & modelVar_nZEB_T,
   AdmsSensFadType & modelVar_pow2_2mPE,
   AdmsSensFadType & modelVar_pow2_PEm2,
   AdmsSensFadType & modelVar_inv_VDE_T,
   AdmsSensFadType & modelVar_VGZEB_T,
   AdmsSensFadType & modelVar_TAUE_T,
   AdmsSensFadType & modelVar_TAUB_T,
   AdmsSensFadType & modelVar_TEPI_T,
   AdmsSensFadType & modelVar_TAUR_T,
   AdmsSensFadType & modelVar_BnT,
   AdmsSensFadType & modelVar_DEG_T,
   AdmsSensFadType & modelVar_VDS_T,
   AdmsSensFadType & modelVar_IKS_T,
   AdmsSensFadType & modelVar_IS_TM,
   AdmsSensFadType & modelVar_IK_TM,
   AdmsSensFadType & modelVar_IBF_TM,
   AdmsSensFadType & modelVar_IBR_TM,
   AdmsSensFadType & modelVar_IHC_M,
   AdmsSensFadType & modelVar_IZEB_TM,
   AdmsSensFadType & modelVar_CJE_TM,
   AdmsSensFadType & modelVar_CJC_TM,
   AdmsSensFadType & modelVar_RE_TM,
   AdmsSensFadType & modelVar_RBC_TM,
   AdmsSensFadType & modelVar_RBV_TM,
   AdmsSensFadType & modelVar_RCV_TM,
   AdmsSensFadType & modelVar_SCRCV_M,
   AdmsSensFadType & modelVar_RCCxx_TM,
   AdmsSensFadType & modelVar_GCCxx_TM,
   AdmsSensFadType & modelVar_GCCex_TM,
   AdmsSensFadType & modelVar_GCCin_TM,
   AdmsSensFadType & modelVar_KF_M,
   AdmsSensFadType & modelVar_KFN_M,
   AdmsSensFadType & modelVar_ISS_TM,
   AdmsSensFadType & modelVar_ICSS_TM,
   AdmsSensFadType & modelVar_IKS_TM,
   AdmsSensFadType & modelVar_CJS_TM,
   AdmsSensFadType & modelVar_Xext1,
   AdmsSensFadType & modelVar_CBEO_M,
   AdmsSensFadType & modelVar_CBCO_M,
   // basic variables
   double admsTemperature, double adms_vt_nom, double gmin, std::vector <AdmsSensFadType> & staticContributions, std::vector <AdmsSensFadType> & dynamicContributions, const Instance & theInstance)
{

  // Local variables
  AdmsSensFadType common;
  AdmsSensFadType powerREC;
  AdmsSensFadType powerRBC;
  AdmsSensFadType powerRCCxx;
  AdmsSensFadType powerRCCex;
  AdmsSensFadType powerRCCin;
  AdmsSensFadType powerRBV;
  AdmsSensFadType powerCCS;
  AdmsSensFadType powerFBCS;
  AdmsSensFadType powerFBC1fB1;
  AdmsSensFadType exponentFBC1fB2;
  AdmsSensFadType powerFBC1fB2;
  AdmsSensFadType powerEBSCS;
  AdmsSensFadType powerEBSC1f;
  AdmsSensFadType powerRBCS;
  AdmsSensFadType powerRBC1f;
  AdmsSensFadType powerExCS;
  AdmsSensFadType powerExC1f;
  AdmsSensFadType powerExCSMOD;
  AdmsSensFadType powerExC1fMOD;
  AdmsSensFadType powerSubsCS_B1S;
  AdmsSensFadType powerSubsCS_BS;
  AdmsSensFadType twoqIavl;
  AdmsSensFadType powerCCS_A;
  AdmsSensFadType Vb2c1;
  AdmsSensFadType Vb2c2;
  AdmsSensFadType Vb2e1;
  AdmsSensFadType Vb1e1;
  AdmsSensFadType Vb1b2;
  AdmsSensFadType Vsc1;
  AdmsSensFadType Vc1c2;
  AdmsSensFadType Vee1;
  AdmsSensFadType Vbb1;
  AdmsSensFadType Vbe;
  AdmsSensFadType Vbc;
  AdmsSensFadType Vc4c1;
  AdmsSensFadType Vc3c4;
  AdmsSensFadType Vb1c4;
  AdmsSensFadType Vcc3;
  AdmsSensFadType Vbc3;
  AdmsSensFadType Vsc4;
  AdmsSensFadType Vsc3;
  double expl;
  AdmsSensFadType eVb2c2;
  AdmsSensFadType eVb2e1;
  AdmsSensFadType eVb1e1;
  AdmsSensFadType eVb1c4;
  AdmsSensFadType eVbc3;
  AdmsSensFadType eVsc1;
  AdmsSensFadType eVsc3;
  AdmsSensFadType eVsc4;
  AdmsSensFadType eVbc3VDC;
  AdmsSensFadType eVb1c4VDC;
  AdmsSensFadType eVb2c2VDC;
  AdmsSensFadType eVb2c1VDC;
  AdmsSensFadType K0;
  AdmsSensFadType Kw;
  AdmsSensFadType pW;
  AdmsSensFadType Ec;
  AdmsSensFadType Ic1c2;
  AdmsSensFadType pav;
  AdmsSensFadType tmpV;
  AdmsSensFadType Vqs_th;
  AdmsSensFadType eps_VDC;
  AdmsSensFadType eps2;
  AdmsSensFadType x2;
  AdmsSensFadType Vqs;
  AdmsSensFadType Iqs;
  AdmsSensFadType Ic1c2_Iqs;
  AdmsSensFadType alpha1;
  AdmsSensFadType alpha;
  AdmsSensFadType vyi;
  AdmsSensFadType yi;
  AdmsSensFadType xi_w;
  AdmsSensFadType gp0;
  AdmsSensFadType gp0_help;
  AdmsSensFadType gp02;
  AdmsSensFadType sqr_arg;
  AdmsSensFadType p0star;
  AdmsSensFadType eVb2c2star;
  AdmsSensFadType B1;
  AdmsSensFadType B2;
  AdmsSensFadType Vxi0;
  AdmsSensFadType Vch;
  AdmsSensFadType Icap;
  AdmsSensFadType Icap_IHC;
  AdmsSensFadType Vfe;
  AdmsSensFadType a_VDE;
  AdmsSensFadType Vje;
  AdmsSensFadType E0BE;
  AdmsSensFadType Vte;
  AdmsSensFadType Vjunc;
  AdmsSensFadType bjc;
  AdmsSensFadType Vfc;
  AdmsSensFadType Vjc;
  AdmsSensFadType fI;
  AdmsSensFadType Vcv;
  AdmsSensFadType Vtc;
  AdmsSensFadType If0;
  AdmsSensFadType f1;
  AdmsSensFadType n0;
  AdmsSensFadType f2;
  AdmsSensFadType nB;
  AdmsSensFadType termE;
  AdmsSensFadType termC;
  AdmsSensFadType q0I;
  AdmsSensFadType q1I;
  AdmsSensFadType In;
  AdmsSensFadType Ibf0;
  AdmsSensFadType tmpExp;
  AdmsSensFadType eZEB;
  AdmsSensFadType x;
  AdmsSensFadType dE0BE;
  AdmsSensFadType edZEB;
  AdmsSensFadType DZEB;
  AdmsSensFadType g1;
  AdmsSensFadType g2;
  AdmsSensFadType nBex;
  AdmsSensFadType pWex;
  AdmsSensFadType Isf;
  AdmsSensFadType Xg1;
  AdmsSensFadType XnBex;
  AdmsSensFadType XIMex;
  AdmsSensFadType XIMsub;
  AdmsSensFadType Vex_bias;
  AdmsSensFadType Vex;
  AdmsSensFadType vdif;
  AdmsSensFadType VBex;
  AdmsSensFadType Fex;
  AdmsSensFadType q0Q;
  AdmsSensFadType q1Q;
  AdmsSensFadType qBQ;
  AdmsSensFadType Ib1b2;
  AdmsSensFadType Iavl;
  AdmsSensFadType dEdx0;
  AdmsSensFadType xd;
  AdmsSensFadType xi_w1;
  AdmsSensFadType Weff;
  AdmsSensFadType Wd;
  AdmsSensFadType Eav;
  AdmsSensFadType E0;
  AdmsSensFadType SHw;
  AdmsSensFadType Efi;
  AdmsSensFadType Ew;
  AdmsSensFadType Em;
  AdmsSensFadType EmEav_Em;
  AdmsSensFadType lambda;
  AdmsSensFadType Gmax;
  AdmsSensFadType Vb2c2star;
  AdmsSensFadType Qte;
  AdmsSensFadType Vje_s;
  AdmsSensFadType Qte_s;
  AdmsSensFadType Qtc;
  AdmsSensFadType Qb0;
  AdmsSensFadType Qbe_qs;
  AdmsSensFadType Qbc_qs;
  AdmsSensFadType a_VDC;
  AdmsSensFadType Vjcex;
  AdmsSensFadType Vtexv;
  AdmsSensFadType Qtex;
  AdmsSensFadType XVjcex;
  AdmsSensFadType XVtexv;
  AdmsSensFadType XQtex;
  AdmsSensFadType a_VDS;
  AdmsSensFadType Vfs;
  AdmsSensFadType Vjs;
  AdmsSensFadType Qts;
  AdmsSensFadType Qe0;
  AdmsSensFadType Qe;
  AdmsSensFadType Qepi0;
  AdmsSensFadType Qepi;
  AdmsSensFadType Qex;
  AdmsSensFadType XQex;
  AdmsSensFadType Xg2;
  AdmsSensFadType XpWex;
  AdmsSensFadType Qb1b2;
  AdmsSensFadType dVteVje;
  AdmsSensFadType Vb2e1Vfe;
  AdmsSensFadType dVjeVb2e1;
  AdmsSensFadType dVteVb2e1;
  AdmsSensFadType dQteVb2e1;
  AdmsSensFadType dn0Vb2e1;
  AdmsSensFadType dQbeVb2e1;
  AdmsSensFadType dQeVb2e1;
  AdmsSensFadType Qbc;
  AdmsSensFadType Qbe;
  AdmsSensFadType cor_exp_1;
  AdmsSensFadType cor_exp_2;


  // -- code converted from analog/code block
  {
    Vb2c1 = probeVars[admsProbeID_V_b2_c1];

    Vb2c2 = probeVars[admsProbeID_V_b2_c2];

    Vb2e1 = (modelPar_TYPE*(probeVars[admsProbeID_V_b2_e1]));
    Vb1e1 = probeVars[admsProbeID_V_b1_e1];

    Vb1b2 = probeVars[admsProbeID_V_b1_b2];

    Vsc1 = (modelPar_TYPE*(probeVars[admsProbeID_V_s_c1]));
    Vc1c2 = (modelPar_TYPE*(probeVars[admsProbeID_V_c1_c2]));
    Vee1 = (modelPar_TYPE*(probeVars[admsProbeID_V_e_e1]));
    Vbb1 = (modelPar_TYPE*(probeVars[admsProbeID_V_b_b1]));
    Vbe = (modelPar_TYPE*(probeVars[admsProbeID_V_b_e]));
    Vbc = (modelPar_TYPE*(probeVars[admsProbeID_V_b_c]));
    if ((modelPar_RCBLX>0.0))
    {
      if ((modelPar_RCBLI>0.0))
      {
        Vc4c1 = (modelPar_TYPE*(probeVars[admsProbeID_V_c4_c1]));
        Vc3c4 = (modelPar_TYPE*(probeVars[admsProbeID_V_c3_c4]));
      }
      else
      {
        Vc4c1 = 0;
        Vc3c4 = (modelPar_TYPE*(probeVars[admsProbeID_V_c3_c1]));
      }
    }
    else
    {
      if ((modelPar_RCBLI>0.0))
      {
        Vc4c1 = (modelPar_TYPE*(probeVars[admsProbeID_V_c4_c1]));
        Vc3c4 = 0;
      }
      else
      {
        Vc4c1 = 0;
        Vc3c4 = 0;
      }
    }
    Vb1c4 = (((Vb1b2+Vb2c2)-Vc1c2)-Vc4c1);
    Vcc3 = ((((-Vbc)+Vbb1)+Vb1c4)-Vc3c4);
    Vbc3 = (Vbc+Vcc3);
    Vsc4 = (Vsc1-Vc4c1);
    Vsc3 = (Vsc4-Vc3c4);
    if (((Vb2c2*modelVar_VtINV)<400.0))
    {
      eVb2c2 = exp((Vb2c2*modelVar_VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVb2c2 = (expl*(1.0+((Vb2c2*modelVar_VtINV)-400.0)));
    }
    if (((Vb2e1*modelVar_VtINV)<400.0))
    {
      eVb2e1 = exp((Vb2e1*modelVar_VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVb2e1 = (expl*(1.0+((Vb2e1*modelVar_VtINV)-400.0)));
    }
    if (((Vb1e1*modelVar_VtINV)<400.0))
    {
      eVb1e1 = exp((Vb1e1*modelVar_VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVb1e1 = (expl*(1.0+((Vb1e1*modelVar_VtINV)-400.0)));
    }
    if (((Vb1c4*modelVar_VtINV)<400.0))
    {
      eVb1c4 = exp((Vb1c4*modelVar_VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVb1c4 = (expl*(1.0+((Vb1c4*modelVar_VtINV)-400.0)));
    }
    if (((Vb1b2*modelVar_VtINV)<400.0))
    {
      instanceVar_eVb1b2 = exp((Vb1b2*modelVar_VtINV));
    }
    else
    {
      expl = exp(400.0);
      instanceVar_eVb1b2 = (expl*(1.0+((Vb1b2*modelVar_VtINV)-400.0)));
    }
    if (((Vbc3*modelVar_VtINV)<400.0))
    {
      eVbc3 = exp((Vbc3*modelVar_VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVbc3 = (expl*(1.0+((Vbc3*modelVar_VtINV)-400.0)));
    }
    if (((Vsc1*modelVar_VtINV)<400.0))
    {
      eVsc1 = exp((Vsc1*modelVar_VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVsc1 = (expl*(1.0+((Vsc1*modelVar_VtINV)-400.0)));
    }
    if (((Vsc3*modelVar_VtINV)<400.0))
    {
      eVsc3 = exp((Vsc3*modelVar_VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVsc3 = (expl*(1.0+((Vsc3*modelVar_VtINV)-400.0)));
    }
    if (((Vsc4*modelVar_VtINV)<400.0))
    {
      eVsc4 = exp((Vsc4*modelVar_VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVsc4 = (expl*(1.0+((Vsc4*modelVar_VtINV)-400.0)));
    }
    if ((((Vbc3-modelVar_VDC_T)*modelVar_VtINV)<400.0))
    {
      eVbc3VDC = exp(((Vbc3-modelVar_VDC_T)*modelVar_VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVbc3VDC = (expl*(1.0+(((Vbc3-modelVar_VDC_T)*modelVar_VtINV)-400.0)));
    }
    if ((((Vb1c4-modelVar_VDC_T)*modelVar_VtINV)<400.0))
    {
      eVb1c4VDC = exp(((Vb1c4-modelVar_VDC_T)*modelVar_VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVb1c4VDC = (expl*(1.0+(((Vb1c4-modelVar_VDC_T)*modelVar_VtINV)-400.0)));
    }
    if ((((Vb2c2-modelVar_VDC_T)*modelVar_VtINV)<400.0))
    {
      eVb2c2VDC = exp(((Vb2c2-modelVar_VDC_T)*modelVar_VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVb2c2VDC = (expl*(1.0+(((Vb2c2-modelVar_VDC_T)*modelVar_VtINV)-400.0)));
    }
    if ((((Vb2c1-modelVar_VDC_T)*modelVar_VtINV)<400.0))
    {
      eVb2c1VDC = exp(((Vb2c1-modelVar_VDC_T)*modelVar_VtINV));
    }
    else
    {
      expl = exp(400.0);
      eVb2c1VDC = (expl*(1.0+(((Vb2c1-modelVar_VDC_T)*modelVar_VtINV)-400.0)));
    }
    K0 = sqrt((1.0+(4.0*eVb2c2VDC)));
    Kw = sqrt((1.0+(4.0*eVb2c1VDC)));
    pW = ((2.0*eVb2c1VDC)/(1.0+Kw));
    if ((pW<1.0e-40))
    {
      pW = 0;
    }
    Ec = (modelVar_Vt*((K0-Kw)-log(((K0+1.0)/(Kw+1.0)))));
    Ic1c2 = ((Ec+Vc1c2)/modelVar_RCV_TM);
    if ((Ic1c2>0.0))
    {
      if ((Vb2c1<100.0))
      {
        tmpV = Vb2c1;
      }
      else
      {
        tmpV = (100.0+log((1.0+(Vb2c1-100.0))));
      }
      tmpV = tmpV;
      Vqs_th = ((modelVar_VDC_T+((2.0*modelVar_Vt)*log(((((0.5*Ic1c2)*modelVar_RCV_TM)*modelVar_VtINV)+1.0))))-tmpV);
      eps_VDC = (0.2*modelVar_VDC_T);
      eps2 = (eps_VDC*eps_VDC);
      x2 = (Vqs_th*Vqs_th);
      if ((Vqs_th<0.0))
      {
        Vqs = ((0.5*eps2)/(sqrt((x2+eps2))-Vqs_th));
      }
      else
      {
        Vqs = (0.5*(sqrt((x2+eps2))+Vqs_th));
      }
      Vqs = Vqs;
      Iqs = ((Vqs*(Vqs+(modelVar_IHC_M*modelVar_SCRCV_M)))/(modelVar_SCRCV_M*(Vqs+(modelVar_IHC_M*modelVar_RCV_TM))));
      Ic1c2_Iqs = (Ic1c2/Iqs);
      {
        //Block-local variables for block 
        AdmsSensFadType dxa;
        //End of Block-local variables
        dxa = ((Ic1c2_Iqs-1.0)/modelPar_AXI);
        if ((Ic1c2_Iqs<1.0))
        {
          alpha1 = (1.0+(modelPar_AXI*log((1.0+exp(dxa)))));
        }
        else
        {
          alpha1 = (Ic1c2_Iqs+(modelPar_AXI*log((1.0+exp((-dxa))))));
        }
        alpha1 = alpha1;
      }
      alpha = (alpha1/(1.0+(modelPar_AXI*log((1.0+exp(((-1.0)/modelPar_AXI)))))));
      vyi = (Vqs/(modelVar_IHC_M*modelVar_SCRCV_M));
      yi = ((1.0+sqrt((1.0+(((4.0*alpha)*vyi)*(1.0+vyi)))))/((2.0*alpha)*(1.0+vyi)));
      xi_w = (1.0-(yi/(1.0+(pW*yi))));
      gp0 = ((((0.5*Ic1c2)*modelVar_RCV_TM)*xi_w)*modelVar_VtINV);
      gp0_help = ((2.0*gp0)+(pW*((pW+gp0)+1.0)));
      gp02 = (0.5*(gp0-1.0));
      sqr_arg = ((gp02*gp02)+gp0_help);
      if ((gp0>=1.0))
      {
        p0star = (gp02+sqrt(sqr_arg));
      }
      else
      {
        p0star = (gp0_help/(sqrt(sqr_arg)-gp02));
      }
      if ((p0star<1.0e-40))
      {
        p0star = 0.0;
      }
      eVb2c2star = ((p0star*(p0star+1.0))*exp((modelVar_VDC_T*modelVar_VtINV)));
      B1 = ((0.5*modelVar_SCRCV_M)*(Ic1c2-modelVar_IHC_M));
      B2 = (((modelVar_SCRCV_M*modelVar_RCV_TM)*modelVar_IHC_M)*Ic1c2);
      Vxi0 = (B1+sqrt(((B1*B1)+B2)));
      Vch = (modelVar_VDC_T*(0.1+((2.0*Ic1c2)/(Ic1c2+Iqs))));
      Icap = ((modelVar_IHC_M*Ic1c2)/(modelVar_IHC_M+Ic1c2));
      Icap_IHC = (modelVar_IHC_M/(modelVar_IHC_M+Ic1c2));
    }
    else
    {
      Iqs = 0.0;
      p0star = ((2.0*eVb2c2VDC)/(1.0+K0));
      eVb2c2star = eVb2c2;
      if (((fabs(Vc1c2)<(1.0e-5*modelVar_Vt))||(fabs(Ec)<((1.0e-40*modelVar_Vt)*(K0+Kw)))))
      {
        pav = (0.5*(p0star+pW));
        xi_w = (pav/(pav+1.0));
      }
      else
      {
        xi_w = (Ec/((Ec+Vb2c2)-Vb2c1));
      }
      Vxi0 = Vc1c2;
      Vch = (0.1*modelVar_VDC_T);
      Icap = Ic1c2;
      Icap_IHC = (1.0-(Icap/modelVar_IHC_M));
    }
    Vfe = (modelVar_VDE_T*(1.0-pow(3.0,((-1.0)/modelPar_PE))));
    a_VDE = (0.1*modelVar_VDE_T);
    {
      //Block-local variables for block 
      AdmsSensFadType dxa;
      //End of Block-local variables
      dxa = ((Vb2e1-Vfe)/a_VDE);
      if ((Vb2e1<Vfe))
      {
        Vje = (Vb2e1-(a_VDE*log((1.0+exp(dxa)))));
      }
      else
      {
        Vje = (Vfe-(a_VDE*log((1.0+exp((-dxa))))));
      }
      Vje = Vje;
    }
    E0BE = pow((1.0-(Vje*modelVar_inv_VDE_T)),(1.0-modelPar_PE));
    Vte = (((modelVar_VDE_T/(1.0-modelPar_PE))*(1.0-E0BE))+(3.0*(Vb2e1-Vje)));
    Vjunc = (Vb2c1+Vxi0);
    bjc = ((2.0-modelVar_XP_T)/(1.0-modelVar_XP_T));
    Vfc = (modelVar_VDC_T*(1.0-pow(bjc,((-1.0)/modelPar_PC))));
    {
      //Block-local variables for block 
      AdmsSensFadType dxa;
      //End of Block-local variables
      dxa = ((Vjunc-Vfc)/Vch);
      if ((Vjunc<Vfc))
      {
        Vjc = (Vjunc-(Vch*log((1.0+exp(dxa)))));
      }
      else
      {
        Vjc = (Vfc-(Vch*log((1.0+exp((-dxa))))));
      }
      Vjc = Vjc;
    }
    fI = pow(Icap_IHC,modelPar_MC);
    Vcv = (((modelVar_VDC_T/(1.0-modelPar_PC))*(1.0-(fI*pow((1.0-(Vjc/modelVar_VDC_T)),(1.0-modelPar_PC)))))+((fI*bjc)*(Vjunc-Vjc)));
    Vtc = (((1.0-modelVar_XP_T)*Vcv)+(modelVar_XP_T*Vb2c1));
    If0 = ((4.0*modelVar_IS_TM)/modelVar_IK_TM);
    f1 = (If0*eVb2e1);
    n0 = (f1/(1.0+sqrt((1.0+f1))));
    f2 = (If0*eVb2c2star);
    nB = (f2/(1.0+sqrt((1.0+f2))));
    if ((modelPar_DEG==0.0))
    {
      q0I = ((1.0+(Vte/modelVar_VER_T))+(Vtc/modelVar_VEF_T));
    }
    else
    {
      termE = ((((Vte/modelVar_VER_T)+1.0)*modelVar_DEG_T)*modelVar_VtINV);
      termC = ((((-Vtc)/modelVar_VEF_T)*modelVar_DEG_T)*modelVar_VtINV);
      q0I = ((exp(termE)-exp(termC))/(exp((modelVar_DEG_T*modelVar_VtINV))-1.0));
    }
    eps2 = (0.1*0.1);
    x2 = (q0I*q0I);
    if ((q0I<0.0))
    {
      q1I = ((0.5*eps2)/(sqrt((x2+eps2))-q0I));
    }
    else
    {
      q1I = (0.5*(sqrt((x2+eps2))+q0I));
    }
    q1I = q1I;
    instanceVar_qBI = (q1I*(1.0+(0.5*(n0+nB))));
    instanceVar_Ir = (modelVar_IS_TM*eVb2c2star);
    instanceVar_If = (modelVar_IS_TM*eVb2e1);
    In = ((instanceVar_If-instanceVar_Ir)/instanceVar_qBI);
    Ibf0 = (modelVar_IS_TM/modelVar_BF_T);
    if ((modelPar_XREC==0.0))
    {
      instanceVar_Ib1 = (((1.0-modelPar_XIBI)*Ibf0)*(eVb2e1-1.0));
    }
    else
    {
      instanceVar_Ib1 = (((1.0-modelPar_XIBI)*Ibf0)*(((1.0-modelPar_XREC)*(eVb2e1-1.0))+((modelPar_XREC*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/modelVar_VEF_T)))));
    }
    instanceVar_Ib1_s = ((modelPar_XIBI*Ibf0)*(eVb1e1-1.0));
    if ((((Vb2e1*modelVar_VtINV)/modelPar_MLF)<400.0))
    {
      tmpExp = exp(((Vb2e1*modelVar_VtINV)/modelPar_MLF));
    }
    else
    {
      expl = exp(400.0);
      tmpExp = (expl*(1.0+(((Vb2e1*modelVar_VtINV)/modelPar_MLF)-400.0)));
    }
    instanceVar_Ib2 = ((modelVar_IBF_TM*(tmpExp-1.0))+(modelPar_GMIN*Vb2e1));
    if ((((0.5*Vb1c4)*modelVar_VtINV)<400.0))
    {
      tmpExp = exp(((0.5*Vb1c4)*modelVar_VtINV));
    }
    else
    {
      expl = exp(400.0);
      tmpExp = (expl*(1.0+(((0.5*Vb1c4)*modelVar_VtINV)-400.0)));
    }
    instanceVar_Ib3 = (((modelVar_IBR_TM*(eVb1c4-1.0))/(tmpExp+exp(((0.5*modelPar_VLR)*modelVar_VtINV))))+(modelPar_GMIN*Vb1c4));
    if ((((modelPar_IZEB>0.0)&&(modelPar_NZEB>0.0))&&(Vb2e1<0)))
    {
      if (((modelVar_nZEB_T*(1-(modelVar_pow2_2mPE/(2.0*E0BE))))<400.0))
      {
        eZEB = exp((modelVar_nZEB_T*(1-(modelVar_pow2_2mPE/(2.0*E0BE)))));
      }
      else
      {
        expl = exp(400.0);
        eZEB = (expl*(1.0+((modelVar_nZEB_T*(1-(modelVar_pow2_2mPE/(2.0*E0BE))))-400.0)));
      }
      x = (Vb2e1*modelVar_inv_VDE_T);
      dE0BE = ((pow((-x),((-2.0)-modelPar_PE))*((modelPar_PE*((1-(modelPar_PE*modelPar_PE))-((3*x)*(modelPar_PE-1))))-(((6*x)*x)*((modelPar_PE-1)+x))))*0.16666666666666666667);
      if (((((Vb2e1*modelVar_pow2_2mPE)*modelVar_nZEB_T)/(modelVar_VGZEB_T*dE0BE))<400.0))
      {
        edZEB = exp((((Vb2e1*modelVar_pow2_2mPE)*modelVar_nZEB_T)/(modelVar_VGZEB_T*dE0BE)));
      }
      else
      {
        expl = exp(400.0);
        edZEB = (expl*(1.0+((((Vb2e1*modelVar_pow2_2mPE)*modelVar_nZEB_T)/(modelVar_VGZEB_T*dE0BE))-400.0)));
      }
      DZEB = ((-Vb2e1)-(((modelVar_VGZEB_T*dE0BE)*(1-edZEB))/(modelVar_pow2_2mPE*modelVar_nZEB_T)));
      instanceVar_Izteb = ((((((2.0*modelVar_IZEB_TM)*DZEB)*E0BE)*eZEB)*modelVar_inv_VDE_T)*modelVar_pow2_PEm2);
    }
    else
    {
      DZEB = 0;
      instanceVar_Izteb = 0;
    }
    g1 = (If0*eVb1c4);
    g2 = (4.0*eVb1c4VDC);
    nBex = ((g1-If0)/(1.0+sqrt((1.0+g1))));
    pWex = (g2/(1.0+sqrt((1.0+g2))));
    instanceVar_Iex = ((modelVar_IK_TM*nBex)/(2.0*modelVar_BRI_T));
    if ((modelPar_EXSUB==1.0))
    {
      instanceVar_Isub = (((2.0*modelVar_ISS_TM)*(eVb1c4-eVsc4))/(1.0+sqrt((1.0+((4.0*(modelVar_IS_TM/modelVar_IKS_TM))*eVb1c4)))));
    }
    else
    {
      instanceVar_Isub = (((2.0*modelVar_ISS_TM)*(eVb1c4-1.0))/(1.0+sqrt((1.0+((4.0*(modelVar_IS_TM/modelVar_IKS_TM))*eVb1c4)))));
    }
    if ((modelPar_ICSS<0.0))
    {
      Isf = (modelVar_ISS_TM*(eVsc1-1.0));
    }
    else
    {
      Isf = (modelVar_ICSS_TM*(eVsc1-1.0));
    }
    instanceVar_XIex = 0.0;
    instanceVar_XIsub = 0.0;
    if (((modelPar_EXMOD==1)||(modelPar_EXMOD==2)))
    {
      instanceVar_Iex = (instanceVar_Iex*modelVar_Xext1);
      instanceVar_Isub = (instanceVar_Isub*modelVar_Xext1);
      Xg1 = (If0*eVbc3);
      XnBex = ((Xg1-If0)/(1.0+sqrt((1.0+Xg1))));
      XIMex = ((((modelPar_XEXT*0.5)*modelVar_IK_TM)*XnBex)/modelVar_BRI_T);
      if ((modelPar_EXSUB==1.0))
      {
        XIMsub = ((((modelPar_XEXT*2.0)*modelVar_ISS_TM)*(eVbc3-eVsc3))/(1.0+sqrt((1.0+(((4.0*modelVar_IS_T)/modelVar_IKS_T)*eVbc3)))));
      }
      else
      {
        XIMsub = ((((modelPar_XEXT*2.0)*modelVar_ISS_TM)*(eVbc3-1.0))/(1.0+sqrt((1.0+(((4.0*modelVar_IS_T)/modelVar_IKS_T)*eVbc3)))));
      }
      if ((modelPar_EXMOD==1))
      {
        Vex_bias = ((modelPar_XEXT*((modelVar_IS_TM/modelVar_BRI_T)+modelVar_ISS_TM))*modelVar_RCCxx_TM);
        Vex = (modelVar_Vt*(2.0-log((Vex_bias*modelVar_VtINV))));
        vdif = (Vbc3-Vex);
        eps2 = (0.11*0.11);
        x2 = (vdif*vdif);
        if ((vdif<0.0))
        {
          VBex = ((0.5*eps2)/(sqrt((x2+eps2))-vdif));
        }
        else
        {
          VBex = (0.5*(sqrt((x2+eps2))+vdif));
        }
        VBex = VBex;
        Fex = (VBex/((Vex_bias+((XIMex+XIMsub)*modelVar_RCCxx_TM))+VBex));
      }
      else
      {
        Vex = 0.0;
        vdif = 0.0;
        VBex = 0.0;
        Fex = 1.0;
      }
      instanceVar_XIex = (Fex*XIMex);
      instanceVar_XIsub = (Fex*XIMsub);
    }
    else
    {
      Fex = 0;
      XnBex = 0;
    }
    q0Q = ((1.0+(Vte/modelVar_VER_T))+(Vtc/modelVar_VEF_T));
    eps2 = (0.1*0.1);
    x2 = (q0Q*q0Q);
    if ((q0Q<0.0))
    {
      q1Q = ((0.5*eps2)/(sqrt((x2+eps2))-q0Q));
    }
    else
    {
      q1Q = (0.5*(sqrt((x2+eps2))+q0Q));
    }
    q1Q = q1Q;
    qBQ = (q1Q*(1.0+(0.5*(n0+nB))));
    instanceVar_Rb2 = ((3.0*modelVar_RBV_TM)/qBQ);
    Ib1b2 = ((((2.0*modelVar_Vt)*(instanceVar_eVb1b2-1.0))+Vb1b2)/instanceVar_Rb2);
    Iavl = 0.0;
    instanceVar_Gem = 0.0;
    if (((Ic1c2>0.0)&&(Vb2c1<modelVar_VDC_T)))
    {
      dEdx0 = ((2.0*modelPar_VAVL)/(modelPar_WAVL*modelPar_WAVL));
      sqr_arg = ((modelVar_VDC_T-Vb2c1)/Icap_IHC);
      xd = sqrt(((2.0*sqr_arg)/dEdx0));
      if ((modelPar_EXAVL==0.0))
      {
        Weff = modelPar_WAVL;
      }
      else
      {
        xi_w1 = (1.0-(0.5*xi_w));
        Weff = ((modelPar_WAVL*xi_w1)*xi_w1);
      }
      Wd = ((xd*Weff)/sqrt(((xd*xd)+(Weff*Weff))));
      Eav = ((modelVar_VDC_T-Vb2c1)/Wd);
      E0 = (Eav+(((0.5*Wd)*dEdx0)*Icap_IHC));
      if ((modelPar_EXAVL==0))
      {
        Em = E0;
      }
      else
      {
        SHw = (1.0+((2.0*modelPar_SFH)*(1.0+(2.0*xi_w))));
        Efi = ((1.0+modelPar_SFH)/(1.0+(2.0*modelPar_SFH)));
        Ew = (Eav-(((0.5*Wd)*dEdx0)*(Efi-(Ic1c2/(modelVar_IHC_M*SHw)))));
        sqr_arg = (((Ew-E0)*(Ew-E0))+((((0.1*Eav)*Eav)*Icap)/modelVar_IHC_M));
        Em = (0.5*((Ew+E0)+sqrt(sqr_arg)));
      }
      EmEav_Em = ((Em-Eav)/Em);
      if ((fabs(EmEav_Em)>1.0e-7))
      {
        lambda = ((0.5*Wd)/EmEav_Em);
        instanceVar_Gem = ((((modelVar_An/modelVar_BnT)*Em)*lambda)*(exp(((-modelVar_BnT)/Em))-exp((((-modelVar_BnT)/Em)*(1.0+(Weff/lambda))))));
      }
      else
      {
        instanceVar_Gem = ((modelVar_An*Weff)*exp(((-modelVar_BnT)/Em)));
      }
      Gmax = (((modelVar_Vt/(Ic1c2*(modelVar_RBC_TM+instanceVar_Rb2)))+(instanceVar_qBI/modelVar_BF_T))+(modelVar_RE_TM/(modelVar_RBC_TM+instanceVar_Rb2)));
      Iavl = ((Ic1c2*instanceVar_Gem)/((instanceVar_Gem+(instanceVar_Gem/Gmax))+1.0));
    }
    if ((eVb2c2star>0.0))
    {
      Vb2c2star = (modelVar_Vt*log(eVb2c2star));
    }
    else
    {
      Vb2c2star = Vb2c2;
    }
    Qte = (((1.0-modelPar_XCJE)*modelVar_CJE_TM)*Vte);
    {
      //Block-local variables for block 
      AdmsSensFadType dxa;
      //End of Block-local variables
      dxa = ((Vb1e1-Vfe)/a_VDE);
      if ((Vb1e1<Vfe))
      {
        Vje_s = (Vb1e1-(a_VDE*log((1.0+exp(dxa)))));
      }
      else
      {
        Vje_s = (Vfe-(a_VDE*log((1.0+exp((-dxa))))));
      }
      Vje_s = Vje_s;
    }
    Qte_s = ((modelPar_XCJE*modelVar_CJE_TM)*(((modelVar_VDE_T/(1.0-modelPar_PE))*(1.0-pow((1.0-(Vje_s*modelVar_inv_VDE_T)),(1.0-modelPar_PE))))+(3.0*(Vb1e1-Vje_s))));
    Qtc = ((modelPar_XCJC*modelVar_CJC_TM)*Vtc);
    Qb0 = (modelVar_TAUB_T*modelVar_IK_TM);
    Qbe_qs = (((0.5*Qb0)*n0)*q1Q);
    Qbc_qs = (((0.5*Qb0)*nB)*q1Q);
    a_VDC = (0.1*modelVar_VDC_T);
    {
      //Block-local variables for block 
      AdmsSensFadType dxa;
      //End of Block-local variables
      dxa = ((Vb1c4-Vfc)/a_VDC);
      if ((Vb1c4<Vfc))
      {
        Vjcex = (Vb1c4-(a_VDC*log((1.0+exp(dxa)))));
      }
      else
      {
        Vjcex = (Vfc-(a_VDC*log((1.0+exp((-dxa))))));
      }
      Vjcex = Vjcex;
    }
    Vtexv = (((modelVar_VDC_T/(1.0-modelPar_PC))*(1.0-pow((1.0-(Vjcex/modelVar_VDC_T)),(1.0-modelPar_PC))))+(bjc*(Vb1c4-Vjcex)));
    Qtex = (((modelVar_CJC_TM*(((1.0-modelVar_XP_T)*Vtexv)+(modelVar_XP_T*Vb1c4)))*(1.0-modelPar_XCJC))*(1.0-modelPar_XEXT));
    {
      //Block-local variables for block 
      AdmsSensFadType dxa;
      //End of Block-local variables
      dxa = ((Vbc3-Vfc)/a_VDC);
      if ((Vbc3<Vfc))
      {
        XVjcex = (Vbc3-(a_VDC*log((1.0+exp(dxa)))));
      }
      else
      {
        XVjcex = (Vfc-(a_VDC*log((1.0+exp((-dxa))))));
      }
      XVjcex = XVjcex;
    }
    XVtexv = (((modelVar_VDC_T/(1.0-modelPar_PC))*(1.0-pow((1.0-(XVjcex/modelVar_VDC_T)),(1.0-modelPar_PC))))+(bjc*(Vbc3-XVjcex)));
    XQtex = (((modelVar_CJC_TM*(((1.0-modelVar_XP_T)*XVtexv)+(modelVar_XP_T*Vbc3)))*(1.0-modelPar_XCJC))*modelPar_XEXT);
    a_VDS = (0.1*modelVar_VDS_T);
    Vfs = (modelVar_VDS_T*(1.0-pow(2.0,((-1.0)/modelPar_PS))));
    {
      //Block-local variables for block 
      AdmsSensFadType dxa;
      //End of Block-local variables
      dxa = ((Vsc1-Vfs)/a_VDS);
      if ((Vsc1<Vfs))
      {
        Vjs = (Vsc1-(a_VDS*log((1.0+exp(dxa)))));
      }
      else
      {
        Vjs = (Vfs-(a_VDS*log((1.0+exp((-dxa))))));
      }
      Vjs = Vjs;
    }
    Qts = (modelVar_CJS_TM*(((modelVar_VDS_T/(1.0-modelPar_PS))*(1.0-pow((1.0-(Vjs/modelVar_VDS_T)),(1.0-modelPar_PS))))+(2.0*(Vsc1-Vjs))));
    Qe0 = ((modelVar_TAUE_T*modelVar_IK_TM)*pow((modelVar_IS_TM/modelVar_IK_TM),(1.0/modelPar_MTAU)));
    if (((Vb2e1/(modelPar_MTAU*modelVar_Vt))<400.0))
    {
      tmpExp = exp((Vb2e1/(modelPar_MTAU*modelVar_Vt)));
    }
    else
    {
      expl = exp(400.0);
      tmpExp = (expl*(1.0+((Vb2e1/(modelPar_MTAU*modelVar_Vt))-400.0)));
    }
    Qe = (Qe0*(tmpExp-1.0));
    Qepi0 = (((4.0*modelVar_TEPI_T)*modelVar_Vt)/modelVar_RCV_TM);
    Qepi = (((0.5*Qepi0)*xi_w)*((p0star+pW)+2.0));
    Qex = (((modelVar_TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))/(modelVar_TAUB_T+modelVar_TEPI_T));
    XQex = 0.0;
    if ((modelPar_EXMOD==1))
    {
      Qex = (Qex*(1.0-modelPar_XEXT));
      Xg2 = (4.0*eVbc3VDC);
      XpWex = (Xg2/(1.0+sqrt((1.0+Xg2))));
      XQex = (((((0.5*Fex)*modelPar_XEXT)*modelVar_TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))/(modelVar_TAUB_T+modelVar_TEPI_T));
    }
    Qb1b2 = 0.0;
    if ((modelPar_EXPHI==1))
    {
      dVteVje = (pow((1.0-(Vje*modelVar_inv_VDE_T)),(-modelPar_PE))-3.0);
      Vb2e1Vfe = ((Vb2e1-Vfe)/a_VDE);
      if ((Vb2e1Vfe<0.0))
      {
        dVjeVb2e1 = (1.0/(1.0+exp(Vb2e1Vfe)));
      }
      else
      {
        dVjeVb2e1 = (exp((-Vb2e1Vfe))/(1.0+exp((-Vb2e1Vfe))));
      }
      dVteVb2e1 = ((dVteVje*dVjeVb2e1)+3.0);
      dQteVb2e1 = (((1.0-modelPar_XCJE)*modelVar_CJE_TM)*dVteVb2e1);
      dn0Vb2e1 = (((If0*eVb2e1)*modelVar_VtINV)*(0.5/sqrt((1.0+f1))));
      dQbeVb2e1 = (((0.5*Qb0)*q1Q)*dn0Vb2e1);
      dQeVb2e1 = ((Qe+Qe0)/(modelPar_MTAU*modelVar_Vt));
      Qb1b2 = ((0.2*Vb1b2)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1));
      Qbc = ((Qbe_qs*0.33333333333333333333)+Qbc_qs);
      Qbe = ((2.0*Qbe_qs)*0.33333333333333333333);
    }
    else
    {
      Qbe = Qbe_qs;
      Qbc = Qbc_qs;
    }
    // I(c1,c2) <+ ((TYPE*Ic1c2))
    staticContributions[admsNodeID_c1] += (modelPar_TYPE*Ic1c2);
    staticContributions[admsNodeID_c2] -= (modelPar_TYPE*Ic1c2);
    // I(c2,e1) <+ ((TYPE*In))
    staticContributions[admsNodeID_c2] += (modelPar_TYPE*In);
    staticContributions[admsNodeID_e1] -= (modelPar_TYPE*In);
    // I(b1,e1) <+ ((TYPE*Ib1_s))
    staticContributions[admsNodeID_b1] += (modelPar_TYPE*instanceVar_Ib1_s);
    staticContributions[admsNodeID_e1] -= (modelPar_TYPE*instanceVar_Ib1_s);
    // I(b2,e1) <+ ((TYPE*((Ib1+Ib2)-Izteb)))
    staticContributions[admsNodeID_b2] += (modelPar_TYPE*((instanceVar_Ib1+instanceVar_Ib2)-instanceVar_Izteb));
    staticContributions[admsNodeID_e1] -= (modelPar_TYPE*((instanceVar_Ib1+instanceVar_Ib2)-instanceVar_Izteb));
    // I(b1,s) <+ ((TYPE*Isub))
    staticContributions[admsNodeID_b1] += (modelPar_TYPE*instanceVar_Isub);
    staticContributions[admsNodeID_s] -= (modelPar_TYPE*instanceVar_Isub);
    // I(b,s) <+ ((TYPE*XIsub))
    staticContributions[admsNodeID_b] += (modelPar_TYPE*instanceVar_XIsub);
    staticContributions[admsNodeID_s] -= (modelPar_TYPE*instanceVar_XIsub);
    // I(s,c1) <+ ((TYPE*Isf))
    staticContributions[admsNodeID_s] += (modelPar_TYPE*Isf);
    staticContributions[admsNodeID_c1] -= (modelPar_TYPE*Isf);
    // I(b1,b2) <+ ((TYPE*Ib1b2))
    staticContributions[admsNodeID_b1] += (modelPar_TYPE*Ib1b2);
    staticContributions[admsNodeID_b2] -= (modelPar_TYPE*Ib1b2);
    // I(b2,c2) <+ ((TYPE*((-1.0)*Iavl)))
    staticContributions[admsNodeID_b2] += (modelPar_TYPE*((-1.0)*Iavl));
    staticContributions[admsNodeID_c2] -= (modelPar_TYPE*((-1.0)*Iavl));
    // I(e,e1) <+ (((TYPE*Vee1)/RE_TM))
    staticContributions[admsNodeID_e] += ((modelPar_TYPE*Vee1)/modelVar_RE_TM);
    staticContributions[admsNodeID_e1] -= ((modelPar_TYPE*Vee1)/modelVar_RE_TM);
    // I(b,b1) <+ (((TYPE*Vbb1)/RBC_TM))
    staticContributions[admsNodeID_b] += ((modelPar_TYPE*Vbb1)/modelVar_RBC_TM);
    staticContributions[admsNodeID_b1] -= ((modelPar_TYPE*Vbb1)/modelVar_RBC_TM);
    // I(noi,e1) <+ (V(noi,e1))
    staticContributions[admsNodeID_noi] += (probeVars[admsProbeID_V_noi_e1]);
    staticContributions[admsNodeID_e1] -= (probeVars[admsProbeID_V_noi_e1]);
    cor_exp_1 = (sqrt((1.0+(2.0*instanceVar_Gem)))*(probeVars[admsProbeID_V_noi_e1]));
    // I(b2,e1) <+ (cor_exp_1)
    staticContributions[admsNodeID_b2] += cor_exp_1;
    staticContributions[admsNodeID_e1] -= cor_exp_1;
    cor_exp_2 = (((2.0+(2.0*instanceVar_Gem))/sqrt((1.0+(2.0*instanceVar_Gem))))*(probeVars[admsProbeID_V_noi_e1]));
    // I(e1,c2) <+ (cor_exp_2)
    staticContributions[admsNodeID_e1] += cor_exp_2;
    staticContributions[admsNodeID_c2] -= cor_exp_2;
    // I(b2,e1) <+ (ddt((TYPE*((Qte+Qbe)+Qe))))
    dynamicContributions[admsNodeID_b2] += ((modelPar_TYPE*((Qte+Qbe)+Qe)));
    dynamicContributions[admsNodeID_e1] -= ((modelPar_TYPE*((Qte+Qbe)+Qe)));
    // I(b1,e1) <+ (ddt((TYPE*Qte_s)))
    dynamicContributions[admsNodeID_b1] += ((modelPar_TYPE*Qte_s));
    dynamicContributions[admsNodeID_e1] -= ((modelPar_TYPE*Qte_s));
    // I(b2,c2) <+ (ddt((TYPE*((Qtc+Qbc)+Qepi))))
    dynamicContributions[admsNodeID_b2] += ((modelPar_TYPE*((Qtc+Qbc)+Qepi)));
    dynamicContributions[admsNodeID_c2] -= ((modelPar_TYPE*((Qtc+Qbc)+Qepi)));
    // I(s,c1) <+ (ddt((TYPE*Qts)))
    dynamicContributions[admsNodeID_s] += ((modelPar_TYPE*Qts));
    dynamicContributions[admsNodeID_c1] -= ((modelPar_TYPE*Qts));
    // I(b1,b2) <+ (ddt((TYPE*Qb1b2)))
    dynamicContributions[admsNodeID_b1] += ((modelPar_TYPE*Qb1b2));
    dynamicContributions[admsNodeID_b2] -= ((modelPar_TYPE*Qb1b2));
    // I(b,e) <+ (ddt(((TYPE*CBEO_M)*Vbe)))
    dynamicContributions[admsNodeID_b] += (((modelPar_TYPE*modelVar_CBEO_M)*Vbe));
    dynamicContributions[admsNodeID_e] -= (((modelPar_TYPE*modelVar_CBEO_M)*Vbe));
    // I(b,c) <+ (ddt(((TYPE*CBCO_M)*Vbc)))
    dynamicContributions[admsNodeID_b] += (((modelPar_TYPE*modelVar_CBCO_M)*Vbc));
    dynamicContributions[admsNodeID_c] -= (((modelPar_TYPE*modelVar_CBCO_M)*Vbc));
  }
  if ((modelPar_RCBLX>0.0))
  {
    // I(b,c3) <+ ((TYPE*XIex))
    staticContributions[admsNodeID_b] += (modelPar_TYPE*instanceVar_XIex);
    staticContributions[admsNodeID_c3] -= (modelPar_TYPE*instanceVar_XIex);
    // I(c,c3) <+ (((TYPE*Vcc3)*GCCxx_TM))
    staticContributions[admsNodeID_c] += ((modelPar_TYPE*Vcc3)*modelVar_GCCxx_TM);
    staticContributions[admsNodeID_c3] -= ((modelPar_TYPE*Vcc3)*modelVar_GCCxx_TM);
    // I(b,c3) <+ (ddt((TYPE*(XQtex+XQex))))
    dynamicContributions[admsNodeID_b] += ((modelPar_TYPE*(XQtex+XQex)));
    dynamicContributions[admsNodeID_c3] -= ((modelPar_TYPE*(XQtex+XQex)));
    if ((modelPar_RCBLI>0.0))
    {
      // I(c4,c1) <+ (((TYPE*Vc4c1)*GCCin_TM))
      staticContributions[admsNodeID_c4] += ((modelPar_TYPE*Vc4c1)*modelVar_GCCin_TM);
      staticContributions[admsNodeID_c1] -= ((modelPar_TYPE*Vc4c1)*modelVar_GCCin_TM);
      // I(b1,c4) <+ ((TYPE*(Ib3+Iex)))
      staticContributions[admsNodeID_b1] += (modelPar_TYPE*(instanceVar_Ib3+instanceVar_Iex));
      staticContributions[admsNodeID_c4] -= (modelPar_TYPE*(instanceVar_Ib3+instanceVar_Iex));
      // I(c3,c4) <+ (((TYPE*Vc3c4)*GCCex_TM))
      staticContributions[admsNodeID_c3] += ((modelPar_TYPE*Vc3c4)*modelVar_GCCex_TM);
      staticContributions[admsNodeID_c4] -= ((modelPar_TYPE*Vc3c4)*modelVar_GCCex_TM);
      // I(b1,c4) <+ (ddt((TYPE*(Qtex+Qex))))
      dynamicContributions[admsNodeID_b1] += ((modelPar_TYPE*(Qtex+Qex)));
      dynamicContributions[admsNodeID_c4] -= ((modelPar_TYPE*(Qtex+Qex)));
    }
    else
    {
      // V(c4,c1) <+ (0.0)
      // do nothing at all
      // I(b1,c1) <+ ((TYPE*(Ib3+Iex)))
      staticContributions[admsNodeID_b1] += (modelPar_TYPE*(instanceVar_Ib3+instanceVar_Iex));
      staticContributions[admsNodeID_c1] -= (modelPar_TYPE*(instanceVar_Ib3+instanceVar_Iex));
      // I(b1,c1) <+ (ddt((TYPE*(Qtex+Qex))))
      dynamicContributions[admsNodeID_b1] += ((modelPar_TYPE*(Qtex+Qex)));
      dynamicContributions[admsNodeID_c1] -= ((modelPar_TYPE*(Qtex+Qex)));
      // I(c3,c1) <+ (((TYPE*Vc3c4)*GCCex_TM))
      staticContributions[admsNodeID_c3] += ((modelPar_TYPE*Vc3c4)*modelVar_GCCex_TM);
      staticContributions[admsNodeID_c1] -= ((modelPar_TYPE*Vc3c4)*modelVar_GCCex_TM);
    }
  }
  else
  {
    // V(c3,c4) <+ (0)
    // do nothing at all
    if ((modelPar_RCBLI>0.0))
    {
      // I(b,c4) <+ ((TYPE*XIex))
      staticContributions[admsNodeID_b] += (modelPar_TYPE*instanceVar_XIex);
      staticContributions[admsNodeID_c4] -= (modelPar_TYPE*instanceVar_XIex);
      // I(c,c4) <+ (((TYPE*Vcc3)*GCCxx_TM))
      staticContributions[admsNodeID_c] += ((modelPar_TYPE*Vcc3)*modelVar_GCCxx_TM);
      staticContributions[admsNodeID_c4] -= ((modelPar_TYPE*Vcc3)*modelVar_GCCxx_TM);
      // I(c4,c1) <+ (((TYPE*Vc4c1)*GCCin_TM))
      staticContributions[admsNodeID_c4] += ((modelPar_TYPE*Vc4c1)*modelVar_GCCin_TM);
      staticContributions[admsNodeID_c1] -= ((modelPar_TYPE*Vc4c1)*modelVar_GCCin_TM);
      // I(b1,c4) <+ ((TYPE*(Ib3+Iex)))
      staticContributions[admsNodeID_b1] += (modelPar_TYPE*(instanceVar_Ib3+instanceVar_Iex));
      staticContributions[admsNodeID_c4] -= (modelPar_TYPE*(instanceVar_Ib3+instanceVar_Iex));
      // I(b1,c4) <+ (ddt((TYPE*(Qtex+Qex))))
      dynamicContributions[admsNodeID_b1] += ((modelPar_TYPE*(Qtex+Qex)));
      dynamicContributions[admsNodeID_c4] -= ((modelPar_TYPE*(Qtex+Qex)));
      // I(b,c4) <+ (ddt((TYPE*(XQtex+XQex))))
      dynamicContributions[admsNodeID_b] += ((modelPar_TYPE*(XQtex+XQex)));
      dynamicContributions[admsNodeID_c4] -= ((modelPar_TYPE*(XQtex+XQex)));
    }
    else
    {
      // I(b,c1) <+ ((TYPE*XIex))
      staticContributions[admsNodeID_b] += (modelPar_TYPE*instanceVar_XIex);
      staticContributions[admsNodeID_c1] -= (modelPar_TYPE*instanceVar_XIex);
      // I(c,c1) <+ (((TYPE*Vcc3)*GCCxx_TM))
      staticContributions[admsNodeID_c] += ((modelPar_TYPE*Vcc3)*modelVar_GCCxx_TM);
      staticContributions[admsNodeID_c1] -= ((modelPar_TYPE*Vcc3)*modelVar_GCCxx_TM);
      // V(c4,c1) <+ (0.0)
      // do nothing at all
      // I(b1,c1) <+ ((TYPE*(Ib3+Iex)))
      staticContributions[admsNodeID_b1] += (modelPar_TYPE*(instanceVar_Ib3+instanceVar_Iex));
      staticContributions[admsNodeID_c1] -= (modelPar_TYPE*(instanceVar_Ib3+instanceVar_Iex));
      // I(b1,c1) <+ (ddt((TYPE*(Qtex+Qex))))
      dynamicContributions[admsNodeID_b1] += ((modelPar_TYPE*(Qtex+Qex)));
      dynamicContributions[admsNodeID_c1] -= ((modelPar_TYPE*(Qtex+Qex)));
      // I(b,c1) <+ (ddt((TYPE*(XQtex+XQex))))
      dynamicContributions[admsNodeID_b] += ((modelPar_TYPE*(XQtex+XQex)));
      dynamicContributions[admsNodeID_c1] -= ((modelPar_TYPE*(XQtex+XQex)));
      // I(c3,c1) <+ (((TYPE*Vc3c4)*GCCex_TM))
      staticContributions[admsNodeID_c3] += ((modelPar_TYPE*Vc3c4)*modelVar_GCCex_TM);
      staticContributions[admsNodeID_c1] -= ((modelPar_TYPE*Vc3c4)*modelVar_GCCex_TM);
    }
  }
  {
  }
}



//-----------------------------------------------------------------------------
// Function      : InstanceSensitivity::operator()
// Purpose       : return sensitivity for a single instance parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
/// Compute sensitivity of a device instance's outputs to a specified instance
/// parameter
/// 
/// 
/// @param[in] entity  The device entity that owns the parameter 
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
/// 
/// 
void InstanceSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Instance & in = *(dynamic_cast<const Instance *> (e1));
  const Model & mod =in.model_;

  dfdp.resize(12+0);
  dqdp.resize(12+0);
  Findices.resize(12+0);
  Qindices.resize(12+0);

  std::vector <double> probeVars(15);
  std::vector <AdmsSensFadType> staticContributions(12+0);
  std::vector <AdmsSensFadType> dynamicContributions(12+0);


  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 12+0 ; ++i)
  {
    staticContributions[i]=0;
    dynamicContributions[i]=0;
  }

  // Copy out all the model parameters (doubles) into FAD types
  //reals
  AdmsSensFadType modelPar_TREF=mod.TREF;
  bool modelPar_given_TREF=mod.given("TREF");
  AdmsSensFadType modelPar_DTA=mod.DTA;
  bool modelPar_given_DTA=mod.given("DTA");
  AdmsSensFadType modelPar_IS=mod.IS;
  bool modelPar_given_IS=mod.given("IS");
  AdmsSensFadType modelPar_IK=mod.IK;
  bool modelPar_given_IK=mod.given("IK");
  AdmsSensFadType modelPar_VER=mod.VER;
  bool modelPar_given_VER=mod.given("VER");
  AdmsSensFadType modelPar_VEF=mod.VEF;
  bool modelPar_given_VEF=mod.given("VEF");
  AdmsSensFadType modelPar_BF=mod.BF;
  bool modelPar_given_BF=mod.given("BF");
  AdmsSensFadType modelPar_IBF=mod.IBF;
  bool modelPar_given_IBF=mod.given("IBF");
  AdmsSensFadType modelPar_MLF=mod.MLF;
  bool modelPar_given_MLF=mod.given("MLF");
  AdmsSensFadType modelPar_XIBI=mod.XIBI;
  bool modelPar_given_XIBI=mod.given("XIBI");
  AdmsSensFadType modelPar_IZEB=mod.IZEB;
  bool modelPar_given_IZEB=mod.given("IZEB");
  AdmsSensFadType modelPar_NZEB=mod.NZEB;
  bool modelPar_given_NZEB=mod.given("NZEB");
  AdmsSensFadType modelPar_BRI=mod.BRI;
  bool modelPar_given_BRI=mod.given("BRI");
  AdmsSensFadType modelPar_IBR=mod.IBR;
  bool modelPar_given_IBR=mod.given("IBR");
  AdmsSensFadType modelPar_VLR=mod.VLR;
  bool modelPar_given_VLR=mod.given("VLR");
  AdmsSensFadType modelPar_XEXT=mod.XEXT;
  bool modelPar_given_XEXT=mod.given("XEXT");
  AdmsSensFadType modelPar_WAVL=mod.WAVL;
  bool modelPar_given_WAVL=mod.given("WAVL");
  AdmsSensFadType modelPar_VAVL=mod.VAVL;
  bool modelPar_given_VAVL=mod.given("VAVL");
  AdmsSensFadType modelPar_SFH=mod.SFH;
  bool modelPar_given_SFH=mod.given("SFH");
  AdmsSensFadType modelPar_RE=mod.RE;
  bool modelPar_given_RE=mod.given("RE");
  AdmsSensFadType modelPar_RBC=mod.RBC;
  bool modelPar_given_RBC=mod.given("RBC");
  AdmsSensFadType modelPar_RBV=mod.RBV;
  bool modelPar_given_RBV=mod.given("RBV");
  AdmsSensFadType modelPar_RCC=mod.RCC;
  bool modelPar_given_RCC=mod.given("RCC");
  AdmsSensFadType modelPar_RCV=mod.RCV;
  bool modelPar_given_RCV=mod.given("RCV");
  AdmsSensFadType modelPar_SCRCV=mod.SCRCV;
  bool modelPar_given_SCRCV=mod.given("SCRCV");
  AdmsSensFadType modelPar_IHC=mod.IHC;
  bool modelPar_given_IHC=mod.given("IHC");
  AdmsSensFadType modelPar_AXI=mod.AXI;
  bool modelPar_given_AXI=mod.given("AXI");
  AdmsSensFadType modelPar_CJE=mod.CJE;
  bool modelPar_given_CJE=mod.given("CJE");
  AdmsSensFadType modelPar_VDE=mod.VDE;
  bool modelPar_given_VDE=mod.given("VDE");
  AdmsSensFadType modelPar_PE=mod.PE;
  bool modelPar_given_PE=mod.given("PE");
  AdmsSensFadType modelPar_XCJE=mod.XCJE;
  bool modelPar_given_XCJE=mod.given("XCJE");
  AdmsSensFadType modelPar_CBEO=mod.CBEO;
  bool modelPar_given_CBEO=mod.given("CBEO");
  AdmsSensFadType modelPar_CJC=mod.CJC;
  bool modelPar_given_CJC=mod.given("CJC");
  AdmsSensFadType modelPar_VDC=mod.VDC;
  bool modelPar_given_VDC=mod.given("VDC");
  AdmsSensFadType modelPar_PC=mod.PC;
  bool modelPar_given_PC=mod.given("PC");
  AdmsSensFadType modelPar_XP=mod.XP;
  bool modelPar_given_XP=mod.given("XP");
  AdmsSensFadType modelPar_MC=mod.MC;
  bool modelPar_given_MC=mod.given("MC");
  AdmsSensFadType modelPar_XCJC=mod.XCJC;
  bool modelPar_given_XCJC=mod.given("XCJC");
  AdmsSensFadType modelPar_RCBLX=mod.RCBLX;
  bool modelPar_given_RCBLX=mod.given("RCBLX");
  AdmsSensFadType modelPar_RCBLI=mod.RCBLI;
  bool modelPar_given_RCBLI=mod.given("RCBLI");
  AdmsSensFadType modelPar_CBCO=mod.CBCO;
  bool modelPar_given_CBCO=mod.given("CBCO");
  AdmsSensFadType modelPar_MTAU=mod.MTAU;
  bool modelPar_given_MTAU=mod.given("MTAU");
  AdmsSensFadType modelPar_TAUE=mod.TAUE;
  bool modelPar_given_TAUE=mod.given("TAUE");
  AdmsSensFadType modelPar_TAUB=mod.TAUB;
  bool modelPar_given_TAUB=mod.given("TAUB");
  AdmsSensFadType modelPar_TEPI=mod.TEPI;
  bool modelPar_given_TEPI=mod.given("TEPI");
  AdmsSensFadType modelPar_TAUR=mod.TAUR;
  bool modelPar_given_TAUR=mod.given("TAUR");
  AdmsSensFadType modelPar_DEG=mod.DEG;
  bool modelPar_given_DEG=mod.given("DEG");
  AdmsSensFadType modelPar_XREC=mod.XREC;
  bool modelPar_given_XREC=mod.given("XREC");
  AdmsSensFadType modelPar_AQBO=mod.AQBO;
  bool modelPar_given_AQBO=mod.given("AQBO");
  AdmsSensFadType modelPar_AE=mod.AE;
  bool modelPar_given_AE=mod.given("AE");
  AdmsSensFadType modelPar_AB=mod.AB;
  bool modelPar_given_AB=mod.given("AB");
  AdmsSensFadType modelPar_AEPI=mod.AEPI;
  bool modelPar_given_AEPI=mod.given("AEPI");
  AdmsSensFadType modelPar_AEX=mod.AEX;
  bool modelPar_given_AEX=mod.given("AEX");
  AdmsSensFadType modelPar_AC=mod.AC;
  bool modelPar_given_AC=mod.given("AC");
  AdmsSensFadType modelPar_ACBL=mod.ACBL;
  bool modelPar_given_ACBL=mod.given("ACBL");
  AdmsSensFadType modelPar_DVGBF=mod.DVGBF;
  bool modelPar_given_DVGBF=mod.given("DVGBF");
  AdmsSensFadType modelPar_DVGBR=mod.DVGBR;
  bool modelPar_given_DVGBR=mod.given("DVGBR");
  AdmsSensFadType modelPar_VGB=mod.VGB;
  bool modelPar_given_VGB=mod.given("VGB");
  AdmsSensFadType modelPar_VGC=mod.VGC;
  bool modelPar_given_VGC=mod.given("VGC");
  AdmsSensFadType modelPar_VGJ=mod.VGJ;
  bool modelPar_given_VGJ=mod.given("VGJ");
  AdmsSensFadType modelPar_VGZEB=mod.VGZEB;
  bool modelPar_given_VGZEB=mod.given("VGZEB");
  AdmsSensFadType modelPar_AVGEB=mod.AVGEB;
  bool modelPar_given_AVGEB=mod.given("AVGEB");
  AdmsSensFadType modelPar_TVGEB=mod.TVGEB;
  bool modelPar_given_TVGEB=mod.given("TVGEB");
  AdmsSensFadType modelPar_DVGTE=mod.DVGTE;
  bool modelPar_given_DVGTE=mod.given("DVGTE");
  AdmsSensFadType modelPar_DAIS=mod.DAIS;
  bool modelPar_given_DAIS=mod.given("DAIS");
  AdmsSensFadType modelPar_AF=mod.AF;
  bool modelPar_given_AF=mod.given("AF");
  AdmsSensFadType modelPar_KF=mod.KF;
  bool modelPar_given_KF=mod.given("KF");
  AdmsSensFadType modelPar_KFN=mod.KFN;
  bool modelPar_given_KFN=mod.given("KFN");
  AdmsSensFadType modelPar_ISS=mod.ISS;
  bool modelPar_given_ISS=mod.given("ISS");
  AdmsSensFadType modelPar_ICSS=mod.ICSS;
  bool modelPar_given_ICSS=mod.given("ICSS");
  AdmsSensFadType modelPar_IKS=mod.IKS;
  bool modelPar_given_IKS=mod.given("IKS");
  AdmsSensFadType modelPar_CJS=mod.CJS;
  bool modelPar_given_CJS=mod.given("CJS");
  AdmsSensFadType modelPar_VDS=mod.VDS;
  bool modelPar_given_VDS=mod.given("VDS");
  AdmsSensFadType modelPar_PS=mod.PS;
  bool modelPar_given_PS=mod.given("PS");
  AdmsSensFadType modelPar_VGS=mod.VGS;
  bool modelPar_given_VGS=mod.given("VGS");
  AdmsSensFadType modelPar_AS=mod.AS;
  bool modelPar_given_AS=mod.given("AS");
  AdmsSensFadType modelPar_ASUB=mod.ASUB;
  bool modelPar_given_ASUB=mod.given("ASUB");
  AdmsSensFadType modelPar_MULT=mod.MULT;
  bool modelPar_given_MULT=mod.given("MULT");
  AdmsSensFadType modelPar_GMIN=mod.GMIN;
  bool modelPar_given_GMIN=mod.given("GMIN");


  // hidden reals


  // non-reals (including hiddens)
  int modelPar_LEVEL=mod.LEVEL;
  bool modelPar_given_LEVEL=mod.given("LEVEL");
  int modelPar_EXMOD=mod.EXMOD;
  bool modelPar_given_EXMOD=mod.given("EXMOD");
  int modelPar_EXPHI=mod.EXPHI;
  bool modelPar_given_EXPHI=mod.given("EXPHI");
  int modelPar_EXAVL=mod.EXAVL;
  bool modelPar_given_EXAVL=mod.given("EXAVL");
  int modelPar_EXSUB=mod.EXSUB;
  bool modelPar_given_EXSUB=mod.given("EXSUB");
  int modelPar_KAVL=mod.KAVL;
  bool modelPar_given_KAVL=mod.given("KAVL");
  int modelPar_TYPE=mod.TYPE;
  bool modelPar_given_TYPE=mod.given("TYPE");



  // Copy out all the instance parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> inParamMap;

  // reals
  AdmsSensFadType instancePar_MULT=in.MULT;
  bool instancePar_given_MULT=in.given("MULT");
  inParamMap["MULT"] = &instancePar_MULT;


  // Copy all the real hidden instance params into fad types



  // Copy all the non-real instance params into vars of their appropriate type:


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check the name first, otherwise segfault on invalid name!
  inParamMap[name]->diff(0,1);

  //make local copies of all instance vars
  //reals
  AdmsSensFadType instanceVar_Izteb=in.Izteb;
  AdmsSensFadType instanceVar_qBI=in.qBI;
  AdmsSensFadType instanceVar_Ir=in.Ir;
  AdmsSensFadType instanceVar_If=in.If;
  AdmsSensFadType instanceVar_Ib1=in.Ib1;
  AdmsSensFadType instanceVar_Ib1_s=in.Ib1_s;
  AdmsSensFadType instanceVar_Ib2=in.Ib2;
  AdmsSensFadType instanceVar_Ib3=in.Ib3;
  AdmsSensFadType instanceVar_Iex=in.Iex;
  AdmsSensFadType instanceVar_XIex=in.XIex;
  AdmsSensFadType instanceVar_Isub=in.Isub;
  AdmsSensFadType instanceVar_XIsub=in.XIsub;
  AdmsSensFadType instanceVar_Rb2=in.Rb2;
  AdmsSensFadType instanceVar_Gem=in.Gem;
  AdmsSensFadType instanceVar_eVb1b2=in.eVb1b2;


  //non-reals


  //make local copies of all model vars
  //reals
  AdmsSensFadType modelVar_An=mod.An;
  AdmsSensFadType modelVar_Tk=mod.Tk;
  AdmsSensFadType modelVar_Vt=mod.Vt;
  AdmsSensFadType modelVar_VtINV=mod.VtINV;
  AdmsSensFadType modelVar_VDE_T=mod.VDE_T;
  AdmsSensFadType modelVar_VDC_T=mod.VDC_T;
  AdmsSensFadType modelVar_XP_T=mod.XP_T;
  AdmsSensFadType modelVar_BF_T=mod.BF_T;
  AdmsSensFadType modelVar_BRI_T=mod.BRI_T;
  AdmsSensFadType modelVar_IS_T=mod.IS_T;
  AdmsSensFadType modelVar_VEF_T=mod.VEF_T;
  AdmsSensFadType modelVar_VER_T=mod.VER_T;
  AdmsSensFadType modelVar_nZEB_T=mod.nZEB_T;
  AdmsSensFadType modelVar_pow2_2mPE=mod.pow2_2mPE;
  AdmsSensFadType modelVar_pow2_PEm2=mod.pow2_PEm2;
  AdmsSensFadType modelVar_inv_VDE_T=mod.inv_VDE_T;
  AdmsSensFadType modelVar_VGZEB_T=mod.VGZEB_T;
  AdmsSensFadType modelVar_TAUE_T=mod.TAUE_T;
  AdmsSensFadType modelVar_TAUB_T=mod.TAUB_T;
  AdmsSensFadType modelVar_TEPI_T=mod.TEPI_T;
  AdmsSensFadType modelVar_TAUR_T=mod.TAUR_T;
  AdmsSensFadType modelVar_BnT=mod.BnT;
  AdmsSensFadType modelVar_DEG_T=mod.DEG_T;
  AdmsSensFadType modelVar_VDS_T=mod.VDS_T;
  AdmsSensFadType modelVar_IKS_T=mod.IKS_T;
  AdmsSensFadType modelVar_IS_TM=mod.IS_TM;
  AdmsSensFadType modelVar_IK_TM=mod.IK_TM;
  AdmsSensFadType modelVar_IBF_TM=mod.IBF_TM;
  AdmsSensFadType modelVar_IBR_TM=mod.IBR_TM;
  AdmsSensFadType modelVar_IHC_M=mod.IHC_M;
  AdmsSensFadType modelVar_IZEB_TM=mod.IZEB_TM;
  AdmsSensFadType modelVar_CJE_TM=mod.CJE_TM;
  AdmsSensFadType modelVar_CJC_TM=mod.CJC_TM;
  AdmsSensFadType modelVar_RE_TM=mod.RE_TM;
  AdmsSensFadType modelVar_RBC_TM=mod.RBC_TM;
  AdmsSensFadType modelVar_RBV_TM=mod.RBV_TM;
  AdmsSensFadType modelVar_RCV_TM=mod.RCV_TM;
  AdmsSensFadType modelVar_SCRCV_M=mod.SCRCV_M;
  AdmsSensFadType modelVar_RCCxx_TM=mod.RCCxx_TM;
  AdmsSensFadType modelVar_GCCxx_TM=mod.GCCxx_TM;
  AdmsSensFadType modelVar_GCCex_TM=mod.GCCex_TM;
  AdmsSensFadType modelVar_GCCin_TM=mod.GCCin_TM;
  AdmsSensFadType modelVar_KF_M=mod.KF_M;
  AdmsSensFadType modelVar_KFN_M=mod.KFN_M;
  AdmsSensFadType modelVar_ISS_TM=mod.ISS_TM;
  AdmsSensFadType modelVar_ICSS_TM=mod.ICSS_TM;
  AdmsSensFadType modelVar_IKS_TM=mod.IKS_TM;
  AdmsSensFadType modelVar_CJS_TM=mod.CJS_TM;
  AdmsSensFadType modelVar_Xext1=mod.Xext1;
  AdmsSensFadType modelVar_CBEO_M=mod.CBEO_M;
  AdmsSensFadType modelVar_CBCO_M=mod.CBCO_M;


  // non-reals



  Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

  // extract solution variables and set as Fad independent variables.

  probeVars[in.admsProbeID_V_noi_e1] = (*solVectorPtr)[in.li_noi] - (*solVectorPtr)[in.li_e1];
  probeVars[in.admsProbeID_V_c3_c1] = (*solVectorPtr)[in.li_c3] - (*solVectorPtr)[in.li_c1];
  probeVars[in.admsProbeID_V_c3_c4] = (*solVectorPtr)[in.li_c3] - (*solVectorPtr)[in.li_c4];
  probeVars[in.admsProbeID_V_c4_c1] = (*solVectorPtr)[in.li_c4] - (*solVectorPtr)[in.li_c1];
  probeVars[in.admsProbeID_V_b_c] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_c];
  probeVars[in.admsProbeID_V_b_e] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_e];
  probeVars[in.admsProbeID_V_b_b1] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_b1];
  probeVars[in.admsProbeID_V_e_e1] = (*solVectorPtr)[in.li_e] - (*solVectorPtr)[in.li_e1];
  probeVars[in.admsProbeID_V_c1_c2] = (*solVectorPtr)[in.li_c1] - (*solVectorPtr)[in.li_c2];
  probeVars[in.admsProbeID_V_s_c1] = (*solVectorPtr)[in.li_s] - (*solVectorPtr)[in.li_c1];
  probeVars[in.admsProbeID_V_b1_b2] = (*solVectorPtr)[in.li_b1] - (*solVectorPtr)[in.li_b2];
  probeVars[in.admsProbeID_V_b1_e1] = (*solVectorPtr)[in.li_b1] - (*solVectorPtr)[in.li_e1];
  probeVars[in.admsProbeID_V_b2_e1] = (*solVectorPtr)[in.li_b2] - (*solVectorPtr)[in.li_e1];
  probeVars[in.admsProbeID_V_b2_c2] = (*solVectorPtr)[in.li_b2] - (*solVectorPtr)[in.li_c2];
  probeVars[in.admsProbeID_V_b2_c1] = (*solVectorPtr)[in.li_b2] - (*solVectorPtr)[in.li_c1];

  // pre-multiply any "typed" probes (i.e. those limited with "typedpnjlim")
  probeVars[in.admsProbeID_V_b1_b2] *= modelPar_TYPE;
  probeVars[in.admsProbeID_V_b1_e1] *= modelPar_TYPE;
  probeVars[in.admsProbeID_V_b2_c2] *= modelPar_TYPE;
  probeVars[in.admsProbeID_V_b2_c1] *= modelPar_TYPE;


  // Need to use processParams-like function to process the
  // initial_model and initial_instance blocks with the LOCAL copies of
  // instance and model vars, and local copies of instance and model
  // params.
  evaluateInitialModel(
     // model parameters
     // reals
     modelPar_TREF,
     modelPar_given_TREF,
     modelPar_DTA,
     modelPar_given_DTA,
     modelPar_IS,
     modelPar_given_IS,
     modelPar_IK,
     modelPar_given_IK,
     modelPar_VER,
     modelPar_given_VER,
     modelPar_VEF,
     modelPar_given_VEF,
     modelPar_BF,
     modelPar_given_BF,
     modelPar_IBF,
     modelPar_given_IBF,
     modelPar_MLF,
     modelPar_given_MLF,
     modelPar_XIBI,
     modelPar_given_XIBI,
     modelPar_IZEB,
     modelPar_given_IZEB,
     modelPar_NZEB,
     modelPar_given_NZEB,
     modelPar_BRI,
     modelPar_given_BRI,
     modelPar_IBR,
     modelPar_given_IBR,
     modelPar_VLR,
     modelPar_given_VLR,
     modelPar_XEXT,
     modelPar_given_XEXT,
     modelPar_WAVL,
     modelPar_given_WAVL,
     modelPar_VAVL,
     modelPar_given_VAVL,
     modelPar_SFH,
     modelPar_given_SFH,
     modelPar_RE,
     modelPar_given_RE,
     modelPar_RBC,
     modelPar_given_RBC,
     modelPar_RBV,
     modelPar_given_RBV,
     modelPar_RCC,
     modelPar_given_RCC,
     modelPar_RCV,
     modelPar_given_RCV,
     modelPar_SCRCV,
     modelPar_given_SCRCV,
     modelPar_IHC,
     modelPar_given_IHC,
     modelPar_AXI,
     modelPar_given_AXI,
     modelPar_CJE,
     modelPar_given_CJE,
     modelPar_VDE,
     modelPar_given_VDE,
     modelPar_PE,
     modelPar_given_PE,
     modelPar_XCJE,
     modelPar_given_XCJE,
     modelPar_CBEO,
     modelPar_given_CBEO,
     modelPar_CJC,
     modelPar_given_CJC,
     modelPar_VDC,
     modelPar_given_VDC,
     modelPar_PC,
     modelPar_given_PC,
     modelPar_XP,
     modelPar_given_XP,
     modelPar_MC,
     modelPar_given_MC,
     modelPar_XCJC,
     modelPar_given_XCJC,
     modelPar_RCBLX,
     modelPar_given_RCBLX,
     modelPar_RCBLI,
     modelPar_given_RCBLI,
     modelPar_CBCO,
     modelPar_given_CBCO,
     modelPar_MTAU,
     modelPar_given_MTAU,
     modelPar_TAUE,
     modelPar_given_TAUE,
     modelPar_TAUB,
     modelPar_given_TAUB,
     modelPar_TEPI,
     modelPar_given_TEPI,
     modelPar_TAUR,
     modelPar_given_TAUR,
     modelPar_DEG,
     modelPar_given_DEG,
     modelPar_XREC,
     modelPar_given_XREC,
     modelPar_AQBO,
     modelPar_given_AQBO,
     modelPar_AE,
     modelPar_given_AE,
     modelPar_AB,
     modelPar_given_AB,
     modelPar_AEPI,
     modelPar_given_AEPI,
     modelPar_AEX,
     modelPar_given_AEX,
     modelPar_AC,
     modelPar_given_AC,
     modelPar_ACBL,
     modelPar_given_ACBL,
     modelPar_DVGBF,
     modelPar_given_DVGBF,
     modelPar_DVGBR,
     modelPar_given_DVGBR,
     modelPar_VGB,
     modelPar_given_VGB,
     modelPar_VGC,
     modelPar_given_VGC,
     modelPar_VGJ,
     modelPar_given_VGJ,
     modelPar_VGZEB,
     modelPar_given_VGZEB,
     modelPar_AVGEB,
     modelPar_given_AVGEB,
     modelPar_TVGEB,
     modelPar_given_TVGEB,
     modelPar_DVGTE,
     modelPar_given_DVGTE,
     modelPar_DAIS,
     modelPar_given_DAIS,
     modelPar_AF,
     modelPar_given_AF,
     modelPar_KF,
     modelPar_given_KF,
     modelPar_KFN,
     modelPar_given_KFN,
     modelPar_ISS,
     modelPar_given_ISS,
     modelPar_ICSS,
     modelPar_given_ICSS,
     modelPar_IKS,
     modelPar_given_IKS,
     modelPar_CJS,
     modelPar_given_CJS,
     modelPar_VDS,
     modelPar_given_VDS,
     modelPar_PS,
     modelPar_given_PS,
     modelPar_VGS,
     modelPar_given_VGS,
     modelPar_AS,
     modelPar_given_AS,
     modelPar_ASUB,
     modelPar_given_ASUB,
     modelPar_MULT,
     modelPar_given_MULT,
     modelPar_GMIN,
     modelPar_given_GMIN,
     // non-reals (including hidden)
     modelPar_LEVEL,
     modelPar_given_LEVEL,
     modelPar_EXMOD,
     modelPar_given_EXMOD,
     modelPar_EXPHI,
     modelPar_given_EXPHI,
     modelPar_EXAVL,
     modelPar_given_EXAVL,
     modelPar_EXSUB,
     modelPar_given_EXSUB,
     modelPar_KAVL,
     modelPar_given_KAVL,
     modelPar_TYPE,
     modelPar_given_TYPE// model variables
     ,
     // reals
     modelVar_An,
     modelVar_Tk,
     modelVar_Vt,
     modelVar_VtINV,
     modelVar_VDE_T,
     modelVar_VDC_T,
     modelVar_XP_T,
     modelVar_BF_T,
     modelVar_BRI_T,
     modelVar_IS_T,
     modelVar_VEF_T,
     modelVar_VER_T,
     modelVar_nZEB_T,
     modelVar_pow2_2mPE,
     modelVar_pow2_PEm2,
     modelVar_inv_VDE_T,
     modelVar_VGZEB_T,
     modelVar_TAUE_T,
     modelVar_TAUB_T,
     modelVar_TEPI_T,
     modelVar_TAUR_T,
     modelVar_BnT,
     modelVar_DEG_T,
     modelVar_VDS_T,
     modelVar_IKS_T,
     modelVar_IS_TM,
     modelVar_IK_TM,
     modelVar_IBF_TM,
     modelVar_IBR_TM,
     modelVar_IHC_M,
     modelVar_IZEB_TM,
     modelVar_CJE_TM,
     modelVar_CJC_TM,
     modelVar_RE_TM,
     modelVar_RBC_TM,
     modelVar_RBV_TM,
     modelVar_RCV_TM,
     modelVar_SCRCV_M,
     modelVar_RCCxx_TM,
     modelVar_GCCxx_TM,
     modelVar_GCCex_TM,
     modelVar_GCCin_TM,
     modelVar_KF_M,
     modelVar_KFN_M,
     modelVar_ISS_TM,
     modelVar_ICSS_TM,
     modelVar_IKS_TM,
     modelVar_CJS_TM,
     modelVar_Xext1,
     modelVar_CBEO_M,
     modelVar_CBCO_M,
     mod.admsModTemp,in.getDeviceOptions().gmin,in);


  // Now call  the function that does the heavy lifting.
  evaluateModelEquations(
     probeVars,
     // probe constants
     in.admsProbeID_V_noi_e1,
     in.admsProbeID_V_c3_c1,
     in.admsProbeID_V_c3_c4,
     in.admsProbeID_V_c4_c1,
     in.admsProbeID_V_b_c,
     in.admsProbeID_V_b_e,
     in.admsProbeID_V_b_b1,
     in.admsProbeID_V_e_e1,
     in.admsProbeID_V_c1_c2,
     in.admsProbeID_V_s_c1,
     in.admsProbeID_V_b1_b2,
     in.admsProbeID_V_b1_e1,
     in.admsProbeID_V_b2_e1,
     in.admsProbeID_V_b2_c2,
     in.admsProbeID_V_b2_c1,

     // node constants
     in.admsNodeID_c,
     in.admsNodeID_b,
     in.admsNodeID_e,
     in.admsNodeID_s,
     in.admsNodeID_e1,
     in.admsNodeID_b1,
     in.admsNodeID_b2,
     in.admsNodeID_c1,
     in.admsNodeID_c2,
     in.admsNodeID_c3,
     in.admsNodeID_c4,
     in.admsNodeID_noi,
     // instance parameters
     // reals
     instancePar_MULT,
     instancePar_given_MULT,
     // instance variables
     // reals
     instanceVar_Izteb,
     instanceVar_qBI,
     instanceVar_Ir,
     instanceVar_If,
     instanceVar_Ib1,
     instanceVar_Ib1_s,
     instanceVar_Ib2,
     instanceVar_Ib3,
     instanceVar_Iex,
     instanceVar_XIex,
     instanceVar_Isub,
     instanceVar_XIsub,
     instanceVar_Rb2,
     instanceVar_Gem,
     instanceVar_eVb1b2,
     // model parameters
     // reals
     modelPar_TREF,
     modelPar_given_TREF,
     modelPar_DTA,
     modelPar_given_DTA,
     modelPar_IS,
     modelPar_given_IS,
     modelPar_IK,
     modelPar_given_IK,
     modelPar_VER,
     modelPar_given_VER,
     modelPar_VEF,
     modelPar_given_VEF,
     modelPar_BF,
     modelPar_given_BF,
     modelPar_IBF,
     modelPar_given_IBF,
     modelPar_MLF,
     modelPar_given_MLF,
     modelPar_XIBI,
     modelPar_given_XIBI,
     modelPar_IZEB,
     modelPar_given_IZEB,
     modelPar_NZEB,
     modelPar_given_NZEB,
     modelPar_BRI,
     modelPar_given_BRI,
     modelPar_IBR,
     modelPar_given_IBR,
     modelPar_VLR,
     modelPar_given_VLR,
     modelPar_XEXT,
     modelPar_given_XEXT,
     modelPar_WAVL,
     modelPar_given_WAVL,
     modelPar_VAVL,
     modelPar_given_VAVL,
     modelPar_SFH,
     modelPar_given_SFH,
     modelPar_RE,
     modelPar_given_RE,
     modelPar_RBC,
     modelPar_given_RBC,
     modelPar_RBV,
     modelPar_given_RBV,
     modelPar_RCC,
     modelPar_given_RCC,
     modelPar_RCV,
     modelPar_given_RCV,
     modelPar_SCRCV,
     modelPar_given_SCRCV,
     modelPar_IHC,
     modelPar_given_IHC,
     modelPar_AXI,
     modelPar_given_AXI,
     modelPar_CJE,
     modelPar_given_CJE,
     modelPar_VDE,
     modelPar_given_VDE,
     modelPar_PE,
     modelPar_given_PE,
     modelPar_XCJE,
     modelPar_given_XCJE,
     modelPar_CBEO,
     modelPar_given_CBEO,
     modelPar_CJC,
     modelPar_given_CJC,
     modelPar_VDC,
     modelPar_given_VDC,
     modelPar_PC,
     modelPar_given_PC,
     modelPar_XP,
     modelPar_given_XP,
     modelPar_MC,
     modelPar_given_MC,
     modelPar_XCJC,
     modelPar_given_XCJC,
     modelPar_RCBLX,
     modelPar_given_RCBLX,
     modelPar_RCBLI,
     modelPar_given_RCBLI,
     modelPar_CBCO,
     modelPar_given_CBCO,
     modelPar_MTAU,
     modelPar_given_MTAU,
     modelPar_TAUE,
     modelPar_given_TAUE,
     modelPar_TAUB,
     modelPar_given_TAUB,
     modelPar_TEPI,
     modelPar_given_TEPI,
     modelPar_TAUR,
     modelPar_given_TAUR,
     modelPar_DEG,
     modelPar_given_DEG,
     modelPar_XREC,
     modelPar_given_XREC,
     modelPar_AQBO,
     modelPar_given_AQBO,
     modelPar_AE,
     modelPar_given_AE,
     modelPar_AB,
     modelPar_given_AB,
     modelPar_AEPI,
     modelPar_given_AEPI,
     modelPar_AEX,
     modelPar_given_AEX,
     modelPar_AC,
     modelPar_given_AC,
     modelPar_ACBL,
     modelPar_given_ACBL,
     modelPar_DVGBF,
     modelPar_given_DVGBF,
     modelPar_DVGBR,
     modelPar_given_DVGBR,
     modelPar_VGB,
     modelPar_given_VGB,
     modelPar_VGC,
     modelPar_given_VGC,
     modelPar_VGJ,
     modelPar_given_VGJ,
     modelPar_VGZEB,
     modelPar_given_VGZEB,
     modelPar_AVGEB,
     modelPar_given_AVGEB,
     modelPar_TVGEB,
     modelPar_given_TVGEB,
     modelPar_DVGTE,
     modelPar_given_DVGTE,
     modelPar_DAIS,
     modelPar_given_DAIS,
     modelPar_AF,
     modelPar_given_AF,
     modelPar_KF,
     modelPar_given_KF,
     modelPar_KFN,
     modelPar_given_KFN,
     modelPar_ISS,
     modelPar_given_ISS,
     modelPar_ICSS,
     modelPar_given_ICSS,
     modelPar_IKS,
     modelPar_given_IKS,
     modelPar_CJS,
     modelPar_given_CJS,
     modelPar_VDS,
     modelPar_given_VDS,
     modelPar_PS,
     modelPar_given_PS,
     modelPar_VGS,
     modelPar_given_VGS,
     modelPar_AS,
     modelPar_given_AS,
     modelPar_ASUB,
     modelPar_given_ASUB,
     modelPar_MULT,
     modelPar_given_MULT,
     modelPar_GMIN,
     modelPar_given_GMIN,
     // non-reals (including hidden)
     modelPar_LEVEL,
     modelPar_given_LEVEL,
     modelPar_EXMOD,
     modelPar_given_EXMOD,
     modelPar_EXPHI,
     modelPar_given_EXPHI,
     modelPar_EXAVL,
     modelPar_given_EXAVL,
     modelPar_EXSUB,
     modelPar_given_EXSUB,
     modelPar_KAVL,
     modelPar_given_KAVL,
     modelPar_TYPE,
     modelPar_given_TYPE// model variables
     ,
     // reals
     modelVar_An,
     modelVar_Tk,
     modelVar_Vt,
     modelVar_VtINV,
     modelVar_VDE_T,
     modelVar_VDC_T,
     modelVar_XP_T,
     modelVar_BF_T,
     modelVar_BRI_T,
     modelVar_IS_T,
     modelVar_VEF_T,
     modelVar_VER_T,
     modelVar_nZEB_T,
     modelVar_pow2_2mPE,
     modelVar_pow2_PEm2,
     modelVar_inv_VDE_T,
     modelVar_VGZEB_T,
     modelVar_TAUE_T,
     modelVar_TAUB_T,
     modelVar_TEPI_T,
     modelVar_TAUR_T,
     modelVar_BnT,
     modelVar_DEG_T,
     modelVar_VDS_T,
     modelVar_IKS_T,
     modelVar_IS_TM,
     modelVar_IK_TM,
     modelVar_IBF_TM,
     modelVar_IBR_TM,
     modelVar_IHC_M,
     modelVar_IZEB_TM,
     modelVar_CJE_TM,
     modelVar_CJC_TM,
     modelVar_RE_TM,
     modelVar_RBC_TM,
     modelVar_RBV_TM,
     modelVar_RCV_TM,
     modelVar_SCRCV_M,
     modelVar_RCCxx_TM,
     modelVar_GCCxx_TM,
     modelVar_GCCex_TM,
     modelVar_GCCin_TM,
     modelVar_KF_M,
     modelVar_KFN_M,
     modelVar_ISS_TM,
     modelVar_ICSS_TM,
     modelVar_IKS_TM,
     modelVar_CJS_TM,
     modelVar_Xext1,
     modelVar_CBEO_M,
     modelVar_CBCO_M,
     in.admsTemperature,
     in.adms_vt_nom,
     in.getDeviceOptions().gmin,
     staticContributions,
     dynamicContributions,
     in);


  // We now have the F and Q vector stuff, populate the dependencies:

  dfdp[in.admsNodeID_c] += staticContributions[in.admsNodeID_c].dx(0);
  dqdp[in.admsNodeID_c] += dynamicContributions[in.admsNodeID_c].dx(0);
  Findices[in.admsNodeID_c] = in.li_c;
  Qindices[in.admsNodeID_c] = in.li_c;
  dfdp[in.admsNodeID_b] += staticContributions[in.admsNodeID_b].dx(0);
  dqdp[in.admsNodeID_b] += dynamicContributions[in.admsNodeID_b].dx(0);
  Findices[in.admsNodeID_b] = in.li_b;
  Qindices[in.admsNodeID_b] = in.li_b;
  dfdp[in.admsNodeID_e] += staticContributions[in.admsNodeID_e].dx(0);
  dqdp[in.admsNodeID_e] += dynamicContributions[in.admsNodeID_e].dx(0);
  Findices[in.admsNodeID_e] = in.li_e;
  Qindices[in.admsNodeID_e] = in.li_e;
  dfdp[in.admsNodeID_s] += staticContributions[in.admsNodeID_s].dx(0);
  dqdp[in.admsNodeID_s] += dynamicContributions[in.admsNodeID_s].dx(0);
  Findices[in.admsNodeID_s] = in.li_s;
  Qindices[in.admsNodeID_s] = in.li_s;
  dfdp[in.admsNodeID_e1] += staticContributions[in.admsNodeID_e1].dx(0);
  dqdp[in.admsNodeID_e1] += dynamicContributions[in.admsNodeID_e1].dx(0);
  Findices[in.admsNodeID_e1] = in.li_e1;
  Qindices[in.admsNodeID_e1] = in.li_e1;
  dfdp[in.admsNodeID_b1] += staticContributions[in.admsNodeID_b1].dx(0);
  dqdp[in.admsNodeID_b1] += dynamicContributions[in.admsNodeID_b1].dx(0);
  Findices[in.admsNodeID_b1] = in.li_b1;
  Qindices[in.admsNodeID_b1] = in.li_b1;
  dfdp[in.admsNodeID_b2] += staticContributions[in.admsNodeID_b2].dx(0);
  dqdp[in.admsNodeID_b2] += dynamicContributions[in.admsNodeID_b2].dx(0);
  Findices[in.admsNodeID_b2] = in.li_b2;
  Qindices[in.admsNodeID_b2] = in.li_b2;
  dfdp[in.admsNodeID_c1] += staticContributions[in.admsNodeID_c1].dx(0);
  dqdp[in.admsNodeID_c1] += dynamicContributions[in.admsNodeID_c1].dx(0);
  Findices[in.admsNodeID_c1] = in.li_c1;
  Qindices[in.admsNodeID_c1] = in.li_c1;
  dfdp[in.admsNodeID_c2] += staticContributions[in.admsNodeID_c2].dx(0);
  dqdp[in.admsNodeID_c2] += dynamicContributions[in.admsNodeID_c2].dx(0);
  Findices[in.admsNodeID_c2] = in.li_c2;
  Qindices[in.admsNodeID_c2] = in.li_c2;
  dfdp[in.admsNodeID_c3] += staticContributions[in.admsNodeID_c3].dx(0);
  dqdp[in.admsNodeID_c3] += dynamicContributions[in.admsNodeID_c3].dx(0);
  Findices[in.admsNodeID_c3] = in.li_c3;
  Qindices[in.admsNodeID_c3] = in.li_c3;
  dfdp[in.admsNodeID_c4] += staticContributions[in.admsNodeID_c4].dx(0);
  dqdp[in.admsNodeID_c4] += dynamicContributions[in.admsNodeID_c4].dx(0);
  Findices[in.admsNodeID_c4] = in.li_c4;
  Qindices[in.admsNodeID_c4] = in.li_c4;
  dfdp[in.admsNodeID_noi] += staticContributions[in.admsNodeID_noi].dx(0);
  dqdp[in.admsNodeID_noi] += dynamicContributions[in.admsNodeID_noi].dx(0);
  Findices[in.admsNodeID_noi] = in.li_noi;
  Qindices[in.admsNodeID_noi] = in.li_noi;


}

//-----------------------------------------------------------------------------
// Function      : ModelSensitivity::operator()
// Purpose       : return sensitivity for a single model parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
/// Compute sensitivity to a specified model
/// parameter of all device instances of that model's outputs
/// 
/// 
/// @param[in] entity  The device entity that owns the parameter 
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
/// 
/// 
void ModelSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Model & mod = *(dynamic_cast<const Model *> (e1));
  int sizeInstance = mod.instanceContainer.size();

  dfdp.resize((12+0)*sizeInstance);
  dqdp.resize((12+0)*sizeInstance);
  Findices.resize((12+0)*sizeInstance);
  Qindices.resize((12+0)*sizeInstance);

  std::vector <double> probeVars(15);
  std::vector <AdmsSensFadType> staticContributions(12+0);
  std::vector <AdmsSensFadType> dynamicContributions(12+0);


  // Copy out all the model parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> modParamMap;

  // reals
  AdmsSensFadType modelPar_TREF=mod.TREF;
  bool modelPar_given_TREF=mod.given("TREF");
  modParamMap["TREF"] = &modelPar_TREF;
  AdmsSensFadType modelPar_DTA=mod.DTA;
  bool modelPar_given_DTA=mod.given("DTA");
  modParamMap["DTA"] = &modelPar_DTA;
  AdmsSensFadType modelPar_IS=mod.IS;
  bool modelPar_given_IS=mod.given("IS");
  modParamMap["IS"] = &modelPar_IS;
  AdmsSensFadType modelPar_IK=mod.IK;
  bool modelPar_given_IK=mod.given("IK");
  modParamMap["IK"] = &modelPar_IK;
  AdmsSensFadType modelPar_VER=mod.VER;
  bool modelPar_given_VER=mod.given("VER");
  modParamMap["VER"] = &modelPar_VER;
  AdmsSensFadType modelPar_VEF=mod.VEF;
  bool modelPar_given_VEF=mod.given("VEF");
  modParamMap["VEF"] = &modelPar_VEF;
  AdmsSensFadType modelPar_BF=mod.BF;
  bool modelPar_given_BF=mod.given("BF");
  modParamMap["BF"] = &modelPar_BF;
  AdmsSensFadType modelPar_IBF=mod.IBF;
  bool modelPar_given_IBF=mod.given("IBF");
  modParamMap["IBF"] = &modelPar_IBF;
  AdmsSensFadType modelPar_MLF=mod.MLF;
  bool modelPar_given_MLF=mod.given("MLF");
  modParamMap["MLF"] = &modelPar_MLF;
  AdmsSensFadType modelPar_XIBI=mod.XIBI;
  bool modelPar_given_XIBI=mod.given("XIBI");
  modParamMap["XIBI"] = &modelPar_XIBI;
  AdmsSensFadType modelPar_IZEB=mod.IZEB;
  bool modelPar_given_IZEB=mod.given("IZEB");
  modParamMap["IZEB"] = &modelPar_IZEB;
  AdmsSensFadType modelPar_NZEB=mod.NZEB;
  bool modelPar_given_NZEB=mod.given("NZEB");
  modParamMap["NZEB"] = &modelPar_NZEB;
  AdmsSensFadType modelPar_BRI=mod.BRI;
  bool modelPar_given_BRI=mod.given("BRI");
  modParamMap["BRI"] = &modelPar_BRI;
  AdmsSensFadType modelPar_IBR=mod.IBR;
  bool modelPar_given_IBR=mod.given("IBR");
  modParamMap["IBR"] = &modelPar_IBR;
  AdmsSensFadType modelPar_VLR=mod.VLR;
  bool modelPar_given_VLR=mod.given("VLR");
  modParamMap["VLR"] = &modelPar_VLR;
  AdmsSensFadType modelPar_XEXT=mod.XEXT;
  bool modelPar_given_XEXT=mod.given("XEXT");
  modParamMap["XEXT"] = &modelPar_XEXT;
  AdmsSensFadType modelPar_WAVL=mod.WAVL;
  bool modelPar_given_WAVL=mod.given("WAVL");
  modParamMap["WAVL"] = &modelPar_WAVL;
  AdmsSensFadType modelPar_VAVL=mod.VAVL;
  bool modelPar_given_VAVL=mod.given("VAVL");
  modParamMap["VAVL"] = &modelPar_VAVL;
  AdmsSensFadType modelPar_SFH=mod.SFH;
  bool modelPar_given_SFH=mod.given("SFH");
  modParamMap["SFH"] = &modelPar_SFH;
  AdmsSensFadType modelPar_RE=mod.RE;
  bool modelPar_given_RE=mod.given("RE");
  modParamMap["RE"] = &modelPar_RE;
  AdmsSensFadType modelPar_RBC=mod.RBC;
  bool modelPar_given_RBC=mod.given("RBC");
  modParamMap["RBC"] = &modelPar_RBC;
  AdmsSensFadType modelPar_RBV=mod.RBV;
  bool modelPar_given_RBV=mod.given("RBV");
  modParamMap["RBV"] = &modelPar_RBV;
  AdmsSensFadType modelPar_RCC=mod.RCC;
  bool modelPar_given_RCC=mod.given("RCC");
  modParamMap["RCC"] = &modelPar_RCC;
  AdmsSensFadType modelPar_RCV=mod.RCV;
  bool modelPar_given_RCV=mod.given("RCV");
  modParamMap["RCV"] = &modelPar_RCV;
  AdmsSensFadType modelPar_SCRCV=mod.SCRCV;
  bool modelPar_given_SCRCV=mod.given("SCRCV");
  modParamMap["SCRCV"] = &modelPar_SCRCV;
  AdmsSensFadType modelPar_IHC=mod.IHC;
  bool modelPar_given_IHC=mod.given("IHC");
  modParamMap["IHC"] = &modelPar_IHC;
  AdmsSensFadType modelPar_AXI=mod.AXI;
  bool modelPar_given_AXI=mod.given("AXI");
  modParamMap["AXI"] = &modelPar_AXI;
  AdmsSensFadType modelPar_CJE=mod.CJE;
  bool modelPar_given_CJE=mod.given("CJE");
  modParamMap["CJE"] = &modelPar_CJE;
  AdmsSensFadType modelPar_VDE=mod.VDE;
  bool modelPar_given_VDE=mod.given("VDE");
  modParamMap["VDE"] = &modelPar_VDE;
  AdmsSensFadType modelPar_PE=mod.PE;
  bool modelPar_given_PE=mod.given("PE");
  modParamMap["PE"] = &modelPar_PE;
  AdmsSensFadType modelPar_XCJE=mod.XCJE;
  bool modelPar_given_XCJE=mod.given("XCJE");
  modParamMap["XCJE"] = &modelPar_XCJE;
  AdmsSensFadType modelPar_CBEO=mod.CBEO;
  bool modelPar_given_CBEO=mod.given("CBEO");
  modParamMap["CBEO"] = &modelPar_CBEO;
  AdmsSensFadType modelPar_CJC=mod.CJC;
  bool modelPar_given_CJC=mod.given("CJC");
  modParamMap["CJC"] = &modelPar_CJC;
  AdmsSensFadType modelPar_VDC=mod.VDC;
  bool modelPar_given_VDC=mod.given("VDC");
  modParamMap["VDC"] = &modelPar_VDC;
  AdmsSensFadType modelPar_PC=mod.PC;
  bool modelPar_given_PC=mod.given("PC");
  modParamMap["PC"] = &modelPar_PC;
  AdmsSensFadType modelPar_XP=mod.XP;
  bool modelPar_given_XP=mod.given("XP");
  modParamMap["XP"] = &modelPar_XP;
  AdmsSensFadType modelPar_MC=mod.MC;
  bool modelPar_given_MC=mod.given("MC");
  modParamMap["MC"] = &modelPar_MC;
  AdmsSensFadType modelPar_XCJC=mod.XCJC;
  bool modelPar_given_XCJC=mod.given("XCJC");
  modParamMap["XCJC"] = &modelPar_XCJC;
  AdmsSensFadType modelPar_RCBLX=mod.RCBLX;
  bool modelPar_given_RCBLX=mod.given("RCBLX");
  modParamMap["RCBLX"] = &modelPar_RCBLX;
  AdmsSensFadType modelPar_RCBLI=mod.RCBLI;
  bool modelPar_given_RCBLI=mod.given("RCBLI");
  modParamMap["RCBLI"] = &modelPar_RCBLI;
  AdmsSensFadType modelPar_CBCO=mod.CBCO;
  bool modelPar_given_CBCO=mod.given("CBCO");
  modParamMap["CBCO"] = &modelPar_CBCO;
  AdmsSensFadType modelPar_MTAU=mod.MTAU;
  bool modelPar_given_MTAU=mod.given("MTAU");
  modParamMap["MTAU"] = &modelPar_MTAU;
  AdmsSensFadType modelPar_TAUE=mod.TAUE;
  bool modelPar_given_TAUE=mod.given("TAUE");
  modParamMap["TAUE"] = &modelPar_TAUE;
  AdmsSensFadType modelPar_TAUB=mod.TAUB;
  bool modelPar_given_TAUB=mod.given("TAUB");
  modParamMap["TAUB"] = &modelPar_TAUB;
  AdmsSensFadType modelPar_TEPI=mod.TEPI;
  bool modelPar_given_TEPI=mod.given("TEPI");
  modParamMap["TEPI"] = &modelPar_TEPI;
  AdmsSensFadType modelPar_TAUR=mod.TAUR;
  bool modelPar_given_TAUR=mod.given("TAUR");
  modParamMap["TAUR"] = &modelPar_TAUR;
  AdmsSensFadType modelPar_DEG=mod.DEG;
  bool modelPar_given_DEG=mod.given("DEG");
  modParamMap["DEG"] = &modelPar_DEG;
  AdmsSensFadType modelPar_XREC=mod.XREC;
  bool modelPar_given_XREC=mod.given("XREC");
  modParamMap["XREC"] = &modelPar_XREC;
  AdmsSensFadType modelPar_AQBO=mod.AQBO;
  bool modelPar_given_AQBO=mod.given("AQBO");
  modParamMap["AQBO"] = &modelPar_AQBO;
  AdmsSensFadType modelPar_AE=mod.AE;
  bool modelPar_given_AE=mod.given("AE");
  modParamMap["AE"] = &modelPar_AE;
  AdmsSensFadType modelPar_AB=mod.AB;
  bool modelPar_given_AB=mod.given("AB");
  modParamMap["AB"] = &modelPar_AB;
  AdmsSensFadType modelPar_AEPI=mod.AEPI;
  bool modelPar_given_AEPI=mod.given("AEPI");
  modParamMap["AEPI"] = &modelPar_AEPI;
  AdmsSensFadType modelPar_AEX=mod.AEX;
  bool modelPar_given_AEX=mod.given("AEX");
  modParamMap["AEX"] = &modelPar_AEX;
  AdmsSensFadType modelPar_AC=mod.AC;
  bool modelPar_given_AC=mod.given("AC");
  modParamMap["AC"] = &modelPar_AC;
  AdmsSensFadType modelPar_ACBL=mod.ACBL;
  bool modelPar_given_ACBL=mod.given("ACBL");
  modParamMap["ACBL"] = &modelPar_ACBL;
  AdmsSensFadType modelPar_DVGBF=mod.DVGBF;
  bool modelPar_given_DVGBF=mod.given("DVGBF");
  modParamMap["DVGBF"] = &modelPar_DVGBF;
  AdmsSensFadType modelPar_DVGBR=mod.DVGBR;
  bool modelPar_given_DVGBR=mod.given("DVGBR");
  modParamMap["DVGBR"] = &modelPar_DVGBR;
  AdmsSensFadType modelPar_VGB=mod.VGB;
  bool modelPar_given_VGB=mod.given("VGB");
  modParamMap["VGB"] = &modelPar_VGB;
  AdmsSensFadType modelPar_VGC=mod.VGC;
  bool modelPar_given_VGC=mod.given("VGC");
  modParamMap["VGC"] = &modelPar_VGC;
  AdmsSensFadType modelPar_VGJ=mod.VGJ;
  bool modelPar_given_VGJ=mod.given("VGJ");
  modParamMap["VGJ"] = &modelPar_VGJ;
  AdmsSensFadType modelPar_VGZEB=mod.VGZEB;
  bool modelPar_given_VGZEB=mod.given("VGZEB");
  modParamMap["VGZEB"] = &modelPar_VGZEB;
  AdmsSensFadType modelPar_AVGEB=mod.AVGEB;
  bool modelPar_given_AVGEB=mod.given("AVGEB");
  modParamMap["AVGEB"] = &modelPar_AVGEB;
  AdmsSensFadType modelPar_TVGEB=mod.TVGEB;
  bool modelPar_given_TVGEB=mod.given("TVGEB");
  modParamMap["TVGEB"] = &modelPar_TVGEB;
  AdmsSensFadType modelPar_DVGTE=mod.DVGTE;
  bool modelPar_given_DVGTE=mod.given("DVGTE");
  modParamMap["DVGTE"] = &modelPar_DVGTE;
  AdmsSensFadType modelPar_DAIS=mod.DAIS;
  bool modelPar_given_DAIS=mod.given("DAIS");
  modParamMap["DAIS"] = &modelPar_DAIS;
  AdmsSensFadType modelPar_AF=mod.AF;
  bool modelPar_given_AF=mod.given("AF");
  modParamMap["AF"] = &modelPar_AF;
  AdmsSensFadType modelPar_KF=mod.KF;
  bool modelPar_given_KF=mod.given("KF");
  modParamMap["KF"] = &modelPar_KF;
  AdmsSensFadType modelPar_KFN=mod.KFN;
  bool modelPar_given_KFN=mod.given("KFN");
  modParamMap["KFN"] = &modelPar_KFN;
  AdmsSensFadType modelPar_ISS=mod.ISS;
  bool modelPar_given_ISS=mod.given("ISS");
  modParamMap["ISS"] = &modelPar_ISS;
  AdmsSensFadType modelPar_ICSS=mod.ICSS;
  bool modelPar_given_ICSS=mod.given("ICSS");
  modParamMap["ICSS"] = &modelPar_ICSS;
  AdmsSensFadType modelPar_IKS=mod.IKS;
  bool modelPar_given_IKS=mod.given("IKS");
  modParamMap["IKS"] = &modelPar_IKS;
  AdmsSensFadType modelPar_CJS=mod.CJS;
  bool modelPar_given_CJS=mod.given("CJS");
  modParamMap["CJS"] = &modelPar_CJS;
  AdmsSensFadType modelPar_VDS=mod.VDS;
  bool modelPar_given_VDS=mod.given("VDS");
  modParamMap["VDS"] = &modelPar_VDS;
  AdmsSensFadType modelPar_PS=mod.PS;
  bool modelPar_given_PS=mod.given("PS");
  modParamMap["PS"] = &modelPar_PS;
  AdmsSensFadType modelPar_VGS=mod.VGS;
  bool modelPar_given_VGS=mod.given("VGS");
  modParamMap["VGS"] = &modelPar_VGS;
  AdmsSensFadType modelPar_AS=mod.AS;
  bool modelPar_given_AS=mod.given("AS");
  modParamMap["AS"] = &modelPar_AS;
  AdmsSensFadType modelPar_ASUB=mod.ASUB;
  bool modelPar_given_ASUB=mod.given("ASUB");
  modParamMap["ASUB"] = &modelPar_ASUB;
  AdmsSensFadType modelPar_MULT=mod.MULT;
  bool modelPar_given_MULT=mod.given("MULT");
  modParamMap["MULT"] = &modelPar_MULT;
  AdmsSensFadType modelPar_GMIN=mod.GMIN;
  bool modelPar_given_GMIN=mod.given("GMIN");
  modParamMap["GMIN"] = &modelPar_GMIN;


  // hidden reals


  // non-reals (including hiddens)
  int modelPar_LEVEL=mod.LEVEL;
  bool modelPar_given_LEVEL=mod.given("LEVEL");
  int modelPar_EXMOD=mod.EXMOD;
  bool modelPar_given_EXMOD=mod.given("EXMOD");
  int modelPar_EXPHI=mod.EXPHI;
  bool modelPar_given_EXPHI=mod.given("EXPHI");
  int modelPar_EXAVL=mod.EXAVL;
  bool modelPar_given_EXAVL=mod.given("EXAVL");
  int modelPar_EXSUB=mod.EXSUB;
  bool modelPar_given_EXSUB=mod.given("EXSUB");
  int modelPar_KAVL=mod.KAVL;
  bool modelPar_given_KAVL=mod.given("KAVL");
  int modelPar_TYPE=mod.TYPE;
  bool modelPar_given_TYPE=mod.given("TYPE");


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check name for presence first!  Segfault on invalid.
  modParamMap[name]->diff(0,1);

  //make local copies of all model vars
  //reals
  AdmsSensFadType modelVar_An=mod.An;
  AdmsSensFadType modelVar_Tk=mod.Tk;
  AdmsSensFadType modelVar_Vt=mod.Vt;
  AdmsSensFadType modelVar_VtINV=mod.VtINV;
  AdmsSensFadType modelVar_VDE_T=mod.VDE_T;
  AdmsSensFadType modelVar_VDC_T=mod.VDC_T;
  AdmsSensFadType modelVar_XP_T=mod.XP_T;
  AdmsSensFadType modelVar_BF_T=mod.BF_T;
  AdmsSensFadType modelVar_BRI_T=mod.BRI_T;
  AdmsSensFadType modelVar_IS_T=mod.IS_T;
  AdmsSensFadType modelVar_VEF_T=mod.VEF_T;
  AdmsSensFadType modelVar_VER_T=mod.VER_T;
  AdmsSensFadType modelVar_nZEB_T=mod.nZEB_T;
  AdmsSensFadType modelVar_pow2_2mPE=mod.pow2_2mPE;
  AdmsSensFadType modelVar_pow2_PEm2=mod.pow2_PEm2;
  AdmsSensFadType modelVar_inv_VDE_T=mod.inv_VDE_T;
  AdmsSensFadType modelVar_VGZEB_T=mod.VGZEB_T;
  AdmsSensFadType modelVar_TAUE_T=mod.TAUE_T;
  AdmsSensFadType modelVar_TAUB_T=mod.TAUB_T;
  AdmsSensFadType modelVar_TEPI_T=mod.TEPI_T;
  AdmsSensFadType modelVar_TAUR_T=mod.TAUR_T;
  AdmsSensFadType modelVar_BnT=mod.BnT;
  AdmsSensFadType modelVar_DEG_T=mod.DEG_T;
  AdmsSensFadType modelVar_VDS_T=mod.VDS_T;
  AdmsSensFadType modelVar_IKS_T=mod.IKS_T;
  AdmsSensFadType modelVar_IS_TM=mod.IS_TM;
  AdmsSensFadType modelVar_IK_TM=mod.IK_TM;
  AdmsSensFadType modelVar_IBF_TM=mod.IBF_TM;
  AdmsSensFadType modelVar_IBR_TM=mod.IBR_TM;
  AdmsSensFadType modelVar_IHC_M=mod.IHC_M;
  AdmsSensFadType modelVar_IZEB_TM=mod.IZEB_TM;
  AdmsSensFadType modelVar_CJE_TM=mod.CJE_TM;
  AdmsSensFadType modelVar_CJC_TM=mod.CJC_TM;
  AdmsSensFadType modelVar_RE_TM=mod.RE_TM;
  AdmsSensFadType modelVar_RBC_TM=mod.RBC_TM;
  AdmsSensFadType modelVar_RBV_TM=mod.RBV_TM;
  AdmsSensFadType modelVar_RCV_TM=mod.RCV_TM;
  AdmsSensFadType modelVar_SCRCV_M=mod.SCRCV_M;
  AdmsSensFadType modelVar_RCCxx_TM=mod.RCCxx_TM;
  AdmsSensFadType modelVar_GCCxx_TM=mod.GCCxx_TM;
  AdmsSensFadType modelVar_GCCex_TM=mod.GCCex_TM;
  AdmsSensFadType modelVar_GCCin_TM=mod.GCCin_TM;
  AdmsSensFadType modelVar_KF_M=mod.KF_M;
  AdmsSensFadType modelVar_KFN_M=mod.KFN_M;
  AdmsSensFadType modelVar_ISS_TM=mod.ISS_TM;
  AdmsSensFadType modelVar_ICSS_TM=mod.ICSS_TM;
  AdmsSensFadType modelVar_IKS_TM=mod.IKS_TM;
  AdmsSensFadType modelVar_CJS_TM=mod.CJS_TM;
  AdmsSensFadType modelVar_Xext1=mod.Xext1;
  AdmsSensFadType modelVar_CBEO_M=mod.CBEO_M;
  AdmsSensFadType modelVar_CBCO_M=mod.CBCO_M;


  // non-reals



  // Now loop over all instances and do the deed
  int inst=0;
  for (std::vector<Instance*>::const_iterator in_it=mod.instanceContainer.begin(); in_it != mod.instanceContainer.end(); ++in_it,++inst)
  {

    Instance & in=*(*in_it);
    // initialize contributions to zero (automatically sets derivatives to zero)
    for (int i=0; i < 12+0 ; ++i)
    {
      staticContributions[i]=0;
      dynamicContributions[i]=0;
    }



    // Copy out all the instance parameters (doubles) into FAD types
    // reals
    AdmsSensFadType instancePar_MULT=in.MULT;
    bool instancePar_given_MULT=in.given("MULT");


    // real hidden instance


    // Copy all the non-real instance params into vars of their appropriate type:




    // If there are any instance parameters that were not given, and have
    // corresponding model params, copy the model param into the instance.
    // This was already done by the instance constructor, but we do it again
    // because now we're propagating derivatives, and the user could be trying
    // to get sensitivity to the model parameter.
    if (!(in.given("MULT")))
    {
      instancePar_MULT = modelPar_MULT;
    }


    //make local copies of all instance vars
    //reals
    AdmsSensFadType instanceVar_Izteb=in.Izteb;
    AdmsSensFadType instanceVar_qBI=in.qBI;
    AdmsSensFadType instanceVar_Ir=in.Ir;
    AdmsSensFadType instanceVar_If=in.If;
    AdmsSensFadType instanceVar_Ib1=in.Ib1;
    AdmsSensFadType instanceVar_Ib1_s=in.Ib1_s;
    AdmsSensFadType instanceVar_Ib2=in.Ib2;
    AdmsSensFadType instanceVar_Ib3=in.Ib3;
    AdmsSensFadType instanceVar_Iex=in.Iex;
    AdmsSensFadType instanceVar_XIex=in.XIex;
    AdmsSensFadType instanceVar_Isub=in.Isub;
    AdmsSensFadType instanceVar_XIsub=in.XIsub;
    AdmsSensFadType instanceVar_Rb2=in.Rb2;
    AdmsSensFadType instanceVar_Gem=in.Gem;
    AdmsSensFadType instanceVar_eVb1b2=in.eVb1b2;

  
    //non-reals
  
  
  
    Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

    // extract solution variables and set as Fad independent variables.
    probeVars[in.admsProbeID_V_noi_e1] = (*solVectorPtr)[in.li_noi] - (*solVectorPtr)[in.li_e1];
    probeVars[in.admsProbeID_V_c3_c1] = (*solVectorPtr)[in.li_c3] - (*solVectorPtr)[in.li_c1];
    probeVars[in.admsProbeID_V_c3_c4] = (*solVectorPtr)[in.li_c3] - (*solVectorPtr)[in.li_c4];
    probeVars[in.admsProbeID_V_c4_c1] = (*solVectorPtr)[in.li_c4] - (*solVectorPtr)[in.li_c1];
    probeVars[in.admsProbeID_V_b_c] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_c];
    probeVars[in.admsProbeID_V_b_e] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_e];
    probeVars[in.admsProbeID_V_b_b1] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_b1];
    probeVars[in.admsProbeID_V_e_e1] = (*solVectorPtr)[in.li_e] - (*solVectorPtr)[in.li_e1];
    probeVars[in.admsProbeID_V_c1_c2] = (*solVectorPtr)[in.li_c1] - (*solVectorPtr)[in.li_c2];
    probeVars[in.admsProbeID_V_s_c1] = (*solVectorPtr)[in.li_s] - (*solVectorPtr)[in.li_c1];
    probeVars[in.admsProbeID_V_b1_b2] = (*solVectorPtr)[in.li_b1] - (*solVectorPtr)[in.li_b2];
    probeVars[in.admsProbeID_V_b1_e1] = (*solVectorPtr)[in.li_b1] - (*solVectorPtr)[in.li_e1];
    probeVars[in.admsProbeID_V_b2_e1] = (*solVectorPtr)[in.li_b2] - (*solVectorPtr)[in.li_e1];
    probeVars[in.admsProbeID_V_b2_c2] = (*solVectorPtr)[in.li_b2] - (*solVectorPtr)[in.li_c2];
    probeVars[in.admsProbeID_V_b2_c1] = (*solVectorPtr)[in.li_b2] - (*solVectorPtr)[in.li_c1];
    
    // pre-multiply any "typed" probes (i.e. those limited with "typedpnjlim")
    probeVars[in.admsProbeID_V_b1_b2] *= modelPar_TYPE;
    probeVars[in.admsProbeID_V_b1_e1] *= modelPar_TYPE;
    probeVars[in.admsProbeID_V_b2_c2] *= modelPar_TYPE;
    probeVars[in.admsProbeID_V_b2_c1] *= modelPar_TYPE;


    // Need to use processParams-like function to process the
    // initial_model block with the LOCAL copies of
    //  model vars, and local copies of model
    // params.
    evaluateInitialModel(
       // model parameters
       // reals
       modelPar_TREF,
       modelPar_given_TREF,
       modelPar_DTA,
       modelPar_given_DTA,
       modelPar_IS,
       modelPar_given_IS,
       modelPar_IK,
       modelPar_given_IK,
       modelPar_VER,
       modelPar_given_VER,
       modelPar_VEF,
       modelPar_given_VEF,
       modelPar_BF,
       modelPar_given_BF,
       modelPar_IBF,
       modelPar_given_IBF,
       modelPar_MLF,
       modelPar_given_MLF,
       modelPar_XIBI,
       modelPar_given_XIBI,
       modelPar_IZEB,
       modelPar_given_IZEB,
       modelPar_NZEB,
       modelPar_given_NZEB,
       modelPar_BRI,
       modelPar_given_BRI,
       modelPar_IBR,
       modelPar_given_IBR,
       modelPar_VLR,
       modelPar_given_VLR,
       modelPar_XEXT,
       modelPar_given_XEXT,
       modelPar_WAVL,
       modelPar_given_WAVL,
       modelPar_VAVL,
       modelPar_given_VAVL,
       modelPar_SFH,
       modelPar_given_SFH,
       modelPar_RE,
       modelPar_given_RE,
       modelPar_RBC,
       modelPar_given_RBC,
       modelPar_RBV,
       modelPar_given_RBV,
       modelPar_RCC,
       modelPar_given_RCC,
       modelPar_RCV,
       modelPar_given_RCV,
       modelPar_SCRCV,
       modelPar_given_SCRCV,
       modelPar_IHC,
       modelPar_given_IHC,
       modelPar_AXI,
       modelPar_given_AXI,
       modelPar_CJE,
       modelPar_given_CJE,
       modelPar_VDE,
       modelPar_given_VDE,
       modelPar_PE,
       modelPar_given_PE,
       modelPar_XCJE,
       modelPar_given_XCJE,
       modelPar_CBEO,
       modelPar_given_CBEO,
       modelPar_CJC,
       modelPar_given_CJC,
       modelPar_VDC,
       modelPar_given_VDC,
       modelPar_PC,
       modelPar_given_PC,
       modelPar_XP,
       modelPar_given_XP,
       modelPar_MC,
       modelPar_given_MC,
       modelPar_XCJC,
       modelPar_given_XCJC,
       modelPar_RCBLX,
       modelPar_given_RCBLX,
       modelPar_RCBLI,
       modelPar_given_RCBLI,
       modelPar_CBCO,
       modelPar_given_CBCO,
       modelPar_MTAU,
       modelPar_given_MTAU,
       modelPar_TAUE,
       modelPar_given_TAUE,
       modelPar_TAUB,
       modelPar_given_TAUB,
       modelPar_TEPI,
       modelPar_given_TEPI,
       modelPar_TAUR,
       modelPar_given_TAUR,
       modelPar_DEG,
       modelPar_given_DEG,
       modelPar_XREC,
       modelPar_given_XREC,
       modelPar_AQBO,
       modelPar_given_AQBO,
       modelPar_AE,
       modelPar_given_AE,
       modelPar_AB,
       modelPar_given_AB,
       modelPar_AEPI,
       modelPar_given_AEPI,
       modelPar_AEX,
       modelPar_given_AEX,
       modelPar_AC,
       modelPar_given_AC,
       modelPar_ACBL,
       modelPar_given_ACBL,
       modelPar_DVGBF,
       modelPar_given_DVGBF,
       modelPar_DVGBR,
       modelPar_given_DVGBR,
       modelPar_VGB,
       modelPar_given_VGB,
       modelPar_VGC,
       modelPar_given_VGC,
       modelPar_VGJ,
       modelPar_given_VGJ,
       modelPar_VGZEB,
       modelPar_given_VGZEB,
       modelPar_AVGEB,
       modelPar_given_AVGEB,
       modelPar_TVGEB,
       modelPar_given_TVGEB,
       modelPar_DVGTE,
       modelPar_given_DVGTE,
       modelPar_DAIS,
       modelPar_given_DAIS,
       modelPar_AF,
       modelPar_given_AF,
       modelPar_KF,
       modelPar_given_KF,
       modelPar_KFN,
       modelPar_given_KFN,
       modelPar_ISS,
       modelPar_given_ISS,
       modelPar_ICSS,
       modelPar_given_ICSS,
       modelPar_IKS,
       modelPar_given_IKS,
       modelPar_CJS,
       modelPar_given_CJS,
       modelPar_VDS,
       modelPar_given_VDS,
       modelPar_PS,
       modelPar_given_PS,
       modelPar_VGS,
       modelPar_given_VGS,
       modelPar_AS,
       modelPar_given_AS,
       modelPar_ASUB,
       modelPar_given_ASUB,
       modelPar_MULT,
       modelPar_given_MULT,
       modelPar_GMIN,
       modelPar_given_GMIN,
       // non-reals (including hidden)
       modelPar_LEVEL,
       modelPar_given_LEVEL,
       modelPar_EXMOD,
       modelPar_given_EXMOD,
       modelPar_EXPHI,
       modelPar_given_EXPHI,
       modelPar_EXAVL,
       modelPar_given_EXAVL,
       modelPar_EXSUB,
       modelPar_given_EXSUB,
       modelPar_KAVL,
       modelPar_given_KAVL,
       modelPar_TYPE,
       modelPar_given_TYPE// model variables
       ,
       // reals
       modelVar_An,
       modelVar_Tk,
       modelVar_Vt,
       modelVar_VtINV,
       modelVar_VDE_T,
       modelVar_VDC_T,
       modelVar_XP_T,
       modelVar_BF_T,
       modelVar_BRI_T,
       modelVar_IS_T,
       modelVar_VEF_T,
       modelVar_VER_T,
       modelVar_nZEB_T,
       modelVar_pow2_2mPE,
       modelVar_pow2_PEm2,
       modelVar_inv_VDE_T,
       modelVar_VGZEB_T,
       modelVar_TAUE_T,
       modelVar_TAUB_T,
       modelVar_TEPI_T,
       modelVar_TAUR_T,
       modelVar_BnT,
       modelVar_DEG_T,
       modelVar_VDS_T,
       modelVar_IKS_T,
       modelVar_IS_TM,
       modelVar_IK_TM,
       modelVar_IBF_TM,
       modelVar_IBR_TM,
       modelVar_IHC_M,
       modelVar_IZEB_TM,
       modelVar_CJE_TM,
       modelVar_CJC_TM,
       modelVar_RE_TM,
       modelVar_RBC_TM,
       modelVar_RBV_TM,
       modelVar_RCV_TM,
       modelVar_SCRCV_M,
       modelVar_RCCxx_TM,
       modelVar_GCCxx_TM,
       modelVar_GCCex_TM,
       modelVar_GCCin_TM,
       modelVar_KF_M,
       modelVar_KFN_M,
       modelVar_ISS_TM,
       modelVar_ICSS_TM,
       modelVar_IKS_TM,
       modelVar_CJS_TM,
       modelVar_Xext1,
       modelVar_CBEO_M,
       modelVar_CBCO_M,
       mod.admsModTemp,in.getDeviceOptions().gmin,in);


    // Now call  the function that does the heavy lifting.

    evaluateModelEquations(
       probeVars,
       // probe constants
       in.admsProbeID_V_noi_e1,
       in.admsProbeID_V_c3_c1,
       in.admsProbeID_V_c3_c4,
       in.admsProbeID_V_c4_c1,
       in.admsProbeID_V_b_c,
       in.admsProbeID_V_b_e,
       in.admsProbeID_V_b_b1,
       in.admsProbeID_V_e_e1,
       in.admsProbeID_V_c1_c2,
       in.admsProbeID_V_s_c1,
       in.admsProbeID_V_b1_b2,
       in.admsProbeID_V_b1_e1,
       in.admsProbeID_V_b2_e1,
       in.admsProbeID_V_b2_c2,
       in.admsProbeID_V_b2_c1,

       // node constants
       in.admsNodeID_c,
       in.admsNodeID_b,
       in.admsNodeID_e,
       in.admsNodeID_s,
       in.admsNodeID_e1,
       in.admsNodeID_b1,
       in.admsNodeID_b2,
       in.admsNodeID_c1,
       in.admsNodeID_c2,
       in.admsNodeID_c3,
       in.admsNodeID_c4,
       in.admsNodeID_noi,
       // instance parameters
       // reals
       instancePar_MULT,
       instancePar_given_MULT,
       // instance variables
       // reals
       instanceVar_Izteb,
       instanceVar_qBI,
       instanceVar_Ir,
       instanceVar_If,
       instanceVar_Ib1,
       instanceVar_Ib1_s,
       instanceVar_Ib2,
       instanceVar_Ib3,
       instanceVar_Iex,
       instanceVar_XIex,
       instanceVar_Isub,
       instanceVar_XIsub,
       instanceVar_Rb2,
       instanceVar_Gem,
       instanceVar_eVb1b2,
       // model parameters
       // reals
       modelPar_TREF,
       modelPar_given_TREF,
       modelPar_DTA,
       modelPar_given_DTA,
       modelPar_IS,
       modelPar_given_IS,
       modelPar_IK,
       modelPar_given_IK,
       modelPar_VER,
       modelPar_given_VER,
       modelPar_VEF,
       modelPar_given_VEF,
       modelPar_BF,
       modelPar_given_BF,
       modelPar_IBF,
       modelPar_given_IBF,
       modelPar_MLF,
       modelPar_given_MLF,
       modelPar_XIBI,
       modelPar_given_XIBI,
       modelPar_IZEB,
       modelPar_given_IZEB,
       modelPar_NZEB,
       modelPar_given_NZEB,
       modelPar_BRI,
       modelPar_given_BRI,
       modelPar_IBR,
       modelPar_given_IBR,
       modelPar_VLR,
       modelPar_given_VLR,
       modelPar_XEXT,
       modelPar_given_XEXT,
       modelPar_WAVL,
       modelPar_given_WAVL,
       modelPar_VAVL,
       modelPar_given_VAVL,
       modelPar_SFH,
       modelPar_given_SFH,
       modelPar_RE,
       modelPar_given_RE,
       modelPar_RBC,
       modelPar_given_RBC,
       modelPar_RBV,
       modelPar_given_RBV,
       modelPar_RCC,
       modelPar_given_RCC,
       modelPar_RCV,
       modelPar_given_RCV,
       modelPar_SCRCV,
       modelPar_given_SCRCV,
       modelPar_IHC,
       modelPar_given_IHC,
       modelPar_AXI,
       modelPar_given_AXI,
       modelPar_CJE,
       modelPar_given_CJE,
       modelPar_VDE,
       modelPar_given_VDE,
       modelPar_PE,
       modelPar_given_PE,
       modelPar_XCJE,
       modelPar_given_XCJE,
       modelPar_CBEO,
       modelPar_given_CBEO,
       modelPar_CJC,
       modelPar_given_CJC,
       modelPar_VDC,
       modelPar_given_VDC,
       modelPar_PC,
       modelPar_given_PC,
       modelPar_XP,
       modelPar_given_XP,
       modelPar_MC,
       modelPar_given_MC,
       modelPar_XCJC,
       modelPar_given_XCJC,
       modelPar_RCBLX,
       modelPar_given_RCBLX,
       modelPar_RCBLI,
       modelPar_given_RCBLI,
       modelPar_CBCO,
       modelPar_given_CBCO,
       modelPar_MTAU,
       modelPar_given_MTAU,
       modelPar_TAUE,
       modelPar_given_TAUE,
       modelPar_TAUB,
       modelPar_given_TAUB,
       modelPar_TEPI,
       modelPar_given_TEPI,
       modelPar_TAUR,
       modelPar_given_TAUR,
       modelPar_DEG,
       modelPar_given_DEG,
       modelPar_XREC,
       modelPar_given_XREC,
       modelPar_AQBO,
       modelPar_given_AQBO,
       modelPar_AE,
       modelPar_given_AE,
       modelPar_AB,
       modelPar_given_AB,
       modelPar_AEPI,
       modelPar_given_AEPI,
       modelPar_AEX,
       modelPar_given_AEX,
       modelPar_AC,
       modelPar_given_AC,
       modelPar_ACBL,
       modelPar_given_ACBL,
       modelPar_DVGBF,
       modelPar_given_DVGBF,
       modelPar_DVGBR,
       modelPar_given_DVGBR,
       modelPar_VGB,
       modelPar_given_VGB,
       modelPar_VGC,
       modelPar_given_VGC,
       modelPar_VGJ,
       modelPar_given_VGJ,
       modelPar_VGZEB,
       modelPar_given_VGZEB,
       modelPar_AVGEB,
       modelPar_given_AVGEB,
       modelPar_TVGEB,
       modelPar_given_TVGEB,
       modelPar_DVGTE,
       modelPar_given_DVGTE,
       modelPar_DAIS,
       modelPar_given_DAIS,
       modelPar_AF,
       modelPar_given_AF,
       modelPar_KF,
       modelPar_given_KF,
       modelPar_KFN,
       modelPar_given_KFN,
       modelPar_ISS,
       modelPar_given_ISS,
       modelPar_ICSS,
       modelPar_given_ICSS,
       modelPar_IKS,
       modelPar_given_IKS,
       modelPar_CJS,
       modelPar_given_CJS,
       modelPar_VDS,
       modelPar_given_VDS,
       modelPar_PS,
       modelPar_given_PS,
       modelPar_VGS,
       modelPar_given_VGS,
       modelPar_AS,
       modelPar_given_AS,
       modelPar_ASUB,
       modelPar_given_ASUB,
       modelPar_MULT,
       modelPar_given_MULT,
       modelPar_GMIN,
       modelPar_given_GMIN,
       // non-reals (including hidden)
       modelPar_LEVEL,
       modelPar_given_LEVEL,
       modelPar_EXMOD,
       modelPar_given_EXMOD,
       modelPar_EXPHI,
       modelPar_given_EXPHI,
       modelPar_EXAVL,
       modelPar_given_EXAVL,
       modelPar_EXSUB,
       modelPar_given_EXSUB,
       modelPar_KAVL,
       modelPar_given_KAVL,
       modelPar_TYPE,
       modelPar_given_TYPE// model variables
       ,
       // reals
       modelVar_An,
       modelVar_Tk,
       modelVar_Vt,
       modelVar_VtINV,
       modelVar_VDE_T,
       modelVar_VDC_T,
       modelVar_XP_T,
       modelVar_BF_T,
       modelVar_BRI_T,
       modelVar_IS_T,
       modelVar_VEF_T,
       modelVar_VER_T,
       modelVar_nZEB_T,
       modelVar_pow2_2mPE,
       modelVar_pow2_PEm2,
       modelVar_inv_VDE_T,
       modelVar_VGZEB_T,
       modelVar_TAUE_T,
       modelVar_TAUB_T,
       modelVar_TEPI_T,
       modelVar_TAUR_T,
       modelVar_BnT,
       modelVar_DEG_T,
       modelVar_VDS_T,
       modelVar_IKS_T,
       modelVar_IS_TM,
       modelVar_IK_TM,
       modelVar_IBF_TM,
       modelVar_IBR_TM,
       modelVar_IHC_M,
       modelVar_IZEB_TM,
       modelVar_CJE_TM,
       modelVar_CJC_TM,
       modelVar_RE_TM,
       modelVar_RBC_TM,
       modelVar_RBV_TM,
       modelVar_RCV_TM,
       modelVar_SCRCV_M,
       modelVar_RCCxx_TM,
       modelVar_GCCxx_TM,
       modelVar_GCCex_TM,
       modelVar_GCCin_TM,
       modelVar_KF_M,
       modelVar_KFN_M,
       modelVar_ISS_TM,
       modelVar_ICSS_TM,
       modelVar_IKS_TM,
       modelVar_CJS_TM,
       modelVar_Xext1,
       modelVar_CBEO_M,
       modelVar_CBCO_M,
       in.admsTemperature,
       in.adms_vt_nom,
       in.getDeviceOptions().gmin,
       staticContributions,
       dynamicContributions,
       in);

  
    // We now have the F and Q vector stuff, populate the dependencies:
  
    dfdp[in.admsNodeID_c+inst*(12+0)] += staticContributions[in.admsNodeID_c].dx(0);
    dqdp[in.admsNodeID_c+inst*(12+0)] += dynamicContributions[in.admsNodeID_c].dx(0);
    Findices[in.admsNodeID_c+inst*(12+0)] = in.li_c;
    Qindices[in.admsNodeID_c+inst*(12+0)] = in.li_c;
    dfdp[in.admsNodeID_b+inst*(12+0)] += staticContributions[in.admsNodeID_b].dx(0);
    dqdp[in.admsNodeID_b+inst*(12+0)] += dynamicContributions[in.admsNodeID_b].dx(0);
    Findices[in.admsNodeID_b+inst*(12+0)] = in.li_b;
    Qindices[in.admsNodeID_b+inst*(12+0)] = in.li_b;
    dfdp[in.admsNodeID_e+inst*(12+0)] += staticContributions[in.admsNodeID_e].dx(0);
    dqdp[in.admsNodeID_e+inst*(12+0)] += dynamicContributions[in.admsNodeID_e].dx(0);
    Findices[in.admsNodeID_e+inst*(12+0)] = in.li_e;
    Qindices[in.admsNodeID_e+inst*(12+0)] = in.li_e;
    dfdp[in.admsNodeID_s+inst*(12+0)] += staticContributions[in.admsNodeID_s].dx(0);
    dqdp[in.admsNodeID_s+inst*(12+0)] += dynamicContributions[in.admsNodeID_s].dx(0);
    Findices[in.admsNodeID_s+inst*(12+0)] = in.li_s;
    Qindices[in.admsNodeID_s+inst*(12+0)] = in.li_s;
    dfdp[in.admsNodeID_e1+inst*(12+0)] += staticContributions[in.admsNodeID_e1].dx(0);
    dqdp[in.admsNodeID_e1+inst*(12+0)] += dynamicContributions[in.admsNodeID_e1].dx(0);
    Findices[in.admsNodeID_e1+inst*(12+0)] = in.li_e1;
    Qindices[in.admsNodeID_e1+inst*(12+0)] = in.li_e1;
    dfdp[in.admsNodeID_b1+inst*(12+0)] += staticContributions[in.admsNodeID_b1].dx(0);
    dqdp[in.admsNodeID_b1+inst*(12+0)] += dynamicContributions[in.admsNodeID_b1].dx(0);
    Findices[in.admsNodeID_b1+inst*(12+0)] = in.li_b1;
    Qindices[in.admsNodeID_b1+inst*(12+0)] = in.li_b1;
    dfdp[in.admsNodeID_b2+inst*(12+0)] += staticContributions[in.admsNodeID_b2].dx(0);
    dqdp[in.admsNodeID_b2+inst*(12+0)] += dynamicContributions[in.admsNodeID_b2].dx(0);
    Findices[in.admsNodeID_b2+inst*(12+0)] = in.li_b2;
    Qindices[in.admsNodeID_b2+inst*(12+0)] = in.li_b2;
    dfdp[in.admsNodeID_c1+inst*(12+0)] += staticContributions[in.admsNodeID_c1].dx(0);
    dqdp[in.admsNodeID_c1+inst*(12+0)] += dynamicContributions[in.admsNodeID_c1].dx(0);
    Findices[in.admsNodeID_c1+inst*(12+0)] = in.li_c1;
    Qindices[in.admsNodeID_c1+inst*(12+0)] = in.li_c1;
    dfdp[in.admsNodeID_c2+inst*(12+0)] += staticContributions[in.admsNodeID_c2].dx(0);
    dqdp[in.admsNodeID_c2+inst*(12+0)] += dynamicContributions[in.admsNodeID_c2].dx(0);
    Findices[in.admsNodeID_c2+inst*(12+0)] = in.li_c2;
    Qindices[in.admsNodeID_c2+inst*(12+0)] = in.li_c2;
    dfdp[in.admsNodeID_c3+inst*(12+0)] += staticContributions[in.admsNodeID_c3].dx(0);
    dqdp[in.admsNodeID_c3+inst*(12+0)] += dynamicContributions[in.admsNodeID_c3].dx(0);
    Findices[in.admsNodeID_c3+inst*(12+0)] = in.li_c3;
    Qindices[in.admsNodeID_c3+inst*(12+0)] = in.li_c3;
    dfdp[in.admsNodeID_c4+inst*(12+0)] += staticContributions[in.admsNodeID_c4].dx(0);
    dqdp[in.admsNodeID_c4+inst*(12+0)] += dynamicContributions[in.admsNodeID_c4].dx(0);
    Findices[in.admsNodeID_c4+inst*(12+0)] = in.li_c4;
    Qindices[in.admsNodeID_c4+inst*(12+0)] = in.li_c4;
    dfdp[in.admsNodeID_noi+inst*(12+0)] += staticContributions[in.admsNodeID_noi].dx(0);
    dqdp[in.admsNodeID_noi+inst*(12+0)] += dynamicContributions[in.admsNodeID_noi].dx(0);
    Findices[in.admsNodeID_noi+inst*(12+0)] = in.li_noi;
    Qindices[in.admsNodeID_noi+inst*(12+0)] = in.li_noi;
  }

}

#endif // Xyce_ADMS_SENSITIVITIES

} // namespace ADMSbjt504va
} // namespace Device
} // namespace Xyce
